#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=CHDK-Shell\icons\CHDKlogo3.ico
#AutoIt3Wrapper_Compression=0
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=CHDK GCC Compiler Shell
#AutoIt3Wrapper_Res_Fileversion=3.4.3.0
#AutoIt3Wrapper_Res_LegalCopyright=GPLv2
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Res_Field=Author|whim
#AutoIt3Wrapper_Res_Field=Support|http://chdk.setepontos.com/index.php/topic,845.0.html
#AutoIt3Wrapper_Res_Field=Thanks|reyalp, fe50, rudi, msl, hotvedt, nmcconnell, Darkness, p::d, ultimA
#AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
#AutoIt3Wrapper_Res_Field=AutoIt Thanks|Bowmore, Siao, Melba32, UEZ @ www.autoitscript.com/forum
#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/so
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#
#Region -----------  2-pass compile: AutoIt3Wrapper_GUI Wrappers for Stage 2  --------------------

; Commented-out Wrapper settings below are my workaround to reduce file size
; i get about 60 kB smaller executables this way, but they should also be
; faster, since AutoIt reads all source line by line at runtime ...
; of course this is totally optional, but i just wanted to explain it :)
; Workflow is as follows:
;
; 1) compile (Tools -> Compile, Ctrl+F7) with Wrapper settings above, then load the CHDK-Shell-v(number)_Obfuscated.au3
; 2) rename to a 'future' version ( e.g. CHDK-Shell-v(number+1).au3 )
; 3) Copy Phase 2 Wrappers to top of file and DO NOT FORGET TO UNCOMMENT them
; 4) Compile (Tools -> Compile, Ctrl+F7)
; 5) Remove CHDK-Shell-v(number).exe, then rename CHDK-Shell-v(number+1).exe to CHDK-Shell-v(number).exe

; Wrappers for Phase 2 compilation, put @top of script for pass 2

;~ #AutoIt3Wrapper_icon=CHDK-Shell\icons\CHDKlogo3.ico
;~ #AutoIt3Wrapper_Compression=4
;~ #AutoIt3Wrapper_UseUpx=n
;~ #AutoIt3Wrapper_Res_Description=CHDK GCC Compiler Shell
;~ #AutoIt3Wrapper_Res_Fileversion=3.4.3.0
;~ #AutoIt3Wrapper_Res_LegalCopyright=GPLv2
;~ #AutoIt3Wrapper_Res_Field=Author|whim
;~ #AutoIt3Wrapper_Res_Field=Support|http://chdk.setepontos.com/index.php/topic,845.0.html
;~ #AutoIt3Wrapper_Res_Field=Thanks|reyalp, fe50, rudi, msl, hotvedt, nmcconnell, Darkness, p::d, ultimA
;~ #AutoIt3Wrapper_Res_Field=AutoIt Version|%AutoItVer%
;~ #AutoIt3Wrapper_Res_Field=AutoIt Thanks|Bowmore, Siao, Melba32, UEZ @ www.autoitscript.com/forum
;~ #AutoIt3Wrapper_Run_After="%scitedir%\upx.exe" --ultra-brute -k %out%
;~ #AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
;~ #AutoIt3Wrapper_Run_Obfuscator=y
;~ #Obfuscator_Parameters=/sf /sv /om /cs=0 /cn=0

#EndRegion
#
#Region ---------------------------- AutoIt Options ----------------------------------------------
Opt("WinWaitDelay", 0)	; default 250 ms
#EndRegion
#
#Region ---------------------------- Program Global Const ----------------------------------------
; ============================
Global Const $Version = "3.43"
; ============================
Global Const $mini_height = 135
Global Const $CShell = "CHDK GCC Compiler Shell v."
Global Const $Title = $CShell & $Version & "a"
Global Const $ready = "Ready"
Global Const $none = "[NONE]"
Global Const $sections[5] = [ "Program", "Trunk", "Card", "CamPanel", "Cameras" ]
Global Const $cc_patt = "build time optional components"
Global Const $mycomp = "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}" ; GUID for 'My Computer'
Global Const $gr_font = "Comic Sans MS"
Global Const $txt_process[3] = [ "Zips: Keep", "Zips: Unzip/Keep", "Zips: Unzip/Delete" ]
Global Const $txt_autcomp[3] = [ "No", "All", "Selected" ]
Global Const $txt_branch[3] = [ "None", "Default only", "All" ]
Global Const $web = "http://"
Global Const $sweb = "https://"
Global Const $SDM_Site = $web & "stereo.jpn.org/eng/sdm"
Global Const $SrcSites[2] = [ "trac.assembla.com", "trac.assembla.com" ]
Global Const $VerPaths[2] = [ "/chdk/", "/chdkde/" ]
Global Const $VerPrefix[2] = [ "", "\DE" ]
Global Const $VerDefBr[2] = [ "juciphox", "fe50t" ]
Global Const $Wikia = $web & "chdk.wikia.com/wiki/CHDK"
Global Const $Forum[2] = [ $web & "chdk.setepontos.com/", $web & "forum.chdk-treff.de/" ]
Global Const $Home[2] = [ $web & "chdk.setepontos.com/index.php?topic=845.0", $web & "forum.chdk-treff.de/viewtopic.php?f=1&t=1606" ]
Global Const $Mantis = $web & "chdk.kernreaktor.org/mantis"
Global Const $Get_gcc = $web & "www.box.net/shared/njaq9vvozu"
Global Const $Get_CHDK_Shell_updater = $web & "www.box.net/shared/4d5g57navx"
Global Const $GermanOSLang = "0407,0807,0c07,0C07,1007,1407" ; German language OS if @OSLang is one of these
Global Const $CP_default[16] = [ 0, 127, 127, 127, 255, 255, 255, 1, 0, 0, 0, 200, 255, 255, 1, 85 ] ; cam panel color presets
Global Const $PivotPrms[4][2] = [ [0x00040005, 0x0005000A], [0x00040006, 0x00050009], [0x00040009, 0x00050006], [0x0004000A, 0x00050005] ]
Global Const $semi_allowed = "WIN_VISTA WIN_2008 WIN_7" ; support only 'approved' GCC3 unless overridden ...
Global Const $allowed = "WIN_2000 WIN_XPe WIN_2003" & $semi_allowed ; program will refuse to run on any OS not in here
; RGB colors
Global Const $red = 0xFF0000, $green = 0x50FF50, $orange = 0xFFAA00, $blue = 0x0000FF, $dgrey = 0x606060
Global Const $white = 0xFFFFFF, $black = 0x000000, $seagreen = 0x007F7F
; system macro's
Global Const $topmost = 262144	; for MsgBox
Global Const $State_Show = @SW_SHOW
Global Const $State_Hide = @SW_HIDE
Global Const $State_Restore = @SW_RESTORE
Global Const $State_Enable = @SW_ENABLE
Global Const $State_Disable = @SW_DISABLE
Global Const $State_Minimize = @SW_MINIMIZE
Global Const $CurrOSVersion = @OSVersion
Global Const $SysComSpec = @ComSpec

#EndRegion
#
#Region ---------------------------- Globals & Global Const for Includes -------------------------

;~ #include "GUIConstantsEx.au3"
;~ #include <Constants.au3>
;~ #include <StaticConstants.au3>
;~ #include <UpdownConstants.au3>
;~ #include <WindowsConstants.au3>
;~ #include <ButtonConstants.au3>

Global Const $GUI_WS_EX_PARENTDRAG = 0x00100000
Global Const $SS_SUNKEN = 0x1000
Global Const $WS_POPUP = 0x80000000
Global Const $WS_EX_TOOLWINDOW = 0x00000080
Global Const $WS_EX_LAYERED = 0x00080000
Global Const $WS_EX_MDICHILD = 0x00000040

Global Const $WS_SYSMENU = 0x00080000
Global Const $WS_CAPTION = 0x00C00000
Global Const $WS_MINIMIZEBOX = 0x00020000

Global Const $tagSIZE = "long X;long Y"
Global Const $tagPOINT = "long X;long Y"
Global Const $tagBLENDFUNCTION = "byte Op;byte Flags;byte Alpha;byte Format"

Global $ghGDIPDll = 0
Global $giGDIPRef = 0
Global $giGDIPToken = 0

#EndRegion
#
#Region ---------------------------- Program Globals ---------------------------------------------
; general purpose
; ====== removed $c, $f, $dummy, they're now all localised
Global $mak	; used to share the parsed Makefile as an array between 2 functions
; path and various related strings
Global $here, $subdir, $sourcedir, $sourcedir0, $icons, $BrowserDLDir, $ShortcutDir, $UTarget = ""	; $prefs,
Global $GCCpath, $GCC3path, $GCC4path; full paths to dev kits, versions
Global $gccver[2], $GCC3_Lock = False
Global $NewestBuild = "", $NetBuild = "", $BuildName, $LastBuildName, $CBFN ; = Current Build Full Name
Global $bpath, $tpath, $apath, $CurrentBuild, $LongBuildName, $cardmenu, $card_drive = ""
; files
Global $inifile, $errlog, $lastpatch = ""
; program state variables
Global $ProgStarted, $WinVer
Global $New_Or_Updated = 0
Global $NewStyle_Makefile = False
Global $site ; selecter determines which source site to use (0 or 1 at present)
Global $web_prefix	; used to toggle between $web ("http://") and $sweb ("https://")
Global $DefBranch[2], $trunk[2], $do_branches[2] ; keeps default branch and trunk switch settings on a per site base
Global $MaxSearch[2]	; highest build number to search for
Global $MaxBuild[2]	= [ 300, 10 ]	; highest build number found locally
Global $MinBuild[2] = [ 300, 10 ]	; the (included) default trunk builds for CHDK / CHDK-DE
Global $LastUsed[2][2] = [ [ "", "" ], [ "", "" ] ]
Global $CHDKLogo[2]
Global $CurrentGUI[2]	; [ handle, name ]
Global $Timer_Interval     	; 	repeat interval for garbage collection in seconds, for accurate timing, default = 10
;								(60 / $Timer_Interval) should be integer --> 1, 2, 3, 4, 5, 6, 10, 12, 15, 20, 30, 60
Global $GC_Flag, $GC_ratio
Global $InstallFlag, $miniGUI = -1, $istate, $last_istate = -1, $checkcompile = 0
Global $makstart, $MakStyle, $MakCmd, $MakOptions[2][2]
Global $ActWin = 0, $cam_font_size, $cam_font_size2, $snooped = 0, $IsDuplicate = -1, $t_last = "N/A", $d_last = ""
Global $ThisProcess, $SkipPostClean
Global $GDI_plus = True
Global $Introspection = 0
Global $Controls_ShowBG	= 0	; will be 1 if painting control BG light blue
Global $Cleanup[4]
Global $NewVersion = False	; flags fresh install or update
Global $WGet_Ver[2]		; wget version string [for GCC3, for GCC4]
Global $warnflag[2] = [ 1, 1 ], $NetConnected[2] = [ 1, 1 ] ; assume net connection
Global $InetTimeOut		; Inetget timeout in func (W)getHTMLSource()
Global $wget_options	; change in inifile, de3faults to "--no-http-keep-alive"
Global $LimitBuilds		; turn on/off deletion of UNPACKED older builds
Global $BuildsToKeep	; protect this many UNPACKED older builds from deletion
Global $PurgeToTrash	; when purging, use Trash i.o. NUL
Global $PurgeFlag = False	; if true, separate purge thread will be started at next timer event
Global $startup = True ; will be reset to False after GUI is shown for first time
Global $CP_color[2][2] ; [before/after][FG/BG]
Global $CP_bold[4] ; [b_init, b_final, b_check, auto]
Global $CP_current[16]
Global $SupportsPrimary, $CustomPrimary, $AutoGCC, $NoGCC4Flags ; these hold info obtained from 'makefile.inc'
Global $cb_slot = 60 ; size of a firmware checkbox in cam panel
Global $cambutton_size = 115
Global $maxfirm = 5 ; initial value, will be dynamically adjusted to save memory
Global $sup_cams = 100 ; initial value, will be dynamically adjusted to save memory
Global $sup_firms
Global $ccs	; = cam column size = $maxfirm * $cb_slot + 125
Global $msg, $gc, $ctim, $mtim, $activity, $ticks_max, $ticks_left, $diskfreespace = 0
Global $AccelMain[9][2], $AccelMini[1][2], $AccelCard[2][2] ;  AKA Alt Key Accelerators
Global $PivIndex
Global $arr_icon[4] ; arrow icons to change to miniGUI
Global $w_chkver ; flag for prog version checking
Global $ulink = "", $uver = "" ; update address / ver if update found
Global $StatusMsg, $OnLine = 0
Global $Sync_Checks, $Sync_Checks_BG, $cardlock = 0
Global $DefLang[2] = ["english", "german"], $DefLang_Configurable = False
; gui pos/size
Global $wpos[4] = [-1, -1, -1, -1], $mpos[4], $mpos0[4]
Global $w_cw = 0 ; window client width = 425 + $cbs, will be set by calls to SelectLocalBuild()
Global $w_cw0 = 0 ; previous client width
Global $w_ch = 740	; was 690
Global $ovh_w, $ovh_h
Global $min_line_height, $firm_font_perc
Global $f_scaler, $w_scaler, $w_sticky, $w_force, $w_animate, $w_slide, $w_outtro, $w_boldpopups, $w_showcountdown, $3D_CountDown
Global $w_minitimer, $w_screensnap, $w_auto, $w_upd, $w_propsortalpha, $w_propsortalpha0, $no_readme_popup
Global $no_ptpcamgui_dl, $update_ptpcam, $w_classic, $w_aero = 0, $w_override_oscheck, $reduce_logo
; font sizes
Global $f_small, $f_normal, $f_large, $f_xxl
; string array & control params
Global $cam_props[$sup_cams][2] ; needs dimensioning BEFORE entry into SelectLocalBuild
Global $MaxProps, $DefaultProps[2], $AutoProps = "", $DefPropsEnd
Global $firmdup[$sup_cams][3] ; needs dimensioning BEFORE entry into SelectLocalBuild
; others will be (re)dimensioned in SelectLocalBuild:
Global $cams, $cam_row_spacing, $max_entry, $cam_columns ; cam/firm strings, row spacing, #cams/column, #columns
Global $LM	; left margin, equals left side of group boxes in right panel.
Global $but_cams[$sup_cams], $dry_cams[$sup_cams]
Global $chk_cams[$sup_cams][$maxfirm]
Global $cam_status[$sup_cams][$maxfirm]
; ==== 25 should be on the safe side ====
Global $branches[25][7] ; names/paths/versions of CHDK Trac source tree
Global $skip_branch[25][2] ; info on branches to skip
Global $BlackList[2]		; testing new approach for branch checking ...
; variable strings
Global $status, $tip, $UpdateButtonText = "Updates .."
; Handle for the main GUI
Global $main
; 'picture' type control handles
Global $pic, $pic_sat, $pic_card, $pic_search, $pic_cmd, $logo
; 'group' type control handles
Global $cam_group, $trunk_group, $set_group, $status_group
; 'checkbox' type control handles
Global $chk_autocams, $chk_debug, $chk_debug2, $chk_autoerr, $chk_inet, $chk_nosel, $chk_keep_dumps
Global $chk_upd, $chk_trayicon, $chk_comp_full, $chk_tooltips, $chk_comp_all, $chk_comp_abort
; 'button' type control handles
Global $but_comp_all, $but_comp_sel, $but_exit, $ctx_cam_all, $ctx_cam_none, $but_sizer, $but_branch, $but_upd_opt
Global $but_err_show, $but_log_show, $but_go_forum, $but_go_mantis, $but_go_wikia, $but_go_progver, $but_unzip
Global $but_sel_ver, $but_open_src, $but_src_tools, $but_cond_comp, $but_mini, $but_sel_site, $but_debug, $but_def_focus
Global $ctx_cam_vx, $ctx_cam_dry
; other types of control handles
Global $inp_upd, $upd_upd, $new_t, $cur_t, $lab_interval, $lab_upd, $lab_upd2, $lab_both, $lab_time, $lab_space
Global $rad_build[3], $lab_last_check, $lab_runtime, $lab_timerbar, $lab_minitimer, $lab_dock, $ico_clone, $ico_stop
Global $context, $ctx_switch, $ctx_mini, $ctx_reset_opts, $ctx_card, $ctx_verstats, $ctx_ptpcam, $ctx_thanks
Global $ctx_but_forum, $ctx_but_wikia, $ctx_wikia, $ctx_forum[2], $ctx_home[2], $subcon, $ctx_sep[5], $dummy_control
Global $MainControls[37]	; for controls in mainGUI that need to be dis/enabled frequently ...
Global $CtxControls[12]
; for the mini GUI ...
Global $ico_sat, $ico_play, $ico_func, $ico_canon, $but_minigui, $but_minimenu, $but_miniswitch
Global $lab_minicur, $lab_mininew, $lab_minispace, $lab_minitime, $lab_miniupd
Global $lab_miniversion, $lab_miniruntime, $lab_minigreen, $lab_miniboth
Global $minimain = 'MAGIC', $minilogo, $minigraph, $ministatus, $mini_dock
Global $mini_countdown, $mini_countdown2, $mini_countdown3, $mini_countdown4
; new or experimental
Global $AP_xoff = 0, $AP_yoff = 0, $titlebar_size, $cmd_mode, $PTP_base = "", $ptp_ctx_entry = "ptpCamGui", $PID_Thanks = 0
;~ Global $mainH, $mainW, $cardH, $cardW
Global $make_options, $make_uses_options, $Background
Global $Rflag, $ShowSplash	; 24-09-10
Global $Incremental_Lock = 0	; 1-12-10
; for Card MBR manipulation
Global $MBR_buffer[3]
; profiler
Global $maxfuncs = 147
; dummy declarations to suppress warnings
; REAL declares are in 'ToggleProfiling()', ~ @line 6225
Global $_ap_g_iStackSize
Global $_ap_g_iStackIndex
Global $_ap_g_aProfileStore
Global $FuncStore
Global $_ap_g_aFuncStack
Global $tracelog	; handle
Global $Pad		; padding string for logging
Global $OVH		; calculated overhead for 1 profile cycle ( = 1 x _ap_ProfileStart + 1 x _ap_ProfileStop )
Global $StackUsed	; profiler function call stack

#EndRegion
#
#Region ----(no Profile/Trace)------ Oneliners & Generic Mini Funcs ------------------------------

; turns absolute into relative sizes or positions

Func R($size)
	Return Round($w_scaler * $size)
EndFunc   ;==>R

Func X($size)
	If $w_scaler < 1.00 Then Return $size
	Return R($size)
EndFunc

; set internet check flag, run thru interrupt routine

Func TracChecker()
	$last_istate = -1
EndFunc   ;==>TracChecker

Func DoGC()	; #3
	If $ticks_left > 0 Then $ticks_left -= 1
	Update_TimerBar()
	$gc = True
EndFunc   ;==>DoGC

; ============================================

Func IsChecked($control)	; #33
	Return BitAND(GUICtrlRead($control), 1)
EndFunc   ;==>IsChecked
; --------------------------------------------
Func SetTrayIcon()
	Opt("TrayIconHide", 1 - IsChecked($chk_trayicon))
EndFunc   ;==>SetTrayIcon
; --------------------------------------------
Func Do_Dumps()
	SaveSett($chk_keep_dumps, $sections[0], "chk_keep_dumps")
EndFunc   ;==>Do_Dumps
; --------------------------------------------
Func Debug_Controls(ByRef $aHandles, $on_off)
	Local $color = Default
	If $on_off = 1 Then $color = $CP_color[0][1]	;0xFFFF00
	For $i = 1 To $aHandles[0]
		GUICtrlSetBkColor($aHandles[$i], $color)
	Next
EndFunc
; --------------------------------------------
Func Debug_LoopTimer($message)
	Static $loop_timer, $loop_msg, $stat_txt
	If $message <> 0 Then $loop_msg = $message

	Local $pos = WinGetPos($CurrentGUI[0])
	Local $txt = " " & $CurrentGUI[1] & ": Last msg = " & $loop_msg & " [ " & StringFormat("%d", 1000 / TimerDiff($loop_timer)) & " loops/s ] "

	If $txt <> $stat_txt Then
		$stat_txt = $txt
		ToolTip($txt, $pos[0] + X(12), $pos[1] + 15, "", 0, 4)	; $pos[3] - X(5)
	EndIf
	$loop_timer = TimerInit()
EndFunc
; --------------------------------------------
Func Trace_Msg($message)
	Static $loop_msg
	If $message <= 0 Or $message = $loop_msg Then Return
	$loop_msg = $message
	FileWriteLine($tracelog, $Pad & "*** " & $CurrentGUI[1] & ": Last msg = " & $loop_msg)
EndFunc
; --------------------------------------------
Func Set_BGColor()
	Switch $Controls_ShowBG
		Case 0
			GUICtrlSetBkColor(-1, Default)
		Case 1
			GUICtrlSetBkColor(-1, $CP_color[0][1])	; 0xFFFF00 0xCCFFFF
	EndSwitch
EndFunc
; --------------------------------------------
Func CopyStringWord($string, $pos, $sepa)	; #52
	Local $tmp, $output = ""

	For $q = $pos To StringLen($string)
		$tmp = StringMid($string, $q, 1)
		If $tmp = $sepa Then ExitLoop
		$output &= $tmp
	Next
	Return $output
EndFunc   ;==>CopyStringWord
; --------------------------------------------
Func GetWPos()	; #60
	$wpos = WinGetPos($main)
EndFunc   ;==>GetWPos
; --------------------------------------------
Func ReadSett($control, $section, $name, $def = 0)	; #89
	Local $state = 4	 ; $GUI_UNCHECKED = 4

	If IniRead($inifile, $section, $name, $def) = 1 Then $state = 1	 ; $GUI_CHECKED = 1
	GUICtrlSetState($control, $state)
EndFunc   ;==>ReadSett
; --------------------------------------------
Func SaveSett($control, $section, $name)	; #90
	IniWrite($inifile, $section, $name, IsChecked($control))
EndFunc   ;==>SaveSett
; --------------------------------------------
Func GetSVN_Name($which)
	Return StringUpper(StringReplace($VerPaths[$which], "/", ""))
EndFunc
; --------------------------------------------
Func IsMainMinimised()
	Return BitAnd(WinGetState($main), 16) = 16
EndFunc
; --------------------------------------------
Func FormatFreeSpace($free)
	If $free < 1000.0 Then
		Return StringFormat("%#.2f GB", $free)
	Else
		Return StringFormat("%#.4f TB", $free / 1024)
	EndIf
EndFunc
; --------------------------------------------
Func InitMainControls()
	$MainControls[0] = $but_branch
	$MainControls[1] = $but_sizer
	$MainControls[2] = $but_mini
	$MainControls[3] = $but_go_forum
	$MainControls[4] = $but_go_wikia
	$MainControls[5] = $but_go_mantis
	$MainControls[6] = $rad_build[1]
	$MainControls[7] = $rad_build[2]
	$MainControls[8] = $but_sel_ver
	$MainControls[9] = $ico_clone
	$MainControls[10] = $cur_t
	$MainControls[11] = $but_sel_site
	$MainControls[12] = $chk_nosel
	$MainControls[13] = $chk_inet
	$MainControls[14] = $chk_upd
	$MainControls[15] = $but_upd_opt
	$MainControls[16] = $but_log_show
	$MainControls[17] = $but_unzip
	$MainControls[18] = $but_go_progver
	$MainControls[19] = $ico_stop
	$MainControls[20] = $chk_trayicon
	$MainControls[21] = $chk_tooltips
	$MainControls[22] = $chk_debug
	$MainControls[23] = $chk_debug2
	$MainControls[24] = $but_debug
	$MainControls[25] = $pic_card
	$MainControls[26] = $but_err_show
	$MainControls[27] = $but_cond_comp
	$MainControls[28] = $pic_search
	$MainControls[29] = $but_open_src
	$MainControls[30] = $chk_comp_full
	$MainControls[31] = $chk_keep_dumps
	$MainControls[32] = $but_src_tools
	$MainControls[33] = $but_comp_sel
	$MainControls[34] = $pic_cmd
	$MainControls[35] = $but_comp_all
	$MainControls[36] = $but_exit

	$CtxControls[0] = $ctx_verstats
	$CtxControls[1] = $ctx_ptpcam
	$CtxControls[2] = $ctx_thanks
	$CtxControls[3] = $ctx_reset_opts
	$CtxControls[4] = $ctx_cam_dry
	$CtxControls[5] = $ctx_cam_vx
	$CtxControls[6] = $ctx_cam_all
	$CtxControls[7] = $ctx_cam_none
	$CtxControls[8] = $ctx_mini
	$CtxControls[9] = $ctx_card
	$CtxControls[10] = $ctx_switch
EndFunc
; --------------------------------------------
Func DisableMainControls($off)
	Static $current_state = -1

	If $off = $current_state Then Return
	$off *= 64
	For $i = 0 To UBound($MainControls) - 1
		If BitAND(GUICtrlGetState($MainControls[$i]), 128 - $off) = 128 - $off Then
			GUICtrlSetState($MainControls[$i], 64 + $off)	; $GUI_DISABLE = 128, $GUI_ENABLE = 64
		EndIf
	Next
	; make sure branch radio button stays disabled if no branch checking selected
	If $do_branches[$site] < 1 And $off = 0 Then GUICtrlSetState($rad_build[2], 128)
	For $i = 0 To UBound($CtxControls) - 1
		If BitAND(GUICtrlGetState($CtxControls[$i]), 128 - $off) = 128 - $off Then
			GUICtrlSetState($CtxControls[$i], 64 + $off)	; $GUI_DISABLE = 128
		EndIf
	Next
	$current_state = $off / 64
;~ 	If $off Then _ArrayDisplay($MainControls)
EndFunc
; --------------------------------------------
Func DisableCamPanel($off)
	Local $state = 64 + $off * 64	; $GUI_DISABLE = 128 $GUI_ENABLE = 64
	For $c = 0 To $sup_cams - 1
		For $f = 1 To $maxfirm
			GUICtrlSetState($chk_cams[$c][$f - 1], $state)
		Next
	Next
EndFunc
; --------------------------------------------
Func SetIncrementalLockControls()
	If $Incremental_Lock Then
		DisableCamPanel(1)
		DisableMainControls(1)
		; re-enable ONLY "Compile Options", "Compile Selected" and "Exit" buttons ...
		GUICtrlSetState($but_mini, 64)	; $GUI_ENABLED = 64
		GUICtrlSetState($but_err_show, 64)	; $GUI_ENABLED = 64
		GUICtrlSetState($but_open_src, 64)	; $GUI_ENABLED = 64
		GUICtrlSetState($but_cond_comp, 64)	; $GUI_ENABLED = 64
		GUICtrlSetState($but_comp_sel, 64)	; $GUI_ENABLED = 64
		GUICtrlSetData($but_comp_sel, "INCR Compile &Sel")	; change button text ...
		GUICtrlSetColor($but_comp_sel, $red)	; ... and color
		GUICtrlSetState($but_exit, 64)	; $GUI_ENABLED = 64
	Else
		; re-enable ALL buttons
		DisableCamPanel(0)
		DisableMainControls(0)
		GUICtrlSetData($but_comp_sel, "Compile &Selected")	; reset default text
		GUICtrlSetColor($but_comp_sel, -1)	; reset default color
	EndIf
EndFunc
; --------------------------------------------
Func _GUICtrl_NoTabStop()
; Author: Melba23 @ AutoIt forum, from this post:
; http://www.autoitscript.com/forum/topic/123546-disable-tabstop-for-specific-button/page__view__findpost__p__858118
	; $GWL_STYLE = 0xFFFFFFF0, $WS_TABSTOP = 0x00010000
	_WinAPI_SetWindowLong(GUICtrlGetHandle(-1), 0xFFFFFFF0, BitAND(_WinAPI_GetWindowLong(GUICtrlGetHandle(-1), 0xFFFFFFF0), BitNOT(0x00010000)))
EndFunc
; --------------------------------------------
Func _Vista_ICE()
; #FUNCTION#;===============================================================================
; Name...........: _Vista_ICE
; Description ...: Returns 1 if DWM is enabled or 0 if not
; Syntax.........: _Vista_ICE()
; Parameters ....:
; Return values .: Success - Returns 1
;                 Failure - Returns 0
; Author ........: James Brooks
; Modified.......:
; Remarks .......: Thanks to BrettF
;;==========================================================================================
    Local $ICEStruct = DllStructCreate("int;")
    DllCall("dwmapi.dll", "int", "DwmIsCompositionEnabled", "ptr", DllStructGetPtr($ICEStruct))
    If @error Then
        Return 0
    Else
        Return DllStructGetData($ICEStruct, 1)
    EndIf
EndFunc ;==>_Vista_ICE
; --------------------------------------------
Func ResetDynamicArrays($camno, $firmmax)
	Global $cams[$camno][$firmmax + 1] ; cam/firm strings
	Global $cam_props[$camno][2] ; cam properties tooltips for each cam
	Global $firmdup[$camno][3]
	Global $but_cams[$camno]
	Global $dry_cams[$camno]
	Global $chk_cams[$camno][$firmmax]
	Global $cam_status[$camno][$firmmax]
EndFunc
; --------------------------------------------
Func SelectedFirms()
	Local $ret = 0
	For $c = 0 To $sup_cams - 1
		For $f = 1 To $maxfirm
			If IsChecked($chk_cams[$c][$f - 1]) Then $ret += 1
		Next
	Next
	Return $ret
EndFunc
; --------------------------------------------
Func RGBColor($r, $g, $b)
	Return $r * 0x10000 + $g * 0x100 + $b
EndFunc
; --------------------------------------------
Func CollectGarbage()
	Static $skip = $GC_ratio

	If $GC_Flag = 0 Then
		Return
	Else
		$skip -= 1
		If $skip > 0 Then
			Return
		Else
			$skip = $GC_ratio	; reload
		EndIf
	EndIf
	_EmptyWorkingSet()
EndFunc
; --------------------------------------------
Func UpdateCamPanel()
	Local $dummy, $fw = 400

	If $CP_bold[1] = 1 And $CP_bold[3] > 100 * $w_scaler Then $fw += 300

	For $c = 0 To $sup_cams - 1
		If $cams[$c][1] <> "" Then
			$dummy = $cams[$c][0]
			If $CP_bold[2] = 1 Then $dummy = StringUpper($dummy)
			GUICtrlSetData($but_cams[$c], $dummy)
			GUICtrlSetFont($but_cams[$c], $cam_font_size, $fw)
			GUICtrlSetColor($but_cams[$c], $CP_color[1][0])
			GUICtrlSetBkColor($but_cams[$c], $CP_color[1][1])
			For $f = 1 To $maxfirm
				If $cams[$c][$f] = "" Then ExitLoop
				GUICtrlSetFont($chk_cams[$c][$f - 1], $cam_font_size2)
			Next ; $f
		EndIf
	Next ; $c
EndFunc
; --------------------------------------------
Func UpdateCamPanel_Tip()
	$cam_font_size2 = $firm_font_perc * $cam_font_size / 100.0
	$tip = 	"   Normal GUI font size  = " & StringFormat("%#.1f", $f_normal) & " (100.0%)" & @CRLF
	$tip &= "     Cam panel font size = " & StringFormat("%#.1f", $cam_font_size) & " ("
	$tip &= StringFormat("%#.1f", 100 * (Round($cam_font_size, 1) / $f_normal) ) & "%)" & @CRLF
	$tip &= "      Checkbox font size = " & StringFormat("%#.1f", $cam_font_size2) & " ("
	$tip &= StringFormat("%#.1f", 100 * (Round($cam_font_size2, 1) / $f_normal) ) & "%)" & @CRLF
	$tip &= "Cam panel row spacing = " & $cam_row_spacing & " (" & StringFormat("%#.1f", 100 * ($cam_row_spacing / R(19))) & "%)"
EndFunc
; --------------------------------------------
Func UpdateMaxSearch()
	For $i = 0 To 1
		If $MaxBuild[$i] > $MaxSearch[$i] - 100  Or ($MaxSearch[$i] = 9999 And $MaxBuild[$i] > $MinBuild[$i]) Then
			$MaxSearch[$i] = $MaxBuild[$i] + 100
			IniWrite($inifile, $sections[1], "maxsearch" & $i, $MaxSearch[$i])
		EndIf
	Next
EndFunc
; --------------------------------------------
Func ResetIncState($path, $verbose = True)
	Local $dummy
	If $verbose Then
		Local $ret = Dlg_MyMsgBox(1,"Reset build options to SVN defaults ?", "Applies to: " & $path & @CR & @CR & "- Use only to prepare the build for SVN upload" & @CR & "- (Re)Opening it in CHDK-Shell will UNDO this", 0, $main)
		If $ret = 2 Then Return
	EndIf
	; reset version.inc and buildconf.inc & remove files created by CHDK-Shell
	FileDelete($path & "\camprops_xref.log")
	FileDelete($path & "\conditional.txt")
	FileDelete($path & "\released@.txt")
	FileDelete($path & "\localbuildconf.inc")
	If $site = 0 Then
		FileMove($path & "\version.inc.org", $path & "\version.inc", 1)
	Else
		$dummy = FileRead($sourcedir & "\buildconf.inc")
		$dummy = StringReplace($dummy, "DEF_SVN_REF=" & $LongBuildName, "DEF_SVN_REF=0")
		If StringInStr($dummy, "DEF_SVN_REF=") Then
			FileDelete($sourcedir & "\buildconf.inc")
			FileWrite($sourcedir & "\buildconf.inc", $dummy)
		EndIf
	EndIf
EndFunc
; --------------------------------------------
Func Run_Thanks()
	Local $path = $subdir & "\guest\thanks"
	GUICtrlSetState($ico_stop, 16) ; $GUI_SHOW = 16
	$PID_Thanks = Run( @AutoItExe & " /AutoIt3ExecuteScript " & $path & "\Thanks.au3", $path)
EndFunc
; --------------------------------------------
Func Run_ptpCamGui()
	Local $param = ""	; , $err_flag = False
	Local $campath = $subdir & "\guest\ptpCamGui"
	Local $camgui = $campath & "\ptpCamGui_Obfuscated.au3"

	If FileExists($camgui) Then
		If @Compiled Then $param &= "/AutoIt3ExecuteScript "
		Run( @AutoItExe & " " & $param & $camgui, $campath)
	EndIf
EndFunc
; --------------------------------------------
Func Check_ptpCamGui()
	Local $camgui = "ptpCamGui_Obfuscated.au3"

	If Not FileExists($subdir & "\guest\ptpCamGui\" & $camgui) Then
		If $no_ptpcamgui_dl = 0 Then Dlg_MyMsgBox(0, "File not found", $camgui & @CR & "not found - maybe download problems ?" & @CR & "Try exiting/restarting CHDK-Shell." )
		GUICtrlSetState($ctx_ptpcam, 128) ; $GUI_DISABLE = 128
	EndIf
EndFunc
; --------------------------------------------
Func CheckWGet()
	Local $idx = 1, $current[2], $old = "GNU Wget 1.9.1", $new = "GNU Wget 1.11.4"
	Local $wgv[2], $devkit_path[2] = [ $GCC3path, $GCC4path ], $version_report[2] = [ "\wgv3.txt", "\wgv4.txt" ]

	Local $splash_state = $ShowSplash

	; get installed versions
	For $i = 0 To 1
		RunWait($SysComSpec & " /c wget --version >" & $subdir & $version_report[$i], $devkit_path[$i], $State_Hide)
		$wgv[$i] = FileRead($subdir & $version_report[$i])
		If StringInStr($wgv[$i], $old) Then
			$current[$i] = $old
		ElseIf StringInStr($wgv[$i], $new) Then
			$current[$i] = $new
		EndIf
		FileDelete($subdir & $version_report[$i])
	Next

	If FileExists($subdir & "\wget.exe") Then
		$ShowSplash = 1
		AutoSplash("Updating WGET .....", 1)
		For $i = 0 To 1
			If $current[$i] = $old Then
				FileMove($devkit_path[$i] & "\wget.exe", $devkit_path[$i] & "\wget.exe.191", 1)
				FileCopy($subdir & "\wget.exe", $devkit_path[$i] & "\wget.exe", 1)
				FileCopy($devkit_path[$i] & "\WGETRC", $devkit_path[$i] & "\wget.ini", 1)
			EndIf
		Next
		FileMove($subdir & "\wget.exe", $subdir & "\wget.exe.1114", 1)
		; get new versions
		For $i = 0 To 1
			RunWait($SysComSpec & " /c wget --version >" & $subdir & $version_report[$i], $devkit_path[$i], $State_Hide)
			$wgv[$i] = FileRead($subdir & $version_report[$i])
			If StringInStr($wgv[$i], $old) Then
				$current[$i] = $old
			ElseIf StringInStr($wgv[$i], $new) Then
				$current[$i] = $new
			EndIf
			FileDelete($subdir & $version_report[$i])
		Next
	EndIf

	$WGet_Ver = $current

	If $GCCpath = $GCC3path Then $idx = 0
	Switch $current[$idx]
		Case $new
			If Not StringInStr($wget_options, " --no-check-certificate") Then
				$wget_options &= " --no-check-certificate"
			EndIf
		Case $old
			If StringInStr($wget_options, " --no-check-certificate") Then
				$wget_options = "--no-http-keep-alive"
			EndIf
	EndSwitch

	If $wget_options <> IniRead($inifile, $sections[0], "wget_options", "--no-http-keep-alive") Then
		IniWrite($inifile, $sections[0], "wget_options", $wget_options)
	EndIf
	$ShowSplash = $splash_state
EndFunc
; --------------------------------------------
Func ConditionalRunWait($wait, $prm1, $prm2, $prm3)
	Local $ret

	If $wait = 0 Then
		$ret = Run($prm1, $prm2, $prm3)
	Else
		$ret = RunWait($prm1, $prm2, $prm3)
	EndIf
	Return $ret
EndFunc
; --------------------------------------------
Func SilentDosExec($command, $wd = $sourcedir)
	Local $state = $State_Hide
	If IsChecked($chk_debug2) Then $state = $State_Show
	Return RunWait($SysComSpec & " /c " & $command, $wd, $state)
EndFunc
; --------------------------------------------
Func Add2Blacklist($name)
	If Not StringInStr($BlackList[$site], $name) Then
		$BlackList[$site] &= "*" & $name
		If StringLeft($BlackList[$site], 1) = "*" Then $BlackList[$site] = StringTrimLeft($BlackList[$site], 1)
	EndIf
EndFunc
; --------------------------------------------

#EndRegion
#
#Region ---------------------------- Includes ... ------------------------------------------------

;~ #include <Process.au3>
;~ #include <File.au3>
;~ #include <Array.au3>  ; needed for _ArrayDisplay
;~ #include <Date.au3>
;~ #include <GDIPlus.au3>
;~ #include <String.au3>

Func _StringBetween($s_String, $s_Start, $s_End, $v_Case = -1)
	Local $s_case = ""
	If $v_Case = Default Or $v_Case = -1 Then $s_case = "(?i)"
	Local $s_pattern_escape = "(\.|\||\*|\?|\+|\(|\)|\{|\}|\[|\]|\^|\$|\\)"
	$s_Start = StringRegExpReplace($s_Start, $s_pattern_escape, "\\$1")
	$s_End = StringRegExpReplace($s_End, $s_pattern_escape, "\\$1")
	If $s_Start = "" Then $s_Start = "\A"
	If $s_End = "" Then $s_End = "\z"
	Local $a_ret = StringRegExp($s_String, "(?s)" & $s_case & $s_Start & "(.*?)" & $s_End, 3)
	If @error Then Return SetError(1, 0, 0)
	Return $a_ret
EndFunc

Func _StringRepeat($sString, $iRepeatCount)
	Local $sResult
	Select
		Case Not StringIsInt($iRepeatCount)
			SetError(1)
			Return ""
		Case StringLen($sString) < 1
			SetError(1)
			Return ""
		Case $iRepeatCount <= 0
			SetError(1)
			Return ""
		Case Else
			For $iCount = 1 To $iRepeatCount
				$sResult &= $sString
			Next
			Return $sResult
	EndSelect
EndFunc

Func _FileReadToArray($sFilePath, ByRef $aArray)
_ap_ProfileStart(1)
	Local $hFile = FileOpen($sFilePath, 0)

	If $hFile = -1 Then
_ap_ProfileStop(1)
		Return SetError(1, 0, 0)
	EndIf
	Local $aFile = FileRead($hFile, FileGetSize($sFilePath))
	If StringRight($aFile, 1) = @LF Then $aFile = StringTrimRight($aFile, 1)
	If StringRight($aFile, 1) = @CR Then $aFile = StringTrimRight($aFile, 1)
	FileClose($hFile)
	If StringInStr($aFile, @LF) Then
		$aArray = StringSplit(StringStripCR($aFile), @LF)
	ElseIf StringInStr($aFile, @CR) Then
		$aArray = StringSplit($aFile, @CR)
	Else
		If StringLen($aFile) Then
			Dim $aArray[2] = [1, $aFile]
		Else
_ap_ProfileStop(1)
			Return SetError(2, 0, 0)
		EndIf
	EndIf
_ap_ProfileStop(1)
	Return 1
EndFunc

Func _FileWriteFromArray($File, $a_Array, $i_Base = 0, $i_UBound = 0, $s_Delim = "|")
	; Check if we have a valid array as input
	If Not IsArray($a_Array) Then Return SetError(2, 0, 0)
	Local $iDims = UBound($a_Array, 0)
	If $iDims > 2 Then Return SetError(4, 0, 0)

	; determine last entry
	Local $last = UBound($a_Array) - 1
	If $i_UBound < 1 Or $i_UBound > $last Then $i_UBound = $last
	If $i_Base < 0 Or $i_Base > $last Then $i_Base = 0

	; Open output file for overwrite by default, or use input file handle if passed
	Local $hFile
	If IsString($File) Then
		$hFile = FileOpen($File, 2)
	Else
		$hFile = $File
	EndIf
	If $hFile = -1 Then Return SetError(1, 0, 0)

	; Write array data to file
	Local $ErrorSav = 0
	Switch $iDims
		Case 1
			For $x = $i_Base To $i_UBound
				If FileWrite($hFile, $a_Array[$x] & @CRLF) = 0 Then
					$ErrorSav = 3
					ExitLoop
				EndIf
			Next
		Case 2
			Local $s_Temp
			For $x = $i_Base To $i_UBound
				$s_Temp = $a_Array[$x][0]
				For $y = 1 To $iDims
					$s_Temp &= $s_Delim & $a_Array[$x][$y]
				Next
				If FileWrite($hFile, $s_Temp & @CRLF) = 0 Then
					$ErrorSav = 3
					ExitLoop
				EndIf
			Next
	EndSwitch

	; Close file only if specified by a string path
	If IsString($File) Then FileClose($hFile)

	; Return results
	If $ErrorSav Then Return SetError($ErrorSav, 0, 0)
	Return 1
EndFunc   ;==>_FileWriteFromArray

Func _ArrayDisplay(Const ByRef $avArray, $sTitle = "Array: ListView Display", $iItemLimit = -1, $iTranspose = 0, $sSeparator = "", $sReplace = "|", $sHeader = "")
_ap_ProfileStart(2)
	If Not IsArray($avArray) Then
_ap_ProfileStop(2)
		Return SetError(1, 0, 0)
	EndIf
	Local $iDimension = UBound($avArray, 0), $iUBound = UBound($avArray, 1) - 1, $iSubMax = UBound($avArray, 2) - 1
	Local $Calling_GUI = $CurrentGUI

	If $iDimension > 2 Then
_ap_ProfileStop(2)
		Return SetError(2, 0, 0)
	EndIf
	If $sSeparator = "" Then $sSeparator = Chr(124)
	If _ArraySearch($avArray, $sSeparator, 0, 0, 0, 1) <> -1 Then
		For $x = 1 To 255
			If $x >= 32 And $x <= 127 Then ContinueLoop
			Local $sFind = _ArraySearch($avArray, Chr($x), 0, 0, 0, 1)
			If $sFind = -1 Then
				$sSeparator = Chr($x)
				ExitLoop
			EndIf
		Next
	EndIf
	Local $vTmp, $iBuffer = 64
	Local $iColLimit = 250
	Local $iOnEventMode = Opt("GUIOnEventMode", 0), $sDataSeparatorChar = Opt("GUIDataSeparatorChar", $sSeparator)
	If $iSubMax < 0 Then $iSubMax = 0
	If $iTranspose Then
		$vTmp = $iUBound
		$iUBound = $iSubMax
		$iSubMax = $vTmp
	EndIf
	If $iSubMax > $iColLimit Then $iSubMax = $iColLimit
	If $iItemLimit < 1 Then $iItemLimit = $iUBound
	If $iUBound > $iItemLimit Then $iUBound = $iItemLimit
	If $sHeader = "" Then
		$sHeader = "Row  "
		For $i = 0 To $iSubMax
			$sHeader &= $sSeparator & "Col " & $i
		Next
	EndIf
	Local $avArrayText[$iUBound + 1]
	For $i = 0 To $iUBound
		$avArrayText[$i] = "[" & $i & "]"
		For $j = 0 To $iSubMax
			If $iDimension = 1 Then
				If $iTranspose Then
					$vTmp = $avArray[$j]
				Else
					$vTmp = $avArray[$i]
				EndIf
			Else
				If $iTranspose Then
					$vTmp = $avArray[$j][$i]
				Else
					$vTmp = $avArray[$i][$j]
				EndIf
			EndIf
			$vTmp = StringReplace($vTmp, $sSeparator, $sReplace, 0, 1)
			$avArrayText[$i] &= $sSeparator & $vTmp
			$vTmp = StringLen($vTmp)
			If $vTmp > $iBuffer Then $iBuffer = $vTmp
		Next
	Next
	$iBuffer += 1
	Local Const $_ARRAYCONSTANT_tagLVITEM = "int Mask;int Item;int SubItem;int State;int StateMask;ptr Text;int TextMax;int Image;int Param;int Indent;int GroupID;int Columns;ptr pColumns"
	Local $iAddMask = BitOR(0x1, 0x4)
	Local $tBuffer = DllStructCreate("wchar Text[" & $iBuffer & "]"), $pBuffer = DllStructGetPtr($tBuffer)
	Local $tItem = DllStructCreate($_ARRAYCONSTANT_tagLVITEM), $pItem = DllStructGetPtr($tItem)
	DllStructSetData($tItem, "Param", 0)
	DllStructSetData($tItem, "Text", $pBuffer)
	DllStructSetData($tItem, "TextMax", $iBuffer)
	Local $iWidth = 640, $iHeight = 480
	Local $hGUI = GUICreate($sTitle, $iWidth, $iHeight, Default, Default, BitOR(0x00040000, 0x00020000, 0x00010000))
	Local $aiGUISize = WinGetClientSize($hGUI)
	Local $hListView = GUICtrlCreateListView($sHeader, 0, 0, $aiGUISize[0], $aiGUISize[1] - 26, 0x8)
	Local $hCopy = GUICtrlCreateButton("Copy Selected", 3, $aiGUISize[1] - 23, $aiGUISize[0] - 6, 20)
	GUICtrlSetResizing($hListView, 0x66)
	GUICtrlSetResizing($hCopy, 0x246)
	GUICtrlSendMsg($hListView, 0x1036, 0x1, 0x1)
	GUICtrlSendMsg($hListView, 0x1036, 0x20, 0x20)
	GUICtrlSendMsg($hListView, 0x1036, 0x0200, 0x0200)
	Local $aItem
	For $i = 0 To $iUBound
		If GUICtrlCreateListViewItem($avArrayText[$i], $hListView) = 0 Then
			$aItem = StringSplit($avArrayText[$i], $sSeparator)
			DllStructSetData($tBuffer, "Text", $aItem[1])
			DllStructSetData($tItem, "Item", $i)
			DllStructSetData($tItem, "SubItem", 0)
			DllStructSetData($tItem, "Mask", $iAddMask)
			GUICtrlSendMsg($hListView, 0x104D, 0, $pItem)
			DllStructSetData($tItem, "Mask", 0x1)
			For $j = 2 To $aItem[0]
				DllStructSetData($tBuffer, "Text", $aItem[$j])
				DllStructSetData($tItem, "SubItem", $j - 1)
				GUICtrlSendMsg($hListView, 0x104C, 0, $pItem)
			Next
		EndIf
	Next
	$iWidth = 0
	For $i = 0 To $iSubMax + 1
		$iWidth += GUICtrlSendMsg($hListView, 0x101D, $i, 0)
	Next
	If $iWidth < 250 Then $iWidth = 230
	$iWidth += 20
	If $iWidth > @DesktopWidth Then $iWidth = @DesktopWidth - 100
	WinMove($hGUI, "",(@DesktopWidth - $iWidth)/2, Default, $iWidth)
	GUISetState(@SW_SHOW, $hGUI)
	$CurrentGUI[0] = $hGUI
	$CurrentGUI[1] = "ArrayDisplay"
_ap_ProfileStop(2)
	Local $a_msg
	While 1
			; added 26-04-11, make function yield / modded 26-06-11
		$a_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($a_msg)
		If WinActive($main) Then WinActivate($hGUI)
		Switch $a_msg
			Case 0
				$activity = $mtim
				If $gc = True Then Clean()
				Sleep(300)
				ContinueLoop
			Case -3
				If IsChecked($chk_debug2) Then ToolTip("")
				ExitLoop
			Case $hCopy
				Local $sClip = ""
				Local $aiCurItems[1] = [0]
				For $i = 0 To GUICtrlSendMsg($hListView, 0x1004, 0, 0)
					If GUICtrlSendMsg($hListView, 0x102C, $i, 0x2) Then
						$aiCurItems[0] += 1
						ReDim $aiCurItems[$aiCurItems[0] + 1]
						$aiCurItems[$aiCurItems[0]] = $i
					EndIf
				Next
				If Not $aiCurItems[0] Then
					For $sItem In $avArrayText
						$sClip &= $sItem & @CRLF
					Next
				Else
					For $i = 1 To UBound($aiCurItems) - 1
						$sClip &= $avArrayText[$aiCurItems[$i]] & @CRLF
					Next
				EndIf
				ClipPut($sClip)
		EndSwitch
	WEnd
	GUIDelete($hGUI)
	$CurrentGUI = $Calling_GUI
	Opt("GUIOnEventMode", $iOnEventMode)
	Opt("GUIDataSeparatorChar", $sDataSeparatorChar)
	Return 1
EndFunc

Func _ArrayReverse(ByRef $avArray, $iStart = 0, $iEnd = 0)
_ap_ProfileStart(3)
	If Not IsArray($avArray) Then
_ap_ProfileStop(3)
		Return SetError(1, 0, 0)
	EndIf
	If UBound($avArray, 0) <> 1 Then
_ap_ProfileStop(3)
		Return SetError(3, 0, 0)
	EndIf
	Local $vTmp, $iUBound = UBound($avArray) - 1
	If $iEnd < 1 Or $iEnd > $iUBound Then $iEnd = $iUBound
	If $iStart < 0 Then $iStart = 0
	If $iStart > $iEnd Then
_ap_ProfileStop(3)
		Return SetError(2, 0, 0)
	EndIf
	For $i = $iStart To Int(($iStart + $iEnd - 1) / 2)
		$vTmp = $avArray[$i]
		$avArray[$i] = $avArray[$iEnd]
		$avArray[$iEnd] = $vTmp
		$iEnd -= 1
	Next
_ap_ProfileStop(3)
	Return 1
EndFunc

Func _ArraySearch(Const ByRef $avArray, $vValue, $iStart = 0, $iEnd = 0, $iCase = 0, $iPartial = 0, $iForward = 1, $iSubItem = -1)
_ap_ProfileStart(4)
	If Not IsArray($avArray) Then
_ap_ProfileStop(4)
		Return SetError(1, 0, -1)
	EndIf
	If UBound($avArray, 0) > 2 Or UBound($avArray, 0) < 1 Then
_ap_ProfileStop(4)
		Return SetError(2, 0, -1)
	EndIf
	Local $iUBound = UBound($avArray) - 1
	If $iEnd < 1 Or $iEnd > $iUBound Then $iEnd = $iUBound
	If $iStart < 0 Then $iStart = 0
	If $iStart > $iEnd Then
_ap_ProfileStop(4)
		Return SetError(4, 0, -1)
	EndIf
	Local $iStep = 1
	If Not $iForward Then
		Local $iTmp = $iStart
		$iStart = $iEnd
		$iEnd = $iTmp
		$iStep = -1
	EndIf
	Switch UBound($avArray, 0)
		Case 1
			If Not $iPartial Then
				If Not $iCase Then
					For $i = $iStart To $iEnd Step $iStep
						If $avArray[$i] = $vValue Then
_ap_ProfileStop(4)
							Return $i
						EndIf
					Next
				Else
					For $i = $iStart To $iEnd Step $iStep
						If $avArray[$i] == $vValue Then
_ap_ProfileStop(4)
							Return $i
						EndIf
					Next
				EndIf
			Else
				For $i = $iStart To $iEnd Step $iStep
					If StringInStr($avArray[$i], $vValue, $iCase) > 0 Then
_ap_ProfileStop(4)
						Return $i
					EndIf
				Next
			EndIf
		Case 2
			Local $iUBoundSub = UBound($avArray, 2) - 1
			If $iSubItem > $iUBoundSub Then $iSubItem = $iUBoundSub
			If $iSubItem < 0 Then
				$iSubItem = 0
			Else
				$iUBoundSub = $iSubItem
			EndIf
			For $j = $iSubItem To $iUBoundSub
				If Not $iPartial Then
					If Not $iCase Then
						For $i = $iStart To $iEnd Step $iStep
							If $avArray[$i][$j] = $vValue Then
_ap_ProfileStop(4)
								Return $i
							EndIf
						Next
					Else
						For $i = $iStart To $iEnd Step $iStep
							If $avArray[$i][$j] == $vValue Then
_ap_ProfileStop(4)
								Return $i
							EndIf
						Next
					EndIf
				Else
					For $i = $iStart To $iEnd Step $iStep
						If StringInStr($avArray[$i][$j], $vValue, $iCase) > 0 Then
_ap_ProfileStop(4)
							Return $i
						EndIf
					Next
				EndIf
			Next
		Case Else
_ap_ProfileStop(4)
			Return SetError(7, 0, -1)
	EndSwitch
_ap_ProfileStop(4)
	Return SetError(6, 0, -1)
EndFunc

Func _ArraySort(ByRef $avArray, $iDescending = 0, $iStart = 0, $iEnd = 0, $iSubItem = 0)
_ap_ProfileStart(5)
	If Not IsArray($avArray) Then
_ap_ProfileStop(5)
		Return SetError(1, 0, 0)
	EndIf
	Local $iUBound = UBound($avArray) - 1
	If $iEnd < 1 Or $iEnd > $iUBound Then $iEnd = $iUBound
	If $iStart < 0 Then $iStart = 0
	If $iStart > $iEnd Then
_ap_ProfileStop(5)
		Return SetError(2, 0, 0)
	EndIf
	Switch UBound($avArray, 0)
		Case 1
			__ArrayQuickSort1D($avArray, $iStart, $iEnd)
			If $iDescending Then _ArrayReverse($avArray, $iStart, $iEnd)
		Case 2
			Local $iSubMax = UBound($avArray, 2) - 1
			If $iSubItem > $iSubMax Then
_ap_ProfileStop(5)
				Return SetError(3, 0, 0)
			EndIf
			If $iDescending Then
				$iDescending = -1
			Else
				$iDescending = 1
			EndIf
			__ArrayQuickSort2D($avArray, $iDescending, $iStart, $iEnd, $iSubItem, $iSubMax)
		Case Else
_ap_ProfileStop(5)
			Return SetError(4, 0, 0)
	EndSwitch
_ap_ProfileStop(5)
	Return 1
EndFunc

Func __ArrayQuickSort1D(ByRef $avArray, ByRef $iStart, ByRef $iEnd)
	If $iEnd <= $iStart Then Return
	Local $vTmp
	If($iEnd - $iStart) < 15 Then
		Local $vCur
		For $i = $iStart + 1 To $iEnd
			$vTmp = $avArray[$i]
			If IsNumber($vTmp) Then
				For $j = $i - 1 To $iStart Step -1
					$vCur = $avArray[$j]
					If($vTmp >= $vCur And IsNumber($vCur)) Or(Not IsNumber($vCur) And StringCompare($vTmp, $vCur) >= 0) Then ExitLoop
					$avArray[$j + 1] = $vCur
				Next
			Else
				For $j = $i - 1 To $iStart Step -1
					If(StringCompare($vTmp, $avArray[$j]) >= 0) Then ExitLoop
					$avArray[$j + 1] = $avArray[$j]
				Next
			EndIf
			$avArray[$j + 1] = $vTmp
		Next
		Return
	EndIf
	Local $L = $iStart, $R = $iEnd, $vPivot = $avArray[Int(($iStart + $iEnd) / 2)], $fnum = IsNumber($vPivot)
	Do
		If $fnum Then
			While($avArray[$L] < $vPivot And IsNumber($avArray[$L])) Or(Not IsNumber($avArray[$L]) And StringCompare($avArray[$L], $vPivot) < 0)
				$L += 1
			WEnd
			While($avArray[$R] > $vPivot And IsNumber($avArray[$R])) Or(Not IsNumber($avArray[$R]) And StringCompare($avArray[$R], $vPivot) > 0)
				$R -= 1
			WEnd
		Else
			While(StringCompare($avArray[$L], $vPivot) < 0)
				$L += 1
			WEnd
			While(StringCompare($avArray[$R], $vPivot) > 0)
				$R -= 1
			WEnd
		EndIf
		If $L <= $R Then
			$vTmp = $avArray[$L]
			$avArray[$L] = $avArray[$R]
			$avArray[$R] = $vTmp
			$L += 1
			$R -= 1
		EndIf
	Until $L > $R
	__ArrayQuickSort1D($avArray, $iStart, $R)
	__ArrayQuickSort1D($avArray, $L, $iEnd)
EndFunc

Func __ArrayQuickSort2D(ByRef $avArray, ByRef $iStep, ByRef $iStart, ByRef $iEnd, ByRef $iSubItem, ByRef $iSubMax)
	If $iEnd <= $iStart Then Return
	Local $vTmp, $L = $iStart, $R = $iEnd, $vPivot = $avArray[Int(($iStart + $iEnd) / 2)][$iSubItem], $fnum = IsNumber($vPivot)
	Do
		If $fnum Then
			While($iStep *($avArray[$L][$iSubItem] - $vPivot) < 0 And IsNumber($avArray[$L][$iSubItem])) Or(Not IsNumber($avArray[$L][$iSubItem]) And $iStep * StringCompare($avArray[$L][$iSubItem], $vPivot) < 0)
				$L += 1
			WEnd
			While($iStep *($avArray[$R][$iSubItem] - $vPivot) > 0 And IsNumber($avArray[$R][$iSubItem])) Or(Not IsNumber($avArray[$R][$iSubItem]) And $iStep * StringCompare($avArray[$R][$iSubItem], $vPivot) > 0)
				$R -= 1
			WEnd
		Else
			While($iStep * StringCompare($avArray[$L][$iSubItem], $vPivot) < 0)
				$L += 1
			WEnd
			While($iStep * StringCompare($avArray[$R][$iSubItem], $vPivot) > 0)
				$R -= 1
			WEnd
		EndIf
		If $L <= $R Then
			For $i = 0 To $iSubMax
				$vTmp = $avArray[$L][$i]
				$avArray[$L][$i] = $avArray[$R][$i]
				$avArray[$R][$i] = $vTmp
			Next
			$L += 1
			$R -= 1
		EndIf
	Until $L > $R
	__ArrayQuickSort2D($avArray, $iStep, $iStart, $R, $iSubItem, $iSubMax)
	__ArrayQuickSort2D($avArray, $iStep, $L, $iEnd, $iSubItem, $iSubMax)
EndFunc

Func _WinAPI_CloseHandle($hObject)
	Local $aResult = DllCall("kernel32.dll", "bool", "CloseHandle", "handle", $hObject)
	If @error Then
		Return SetError(@error, @extended, False)
	EndIf
	Return $aResult[0]
EndFunc

;~ Func _WinAPI_CreateFileEx($sFile, $iCreation, $iAccess, $iShare, $iFlagsAndAttributes = 0, $tSecurity = 0, $hTemplate = 0)
;~ 	Local $Ret = DllCall('kernel32.dll', 'ptr', 'CreateFileW', 'wstr', $sFile, 'dword', $iAccess, 'dword', $iShare, 'ptr', DllStructGetPtr($tSecurity), 'dword', $iCreation, 'dword', $iFlagsAndAttributes, 'ptr', $hTemplate)
;~ 	If(@error) Or($Ret[0] = Ptr(-1)) Then
;~ 		Return SetError(1, 0, 0)
;~ 	EndIf
;~ 	Return $Ret[0]
;~ EndFunc

Func _WinAPI_CreateCompatibleDC($hDC)
_ap_ProfileStart(6)
	Local $aResult = DllCall("gdi32.dll", "handle", "CreateCompatibleDC", "handle", $hDC)
_ap_ProfileStop(6)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc

Func _WinAPI_DeleteDC($hDC)
_ap_ProfileStart(7)
	Local $aResult = DllCall("gdi32.dll", "bool", "DeleteDC", "handle", $hDC)
_ap_ProfileStop(7)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

Func _WinAPI_DeleteObject($hObject)
_ap_ProfileStart(8)
	Local $aResult = DllCall("gdi32.dll", "bool", "DeleteObject", "handle", $hObject)
_ap_ProfileStop(8)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

;~ Func _WinAPI_FlushFileBuffers($hFile)
;~ 	Local $aResult = DllCall("kernel32.dll", "bool", "FlushFileBuffers", "handle", $hFile)
;~ 	If @error Then Return SetError(@error, @extended, False)
;~ 	Return $aResult[0]
;~ EndFunc

Func _WinAPI_GetDC($hWnd)
_ap_ProfileStart(9)
	Local $aResult = DllCall("user32.dll", "handle", "GetDC", "hwnd", $hWnd)
_ap_ProfileStop(9)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc

Func __Ver()
	Local $tOS = DllStructCreate('dword[5];wchar[128]')
	DllStructSetData($tOS, 1, DllStructGetSize($tOS), 1)
	Local $Ret = DllCall('kernel32.dll', 'int', 'GetVersionExW', 'ptr', DllStructGetPtr($tOS))
	If(Not @error) And($Ret[0]) Then
		Return BitOR(BitShift(DllStructGetData($tOS, 1, 2), -8), DllStructGetData($tOS, 1, 3))
	Else
		Return 0
	EndIf
EndFunc

Func _WinAPI_GetProcessTimes($PID = 0)
	If Not $PID Then
		Return SetError(1, 0, 0)
	EndIf

	Local $Access
	If $WinVer < 0x0600 Then
		$Access = 0x00000400
	Else
		$Access = 0x00001000
	EndIf

	Local $hProcess = DllCall('kernel32.dll', 'ptr', 'OpenProcess', 'dword', $Access, 'int', 0, 'dword', $PID)

	If @error Or (Not $hProcess[0]) Then
		Return SetError(1, 0, 0)
	EndIf

	Local $tFILETIME = DllStructCreate("dword Lo;dword Hi")
	Local $Ret = DllCall('kernel32.dll', 'int', 'GetProcessTimes', 'ptr', $hProcess[0], 'ptr', DllStructGetPtr($tFILETIME), 'uint64*', 0, 'uint64*', 0, 'uint64*', 0)

	If @error Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf

	_WinAPI_CloseHandle($hProcess[0])

	If Not IsArray($Ret) Then
		Return SetError(1, 0, 0)
	EndIf
	Local $Result[3]
	$Result[0] = $tFILETIME
	$Result[1] = $Ret[4]
	$Result[2] = $Ret[5]
	Return $Result
EndFunc

Func _WinAPI_GetWindowLong($hWnd, $iIndex)
_ap_ProfileStart(10)
	Local $sFuncName = "GetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "GetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex)
_ap_ProfileStop(10)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_GetWindowLong

;~ Func _WinAPI_ReadFile($hFile, $pBuffer, $iToRead, ByRef $iRead, $pOverlapped = 0)
;~ 	Local $aResult = DllCall("kernel32.dll", "bool", "ReadFile", "handle", $hFile, "ptr", $pBuffer, "dword", $iToRead, "dword*", 0, "ptr", $pOverlapped)
;~ 	If @error Then Return SetError(@error, @extended, False)
;~ 	$iRead = $aResult[4]
;~ 	Return $aResult[0]
;~ EndFunc

Func _WinAPI_ReleaseDC($hWnd, $hDC)
_ap_ProfileStart(11)
	Local $aResult = DllCall("user32.dll", "int", "ReleaseDC", "hwnd", $hWnd, "handle", $hDC)
_ap_ProfileStop(11)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

Func _WinAPI_SelectObject($hDC, $hGDIObj)
_ap_ProfileStart(12)
	Local $aResult = DllCall("gdi32.dll", "handle", "SelectObject", "handle", $hDC, "handle", $hGDIObj)
_ap_ProfileStop(12)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

Func _WinAPI_SetLastError($iErrCode, $curErr=@error, $curExt=@extended)
_ap_ProfileStart(13)
	DllCall("kernel32.dll", "none", "SetLastError", "dword", $iErrCode)
_ap_ProfileStop(13)
	Return SetError($curErr, $curExt)
EndFunc   ;==>_WinAPI_SetLastError

Func _WinAPI_SetWindowLong($hWnd, $iIndex, $iValue)
_ap_ProfileStart(14)
	_WinAPI_SetLastError(0)	; as suggested in MSDN
	Local $sFuncName = "SetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "SetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex, "long_ptr", $iValue)
_ap_ProfileStop(14)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_SetWindowLong

; from WinAPI.au3 @ AutoIt 3.3.7.10 -> "Execute" removed
;~ Func _WinAPI_SetLayeredWindowAttributes($hWnd, $i_transcolor, $Transparency = 255, $dwFlags = 0x03, $isColorRef = False)
;~ 	If $dwFlags = Default Or $dwFlags = "" Or $dwFlags < 0 Then $dwFlags = 0x03
;~ 	If Not $isColorRef Then
;~ 		$i_transcolor = Int(BinaryMid($i_transcolor, 3, 1) & BinaryMid($i_transcolor, 2, 1) & BinaryMid($i_transcolor, 1, 1))
;~ 	EndIf
;~ 	Local $aResult = DllCall("user32.dll", "bool", "SetLayeredWindowAttributes", "hwnd", $hWnd, "dword", $i_transcolor, "byte", $Transparency, "dword", $dwFlags)
;~ 	If @error Then Return SetError(@error, @extended, False)
;~ 	Return $aResult[0]
;~ EndFunc   ;==>_WinAPI_SetLayeredWindowAttributes

Func _WinAPI_UpdateLayeredWindow($hWnd, $hDCDest, $pPTDest, $pSize, $hDCSrce, $pPTSrce, $iRGB, $pBlend, $iFlags)
_ap_ProfileStart(15)
	Local $aResult = DllCall("user32.dll", "bool", "UpdateLayeredWindow", "hwnd", $hWnd, "handle", $hDCDest, "ptr", $pPTDest, "ptr", $pSize, "handle", $hDCSrce, "ptr", $pPTSrce, "dword", $iRGB, "ptr", $pBlend, "dword", $iFlags )
_ap_ProfileStop(15)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0]
EndFunc

;~ Func _WinAPI_WriteFile($hFile, $pBuffer, $iToWrite, ByRef $iWritten, $pOverlapped = 0)
;~ 	Local $aResult = DllCall("kernel32.dll", "bool", "WriteFile", "handle", $hFile, "ptr", $pBuffer, "dword", $iToWrite, "dword*", 0, "ptr", $pOverlapped)
;~ 	If @error Then Return SetError(@error, @extended, False)
;~ 	$iWritten = $aResult[4]
;~ 	Return $aResult[0]
;~ EndFunc

Func _DateIsLeapYear($iYear)
_ap_ProfileStart(16)
	If StringIsInt($iYear) Then
		Select
			Case Mod($iYear, 4) = 0 And Mod($iYear, 100) <> 0
_ap_ProfileStop(16)
				Return 1
			Case Mod($iYear, 400) = 0
_ap_ProfileStop(16)
				Return 1
			Case Else
_ap_ProfileStop(16)
				Return 0
		EndSelect
	EndIf
_ap_ProfileStop(16)
	Return SetError(1,0,0)
EndFunc

Func _DateIsValid($sDate)
_ap_ProfileStart(17)
	Local $asDatePart[4], $asTimePart[4]
	Local $sDateTime = StringSplit($sDate, " T")

	If $sDateTime[0] > 0 Then $asDatePart = StringSplit($sDateTime[1], "/-.")
	If 	UBound($asDatePart) <> 4 Or $asDatePart[0] <> 3 Or Not StringIsInt($asDatePart[1]) Or Not StringIsInt($asDatePart[2]) Or Not StringIsInt($asDatePart[3]) Then
_ap_ProfileStop(17)
		Return 0
	EndIf
	$asDatePart[1] = Number($asDatePart[1])
	$asDatePart[2] = Number($asDatePart[2])
	$asDatePart[3] = Number($asDatePart[3])
	Local $iNumDays = _DaysInMonth($asDatePart[1])
	If 	$asDatePart[1] < 1000 Or $asDatePart[1] > 2999 Or $asDatePart[2] < 1 Or $asDatePart[2] > 12 Or $asDatePart[3] < 1 Or $asDatePart[3] > $iNumDays[$asDatePart[2]] Then
_ap_ProfileStop(17)
		Return 0
	EndIf
	If $sDateTime[0] > 1 Then
		$asTimePart = StringSplit($sDateTime[2], ":")
		If UBound($asTimePart) < 4 Then ReDim $asTimePart[4]
	Else
		Dim $asTimePart[4]
	EndIf
	If $asTimePart[0] < 1 Then
_ap_ProfileStop(17)
		Return 1
	EndIf
	If $asTimePart[0] < 2 Then
_ap_ProfileStop(17)
		Return 0
	EndIf
	If $asTimePart[0] = 2 Then $asTimePart[3] = "00"
	If 	Not StringIsInt($asTimePart[1]) Or Not StringIsInt($asTimePart[2]) Or Not StringIsInt($asTimePart[3]) Then
_ap_ProfileStop(17)
		Return 0
	EndIf
	$asTimePart[1] = Number($asTimePart[1])
	$asTimePart[2] = Number($asTimePart[2])
	$asTimePart[3] = Number($asTimePart[3])
	If 	$asTimePart[1] < 0 Or $asTimePart[1] > 23 Or $asTimePart[2] < 0 Or $asTimePart[2] > 59 Or $asTimePart[3] < 0 Or $asTimePart[3] > 59 Then
_ap_ProfileStop(17)
		Return 0
	EndIf
_ap_ProfileStop(17)
	Return 1
EndFunc

Func _DateToDayValue($iYear, $iMonth, $iDay)
_ap_ProfileStart(18)
	If Not _DateIsValid(StringFormat("%04d/%02d/%02d", $iYear, $iMonth, $iDay)) Then
_ap_ProfileStop(18)
		Return SetError(1,0,"")
	EndIf
	If $iMonth < 3 Then
		$iMonth = $iMonth + 12
		$iYear = $iYear - 1
	EndIf
	Local $i_aFactor = Int($iYear / 100)
	Local $i_bFactor = Int($i_aFactor / 4)
	Local $i_cFactor = 2 - $i_aFactor + $i_bFactor
	Local $i_eFactor = Int(1461 *($iYear + 4716) / 4)
	Local $i_fFactor = Int(153 *($iMonth + 1) / 5)
	Local $iJulianDate = $i_cFactor + $iDay + $i_eFactor + $i_fFactor - 1524.5
_ap_ProfileStop(18)
	Return($iJulianDate)
EndFunc

Func _DaysInMonth($iYear)
	Local $aiDays[13] = [ 0, 31,28,31,30,31,30,31,31,30,31,30,31]
	If _DateIsLeapYear($iYear) Then $aiDays[2] = 29
	Return $aiDays
EndFunc

;~ Func _StringRepeat($sString, $iRepeatCount)
;~ _ap_ProfileStart(19)
;~ 	Local $sResult
;~ 	For $iCount = 1 To $iRepeatCount
;~ 		$sResult &= $sString
;~ 	Next
;~ _ap_ProfileStop(19)
;~ 	Return $sResult
;~ EndFunc

Func _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
_ap_ProfileStart(20)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipCreateBitmapFromGraphics", "int", $iWidth, "int", $iHeight, "handle", $hGraphics, "ptr*", 0)
_ap_ProfileStop(20)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aResult[0], $aResult[4])
EndFunc

Func _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmap, $iARGB = 0xFF000000)
_ap_ProfileStart(21)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipCreateHBITMAPFromBitmap", "handle", $hBitmap, "ptr*", 0, "dword", $iARGB)
_ap_ProfileStop(21)
	If @error Then Return SetError(@error, @extended, 0)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc

Func _GDIPlus_GraphicsDispose($hGraphics)
_ap_ProfileStart(22)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipDeleteGraphics", "handle", $hGraphics)
_ap_ProfileStop(22)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0] = 0
EndFunc

Func _GDIPlus_GraphicsDrawImageRect($hGraphics, $hImage, $iX, $iY, $iW, $iH)
_ap_ProfileStart(23)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipDrawImageRectI", "handle", $hGraphics, "handle", $hImage, "int", $iX, "int", $iY, "int", $iW, "int", $iH)
_ap_ProfileStop(23)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0] = 0
EndFunc

Func _GDIPlus_ImageDispose($hImage)
_ap_ProfileStart(24)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipDisposeImage", "handle", $hImage)
_ap_ProfileStop(24)
	If @error Then Return SetError(@error, @extended, False)
	Return $aResult[0] = 0
EndFunc

Func _GDIPlus_ImageGetGraphicsContext($hImage)
_ap_ProfileStart(25)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipGetImageGraphicsContext", "handle", $hImage, "ptr*", 0)
_ap_ProfileStop(25)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc

Func _GDIPlus_ImageLoadFromFile($sFileName)
_ap_ProfileStart(26)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdipLoadImageFromFile", "wstr", $sFileName, "ptr*", 0)
_ap_ProfileStop(26)
	If @error Then Return SetError(@error, @extended, -1)
	Return SetExtended($aResult[0], $aResult[2])
EndFunc

Func _GDIPlus_Startup()
_ap_ProfileStart(27)
	$giGDIPRef += 1
	If $giGDIPRef > 1 Then
		$giGDIPRef -= 1
_ap_ProfileStop(27)
		Return True
	EndIf
	$ghGDIPDll = DllOpen("GDIPlus.dll")
	If $ghGDIPDll = -1 Then Return SetError(1, 2, False)
	Local $tInput = DllStructCreate("uint Version;ptr Callback;bool NoThread;bool NoCodecs")
	Local $tToken = DllStructCreate("ulong_ptr Data")
	DllStructSetData($tInput, "Version", 1)
	Local $aResult = DllCall($ghGDIPDll, "int", "GdiplusStartup", "ptr", DllStructGetPtr($tToken), "ptr", DllStructGetPtr($tInput), "ptr", 0)
	If @error Then
_ap_ProfileStop(27)
		Return SetError(@error, @extended, False)
	EndIf
	$giGDIPToken = DllStructGetData($tToken, "Data")
_ap_ProfileStop(27)
	Return $aResult[0] = 0
EndFunc

Func _GDIPlus_Shutdown()
_ap_ProfileStart(28)
	If $ghGDIPDll = 0 Then
_ap_ProfileStop(28)
		Return SetError(-1, -1, False)
	EndIf
	$giGDIPRef -= 1
	If $giGDIPRef = 0 Then
		DllCall($ghGDIPDll, "none", "GdiplusShutdown", "ptr", $giGDIPToken)
		DllClose($ghGDIPDll)
		$ghGDIPDll = 0
	EndIf
_ap_ProfileStop(28)
	Return True
EndFunc   ;==>_GDIPlus_Shutdown

#EndRegion
#
#Region ---------------------------- Non-UDF external Functions ----------------------------------

Func _EmptyWorkingSet()
_ap_ProfileStart(29)
	; Author: ?  from AutoIt forum: http://www.autoitscript.com/forum/index.php?act=idx
	DllCall("psapi.dll", "int", "EmptyWorkingSet", "hwnd", $ThisProcess[0])
	If @error Then
		DllCall("kernel32.dll", "int", "K32EmptyWorkingSet", "hwnd", $ThisProcess[0])
	EndIf
_ap_ProfileStop(29)
EndFunc   ;==>_EmptyWorkingSet
; --------------------------------------------
Func _SetBitMap ( $hGUI, $hImage, $iOpacity, $n_width, $n_height )
_ap_ProfileStart(30)
    Local $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend
    $hScrDC = _WinAPI_GetDC ( 0 )
    $hMemDC = _WinAPI_CreateCompatibleDC ( $hScrDC )
    $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap ( $hImage )
    $hOld = _WinAPI_SelectObject ( $hMemDC, $hBitmap )
    $tSize = DllStructCreate ( $tagSIZE )	; $tagSIZE = "long X;long Y"
    $pSize = DllStructGetPtr ( $tSize )
    DllStructSetData ( $tSize, "X", $n_width )
    DllStructSetData ( $tSize, "Y", $n_height )
    $tSource = DllStructCreate ( $tagPOINT )	; $tagPOINT = "long X;long Y"
    $pSource = DllStructGetPtr ( $tSource )
    $tBlend = DllStructCreate ( $tagBLENDFUNCTION )	; $tagBLENDFUNCTION = "byte Op;byte Flags;byte Alpha;byte Format"
    $pBlend = DllStructGetPtr ( $tBlend )
    DllStructSetData ( $tBlend, "Alpha", $iOpacity )
    DllStructSetData ( $tBlend, "Format", 1 )
    _WinAPI_UpdateLayeredWindow ( $hGUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, 0x02 ) ; $ULW_ALPHA = 0x02
    _WinAPI_ReleaseDC ( 0, $hScrDC )
    _WinAPI_SelectObject ( $hMemDC, $hOld )
    _WinAPI_DeleteObject ( $hBitmap )
    _WinAPI_DeleteDC ( $hMemDC )
	_GDIPlus_ImageDispose ( $hImage )
_ap_ProfileStop(30)
EndFunc ;==> _SetBitMap ( )

Func _ImageResize ( $sInImage, $newW, $newH )
_ap_ProfileStart(31)
    Local $oldImage, $GC, $newBmp, $newGC
    _GDIPlus_Startup ( )
    $oldImage = _GDIPlus_ImageLoadFromFile ( $sInImage )
    $GC = _GDIPlus_ImageGetGraphicsContext ( $oldImage )
    $newBmp = _GDIPlus_BitmapCreateFromGraphics ( $newW, $newH, $GC )
    $newGC = _GDIPlus_ImageGetGraphicsContext ( $newBmp )
    _GDIPlus_GraphicsDrawImageRect ( $newGC, $oldImage, 0, 0, $newW, $newH )
    _GDIPlus_GraphicsDispose ( $GC )
    _GDIPlus_GraphicsDispose ( $newGC )
    _GDIPlus_ImageDispose ( $oldImage )
_ap_ProfileStop(31)
    Return $newBmp
EndFunc ;==> _ImageResize ( )
; --------------------------------------------
Func _FileInUse($sFilename)
_ap_ProfileStart(32)
	; author: Siao, from AutoIt forum: http://www.autoitscript.com/forum/index.php?act=idx
    Local $aRet, $hFile
    $aRet = DllCall("Kernel32.dll", "hwnd", "CreateFile", "str", $sFilename, "dword", 0x80000000, "dword", 0, "dword", 0, "dword", 3, "dword", 128, "hwnd", 0)
    $hFile = $aRet[0]
    If $hFile = -1 Then ;INVALID_HANDLE_VALUE = -1
        $aRet = DllCall("Kernel32.dll", "int", "GetLastError")
        SetError($aRet[0])
_ap_ProfileStop(32)
        Return 1
    Else
        DllCall("Kernel32.dll", "int", "CloseHandle", "hwnd", $hFile)
_ap_ProfileStop(32)
        Return 0
    EndIf
EndFunc   ;==>_FileInUse
; --------------------------------------------
Func _GuiRoundCorners($h_win, $i_x1, $i_y1, $i_x3, $i_y3)
_ap_ProfileStart(33)
	; Author: gafrost
    Local $XS_pos, $XS_ret
    $XS_pos = WinGetPos($h_win)
    $XS_ret = DllCall("gdi32.dll", "long", "CreateRoundRectRgn", "long", $i_x1, "long", $i_y1, "long", $XS_pos[2], "long", $XS_pos[3], "long", $i_x3, "long", $i_y3)
    If $XS_ret[0] Then
        DllCall("user32.dll", "long", "SetWindowRgn", "hwnd", $h_win, "long", $XS_ret[0], "int", 1)	; $XS_ret2 =
    EndIf
	; modified to return window position
_ap_ProfileStop(33)
	Return $XS_pos
EndFunc  ;==>_GuiRoundCorners

#EndRegion
#
#Region ---------------------------- Main GUI Functions ------------------------------------------

Func Build_GUI()
_ap_ProfileStart(34)
	Local $ypos, $groupsize, $firmlabel, $cam_row_height, $cam_xoff, $fw = 400, $chk_title

	; set global value for left margin in right panel
	$LM = 20 + $cam_columns * $ccs

	; some size housekeeping ... this is getting way out of hand LOL
	If @DesktopHeight < R($w_ch) + $ovh_h Or @DesktopWidth < R($w_cw) + $ovh_w Then SelectLocalBuild(1, $sourcedir)

	$f_small = 7.0 * $f_scaler
	$f_normal = 8.5 * $f_scaler
	$f_large = 10.0 * $f_scaler
	$f_xxl = 20.0 * $f_scaler

	; ------------------------------------------------------
	$cam_font_size = $f_normal

	If $cam_row_spacing < R(19) Then
		$cam_row_height = $cam_row_spacing - 1
	Else
		$cam_row_height = R(18)
	EndIf

	If $CP_bold[3] > 100 * $w_scaler Then ; is winsize < threshold ?
		If $CP_bold[0] = 1 Then $fw = 700
	EndIf
	; create dummy GUI to check what fontsize is acceptable for buttons ...
	Local $test, $dummy, $wtxt, $testGUI	; , $htxt
	$testGUI = GUICreate("", 300, 100, -1, -1, $WS_CAPTION + $WS_SYSMENU + $WS_MINIMIZEBOX)
	GUISetState($State_Hide, $testGUI)
	While 1
		GUISetFont($cam_font_size, $fw, 1, "Tahoma", $testGUI)
		$wtxt = 0
		For $c = 0 To $sup_cams - 1
			$test = GUICtrlCreateLabel(StringUpper($cams[$c][0]), 10, 10)
			$dummy = ControlGetPos($testGUI, "", $test)
			GUICtrlDelete($test)
			If $dummy[2] > $wtxt Then $wtxt = $dummy[2]
		Next
		If $wtxt < R($cambutton_size) Then ExitLoop		;  And $htxt <= $cam_row_height
		$cam_font_size *= 0.98
	WEnd
	GUIDelete($testGUI)
	; ---------------------------------------------------------

	If WinExists($main) Then
		If $w_animate Then MainSlideOut()
		GUIDelete($pic)
		GUIDelete($main)
		ToolTip("")
		;CollectGarbage()
	EndIf
	; if width has changed thru cam pane resize AND pivot point is top or bottom right, adjust window x coord ...
	; $w_cw & $w_cw0 are ONLY changed by calls to GetLocalBuild()
	If $w_cw <> $w_cw0 And ( $PivIndex = 1 Or $PivIndex = 3 ) Then $wpos[0] -= R($w_cw - $w_cw0)

	If $w_sticky = 0 Then
		$wpos[0] = -1
		$wpos[1] = -1
	EndIf
	If $w_screensnap = 1 Then
		If $wpos[0] < -1  Then $wpos[0] = 0
		If $wpos[1] < -1  Then $wpos[1] = 0
		If $wpos[0] > @DesktopWidth - R($w_cw) Then $wpos[0] = @DesktopWidth - R($w_cw)
		If $wpos[1] > @DesktopHeight - R($w_ch) Then $wpos[1] = @DesktopHeight - R($w_ch)
	EndIf

	; cam select boxes, optimal spacing now calc'd in 'SelectLocalBuild'

	; ============================ the main window frame ============================
	; 0x00CA0000 = $WS_CAPTION (0x00C00000) + $WS_SYSMENU (0x00080000) + $WS_MINIMIZEBOX (0x00020000)
	$main = GUICreate($Title, R($w_cw), R($w_ch), $wpos[0], $wpos[1], $WS_CAPTION + $WS_SYSMENU + $WS_MINIMIZEBOX)
	GUISetFont($f_normal, 400, 1, "Tahoma")
	; calc titlebar height, added 18-12-10
	GetWPos()
	$titlebar_size = $wpos[3] - R($w_ch)
	; ===============================================================================

	; --------------- Camera & Firmware group ------------------------------------------------
	$cam_group = GUICtrlCreateGroup("", R(5), 0, R($cam_columns * $ccs), R($w_ch - 2))
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	UpdateCamPanel_Tip()
	$sup_firms = 0
	$ypos = R(12) + Round($cam_row_spacing / 2)
	$cam_xoff = 0
	; this loop draws all controls on the camera panel
	; Note: $cams array was filled before by reading a Makefile in 'SelectLocalBuild' function
	For $c = 0 To $sup_cams - 1
		If $cams[$c][1] <> "" Then
			$dummy = $cams[$c][0]
			If $CP_bold[2] = 1 Then $dummy = StringUpper($dummy)
			$but_cams[$c] = GUICtrlCreateButton($dummy, R(12 + $cam_xoff), $ypos, R($cambutton_size), $cam_row_height, BitOr(0, 0x8000, 0x0C00) )
			GUICtrlSetFont(-1, $cam_font_size, $fw)
			GUICtrlSetColor(-1, $CP_color[0][0])
			GUICtrlSetBkColor(-1, $CP_color[0][1])
			GUICtrlSetTip(-1, "Show camera properties", StringUpper($cams[$c][0]), 1, 0)
			For $f = 1 To $maxfirm
				If $cams[$c][$f] = "" Then ExitLoop
				$sup_firms += 1
				$firmlabel = StringLeft($cams[$c][$f], 3) & " " & StringRight($cams[$c][$f], 1)
				$chk_title = StringUpper($cams[$c][0] & " - " & StringLeft($cams[$c][$f], 3) & " " & StringRight($cams[$c][$f], 1))
				If $cam_status[$c][$f - 1] <> "" Then $chk_title &= " (" & $cam_status[$c][$f - 1]
				If StringRight($chk_title, 2) = ", " Then $chk_title = StringReplace($chk_title, ", ", ")")
				$chk_cams[$c][$f - 1] = GUICtrlCreateCheckbox(StringUpper($firmlabel),	R(15 + $cambutton_size + $cam_xoff) + ($f - 1) * R($cb_slot - 1), $ypos, R($cb_slot - 3), $cam_row_height )
				GUICtrlSetTip(-1, "Turn compilation for this camera firmware on/off", $chk_title, 1, 0)
				GUICtrlSetFont(-1, $cam_font_size2)
				Set_BGColor()
			Next ; $f
			$ypos += $cam_row_spacing
			If $ypos > R($w_ch - 3) - $cam_row_spacing Then
				$cam_xoff += $ccs - 6
				$ypos = R(12) + Round($cam_row_spacing / 2)
			EndIf
		EndIf
	Next ; $c
	; now we've got required data, set group title and add the buttons
	GUICtrlSetData($cam_group,	"Cameras (" & $sup_cams & ") / firmwares (" & $sup_firms & ") for ." & StringTrimLeft($sourcedir, StringLen($here)))
	; ------------------- Context Menu  -------------------------------------------------------------------
	$context = GUICtrlCreateContextMenu()
	$ctx_verstats = GUICtrlCreateMenuItem("Version Statistics ...", $context)
	GUICtrlCreateMenuItem("", $context)
	$subcon = GUICtrlCreateMenu("Guests", $context)
	$ctx_ptpcam = GUICtrlCreateMenuItem($ptp_ctx_entry, $subcon)
	$ctx_thanks = GUICtrlCreateMenuItem("Thanks !", $context)
	GUICtrlCreateMenuItem("", $context)
	$ctx_reset_opts = GUICtrlCreateMenuItem("Reset Build Options ...", $context)
	GUICtrlCreateMenuItem("", $context)
	$ctx_cam_dry = GUICtrlCreateMenuItem("Select All DryOS firmwares", $context)
	$ctx_cam_vx = GUICtrlCreateMenuItem("Select All VxWorks firmwares", $context)
	GUICtrlCreateMenuItem("", $context)
	$ctx_cam_all = GUICtrlCreateMenuItem("Select All firmwares", $context)
	$ctx_cam_none = GUICtrlCreateMenuItem("Deselect All firmwares", $context)
	GUICtrlCreateMenuItem("", $context)
	$ctx_mini = GUICtrlCreateMenuItem("miniGUI", $context)
	$ctx_card = GUICtrlCreateMenuItem("Card menu", $context)
	$ctx_switch = GUICtrlCreateMenuItem("Switch Sites", $context)
	; -------------------- Top Display 'Group' ----------------------------------------------------------
	GUICtrlCreateIcon($icons & "\au3_logo.ico", -1, R($LM + 130), R(60), R(32), R(32))	; R($LM + 115), R(45), R(64), R(64)
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$but_branch = GUICtrlCreateButton("&Branches ..", R($LM), R(2), R(80), R(22))	; y = 5, h = 20
	$AccelMain[0][0] = "!b"
	$AccelMain[0][1] = $but_branch
	$but_sizer = GUICtrlCreateButton("&GUI ..", R($LM + 140), R(2), R(55), R(22))
	$AccelMain[1][0] = "!g"
	$AccelMain[1][1] = $but_sizer

	$but_mini = GUICtrlCreateIcon($arr_icon[$PivIndex], -1, R($LM + 197), 0, R(32), R(32))
	_GUICtrl_NoTabStop()
	$AccelMain[2][0] = "!d"
	$AccelMain[2][1] = $but_mini
	$lab_minitimer = GUICtrlCreateLabel("", R($LM + 200), R(28), R(29), R(12))
	If $w_minitimer = 1 Then
		GUICtrlSetData(-1, ($mtim * $Timer_Interval / 60) & " m")
		Set_BGColor()
	EndIf
	GUICtrlSetColor(-1, $seagreen)

	$but_go_forum =		GUICtrlCreateButton( "Forum",	R($LM + 230),	 R(3), R(45), R(18) )
	$ctx_but_forum = GUICtrlCreateContextMenu($but_go_forum)
	$ctx_forum[0] = GUICtrlCreateMenuItem("English Forum", $ctx_but_forum)
	$ctx_forum[1] = GUICtrlCreateMenuItem("Forum Deutsch", $ctx_but_forum)
	GUICtrlCreateMenuItem("", $ctx_but_forum)
	$ctx_home[0] = GUICtrlCreateMenuItem("CHDK-Shell Home (en)", $ctx_but_forum)
	$ctx_home[1] = GUICtrlCreateMenuItem("   ~~~   Fragen (de)", $ctx_but_forum)

	$but_go_wikia =		GUICtrlCreateButton( "Wiki",	R($LM + 230),	R(24), R(45), R(18) )
	$ctx_but_wikia = GUICtrlCreateContextMenu($but_go_wikia)

	$ctx_wikia = GUICtrlCreateMenuItem("CHDK-Shell Wiki", $ctx_but_wikia)

	$but_go_mantis =	GUICtrlCreateButton( "Mantis",	R($LM + 230),	R(45), R(45), R(18) )
	$rad_build[1] = 	GUICtrlCreateRadio( "trunk",	R($LM), 		R(65), R(60), R(15) )
	GUICtrlSetFont(-1, $f_normal, 700)
	Set_BGColor()
	$rad_build[2] = 	GUICtrlCreateRadio( $DefBranch[$site], R($LM),	R(40), R(100), R(15) )	; 72
	GUICtrlSetFont(-1, $f_normal, 700)
	Set_BGColor()

	$but_sel_ver =		GUICtrlCreateButton( "Change",	R($LM),			R(91), R(60), R(22) )
	GUICtrlSetFont(-1, $f_normal, 700)

	$lab_last_check = GUICtrlCreateLabel( "Last Check", R($LM + 215+2),	R(66), R(60), R(14), 0x0102  ) ; 220
	Set_BGColor()
	$lab_time = 		GUICtrlCreateLabel( "",			R($LM + 225+2), 	R(83), R(50), R(14), 0x0102  )	; 55
	GUICtrlSetColor(-1, $blue)
	Set_BGColor()
	$lab_runtime = 		GUICtrlCreateLabel( "",			R($LM + 177),	R(101), R(100), R(12), 0x0102 )	; $SS_RIGHT = 0x0002
	GUICtrlSetFont(-1, $f_small)
	Set_BGColor()
	UpdateLastCheck()
	$ico_clone = GUICtrlCreateIcon($icons & "\clone.ico", -1, R($LM - 13), R(123),  R(16), R(16) )
	_GUICtrl_NoTabStop()
	$cur_t =	GUICtrlCreateLabel( $LongBuildName,			  R($LM + 5),  R(115), R(198), R(34) )	; 218
	If $LongBuildName = $NewestBuild Then GUICtrlSetColor(-1, $seagreen)
	Set_BGColor()
	GUICtrlSetFont(-1, $f_xxl, 700 )
	$new_t = GUICtrlCreateLabel( "", R($LM + 206), R(115), R(70), R(34), 0x0102 )	; $SS_RIGHT = 0x0002
	GUICtrlSetFont(-1, $f_xxl, 700)
	GUICtrlSetColor(-1, $red)
	Set_BGColor()

	; parametrizing eases changes to the real groups
	$ypos = R(150)
	$groupsize = R(165)
	; ------------------- SVN Source Options Group ---------------------------------------------------
	$trunk_group = GUICtrlCreateGroup("SVN Source Options", R($LM), $ypos, R(275), $groupsize)
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$but_sel_site = GUICtrlCreateButton("Set SVN Site ..", R($LM + 141), $ypos, R(95), R(20) )
	$lab_both = GUICtrlCreateLabel("2", R($LM + 250), $ypos, R(12), R(20), 0x01)
	GUICtrlSetFont(-1, $f_large, 700)
	Set_BGColor()
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	$pic_sat = GUICtrlCreateIcon($icons & "\sat.ico", -1, R($LM + 238), $ypos - R(5), R(32), R(32), -1)
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	$chk_nosel = GUICtrlCreateCheckbox("Make downloaded new builds current", R($LM + 15), $ypos + R(20), R(235), R(20))
	Set_BGColor()
	$chk_inet = GUICtrlCreateCheckbox("Allow Internet (checks SVN at startup)", R($LM + 15), $ypos + R(45), R(250), R(20))
	Set_BGColor()
	If Not $NetConnected[$site] Then GUICtrlSetBkColor(-1, $orange)
	$chk_upd = GUICtrlCreateCheckbox("Check every", R($LM + 35), $ypos + R(72), R(105), R(18))
	Set_BGColor()
	$inp_upd = GUICtrlCreateInput("30", R($LM + 143), $ypos + R(70), R(50), R(20), 0x2001)
	$upd_upd = GUICtrlCreateUpdown($inp_upd, 0x20)
	GUICtrlSetLimit(-1, 360, 3) ; set min / max recheck periods here
	$lab_interval = GUICtrlCreateLabel("minutes", R($LM + 200), $ypos + R(73), R(55), R(18), 0)
	Set_BGColor()
	$lab_upd = GUICtrlCreateLabel($txt_process[$w_upd], R($LM + 143), $ypos + R(93), R(125), R(16) )
	Set_BGColor()
	$lab_upd2 = GUICtrlCreateLabel("AutoCompile: " & $txt_autcomp[$w_auto], R($LM + 143), $ypos + R(110), R(125), R(16) )
	Set_BGColor()
	$but_upd_opt = GUICtrlCreateButton("SVN Options ..",	R($LM + 35), $ypos + R(100), R(100), R(22) )
	$but_log_show = GUICtrlCreateButton("Update Log ..",		R($LM + 35), $ypos + R(135), R(100), R(22) )
	$but_unzip = GUICtrlCreateButton("Unzip Archive ..",	   R($LM + 141), $ypos + R(135),  R(95), R(22) )
	$lab_dock = GUICtrlCreateLabel("", R($LM) + R(275) - R(5), $ypos + R(5), R(7), R(7))
	GUICtrlSetBkColor(-1, $red)
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	$lab_timerbar = GUICtrlCreateLabel("", R($LM) + R(275) - 1, $ypos + R(8), 1, R(155)  )
	GUICtrlSetBkColor(-1, $seagreen)
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	; -------------------------------------------------------------------------------------------------
	$ypos += $groupsize + 10
	$groupsize = R(130)	; 110
	; --------- Program Options Group -----------------------------------------------------------------
	$set_group = GUICtrlCreateGroup("Program Options", R($LM), $ypos, R(275), $groupsize)
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$but_go_progver = GUICtrlCreateButton($UpdateButtonText, R($LM + 141), $ypos - R(2), R(95), R(22) )
	If $ulink <> "" Then
		GUICtrlSetColor(-1, $red)
		GUICtrlSetData(-1, "Get v" & $uver)
	EndIf
	$ico_stop = GUICtrlCreateIcon(@SystemDir & "\shell32.dll", -28, R($LM - 55), $ypos + R(25),  R(32), R(32) )	; $icons & "\stop.ico", -1
	If $PID_Thanks = 0 Then GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	_GUICtrl_NoTabStop()
	$chk_autocams = GUICtrlCreateCheckbox("Remember Camera/Firmware Selections",R($LM + 15), $ypos + R(22), R(250), R(20) )
	Set_BGColor()
	$chk_autoerr = GUICtrlCreateCheckbox("AutoShow Error Log (unless empty)",	R($LM + 15), $ypos + R(48), R(250), R(20) )
	Set_BGColor()
	$chk_trayicon = GUICtrlCreateCheckbox("Tray Icon", R($LM + 15), $ypos + R(74), R(120), R(20) )
	Set_BGColor()
	$chk_tooltips = GUICtrlCreateCheckbox("Tooltips", R($LM + 141), $ypos + R(74),  R(87), R(20) )
	Set_BGColor()
	$chk_debug = GUICtrlCreateCheckbox("Cmd windows",  R($LM + 15), $ypos + R(100), R(120), R(20), 0x0006 )
	Set_BGColor()
	$chk_debug2 = GUICtrlCreateCheckbox("", R($LM + 141), $ypos + R(100),  R(16), R(20) )
	Set_BGColor()
	If $Introspection = 1 Then GUICtrlSetState(-1, 164) ; $GUI_DISABLE = 128, $GUI_HIDE = 32, $GUI_UNCHECKED = 4
	$but_debug = GUICtrlCreateButton("Debug ..", R($LM + 161), $ypos + R(99),  R(55), R(22) )	; 159
	$pic_card = GUICtrlCreateIcon($icons & "\card2.ico", -1, R($LM + 234), $ypos + R(78), R(33), R(43) )
	_GUICtrl_NoTabStop()
	$AccelMain[3][0] = "!c"
	$AccelMain[3][1] = $pic_card
	; -------------------------------------------------------------------------------------------------
	$ypos += $groupsize + 10 ; 385 ? 465
	; -------------------- Status Group ---------------------------------------------------------------
	$status_group = GUICtrlCreateGroup("Status", R($LM), $ypos, R(275), R(90) )
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$status = GUICtrlCreateLabel($ready, R($LM + 10), $ypos + R(20), R(257), R(38), $SS_SUNKEN )
	GUICtrlSetFont(-1, $f_large, 700)
	GUICtrlCreateLabel("Disk Free", R($LM + 130), $ypos + R(64), R(55), R(14), 0 )
	GUICtrlSetFont(-1, $f_normal)
	Set_BGColor()
	$lab_space = GUICtrlCreateLabel(FormatFreeSpace($diskfreespace), R($LM + 185), $ypos + R(64), R(82), R(15), 0x0102 + $SS_SUNKEN )
	GUICtrlSetFont(-1, $f_normal)
	GUICtrlSetColor(-1, $blue)
	; compilation Abort checkbox moved to more 'logical' place + added Bkg. colour
	$chk_comp_abort = GUICtrlCreateCheckbox("Abort@next", R($LM + 20), $ypos + R(64), R(103), R(14) ) ;R(150) + R(20), R(60), R(20) )
	GUICtrlSetBkColor(-1, $orange)
	GUICtrlSetFont(-1, $f_normal, 700)
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	$but_err_show = GUICtrlCreateButton("Error Log", R($LM + 10), $ypos + R(62), R(115), R(20) )
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
	$but_cond_comp = GUICtrlCreateButton("Compile &Options ..", R($LM + 10), $ypos + R(105), R(115), R(22) )
	$AccelMain[5][0] = "!o"
	$AccelMain[5][1] = $but_cond_comp
	$pic_search = GUICtrlCreateIcon($icons & "\search.ico", -1, R($LM + 130), $ypos + R(107), R(24), R(24) )
	_GUICtrl_NoTabStop()
	$but_open_src = GUICtrlCreateButton("Source Code &Folder", R($LM + 160), $ypos + R(105), R(115), R(22) )
	$AccelMain[4][0] = "!f"
	$AccelMain[4][1] = $but_open_src
	$chk_comp_full = GUICtrlCreateCheckbox("'full' compile", R($LM + 15), $ypos + R(143), R(125), R(20) )	; 115
	Set_BGColor()
	$chk_keep_dumps = GUICtrlCreateCheckbox("ELF objdump", R($LM + 15), $ypos + R(168), R(125), R(20) )	; 115
	Set_BGColor()
	$but_src_tools = GUICtrlCreateButton("Source &Tools ..", R($LM + 160), $ypos + R(153), R(115), R(22) )
	$AccelMain[6][0] = "!t"
	$AccelMain[6][1] = $but_src_tools
	; -------------------- compile & exit buttons -------------------------------------------
	$but_comp_sel = GUICtrlCreateButton("Compile &Selected", R($LM), R($w_ch - 65), R(125), R(25) )	; R(625)
	$AccelMain[7][0] = "!s"
	$AccelMain[7][1] = $but_comp_sel
	$pic_cmd = GUICtrlCreateIcon($icons & "\cmd.ico", -1, R($LM + 130), R($w_ch - 65), R(24), R(24) )	; R(625)
	_GUICtrl_NoTabStop()
	$chk_comp_all = GUICtrlCreateCheckbox("", R($LM + 160), R($w_ch - 65), R(18), R(25) )	; R(625)
	Set_BGColor()
	$but_comp_all = GUICtrlCreateButton("Compile &All", R($LM + 182), R($w_ch - 65), R(93), R(25) )	; R(625)
	$AccelMain[8][0] = "!a"
	$AccelMain[8][1] = $but_comp_all
	$but_exit = GUICtrlCreateButton("Exit (or press Esc)", R($LM), R($w_ch - 30), R(275), R(25) )	; R(660)

	InitMainControls()
	UpdateDynamicControls()
	; this must be last, or GUI will mess up
	SetLogo() ; initialise the logo

	SwitchGUI($miniGUI)
	Set_Tooltips()
	GetCamProperties($w_propsortalpha)

	SplashOff()

	If $InstallFlag > 9 Then Dlg_Welcome()
	If $checkcompile = 1 Then AutoCompile()
_ap_ProfileStop(34)
EndFunc   ;==>Build_GUI
; --------------------------------------------
Func CreateMiniGUI()
_ap_ProfileStart(35)
	Local $barsize, $_s = $CBFN & @CRLF, $delta_x = 0, $delta_y = 0

	If FileExists($sourcedir & "\version.inc") Then
		$_s &= FileReadLine($sourcedir & "\version.inc")
	Else
		$_s &= "no BUILDNUMBER detected"
	EndIf

	If $PivIndex = 1 Or $PivIndex = 3 Then $delta_x = R($w_cw) - 230	; 225
	If $PivIndex = 2 Or $PivIndex = 3 Then $delta_y = R($w_ch) - 127

	$minimain = GUICreate("", 215, $mini_height, $wpos[0] + $delta_x + 5, $wpos[1] + $delta_y + 10, $WS_POPUP, $WS_EX_TOOLWINDOW)
	GUISetFont(7)
	GUICtrlCreateLabel("GDIPLUS.DLL", 153, 0, 60, 10)
	GUICtrlCreateLabel("MISSING", 173, 11, 40, 10)
	$lab_minispace = GUICtrlCreateLabel(" Free: " & FormatFreeSpace($diskfreespace), 53, 10, 75, 10, 0x01, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, 6.5)
	GUICtrlSetColor(-1, $blue)
	Set_BGColor()
	$lab_miniversion = GUICtrlCreateLabel("v" & $Version, 132, 9, 40, 10, -1, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, Default, 700)
	Set_BGColor()
	If StringLeft(GUICtrlRead($but_go_progver), 5) = "Get v" Then
		GUICtrlSetColor($lab_miniversion, $red)
	Else
		GUICtrlSetColor($lab_miniversion, $seagreen)
	EndIf
	If $GDI_plus = False Then
		$minilogo = GUICtrlCreateIcon($icons & "\CHDKLogo3.ico", -1, 10, 8, 48, 48, -1)	; 10, 10
		GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
		_GUICtrl_NoTabStop()
	EndIf
	GUICtrlCreateLabel("Last Check", 68, 19, 55, 10, -1, $GUI_WS_EX_PARENTDRAG)
	Set_BGColor()
	$lab_minitime = GUICtrlCreateLabel($t_last, 71, 30, 50, 14, -1, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, 8.5, 700)
	Set_BGColor()
	$lab_miniboth = GUICtrlCreateLabel("2", 14, 44, 8, 11, -1, $GUI_WS_EX_PARENTDRAG) ; 14, 44
	GUICtrlSetFont(-1, 8.5, 700)
	Set_BGColor()
	$lab_miniruntime = GUICtrlCreateLabel($d_last, 50, 44, 72, 11, 0x102, $GUI_WS_EX_PARENTDRAG)
	Set_BGColor()
	$ico_sat = GUICtrlCreateIcon($arr_icon[3 - $PivIndex], -1, 123, 22, 32, 32)	; 24
	SatIcon($OnLine)
	$but_miniswitch = GUICtrlCreateButton(GetSVN_Name($site), 109, 56, 46, 15)	; 10, 57, 44, 15)
	If $Incremental_Lock = 1 Then
		GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	Else
		GUICtrlSetTip(-1, "Click to switch to " & GetSVN_Name(1 - $site) )
	EndIf
	$lab_miniupd = 	GUICtrlCreateLabel("check every " & GUICtrlRead($inp_upd) & " min :", 11, 57, 96, 11, -1, $GUI_WS_EX_PARENTDRAG)
	Set_BGColor()
	If IsChecked($chk_inet) = 0 Or IsChecked($chk_upd) = 0 Then
		GUICtrlSetData(-1, "checking: DISABLED")
	ElseIf $NetConnected[$site] = 0 Then
		GUICtrlSetBkColor(-1, $orange)
	EndIf
	$ministatus = GUICtrlCreateLabel(GUICtrlRead($status), 10, 75, 145, 25, $SS_SUNKEN, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, Default, 700)
	GUICtrlSetColor(-1, $seagreen)
	$lab_minicur = GUICtrlCreateLabel($LongBuildName, 8, 101, 98, 23)
	If $LongBuildName = $NewestBuild Then GUICtrlSetColor(-1, $seagreen)
	GUICtrlSetFont(-1, 16, 700)
	Set_BGColor()
	$lab_mininew = GUICtrlCreateLabel("", 107, 101, 48+2, 23, 0x0102, $GUI_WS_EX_PARENTDRAG) ; $SS_RIGHT + $SS_NOTIFY = 0x0102 right align style
	GUICtrlSetFont(-1, 16, 700)
	GUICtrlSetColor(-1, $red)
	Set_BGColor()
	$but_minigui = GUICtrlCreateButton("  &DISP.", 175, 113, 35, 15, -1, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, 5.3)
	GUICtrlSetColor(-1, $white)
	GUICtrlSetBkColor(-1, $black)
	$mini_dock = GUICtrlCreateLabel("", 10, 71, 4, 4)	; 71
	GUICtrlSetBkColor(-1, $red)
	GUICtrlSetState(-1, 32) ; $GUI_HIDE = 32
		$ico_canon = GUICtrlCreateIcon($icons & "\can.ico", -1, 55, 125, 52,  9)
		_GUICtrl_NoTabStop()
		GUICtrlSetTip(-1, "Start " & $ptp_ctx_entry)
	If $GDI_plus = True Then
		$lab_minigreen = GUICtrlCreateLabel("", 175, 35, 5, 5)
		; 'lights' up the 'LED' by toggling from dark grey to green
		GUICtrlSetBkColor(-1, $dgrey)
		$ico_play = GUICtrlCreateIcon($icons & "\play.ico", -1, 180, 17, 36, 29)
		_GUICtrl_NoTabStop()
		$ico_func = GUICtrlCreateIcon($icons & "\func.ico", -1, 188, 58, 23, 22)
		_GUICtrl_NoTabStop()
		$but_minimenu = GUICtrlCreateButton(" MENU", 185, 95, 25, 15)
		_GUICtrl_NoTabStop()
		GUICtrlSetFont(-1, 5.3)
		GUICtrlSetColor(-1, $white)
		GUICtrlSetBkColor(-1, $black)
	EndIf
	$barsize = Round( ($ticks_left / $ticks_max) * 144.0 )
	If $3D_CountDown = 1 Then
		$mini_countdown = GUICtrlCreateLabel("", 10, 99, $barsize, 1)
		GUICtrlSetBkColor($mini_countdown, $dgrey)
		$mini_countdown2 = GUICtrlCreateLabel("", 10, 75, $barsize, 1)
		GUICtrlSetBkColor(-1, $white)
		$mini_countdown3 = GUICtrlCreateLabel("", 10, 75, 1, 25)
		GUICtrlSetBkColor(-1, $white)
		$mini_countdown4 = GUICtrlCreateLabel("", 154, 75, 1, 25)
		GUICtrlSetBkColor(-1, $dgrey)
	Else		; If $3D_CountDown = 0 Then
		$mini_countdown = GUICtrlCreateLabel("", 7 + $barsize, 96, 3, 3)
		GUICtrlSetBkColor($mini_countdown, $blue)
	EndIf
	If IsChecked($chk_tooltips) Then
		Local $tip = "[ Keyboard shortcut <Alt> + D ]" & @CRLF & @CRLF & "Returns to full GUI mode"
		GUICtrlSetTip($ico_sat, $tip)
		GUICtrlSetTip($but_minigui, $tip)
		GUICtrlSetTip($lab_minicur, $_s & @CRLF & "Click to browse CHANGELOG")
	EndIf
	$AccelMini[0][0] = "!d"
	$AccelMini[0][1] = $but_minigui
	GUISetAccelerators($AccelMini, $minimain)
	If $GDI_plus = True Then
		; only applies if GDI+ available
		_GDIPlus_Startup()
		; $WS_EX_LAYERED + $WS_EX_MDICHILD = 0x00080000 + 0x00000040 = 0x00080040
		Local $hsize = 52 + $site * 7, $vsize = 42 - $site * 1		; 5, 3
		$minilogo = GUICreate("", $hsize, $vsize, -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_MDICHILD, $minimain)	; -1, -1, 54, 44 / 58, 46
		_SetBitmap($minilogo, _ImageResize($CHDKLogo[$site], $hsize, $vsize ), 255, $hsize, $vsize )
		WinMove($minilogo, "", $wpos[0] + $delta_x + 13, $wpos[1] + $delta_y + 23 + 2 * $site) ; seems useless, but won't show without ???
		GUISetState($State_Disable, $minilogo)
		GUISetState(@SW_LOCK, $minilogo)
		$minigraph = GUICreate("", 232, 152, -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_MDICHILD, $minimain)
		_SetBitmap($minigraph, _GDIPlus_ImageLoadFromFile($subdir & "\cam8.png"), 255, 232, 152 )
		WinMove($minigraph, "", $wpos[0] + $delta_x, $wpos[1] + $delta_y - 2) ; seems useless, but $minigraph won't show without ???
	EndIf

_ap_ProfileStop(35)
EndFunc   ;==>CreateMiniGUI
; --------------------------------------------
Func SwitchGUI($_state)
_ap_ProfileStart(36)
	Local $wt = $Title & " -- " & $CBFN, $active = $ActWin

	WinSetTitle($main, "", $wt)
	If WinExists($minimain) Then
		If $active = $minimain Then $active = $main
		If $GDI_plus = True Then
			GUIDelete($minilogo)
			GUIDelete($minigraph)
		EndIf
		$mpos = WinGetPos($minimain)
		$wpos[0] += ($mpos[0] - $mpos0[0])
		$wpos[1] += ($mpos[1] - $mpos0[1])
		If $w_animate = 1 Then AnimateWin($minimain, $PivotPrms[$PivIndex][1], $ctim)
		GUIDelete($minimain)
	EndIf
	If $_state = 0 Or $startup Then
		If $startup Then $active = $main
		$CurrentGUI[0] = $main
		$CurrentGUI[1] = "mainGUI"
		MainSlideIn()
	EndIf
	If $_state = 1 Then
		CreateMiniGUI()
		$CurrentGUI[0] = $minimain
		$CurrentGUI[1] = "miniGUI"
		If $active = $main Then $active = $minimain
		MainSlideOut()
		; assures GDI logo properly drawn in miniGUI on Win2000 ?
		If $GDI_plus And $CurrOSVersion = "WIN_2000" Then WinActivate("Program Manager")
		If $w_animate = 1 Then AnimateWin($minimain, $PivotPrms[$PivIndex][0], $ctim)
		If $GDI_plus = True Then
			GUISetState($State_Show, $minilogo)
			GUISetState($State_Show, $minigraph)
		EndIf
		$mpos0 = _GuiRoundCorners($minimain, 0, 0, 10, 10)
		GUISetState($State_Show, $minimain)
	EndIf
;~ 	WinSetTitle($main, "", $wt)
	WinActivate($active)
	$ActWin = $active
	$miniGUI = $_state
	Init_TimerBar()
	UpdateDoubleCheckLabels()
	ShowNetBuild("")
	AutoPos()
_ap_ProfileStop(36)
EndFunc   ;==>SwitchGUI
; --------------------------------------------
Func RefreshGUI()
_ap_ProfileStart(37)
	If IsChecked($chk_nosel) Then $sourcedir = ""
	UpdateCurrentBuild(0)
_ap_ProfileStop(37)
EndFunc
; --------------------------------------------
Func Switch2CardMenu()
_ap_ProfileStart(38)
	$cardlock = 1
	MainSlideOut()
	CardMainMenu()
	ClearQ($msg) ; assure msg buffer clear
	$wpos[0] += ($mpos[0] - $mpos0[0])	; in case the window was moved ...
	$wpos[1] += ($mpos[1] - $mpos0[1])
	MainSlideIn()
	WinActivate($main)
	$cardlock = 0
	AutoPos()
	If $Rflag = 1 Then ForceForegroundCheck()
	$activity = $mtim + 1
_ap_ProfileStop(38)
EndFunc   ;==>Switch2CardMenu
; --------------------------------------------
Func SwitchSites($flag = 0, $visible = False)
_ap_ProfileStart(39)
	Local $prefix = "Switching to "

	If $flag Then
		$site = 1 - $site
		$prefix = "Checking "
	EndIf
	If $visible Then AutoSplash($prefix & GetSVN_Name($site) & " ...      ")
	If IsMainMinimised() Or $cardlock = 1 Then WinSetTitle($main, "", "Checking " & GetSVN_Name($site) & " ...")
	; invalidate branch settings to avoid mix ups
	$snooped = 0
	Global $branches[25][7]
	Global $skip_branch[25][2]
	$branches[0][0] = "trunk"
	$branches[1][0] = $DefBranch[$site]

;~ 	; reset inet state to default, connect failure is site dependant - 06/04/10
;~ 	If IsChecked($chk_inet) Then
;~ 		GUICtrlSetBkColor($chk_inet, -1)
;~ 		GUICtrlSetBkColor($lab_miniupd, -1)
;~ 		$NetConnected[$site] = 1
;~ 		$warnflag[$site] = 1 ; re-arm net dropout warn flag
;~ 	EndIf

	If $visible Then RefreshGUI()
	SplashOff()
	TracChecker() ; ... and check for updates if allowed by user
	Check_istate()
_ap_ProfileStop(39)
EndFunc
; --------------------------------------------
Func Wrapped_Check_istate($indialog = 0)
_ap_ProfileStart(40)
	If $Sync_Checks Then
		$istate = IsChecked($chk_inet)
		; must short-circuit ASAP, we don't want GUI flicker ...
		If $istate = $last_istate Or $istate = 0 Or Not IsChecked($chk_upd) Then
_ap_ProfileStop(40)
			Return
		EndIf
		Local $visible = True
		If IsMainMinimised() Or $cardlock = 1 Then
			$visible = False
		EndIf
		; make sure WinAPI doesn't draw graphical junk in our neat dialogs ...
		If $indialog <> 0 Then
			Local $hAct = WinGetHandle("[ACTIVE]")
			If $hAct = $indialog Then WinSetOnTop($indialog, "", 1)
			GUISetState($State_Disable, $indialog)
			If $Sync_Checks_BG = 0 Then	GUISetState($State_Hide, $indialog)
		EndIf
		WriteIni()
		$Background = False
		$Rflag = 0
		If $Sync_Checks_BG = 1 Then
			$visible = False
			$Background = True
		EndIf
		SwitchSites(1, $visible)
		$Background = False
		SwitchSites(1, $visible)
		If IsMainMinimised() Or $cardlock = 1 Then
			WinSetTitle($main, "", $Title & " -- " & $CBFN)
		ElseIf $Rflag = 1 Then
			; retry while temporarily set to foreground ...
			Local $bg = $Sync_Checks_BG
			$Sync_Checks_BG = 0
			UpdateDoubleCheckLabels()
			SwitchSites(1, True)
			SwitchSites(1, True)
			; ... and back to BG
			$Sync_Checks_BG = $bg
			$Rflag = 0
			;ShowNetBuild("")
		EndIf
		UpdateDynamicControls()
		If $indialog <> 0 Then
			If $Sync_Checks_BG = 0 Then	GUISetState($State_Show, $indialog)
			GUISetState($State_Enable, $indialog)
			If $hAct = $indialog Then WinSetOnTop($indialog, "", 0)
			WinActivate($indialog)
			If $hAct <> $indialog Then WinActivate($hAct)
		EndIf
	Else
		Check_istate()
	EndIf
_ap_ProfileStop(40)
EndFunc   ;==>Wrapped_Check_istate
; --------------------------------------------
Func MainSlideIn()
_ap_ProfileStart(41)
	$but_def_focus = $cur_t	; <========= select control to be focused by default
	If $w_animate = 1 Then AnimateWin($main, $PivotPrms[$PivIndex][0], $ctim)
	GUISetState($State_Enable, $main)
	GUISetState(@SW_SHOWNA, $main)
	GUISetState($State_Show, $pic)
	GUISetAccelerators($AccelMain, $main)
	ControlFocus($main, "", $but_def_focus)
	$activity = $mtim + 1
_ap_ProfileStop(41)
EndFunc   ;==>MainSlideIn
; --------------------------------------------
Func MainSlideOut()
_ap_ProfileStart(42)
	GUISetState($State_Hide, $pic)
	If $w_animate = 1 Then AnimateWin($main, $PivotPrms[$PivIndex][1], $ctim)
	GUISetState($State_Hide, $main)
	GUISetState($State_Disable, $main)
	GUISetAccelerators("", $main)
_ap_ProfileStop(42)
EndFunc   ;==>MainSlideOut

#EndRegion
#
#Region ---------------------------- General Functions -------------------------------------------

Func Update_TimerBar()
_ap_ProfileStart(43)
	Static $last = 0

	If Not $w_showcountdown Or Not IsChecked($chk_inet) Or Not IsChecked($chk_upd) Then
_ap_ProfileStop(43)
		Return
	EndIf
	Local $ticks = $ticks_left
	Local $perc = $ticks / $ticks_max
	Local $mcur = $3D_CountDown * Round( $perc * 144.0 ) + (1 - $3D_CountDown) * Round( $perc * 141.0 )
	Local $hcur = R($perc * 155.0)

	If ($miniGUI = 1 And $mcur = $last) Or ($miniGUI = 0 And $hcur = $last) Then
_ap_ProfileStop(43)
		Return
	EndIf

	If $ticks < 2 Then
		GUICtrlSetState($lab_timerbar, 32) ; $GUI_HIDE = 32
		GUICtrlSetState($lab_dock, 16 + 16 * $startup) ; $GUI_SHOW = 16, $GUI_HIDE = 32
		If $miniGUI = 1 Then
			GUICtrlSetState($mini_countdown,  32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_countdown2, 32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_countdown3, 32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_countdown4, 32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_dock, 16 + 16 * $startup) ; $GUI_SHOW = 16, $GUI_HIDE = 32
		EndIf
_ap_ProfileStop(43)
		Return
	ElseIf $ticks = $ticks_max Then
		GUICtrlSetState($lab_dock, 32) ; $GUI_HIDE = 32
		If $miniGUI = 1 Then GUICtrlSetState($mini_dock, 32) ; $GUI_HIDE = 32
	EndIf
	GUICtrlSetPos($lab_timerbar, R($LM) + R(275) - 1, R(150) + R(8), 1, $hcur )	; R($perc * 155.0)
	If $miniGUI = 1 Then
		If $3D_CountDown  = 1 Then
			GUICtrlSetPos ( $mini_countdown4, 10 + $mcur, 76, 1, 24 )
			GUICtrlSetPos ( $mini_countdown2, 10, 75, $mcur, 1 )
			GUICtrlSetPos ( $mini_countdown, 10, 99, $mcur, 1 )
		Else	; If $3D_CountDown  = 0 Then
			GUICtrlSetPos ( $mini_countdown, 10 + $mcur, 96, 3, 3)
		EndIf
		$last = $mcur
;~ 		GUICtrlSetPos ( $mini_countdown, 10, 74 + 25 * $3D_CountDown, $mcur, 2 - $3D_CountDown)
	Else
		$last = $hcur
	EndIf
_ap_ProfileStop(43)
EndFunc   ;==>Update_TimerBar
; --------------------------------------------
Func Clean($indialog = 0)
_ap_ProfileStart(44)

	$gc = False
	If $LimitBuilds = 1 And $PurgeFlag Then
		; if user selected to 'Remove old builds' (in 'SVN Options ..')
		; get current GUI's x, y pos
		Local $curpos = WinGetPos($CurrentGUI[0])
		; pass delete/recycle flag, x, and y as parameters
		Local $params = $PurgeToTrash & " " & $curpos[0] & " " & $curpos[1]
		Run( @AutoItExe & " /AutoIt3ExecuteScript " & $subdir & "\~!~purge.au3 " & $params, $subdir)
		$PurgeFlag = False
	EndIf
	If $UTarget <> "" And FileExists($UTarget) Then
		$ShowSplash = 1	; force on
		AutoSplash("Updating, please wait ...")
		UnpackReplaceRestart()	; downloaded program update needs unpacking
	EndIf
	$activity -= 1
	If $activity = 0 Then
		$activity = $mtim
		; do NOT switch to miniGUI if:  1) switched off 2) already miniGUI 3) minimised to taskbar 4) in card menu
		If $w_minitimer = 1 And $miniGUI = 0 And Not IsMainMinimised() And $cardlock = 0 Then
			SaveWinState()
			SwitchGUI(1)
			If $ActWin <> $main Then WinActivate($ActWin)
		EndIf
	EndIf
	GetWPos()
	SaveWinState()
	Wrapped_Check_istate($indialog)	; see if there's a pending ReCheck event and process it
	DiskSpace()				; check disk space & update indicator if changed
	CollectGarbage()		; try to reduce program's memory footprint
_ap_ProfileStop(44)
EndFunc   ;==>Clean
; --------------------------------------------
Func ClearQ($m)
_ap_ProfileStart(45)
	While $m > 0
		$m = GUIGetMsg()
	WEnd
_ap_ProfileStop(45)
EndFunc   ;==>ClearQ
; --------------------------------------------
Func MyExit($_state)
_ap_ProfileStart(46)
	If WinExists($minimain) Then
		$mpos = WinGetPos($minimain)
		$wpos[0] += ($mpos[0] - $mpos0[0])
		$wpos[1] += ($mpos[1] - $mpos0[1])
	Else
		GetWPos()
	EndIf
	If $_state = 0 Then
		;FileCopy($inifile, $inifile & ".exit1")
		WriteIni()
		;FileCopy($inifile, $inifile & ".exit2")
		WriteXY()
		;FileCopy($inifile, $inifile & ".exit3")
		SortIni($inifile)
		;FileCopy($inifile, $inifile & ".exit4")
	EndIf
	Implode("")
	_GDIPlus_Shutdown()
_ap_ProfileStop(46)
_ap_ProfileStop(0)
_ap_ProfileReport()
	Exit $_state
EndFunc   ;==>MyExit
; --------------------------------------------
Func AutoSplash($mytext, $centered = 0)
_ap_ProfileStart(47)
	Local $_x, $_y, $_fw = 400, $_size = StringLen($mytext)

	SplashOff() ; just in case ...
	If $ShowSplash = 0 Or $_size = 0 Then
_ap_ProfileStop(47)
		Return
	EndIf
	If $w_boldpopups <> 0 Then $_fw = 700
	If $centered = 1 Then
		; just plunk it in the center of screen ...
		$_x = -1
		$_y = -1
	Else
		Switch $miniGUI
			Case 1
				$mpos = WinGetPos($minigraph)
				$_x = Round($mpos[0] + 0.5 * $mpos[2] - 4 * $_size - 10)
				$_y = Round($mpos[1] + 0.4 * $mpos[3] - 15)
			Case 0
				$_x = Round($wpos[0] + 0.5 * $wpos[2] - 4 * $_size - 10)
				$_y = Round($wpos[1] + 0.5 * $wpos[3] - 15)
		EndSwitch
	EndIf
	SplashTextOn("", $mytext, 25 + 8 * $_size, 35, $_x, $_y, 33, Default, Default, $_fw)
_ap_ProfileStop(47)
EndFunc   ;==>AutoSplash
; --------------------------------------------
Func AnimateWin($_handle, $_effect, $_duration)
_ap_ProfileStart(48)
	Local $eff = $_effect, $dur = $_duration
	If $w_slide = 0 Then
		For $i = 0 To 3
			If $eff = $PivotPrms[$i][0] Then
				$eff = 0x00080000
				ExitLoop
			ElseIf $eff = $PivotPrms[$i][1] Then
				$eff = 0x00090000
				ExitLoop
			EndIf
		Next
	EndIf
	DllCall("user32.dll", "int", "AnimateWindow", "hwnd", $_handle, "int", $dur, "long", $eff)
_ap_ProfileStop(48)
EndFunc   ;==>AnimateWin
; --------------------------------------------
Func Implode($str)
_ap_ProfileStart(49)
	Local $bye = IniRead($inifile, $sections[0], "mess_text", "[ your message here ]")
	Local $impl = 0x00050010, $style = $impl

	If $str <> "" Then
		$w_outtro = 1
		$bye = $str
	EndIf
	If $w_outtro = 1 Then AutoSplash($bye)
	If $miniGUI = 1 And $GDI_plus Then
		GUIDelete($minilogo)
		GUIDelete($minigraph)
	EndIf
	If $w_animate = 1 Then
		If $w_slide = 0 Then $style = 0x00090000
		If $miniGUI = 0 Then
			AnimateWin($pic, $impl, $ctim)
			AnimateWin($main, $style, 3 * $ctim)	; $PivotPrms[$PivIndex][0]
		Else
			AnimateWin($minimain, $style, 4 * $ctim)
		EndIf
	Else
		If StringLen($bye) <> 0 Then Sleep(4 * $ctim)
	EndIf
_ap_ProfileStop(49)
EndFunc   ;==>Implode
; --------------------------------------------
Func Sanity_Check()
_ap_ProfileStart(50)
	Local $kit3 = $none, $kit4 = $none, $flag = 0, $ret = 0, $copying = 0, $ARM_GCC = '\arm-elf-gcc.exe'	; $hf3, $hf4,
	Local $bad_OS = Not StringInStr($allowed, $CurrOSVersion), $bad_path = StringInStr($here, "=") + StringInStr($here, " ")
;~ 	Local $no_equal = "DevKit utilities will NOT work with" & @CR & "'=' in the path, please correct !"

	If $CurrOSVersion = "UNKNOWN" Then
		MsgBox($topmost,	"Unknown OS", "You appear to be running an UNKNOWN operating system." & @CR & @CR & "Please fasten your seat belts ;)" , 30)
	ElseIf $bad_OS Or $bad_path Then
		If $bad_OS Then MsgBox($topmost,	"Unsupported OS", "You appear to be running: " & $CurrOSVersion & @CR & "this operating system is not supported, sorry ..." & @CR & @CR & "[ program will now exit ]", 30)
		If $bad_path Then MsgBox($topmost, "Illegal Path Detected", "Please install the compiler shell to a path" & @CR & " without '=' or ' ' (space) characters !" & @CR & @CR & "[ program will now exit ]", 30)
_ap_ProfileStop(50)
_ap_ProfileStop(0)
		Exit
	EndIf
	AutoSplash("Sanity Check ...", 1)
	If $CurrOSVersion = "WIN_2000" Then
		If Not FileExists($icons & "\au3_logo.bak") Then
			FileCopy($icons & "\au3_logo.ico", $icons & "\au3_logo.bak")
			FileMove($icons & "\au3_logo2.ico", $icons & "\au3_logo.ico", 1)
		EndIf
		If Not FileExists($here & "\gdiplus.dll") Then
			SplashOff()
			MsgBox($topmost, "GDIPLUS.DLL missing !", "Windows 2000 does not have GDI+ built-in; please download" & @CR & "'gdiplus-SFX.exe' here: " & $Get_gcc & @CR & "and make it extract to " & $here & @CR & @CR & "[ program will run with GDI+ functions disabled ]", 30)
			$GDI_plus = False
		EndIf
	EndIf
;~ 	$GDI_plus = False	; use for testing
	If $GDI_plus Then
		$CHDKLogo[0] = $subdir & "\CHDKlogo5.png"
		$CHDKLogo[1] = $subdir & "\CHDKlogo6.png"
	Else
		$CHDKLogo[0] = $subdir & "\CHDKlogo2.gif"
		$CHDKLogo[1] = $subdir & "\CHDKlogo3.gif"
	EndIf
	If FileExists($here & "\_base") Then
		Local $setupgui, $lab[18], $but
		SplashOff()
		$setupgui = GUICreate("Setting up your DevKits", 640, 380, -1, -1, $WS_POPUP + $WS_CAPTION)	; 0x80C00000
		$lab[0] = GUICtrlCreateLabel("Checking attributes for: " & $here & "\gcc", 20, 20, 560)
		$lab[1] = GUICtrlCreateLabel("OK", 600, 20, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[2] = GUICtrlCreateLabel("Copying " & $here & "\_base -> " & $here & "\gcc", 20, 50, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[3] = GUICtrlCreateLabel("OK", 600, 50, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$lab[4] = GUICtrlCreateLabel("Checking attributes for: " & $here & "\gcc4", 20, 80, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[5] = GUICtrlCreateLabel("OK", 600, 80, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[6] = GUICtrlCreateLabel("Copying " & $here & "\_base -> " & $here & "\gcc4", 20, 110, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[7] = GUICtrlCreateLabel("OK", 600, 110, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$lab[8] = GUICtrlCreateLabel("Checking attributes for: " & $here & "\gcc451", 20, 140, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[9] = GUICtrlCreateLabel("OK", 600, 140, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[10] = GUICtrlCreateLabel("Copying " & $here & "\_base -> " & $here & "\gcc451", 20, 170, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[11] = GUICtrlCreateLabel("OK", 600, 170, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$lab[12] = GUICtrlCreateLabel("Checking attributes for: " & $here & "\gcc462", 20, 200, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[13] = GUICtrlCreateLabel("OK", 600, 200, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[14] = GUICtrlCreateLabel("Copying " & $here & "\_base -> " & $here & "\gcc462", 20, 230, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[15] = GUICtrlCreateLabel("OK", 600, 230, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$lab[16] = GUICtrlCreateLabel("Removing " & $here & "\_base", 20, 260, 560)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$lab[17] = GUICtrlCreateLabel("OK", 600, 260, 20, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		$but = GUICtrlCreateButton("Continue", 280, 340, 80, 20)
		GUICtrlSetState(-1, 32)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		GUISetState()

		$ret = FileSetAttrib($here & "\gcc", "-RASH", 1)
		$copying += $ret
		If $ret <> 0 Then
			GUICtrlSetState($lab[1], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			GUICtrlSetState($lab[2], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			$ret = DirCopy($here & "\_base", $here & "\gcc", 1)
			$copying += $ret
			If $ret <> 0 Then GUICtrlSetState($lab[3], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		EndIf
		GUICtrlSetState($lab[4], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$ret = FileSetAttrib($here & "\gcc4", "-RASH", 1)
		$copying += $ret
		If $ret <> 0 Then
			GUICtrlSetState($lab[5], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			GUICtrlSetState($lab[6], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			$ret = DirCopy($here & "\_base", $here & "\gcc4", 1)
			$copying += $ret
			If $ret <> 0 Then GUICtrlSetState($lab[7], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		EndIf
		GUICtrlSetState($lab[8], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$ret = FileSetAttrib($here & "\gcc451", "-RASH", 1)
		$copying += $ret
		If $ret <> 0 Then
			GUICtrlSetState($lab[9], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			GUICtrlSetState($lab[10], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			$ret = DirCopy($here & "\_base", $here & "\gcc451", 1)
			$copying += $ret
			If $ret <> 0 Then GUICtrlSetState($lab[11], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		EndIf
		GUICtrlSetState($lab[12], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16

		$ret = FileSetAttrib($here & "\gcc462", "-RASH", 1)
		$copying += $ret
		If $ret <> 0 Then
			GUICtrlSetState($lab[13], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			GUICtrlSetState($lab[14], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			$ret = DirCopy($here & "\_base", $here & "\gcc462", 1)
			$copying += $ret
			If $ret <> 0 Then GUICtrlSetState($lab[15], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		EndIf

		If $copying = 8 Then
			GUICtrlSetState($lab[16], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
			$ret = DirRemove($here & "\_base", 1)
			$copying += $ret
			If $ret <> 0 Then GUICtrlSetState($lab[17], 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		EndIf
		If $copying <> 9 Then GUICtrlSetData($but, "Exit Program")
		GUICtrlSetState($but, 16)	; $GUI_HIDE = 32 $GUI_SHOW = 16
		While GUIGetMsg() <> $but And $copying <> 9
			Sleep(50)
		WEnd
		GUIDelete($setupgui)
		If $copying <> 9 Then Exit 1
		$GCC4path = $here & "\gcc451\bin"	; default to new GCC451, saves ~ 2.7 kB vs. GCC440
	EndIf
	AutoSplash("Initialising ...", 1)

	; in case inifile contains invalid external paths reset to defaults ...
	If Not FileExists($GCC3path & $ARM_GCC) Then $GCC3path = $here & "\gcc\bin"
	If Not FileExists($GCC4path & $ARM_GCC) Then $GCC4path = $here & "\gcc4\bin"
	; ... try validation
	If FileExists($GCC3path & $ARM_GCC) Then
		$kit3 = ValidateDevKit($GCC3path)
;~ 		$hf3 = CheckHelperFiles($GCC3path)
		If Not StringInStr($kit3, $none) And $kit3 <> "" Then $flag += 3 	; And $hf3 = 0
;~ 		If $kit3 = "" Then
;~ 			SplashOff()
;~ 			MsgBox($topmost, "Path: " & $GCC3path, $no_equal)
;~ 		EndIf
	EndIf

	If FileExists($GCC4path & $ARM_GCC) Then
		$kit4 = ValidateDevKit($GCC4path)
;~ 		$hf4 = CheckHelperFiles($GCC4path)
		If Not StringInStr($kit4, $none) And $kit4 <> "" Then $flag += 4	; And $hf4 = 0
;~ 		If $kit4 = "" Then
;~ 			SplashOff()
;~ 			MsgBox($topmost, "Path: " & $GCC4path, $no_equal)
;~ 		EndIf
	EndIf
	If ($kit3 = "" Or StringInStr($kit3, $none)) And ($kit4 = "" Or StringInStr($kit4, $none)) Then
		SplashOff()
		$flag = MsgBox($topmost + 1, "No valid DevKits detected - browse to download site ?", "You have either not installed a full version with DevKits," & @CR & "or you have external DevKit(s) with unknown path(s)." & @CR & @CR & "Click 'Cancel' to browse to your external DevKit(s) or" & @CR & "'OK' to open the download site in your browser." & @CR & "[ program will exit after opening the site ]")
		If $flag = 1 Then
			ShellExecute($Get_gcc)
_ap_ProfileStop(50)
_ap_ProfileStop(0)
			Exit
		Else
			$flag = Dlg_CompilerPaths(0)
		EndIf
	EndIf

	Switch $flag
		Case 0
			SplashOff()
			MsgBox($topmost, "No valid DevKits detected", @CR & "[ program will now exit ]" & @CR)
_ap_ProfileStop(50)
_ap_ProfileStop(0)
			Exit
		Case 3 ; user installed valid GCC 3 only
			$GCCpath = $GCC3path
		Case 4
			$GCCpath = $GCC4path
		Case 7
			If $GCCpath = "" Then $GCCpath = $GCC4path ; preferred, GCC4.4.0 saves ~15 kB per binary ...
	EndSwitch
	CheckWGet()
	DiskSpace()
	If Not FileExists($here & "\DE\trunk\trunk10") Then
		DirCopy($here & "\trunk\trunk300", $here & "\DE\trunk\trunk10")
	EndIf
_ap_ProfileStop(50)
	Return $flag ; 3/4 = GCC3/4 only, 7 = both
EndFunc   ;==>Sanity_Check
; --------------------------------------------
Func SetLogo()	; $gui, $y_offset, $width, $height
_ap_ProfileStart(51)
	Local $_xoff, $_ypos, $hsize, $vsize

	Switch $reduce_logo
		Case 1
			; about 10% smaller
			$_xoff = R(85 - $site * 10)
			$_ypos = R(25 + 3 * $site)
			$hsize = 130 + $site * 10
			$vsize = 104 - $site * 7
		Case 2
			; about 25% smaller
			$_xoff = R(90 - $site * 5)
			$_ypos = R(30 + 3 * $site)
			$hsize = 108 + $site * 8
			$vsize = 87 - $site * 6
		Case Else
			; default
			$_xoff = R(75 - $site * 10)
			$_ypos = R(17 + 3 * $site)
			$hsize = 144 + $site * 11
			$vsize = 116 - $site * 8
	EndSwitch
	GetWPos()

	;If WinExists($pic) Then GUIDelete($pic)

	If $GDI_plus = True Then
		; only applies if GDI+ available
		_GDIPlus_Startup()
		; $WS_EX_LAYERED + $WS_EX_MDICHILD = 0x00080000 + 0x00000040 = 0x00080040
		$pic = GUICreate("", R($hsize), R($vsize), -1, -1, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_MDICHILD, $main)	; 0x00080040
		_SetBitmap($pic, _ImageResize($CHDKLogo[$site], R($hsize), R($vsize)), 255, R($hsize), R($vsize) )
		WinMove($pic, "", $wpos[0] + R($LM) + $_xoff, $wpos[1] + $titlebar_size + $_ypos) ; seems useless, but $minigraph won't show without ???
	Else
		$pic = GUICreate("", R($hsize), R($vsize), R($LM) + $_xoff, $_ypos + 5 * $site, $WS_POPUP, $WS_EX_LAYERED + $WS_EX_MDICHILD, $main)
		; transparent, frameless child window
		$logo = GUICtrlCreatePic($CHDKLogo[$site], 0, 0, R($hsize), R($vsize))
	EndIf
	GUISetState($State_Disable, $pic)
	GUISetState(@SW_LOCK, $pic)

_ap_ProfileStop(51)
EndFunc   ;==>SetLogo
; --------------------------------------------
Func UpdateDynamicControls()
_ap_ProfileStart(52)
	UpdateDoubleCheckLabels()
	If $do_branches[$site] = 0 Then
		IniWrite($inifile, $sections[1], "trunk" & $site, 1)
		GUICtrlSetState($rad_build[2], 132) ; $GUI_UNCHECKED = 4, $GUI_DISABLE = 128
		GUICtrlSetState($rad_build[1], 1) 	; $GUI_CHECKED = 1
	Else
		GUICtrlSetState($rad_build[2], 1 + 3 * $trunk[$site]) ; $GUI_CHECKED = 1, $GUI_UNCHECKED = 4
		GUICtrlSetState($rad_build[1], 4 - 3 * $trunk[$site])
	EndIf
	If $MakOptions[1][0] <> "" Then			; $MakStyle = "batch-zip-complete:"
		GUICtrlSetState($chk_comp_full, 16) ; $GUI_SHOW = 16
	Else
		GUICtrlSetState($chk_comp_full, 32) ; $GUI_HIDE = 32
	EndIf
	ReadIni()
	If Not IsChecked($chk_inet) Then
		SetAutoUpdateControls(128) ; $GUI_DISABLE = 128
	EndIf
_ap_ProfileStop(52)
EndFunc   ;==>UpdateDynamicControls
; --------------------------------------------
Func UpdateDoubleCheckLabels()
_ap_ProfileStart(53)
	Local $state = 32 - 16 * $Sync_Checks ; $GUI_HIDE = 32, $GUI_SHOW = 16
	Local $color = $Sync_Checks_BG * $seagreen + (1 - $Sync_Checks_BG) * $red

	GUICtrlSetState($lab_both, $state)
	GUICtrlSetColor($lab_both, $color)
	If $miniGUI Then
		GUICtrlSetState($lab_miniboth, $state)
		GUICtrlSetColor($lab_miniboth, $color)
	EndIf
_ap_ProfileStop(53)
EndFunc   ;==>UpdateDoubleCheckLabels
; --------------------------------------------
Func ValidateDevKit($_apath)
_ap_ProfileStart(54)
	Local $_tmp, $w32_version = $none, $arm_version = $none
	Local $showversion = $SysComSpec & " /c gcc -dumpversion > " & $here & "\_.txt"

	If StringInStr($_apath, "=") <> 0 Or CheckHelperFiles($_apath) <> 0 Then
_ap_ProfileStop(54)
		Return ""
	EndIf
	If FileExists($_apath & "\gcc.exe") Then
		$_tmp = RunWait($showversion, $_apath, $State_Hide)
		If $_tmp = 0 Then
			$_tmp = FileReadLine($here & "\_.txt")
			If StringLen($_tmp) = 5 And StringMid($_tmp, 2, 1) = "." And StringMid($_tmp, 4, 1) = "." Then
				$w32_version = "[" & $_tmp & "]"
			EndIf
		EndIf
	EndIf
	If FileExists($_apath & "\arm-elf-gcc.exe") Then
		$_tmp = RunWait(StringReplace($showversion, "/c gcc", "/c arm-elf-gcc"), $_apath, $State_Hide)
		If $_tmp = 0 Then
			$_tmp = FileReadLine($here & "\_.txt")
			If StringLen($_tmp) = 5 And StringMid($_tmp, 2, 1) = "." And StringMid($_tmp, 4, 1) = "." Then
				$arm_version = "[" & $_tmp & "]"
				$gccver[Number(StringLeft($_tmp, 1)) - 3] = $_tmp
			EndIf
		EndIf
	EndIf
	FileDelete($here & "\_.txt")
	$_tmp = $w32_version & $arm_version & " = "
	If $w32_version = $none Then $_tmp &= " * No W32 GCC"
	If $arm_version = $none Then $_tmp &= " * No ARM GCC"
	If StringLen($_tmp) < 18 Then $_tmp &= StringTrimRight($_apath, 4) ; ... both are present, add (base) path
_ap_ProfileStop(54)
	Return $_tmp
EndFunc   ;==>ValidateDevKit
; --------------------------------------------
Func Set_Tooltips()
_ap_ProfileStart(55)
	If IsChecked($chk_tooltips) Then
		GUICtrlSetTip($but_sel_ver, "Change current branch/trunk version")
		GUICtrlSetTip($ico_clone, "Clone current build folder as ...")
		GUICtrlSetTip($but_mini, "[ Keyboard shortcut <Alt> + D ]" & @CRLF & @CRLF & "Minimise the GUI to just show info relevant to" & @CRLF & "svn version checking. Press the 'camera' DISP." & @CRLF & "button to return to full GUI mode.")
		GUICtrlSetTip($but_go_wikia, "Opens Wiki in your browser:" & @CRLF & $Wikia & @CRLF & "Right-Click for more ...")
		GUICtrlSetTip($but_go_mantis, "Opens BugTracker in your browser:" & @CRLF & $Mantis)
		GUICtrlSetTip($chk_nosel, "Uncheck this to prevent the program from" & @CRLF & "switching to a newly downloaded version" & @CRLF & "of your current trunk or branch.")
		GUICtrlSetTip($chk_upd, "If you change the ReCheck interval, this will" & @CRLF & "be applied only AFTER the next event; toggle" & @CRLF & "'Allow Internet' to apply immediately")
		GUICtrlSetTip($chk_trayicon, "Tray Icon allows you to pause program execution")
		GUICtrlSetTip($chk_debug2, "Debug mode, if checked it will:" & @CRLF & @CRLF & " - Show msg loop info + key arrays" & @CRLF & " - Time compilation batches" & @CRLF & " - Stop autoclose Cmd Windows (if set to visible)" & @CRLF & @CRLF & "Auto-off @ GUI refresh, DISABLED @ Profile/Trace")
		GUICtrlSetTip($pic_card, "[ Keyboard shortcut <Alt> + C ]" & @CRLF & @CRLF & "Go to Card Functions Menu")
		GUICtrlSetTip($but_open_src, "[ Keyboard shortcut <Alt> + F ]" & @CRLF & @CRLF & "Shows the source code folder" & @CRLF & "for the selected local build" & @CRLF & "(type & version shown to the" & @CRLF & " left of the CHDK logo)")
		GUICtrlSetTip($but_src_tools, "[ Keyboard shortcut <Alt> + T ]" & @CRLF & @CRLF & "Show Source Code Tools Dialog")
		GUICtrlSetTip($chk_comp_full, "Current build offers the 'compile-complete' option." & @CRLF & "This adds useful extra files and readme's into all" & @CRLF & "CHDK ZIP packages generated. Read Makefile to" & @CRLF & "see what is included, YMMV :)")
		GUICtrlSetTip($pic_search, "FAST search & replace in source code folder" & @CRLF & "Note 1: search is CaSe SeNsItIvE" & @CRLF & "Note 2: search & replace length must be equal")
		GUICtrlSetTip($but_comp_sel, "[ Keyboard shortcut <Alt> + S ]" & @CRLF & @CRLF & "Will create CHDK binaries for" & @CRLF & "cams selected in the left panel")
		GUICtrlSetTip($pic_cmd, "Command line access to your current compiler")
		GUICtrlSetTip($chk_comp_all, "Check this to suppress the warning" & @CRLF & "message on selecting 'Compile All'")
		GUICtrlSetTip($but_comp_all, "[ Keyboard shortcut <Alt> + A ]" & @CRLF & @CRLF & "Will create CHDK binaries for" & @CRLF & "all available cams. This does" & @CRLF & "NOT influence your selection(s)")
	Else
		GUICtrlSetTip($but_sel_ver, "")
		GUICtrlSetTip($ico_clone, "")
		GUICtrlSetTip($but_mini, "")
		GUICtrlSetTip($but_go_wikia, "")
		GUICtrlSetTip($but_go_mantis, "")
		GUICtrlSetTip($chk_nosel, "")
		GUICtrlSetTip($chk_upd, "")
		GUICtrlSetTip($chk_trayicon, "")
		GUICtrlSetTip($chk_debug2, "")
		GUICtrlSetTip($pic_card, "")
		GUICtrlSetTip($but_open_src, "")
		GUICtrlSetTip($but_src_tools, "")
		GUICtrlSetTip($chk_comp_full, "")
		GUICtrlSetTip($pic_search, "")
		GUICtrlSetTip($but_comp_sel, "")
		GUICtrlSetTip($pic_cmd, "")
		GUICtrlSetTip($chk_comp_all, "")
		GUICtrlSetTip($but_comp_all, "")
	EndIf
	Set_Dyn_Tooltips()
_ap_ProfileStop(55)
EndFunc   ;==>Set_Tooltips
; --------------------------------------------
Func Set_Dyn_Tooltips()
_ap_ProfileStart(56)
	Local $e, $f, $s

	If IsChecked($chk_tooltips) Then
		GUICtrlSetTip($rad_build[2], "Default branch: " & GUICtrlRead($rad_build[2], 1))
		$e = $do_branches[$site]
		If $e < 0 Then
			$s = "None" & @CRLF & "Local branch: " & $DefBranch[$site]
		Else
			$s = $txt_branch[$e]
		EndIf
		GUICtrlSetTip($but_branch, "[ Keyboard shortcut <Alt> + B ]" & @CRLF & @CRLF & "Select branch(es) to check (if any)" & @CRLF & "and default branch here. Note that" & @CRLF & "trunk will always be checked." & @CRLF & @CRLF & "Current setting: " & $s )

		$s = $CBFN & @CRLF
		If FileExists($sourcedir & "\version.inc") Then
			$s &= FileReadLine($sourcedir & "\version.inc")
		Else
			$s &= "no BUILDNUMBER detected" ;
		EndIf
		GUICtrlSetTip($cur_t, $s & @CRLF & "Click to browse CHANGELOG")

		GUICtrlSetTip($but_sizer, "[ Keyboard shortcut <Alt> + G ]" & @CRLF & @CRLF & "Lets you adjust window and font size" & @CRLF & @CRLF & "[X,Y] WxH: [" & $wpos[0] & "," & $wpos[1] & "] " & $wpos[2] & "x" & (R($w_ch) + $titlebar_size) & " pixels," & @CRLF & "(client size: " & R($w_cw) & "x" & R($w_ch) & " pixels)" & @CRLF & "window: " & $w_scaler * 100 & "% ; font: " & $f_scaler * 100 & "%" & @CRLF & @CRLF & $tip)
		GUICtrlSetTip($but_go_forum, "Opens " & GetSVN_Name($site) & " Forum in your browser:" & @CRLF & $Forum[$site] & @CRLF & "Right-Click for more ...")

		$e = "Yes"
		If $cmd_mode == "/k" Or IsChecked($chk_debug2) Then $e = "No"
		GUICtrlSetTip($chk_debug, "3-state control for Cmd window behaviour:" & @CRLF & @CRLF & "   unchecked -> hidden/autoclose" & @CRLF & "greyed/filled -> minimised/autoclose" & @CRLF & "       checked -> visible (autoclose: " & $e & "*)" & @CRLF & @CRLF & "* Check 'Debug..' to disable Autoclose, or add:" & @CRLF & "    'cmd_mode=/k' to ini file under [Program]")

		$e = "On, @every " & $GC_ratio & " tick(s)"
		If $GC_Flag = 0 Then $e = "Off"
		$f = "On"
		If $Introspection = 0 Then $f = "Off"
		GUICtrlSetTip($but_debug, "Click for more Program Info/Settings" & @CRLF & @CRLF & "Timer Tick: " & $Timer_Interval & " seconds" & @CRLF & "Garbage Collection: " & $e & @CRLF & "Profile/Trace: " & $f)

		GUICtrlSetTip($chk_keep_dumps, "Keep the disassembly of main.elf for each cam" & @CRLF & "as 'dump-<cam>-<firmware>.txt' in the logging" & @CRLF & "directory: " & $sourcedir & "\bin\logs")

		$e = $gccver[1]
		If $GCCpath = $GCC3path Then $e = $gccver[0]
		$e = String($e) & @CRLF & "PRIMARY_ROOT: "
		$f = IniRead($inifile, $sections[0], "ext_primary", "")
		If $f = "" Then $f = "Off"
		$e &= $f & @CRLF & "GMAKE clean AFTER compile: O"
		If $SkipPostClean = 0 Then
			$e &= "n"
		Else
			$e &= "ff"
		EndIf
		Local $gmopts = StringSplit($make_options, "|")
		$gmopts[0] = "default (none)"
		$e &= @CRLF & "GMAKE options: " & $gmopts[$make_uses_options]
		GUICtrlSetTip($but_cond_comp, "[ Keyboard shortcut <Alt> + O ]" & @CRLF & @CRLF & "Current compiler: GCC " & $e)
	Else
		GUICtrlSetTip($but_branch, "")
		GUICtrlSetTip($cur_t, "")
		GUICtrlSetTip($but_sizer, "")
		GUICtrlSetTip($but_go_forum, "")
		GUICtrlSetTip($but_debug, "")
		GUICtrlSetTip($chk_keep_dumps, "")
		GUICtrlSetTip($but_cond_comp, "")
	EndIf
_ap_ProfileStop(56)
EndFunc   ;==>Set_Dyn_Tooltips
; --------------------------------------------
Func GetCamProperties($alphasort)
_ap_ProfileStart(57)
	Local $z, $r, $e, $dum, $cam_h, $lbuf, $idx, $fonw = 400		; $max_elems = 50
	Local $generic = 0, $cur_cam = "", $gpc = 0, $DryFlag, $newsys = False, $def_end = "Overridden values"
	Local $default_marker = "[DEFAULT] ", $deflen = StringLen($default_marker), $undef_marker = "#undef", $comment, $def
	Local $remove_marker = "   <----- can be commented out/removed"
	Local $miss_marker = "   <----- property missing in default values"
	Local $mark = _StringRepeat("=", 100)
	Local $hpp, $pplog = $subdir & "\parsed_props.log"

	If $CP_bold[3] > 100 * $w_scaler And $CP_bold[1] = 1 Then $fonw = 700 ; is winsize < threshold ?

	If _FileReadToArray($sourcedir & "\include\camera.h", $cam_h) = 0 Or ( $w_propsortalpha = $w_propsortalpha0 And $sourcedir = $sourcedir0 ) Then
		; no change, or no camera.h found -> just repaint ...
		UpdateCamPanel()
		$w_propsortalpha0 = $w_propsortalpha
		$sourcedir0 = $sourcedir
_ap_ProfileStop(57)
		Return
;~ 	ElseIf FileGetSize($sourcedir & "\include\camera.h") < 30000 Then
	ElseIf FileExists($sourcedir & "\platform\a610\platform_camera.h") Then
		$newsys = True
		$def_end = "#@EOF"
	EndIf

	DisableMainControls(1)
	; get the cam properties from camera.h and store them in $cam_props
	$StatusMsg = "Processing cam info ..."
	UpdateStatus() ; show user we're busy ...
	; first strip superfluous WS, and find start line of Default value section
	For $z = 1 To $cam_h[0]
		$cam_h[$z] = StringStripWS($cam_h[$z], 7)	; remove leading, trailing, and multiple WS
		If $generic = 0 And StringInStr($cam_h[$z], "// Default values") Then $generic = $z
	Next
	; determine number of properties (for sizing property arrays) ...
	For $z = $generic + 1 To $cam_h[0]
		If StringInStr($cam_h[$z], $def_end) Then ExitLoop ; end of generic section
		If StringLeft($cam_h[$z], 7) = "#define" Or StringLeft($cam_h[$z], 6) = "#undef" Then $gpc += 1
	Next
	$MaxProps = $gpc
	Local $gen_props[$gpc + 1][4]	; [$gpc+1][ {name}, {value}, {comment}, {linenumber} ]
	Local $all_props[$sup_cams + 1][$gpc + 1][4]

	FileDelete($subdir & "\missing.log")
	$gpc = 0
	$AutoProps = ""
	$hpp = FileOpen($pplog, 2)
	FileWriteLine($hpp, $mark)
	FileWriteLine($hpp, "Generic (DEFAULT) property scan from:")
	FileWriteLine($hpp, $sourcedir & "\include\camera.h")
	FileWriteLine($hpp, $mark)
	If $newsys Then
		Local $conditional = False
		For $z = $generic + 1 To $cam_h[0]
			If $cam_h[$z] = "" Or StringLeft($cam_h[$z], 2) = "//" Then ContinueLoop 	; it's an empty or comment line
			; remove line continuation chars & concatenate lines ...
			If StringRight($cam_h[$z], 1) = "\" Then
				$cam_h[$z] = StringTrimRight($cam_h[$z], 1)
				$r = $z + 1
				Do
					$cam_h[$z] &= StringTrimRight($cam_h[$r], 1)
					$r += 1
				Until StringRight($cam_h[$r], 1) <> "\"
				$cam_h[$z] &= $cam_h[$r]
			EndIf
			$lbuf = StringSplit($cam_h[$z], Chr(9) & " ")
			Switch $lbuf[1]
				Case "#define"
					If $conditional Then
						$AutoProps &= $lbuf[2] & " "
						ContinueLoop
					EndIf
					$gen_props[$gpc][0] = $lbuf[2]
					$gen_props[$gpc][1] = ""
					$gen_props[$gpc][2] = ""
					$gen_props[$gpc][3] = $z
					For $r = 3 To $lbuf[0]
						$comment = $r
						If StringInStr($lbuf[$r], "//") Then ExitLoop
						$comment += 1
						$gen_props[$gpc][1] &= $lbuf[$r]
					Next
					FileWriteLine($hpp, "@" & $z & ": " & $gen_props[$gpc][0] & " defined as " & $gen_props[$gpc][1])
					$gen_props[$gpc][1] = $default_marker & $gen_props[$gpc][1]
					For $r = $comment To $lbuf[0]
						$gen_props[$gpc][2] &= $lbuf[$r] & " "
					Next
						$gpc += 1
				Case "#undef"
					If $conditional Then
						$AutoProps &= $lbuf[2] & " "
						ContinueLoop
					EndIf
					$gen_props[$gpc][0] = $lbuf[2]
					$gen_props[$gpc][1] = $default_marker & $undef_marker
					$gen_props[$gpc][2] = ""
					$gen_props[$gpc][3] = $z
					FileWriteLine($hpp, "@" & $z & ": " & $gen_props[$gpc][0] & " undefined")
					For $r = 3 To $lbuf[0]
						$gen_props[$gpc][2] &= $lbuf[$r] & " "
					Next
					$gpc += 1
				Case "#include"
					$DefPropsEnd = $z
					$conditional = True
			EndSwitch
		Next
		If $alphasort = 1 Then _ArraySort($gen_props, 0, 0, $gpc - 1, 0)

		For $w = 0 To $sup_cams
			For $x = 0 To $gpc
				For $y = 0 To 3
					$all_props[$w][$x][$y] = $gen_props[$x][$y]
				Next
			Next
		Next
		$all_props[0][$gpc][0] = "Default"
		$dum = ""
		$DefaultProps[0] = "Default"
		For $r = 0 To $gpc - 1
			; create default property list ...
			If $dum <> "" Then $dum &= @CRLF
			$dum &= ($gen_props[$r][0] & " = " & $gen_props[$r][1] & "  // @" & $gen_props[$r][3] & " " & $gen_props[$r][2])
		Next
		$DefaultProps[1] = $dum

		For $c = 1 To $sup_cams
			; set name for next cam
			$cur_cam = $cam_props[$c - 1][0]
			$cam_h = 0	; reset
			$lbuf = $sourcedir & "\platform\" & $cur_cam & "\platform_camera.h"

			FileWriteLine($hpp, $mark)
			FileWriteLine($hpp, $cur_cam & " property scan from:")
			If FileExists($lbuf) Then		; is there a platform_camera.h ?
				FileWriteLine($hpp, $lbuf)
				FileWriteLine($hpp, $mark)
				_FileReadToArray($lbuf, $cam_h)
				For $z = 1 To $cam_h[0]
					$cam_h[$z] = StringStripWS($cam_h[$z], 7)	; remove leading, trailing, and multiple WS
					If $cam_h[$z] = "" Or StringLeft($cam_h[$z], 2) = "//" Then ContinueLoop ; it's an empty or comment line
					; remove line continuation chars & concatenate lines ...
					If StringRight($cam_h[$z], 1) = "\" Then
						$cam_h[$z] = StringTrimRight($cam_h[$z], 1)
						$r = $z + 1
						Do
							$cam_h[$z] &= StringTrimRight($cam_h[$r], 1)
							$r += 1
						Until StringRight($cam_h[$r], 1) <> "\"
						$cam_h[$z] &= $cam_h[$r]
					EndIf
					$lbuf = StringSplit($cam_h[$z], Chr(9) & " ")
;~ 					If Not IsArray($lbuf) Or $lbuf[0] < 2 Then ContinueLoop
					$dum = ""
					Switch $lbuf[1]
						Case "#define"
							For $r = 0 To $gpc	; scan $cur_props ...
								$def = "(" & StringTrimLeft($gen_props[$r][1], $deflen) & ")"
								If $lbuf[2] = $all_props[$c][$r][0] Then	; ... until property found ...
									$all_props[$c][$r][1] = ""	; clear prop value ....
									$all_props[$c][$r][2] = ""	; clear comments ....
									$all_props[$c][$r][3] = $z
									For $e = 3 To $lbuf[0]
										$comment = $e
										If StringInStr($lbuf[$e], "//") Then ExitLoop
										$all_props[$c][$r][1] &= $lbuf[$e]	; ... overwrite property value
										$comment += 1
									Next
									$dum = "@" & $z & ": " & $lbuf[2] & " defined as " & $all_props[$c][$r][1]
									If StringInStr($def, $all_props[$c][$r][1]) Then	;  Or StringInStr($AutoProps, $lbuf[2])
										$dum = "*" & $dum & $remove_marker
										$all_props[$c][$r][1] = "* " & $all_props[$c][$r][1]
									EndIf
									FileWriteLine($hpp, $dum)
									For $e = $comment To $lbuf[0]
										$all_props[$c][$r][2] &= $lbuf[$e] & " "	; ... add comments, if any
									Next
									ExitLoop
								EndIf
							Next
							If $dum = "" Then
								FileWriteLine( $subdir & "\missing.log", $lbuf[2] )
								FileWriteLine($hpp, "+@" & $z & ": " & $cam_h[$z] & $miss_marker)
							EndIf
						Case "#undef"
							For $r = 0 To $gpc
								$def = StringTrimLeft($gen_props[$r][1], $deflen)
								If $all_props[$c][$r][0] = $lbuf[2] Or $all_props[$c][$r][0] = $lbuf[2] & "(x)" Or $all_props[$c][$r][0] = $lbuf[2] & "(y)" Then
									$all_props[$c][$r][1] = $undef_marker
									$dum = "@" & $z & ": " & $lbuf[2] & " undefined "
									If $def = $undef_marker Then	;  Or StringInStr($AutoProps, $lbuf[2])
										$dum = "*" & $dum & $remove_marker
										$all_props[$c][$r][1] = "* " & $all_props[$c][$r][1]
									EndIf
									FileWriteLine($hpp, $dum)
									$all_props[$c][$r][2] = ""
									For $e = 3 To $lbuf[0]
										$all_props[$c][$r][2] &= $lbuf[$e] & " "	; ... add comments, if any
									Next
									$all_props[$c][$r][3] = $z
									ExitLoop
								EndIf
							Next
							If $dum = "" Then
								FileWriteLine( $subdir & "\missing.log", $lbuf[2] )
								FileWriteLine($hpp, "+@" & $z & ": " & $cam_h[$z] & $miss_marker)
							EndIf
					EndSwitch
				Next
			Else
				FileWriteLine($hpp, "!!! " & $lbuf & " MISSING !!!")
				FileWriteLine($hpp, $mark)
			EndIf

			; end of current cam section detected ...
			$all_props[$c][$gpc][0] = $cur_cam
			$dum = ""
			$DryFlag = 0
			For $r = 0 To $gpc - 1
				; create property list for current cam ...
				If $dum <> "" Then $dum &= @CRLF
				$dum &= ($all_props[$c][$r][0] & " = " & $all_props[$c][$r][1] & "  // @" & $all_props[$c][$r][3] & " " & $all_props[$c][$r][2])
				If $all_props[$c][$r][0] = "CAM_DRYOS" And $all_props[$c][$r][1] = "1" Then $DryFlag = 1
			Next
			$cam_props[$c - 1][1] = $dum
			$dry_cams[$c - 1] = $DryFlag
			GUICtrlSetFont($but_cams[$c - 1], $cam_font_size, $fonw)
			GUICtrlSetColor($but_cams[$c - 1], $CP_color[1][0])
			GUICtrlSetBkColor($but_cams[$c -1], $CP_color[1][1])
		Next
	Else
		; build uses classical, large camera.h
		For $z = $generic + 1 To $cam_h[0]
			If $cam_h[$z] = "" Or StringLeft($cam_h[$z], 2) = "//" Then ContinueLoop ; it's an empty or comment line
			; remove line continuation chars & concatenate lines ...
			If StringRight($cam_h[$z], 1) = "\" Then
				$cam_h[$z] = StringTrimRight($cam_h[$z], 1)
				$r = $z + 1
				Do
					$cam_h[$z] &= StringTrimRight($cam_h[$r], 1)
					$r += 1
				Until StringRight($cam_h[$r], 1) <> "\"
				$cam_h[$z] &= $cam_h[$r]
			EndIf

			$lbuf = StringSplit($cam_h[$z], Chr(9) & " ")

			If $cur_cam = "" Then
				; as long as $cur_cam = "" we're in the generic section, we will store
				; all found properties in $gen_props and prefix them with [default]
				Switch $lbuf[1]
					Case "#define"
						$gen_props[$gpc][0] = $lbuf[2]
						$gen_props[$gpc][1] = ""
						$gen_props[$gpc][2] = ""
						$gen_props[$gpc][3] = $z
						For $r = 3 To $lbuf[0]
							If StringInStr($lbuf[$r], "//") Then
								$comment = $r
								ExitLoop
							EndIf
							$gen_props[$gpc][1] &= $lbuf[$r]
						Next
						FileWriteLine($hpp, "@" & $z & ": " & $gen_props[$gpc][0] & " defined as " & $gen_props[$gpc][1])
						$gen_props[$gpc][1] = $default_marker & $gen_props[$gpc][1]
						For $r = $comment To $lbuf[0]
							$gen_props[$gpc][2] &= $lbuf[$r] & " "
						Next
						$gpc += 1
					Case "#undef"
						$gen_props[$gpc][0] = $lbuf[2]
						$gen_props[$gpc][1] = $default_marker & $undef_marker
						$gen_props[$gpc][2] = ""
						$gen_props[$gpc][3] = $z
						For $r = 3 To $lbuf[0]
							$gen_props[$gpc][2] &= $lbuf[$r] & " "
						Next
						FileWriteLine($hpp, "@" & $z & ": " & $gen_props[$gpc][0] & " undefined")
						$gpc += 1
					Case "#if"
						$DefPropsEnd = $z
						$cur_cam = StringTrimLeft(StringTrimRight($lbuf[3], 1), 8) ; strip off "(CAMERA_" & ")"
						; now is the time to sort gen_props alphabetically ...
						If $alphasort = 1 Then _ArraySort($gen_props, 0, 0, $gpc - 1, 0)
						; now copy $gen_props into $all_props for all camera's
						For $w = 0 To $sup_cams
							For $x = 0 To $gpc
								For $y = 0 To 3
									$all_props[$w][$x][$y] = $gen_props[$x][$y]
								Next
							Next
						Next
						$dum = ""
						$DefaultProps[0] = "Default"
						For $r = 0 To $gpc
							; create default property list ...
							If $dum <> "" Then $dum &= @CRLF
							$dum &= ($gen_props[$r][0] & " = " & $gen_props[$r][1] & "  // @" & $gen_props[$r][3] & " " & $gen_props[$r][2])
						Next
						$DefaultProps[1] = $dum
						FileWriteLine($hpp, $mark)
						FileWriteLine($hpp, $cur_cam & " property scan from:")
						FileWriteLine($hpp, $sourcedir & "\include\camera.h")
						FileWriteLine($hpp, $mark)
					Case Else
						; ignore any lines not matched above
						ContinueLoop
				EndSwitch
			Else
				; $cur_cam <> "", we're in a specific cam section and will use any found #define or #undef's
				; to override the default settings (in $all_props, which INITIALLY equals $gen_props)
				For $r = 0 To $sup_cams - 1
					If $cam_props[$r][0] = $cur_cam Then
						$idx = $r + 1
						ExitLoop
					EndIf
				Next
				$dum = ""
				Switch $lbuf[1]
					Case "#define"
						For $r = 0 To $gpc	; scan $cur_props ...
							$def = "(" & StringTrimLeft($gen_props[$r][1], $deflen) & ")"
							If StringInStr( $lbuf[2], $all_props[$idx][$r][0] ) Then	; ... until property found ...
								$all_props[$idx][$r][1] = ""
								$all_props[$idx][$r][2] = ""
								$all_props[$idx][$r][3] = $z
								For $e = 3 To $lbuf[0]
									$comment = $e
									If StringInStr($lbuf[$e], "//") Then ExitLoop
									$all_props[$idx][$r][1] &= $lbuf[$e]	; ... overwrite property value
									$comment += 1
								Next
								$dum = "@" & $z & ": " & $lbuf[2] & " defined as " & $all_props[$idx][$r][1]
								If StringInStr($def, $all_props[$idx][$r][1]) Then
									$all_props[$idx][$r][1] = "* " & $all_props[$idx][$r][1]
									$dum = "*" & $dum & $remove_marker
								EndIf
								FileWriteLine($hpp, $dum)
								$dum = "yep"
								$all_props[$idx][$gpc][2] = ""
								For $e = $comment To $lbuf[0]
									$all_props[$idx][$r][2] &= $lbuf[$e] & " "
								Next
								ExitLoop
							EndIf
						Next
						If $dum = "" Then
							FileWriteLine( $subdir & "\missing.log", $lbuf[2] )
							FileWriteLine($hpp, "+@" & $z & ": " & $cam_h[$z] & $miss_marker)
						EndIf
					Case "#undef"
						For $r = 0 To $gpc
							$def = StringTrimLeft($gen_props[$r][1], $deflen)
							If $all_props[$idx][$r][0] = $lbuf[2] Or $all_props[$idx][$r][0] = $lbuf[2] & "(x)" Or $all_props[$idx][$r][0] = $lbuf[2] & "(y)" Then
								$all_props[$idx][$r][1] = $undef_marker
								$all_props[$idx][$r][2] = ""
								$all_props[$idx][$r][3] = $z
								$dum = "@" & $z & ": " & $lbuf[2] & " undefined"
								If $def = $undef_marker Then
									$all_props[$idx][$r][1] = "* " & $all_props[$idx][$r][1]
									$dum = "*" & $dum & $remove_marker
								EndIf
								FileWriteLine($hpp, $dum)
								$dum = "yep"
								For $e = 3 To $lbuf[0]
									$all_props[$idx][$r][2] &= $lbuf[$e] & " "
								Next
								ExitLoop
							EndIf
						Next
						If $dum = "" Then
							FileWriteLine( $subdir & "\missing.log", $lbuf[2] )
							FileWriteLine($hpp, "+@" & $z & ": " & $cam_h[$z] & $miss_marker)
						EndIf
					Case "#elif", "#else"
						; end of current cam section detected ...
						$DryFlag = 0
						For $r = 0 To $gpc - 1
							; create property list for current cam ...
							If $dum <> "" Then $dum &= @CRLF
							$dum &= ($all_props[$idx][$r][0] & " = " & $all_props[$idx][$r][1] & "  // @" & $all_props[$idx][$r][3] & " " & $all_props[$idx][$r][2])
							If $all_props[$idx][$r][0] = "CAM_DRYOS" And $all_props[$idx][$r][1] = "1" Then $DryFlag = 1
						Next
						$all_props[$idx][$gpc][0] = $cur_cam
						For $r = 0 To $sup_cams - 1
							If $cam_props[$r][0] = $cur_cam Then
								$cam_props[$r][1] = $dum
								$dry_cams[$r] = $DryFlag
								GUICtrlSetFont($but_cams[$r], $cam_font_size, $fonw)
								GUICtrlSetColor($but_cams[$r], $CP_color[1][0])
								GUICtrlSetBkColor($but_cams[$r], $CP_color[1][1])
								ExitLoop
							EndIf
						Next
						If $lbuf[1] = "#else" Then
							; it was the last cam, we're done !
							ExitLoop
						Else
							; set name for next cam
							$cur_cam = StringTrimLeft(StringTrimRight($lbuf[3], 1), 8) ; strip off "(CAMERA_" & ")"
							FileWriteLine($hpp, $mark)
							FileWriteLine($hpp, $cur_cam & " property scan from:")
							FileWriteLine($hpp, $sourcedir & "\include\camera.h")
							FileWriteLine($hpp, $mark)
						EndIf
				EndSwitch
			EndIf
		Next
	EndIf
	FileClose($hpp)
	$sourcedir0 = $sourcedir
	$w_propsortalpha0 = $w_propsortalpha
	If Not $startup Then DisableMainControls(0)
	$StatusMsg = $ready
	UpdateStatus()
_ap_ProfileStop(57)
EndFunc   ;==>GetCamProperties
; --------------------------------------------
Func ShowCamProps($camno)
_ap_ProfileStart(58)
	Local $_h, $thisline, $buffer = "", $cam_h = $sourcedir & "\include\camera.h", $ppath = $sourcedir & "\platform\"
	Local $firm_enum = "", $loc_cam_h, $ext_prim, $mark = _StringRepeat("=", 106)
	Static $mbox_timeout25 = 30

	$ext_prim = IniRead($inifile, $sections[0], "ext_primary", "")
	If $ext_prim <> "" And FileExists($ext_prim & "\" & $cam_props[$camno][0]) Then
		Local $short_name = StringSplit($cam_props[$camno][0], "_")
		Local $pdf, $srch = FileFindFirstFile($ext_prim & "\" & $cam_props[$camno][0] & "\*.pdf")
		While 1
			$pdf = FileFindNextFile($srch)
			If @error = 1 Then ExitLoop
			For $i = 1 To $short_name[0]
				If StringInStr($pdf, $short_name[$i]) Then
					ShellExecute($ext_prim & "\" & $cam_props[$camno][0] & "\" & $pdf)
					ExitLoop 2
				EndIf
			Next
		WEnd
		FileClose($srch)
		FileChangeDir($here)
	EndIf

	If Not FileExists($cam_h) Then		; Or FileGetSize($cam_h) < 20000
		Dlg_MyMsgBox(0, "Unknown camera.h !", "Sorry, can't get cam properties for this build", $mbox_timeout25, $main)
		If @error <> 0 Then
			$mbox_timeout25 = @error
		Else
			$mbox_timeout25 = @extended
		EndIf
_ap_ProfileStop(58)
		Return
	EndIf
	$loc_cam_h = $ppath & $cam_props[$camno][0] & "\platform_camera.h"
	If FileGetSize($cam_h) > 20000 Then $loc_cam_h = $cam_h
	$_h = FileOpen($subdir & "\camprop.txt", 2) ; overwrite

	For $i = 1 To $maxfirm
		If $cams[$camno][$i] = "" Then ExitLoop
		$firm_enum &= " " & $cams[$camno][$i]
		For $z = 0 To UBound($firmdup) - 1
			If $firmdup[$z][0] = "" Then ExitLoop
			If $firmdup[$z][0] = $cam_props[$camno][0] Then
				If $firmdup[$z][1] = $cams[$camno][$i] Then
					$firm_enum &= "(=" & $firmdup[$z][2] & ")"
					ExitLoop
				EndIf
			EndIf
		Next
	Next
	FileWrite($_h, "Camera properties for " & StringUpper($cam_props[$camno][0]) & " - firmwares:" & $firm_enum & @CRLF)
	FileWrite($_h, "Derived from the Default properties in: " & $cam_h & @CRLF)

	If FileExists($loc_cam_h) Then
		FileWrite($_h, "And Overridden properties in: " & $loc_cam_h & @CRLF & @CRLF)
		FileWriteLine($_h, "ALL CAMERA PROPERTIES (after applying overrides)")
	EndIf
	FileWriteLine($_h, $mark )
	FileWriteLine($_h, "Notes:")
	FileWrite($_h, "The following tags were added to the values:" & @CRLF & Chr(9) & "  #undef  --> property was #undef'ed" & @CRLF & Chr(9) & "[DEFAULT] --> (prefix) cam uses property inherited from Default Values" & @CRLF)
	If FileExists($loc_cam_h) Then
		FileWriteLine($_h, Chr(9) & "    *     --> (prefix) cam uses Default value, but overrides it anyway ...")
		FileWriteLine($_h, @CRLF & "Line numbers ('@xxx') for [DEFAULT] properties refer to " & $cam_h & " !")
	Else
		FileWriteLine($_h, @CRLF & "Warning: " & $loc_cam_h & " missing, using Default properties only !")
	EndIf
	FileWriteLine($_h, $mark )
	FileWriteLine($_h, "")
	FileWriteLine($_h, $cam_props[$camno][1])
	FileWriteLine($_h, "")
	FileWriteLine($_h, "")
	$thisline = StringSplit($cam_props[$camno][1], @CRLF)
	For $i = 1 To $thisline[0]
		If StringInStr($thisline[$i], "= *") Then $buffer &= $thisline[$i] & @CRLF
	Next
	If $buffer <> "" Then
		FileWriteLine($_h, _StringRepeat("*", 106) & @CRLF & @CRLF & "The following OVERRIDES can PROBABLY be REMOVED (in " & $loc_cam_h & ")")
		FileWrite($_h, @CRLF & $buffer & @CRLF & _StringRepeat("*", 106) & @CRLF & @CRLF)
	EndIf

	FileClose($_h)
	ShellExecute($subdir & "\camprop.txt")
	ControlFocus($main, "", $but_def_focus)
_ap_ProfileStop(58)
EndFunc   ;==>ShowCamProps
; --------------------------------------------
Func XRefCamProps($show = True)
_ap_ProfileStart(59)

	Local $term, $line, $buffer, $all_cam_props[$sup_cams][200], $head = "Cam #|Camera"
	Local $output = $sourcedir & "\camprops_xref.log"
	Local $description = "Current Camera Properties, full report + fixes here:  " & StringUpper($output)
	Local $sig = "Generated by " & $Title & "  ( Source Code Tools -> Cam Properties Cross-reference -> Show )"
	Local $_tmp, $missing, $spacepad = _StringRepeat(" ", 152)	; , $column[$sup_cams], $default
	Local $message = "Cross-Referencing ...", $smark = _StringRepeat("*", 100), $mark = _StringRepeat("=", 100)
	Local $remove_marker = "   <----- can be commented out/removed"
	Local $default_marker = "[DEFAULT] "
	Local $c_h = "camera.h", $l_c_h = StringLen($c_h)
	Local $cam_h_main = $sourcedir & "\include\" & $c_h
	Local $def_platform = $sourcedir & "\platform\{camname}\platform_" & $c_h
	Local $fixed_lines[2] = [ 0, 0 ]

;~ 	Local $newsys = False
;~ 	If FileGetSize($cam_h_main) < 20000 Then $newsys = True

	DisableMainControls(1)
	AutoSplash($message)
	$StatusMsg = $message
	UpdateStatus()

	For $i = 0 To $sup_cams - 1
		$buffer = StringSplit($cam_props[$i][1], @CRLF, 1)
		$all_cam_props[$i][0] = StringUpper($cam_props[$i][0])
		For $k = 1 To $buffer[0]
			$line = StringSplit($buffer[$k], " = ", 1)
			If $i = 1 Then $head &= "|" & $line[1]
			$term = StringSplit($line[2], "//", 1)
			If IsArray($term) Then
				$_tmp = $term[1]
			Else
				$_tmp = $line[2]
			EndIf
			$all_cam_props[$i][$k] = StringStripWS($_tmp, 3)
		Next
	Next

	Local $headers = StringSplit($head, "|")
	Local $strlen[$headers[0]]

	For $x = 2 To $headers[0]
		$strlen[$x - 2] = StringLen($headers[$x])
		For $y = 0 To $sup_cams - 1
			$_tmp = StringLen($all_cam_props[$y][$x - 2])
			If $strlen[$x - 2] < $_tmp Then $strlen[$x - 2] = $_tmp
		Next
	Next
	Local $han = FileOpen($output, 2)
	; write comment & explain ...
	FileWrite($han, _StringRepeat("=", StringLen($sig)) & @CRLF)
	FileWrite($han, "Overview of Camera Properties, as found in: " & $cam_h_main & @CRLF )
	FileWrite($han, "(and - if applicable - " & $def_platform & @CRLF )
	FileWrite($han, $sig & @CRLF)
	FileWrite($han, "Please open this in a REAL editor, the lines are too long for Notepad, even without WordWrap ;)" & @CRLF)
	FileWrite($han, _StringRepeat("=", StringLen($sig)) & @CRLF & @CRLF)

	FileWriteLine($han, "Check Scan log (at the end of this file) for properties that have no default,")
	FileWrite($han, "or are overridden to the same value as the default." & @CRLF & @CRLF)
	FileWrite($han, "The following tags were added to the values:" & @CRLF & @CRLF & Chr(9) & "  #undef  --> property was #undef'ed" & @CRLF & @CRLF & Chr(9) & $default_marker & "--> (prefix) cam uses property inherited from Default Values" & @CRLF & @CRLF & Chr(9) & "    *     --> (prefix) cam uses Default value, but overrides it anyway ..." & @CRLF & @CRLF & @CRLF	)

	Local $headfoot = ""
	$buffer = ""
	; first write the headers/footers ...
	For $k = 2 To $headers[0]
		$headfoot &= ( StringLeft($headers[$k] & $spacepad, $strlen[$k - 2] + 3) )
		$buffer &= ( StringLeft(_StringRepeat("=", $strlen[$k - 2]) & $spacepad, $strlen[$k - 2] + 3) )
		; after every 2 properties, insert cam names
		If $k > 2 And Mod($k, 2) = 0 Then
			$headfoot &= ( StringLeft($headers[2] & $spacepad, $strlen[0] + 3) )
			$buffer &= ( StringLeft(_StringRepeat("=", $strlen[0]) & $spacepad, $strlen[0] + 3) )
		EndIf
	Next
	For $i = 0 To $sup_cams - 1
		If Mod($i, 24) = 0 Then FileWrite($han, $buffer & @CRLF & $headfoot & @CRLF & $buffer & @CRLF)
		$_tmp = ""
		For $k = 2 To $headers[0]
			$_tmp &= ( StringLeft($all_cam_props[$i][$k - 2] & $spacepad, $strlen[$k - 2] + 3) )
			; after every 2 properties, insert cam names
			If $k > 2 And Mod($k, 2) = 0 Then
				$_tmp &= ( StringLeft($all_cam_props[$i][0] & $spacepad, $strlen[0] + 3) )
			EndIf
		Next
		FileWriteLine($han, $_tmp)
	Next

	If FileExists($subdir & "\missing.log") Then
		_FileReadToArray($subdir & "\missing.log", $missing)
		_ArraySort($missing, 0, 1)
		For $i = 1 To $missing[0]
			If $missing[$i] = "" Then ContinueLoop
			For $k = $i + 1 To $missing[0]
				If $missing[$k] = "" Then ContinueLoop
				If $missing[$k] = $missing[$i] Then $missing[$k] = 0
				If $missing[$k] = $missing[$i] & "(x)" Then $missing[$k] = 0
				If $missing[$k] = $missing[$i] & "(y)" Then $missing[$k] = 0
			Next
		Next
		FileWriteLine($han, @CRLF & @CRLF & @CRLF & $smark )
		FileWriteLine($han, _StringRepeat("*", 20) & " SUGGESTED ADDITION TO default section of include\camera.h " & _StringRepeat("*", 21) )
		FileWrite($han, $smark & @CRLF & @CRLF)
		$buffer = ""
		For $i = 1 To $missing[0]
			If $missing[$i] <> "" And Not StringInStr($head, $missing[$i]) Then 	; $buffer &= $missing[$i] & "|"
				If Not StringInStr($AutoProps, $missing[$i]) Then
					FileWriteLine($han, "#undef " & $missing[$i])
					$buffer &= "#undef " & $missing[$i] & @CRLF
					$fixed_lines[0] += 1
				EndIf
			EndIf
		Next
		If $buffer <> "" Then
			FileDelete($subdir & "\missing.fix")
			FileWrite($subdir & "\missing.fix", $buffer )
		EndIf
	EndIf

	FileWriteLine($han, @CRLF & @CRLF & $smark )
	FileWriteLine($han, _StringRepeat("*", 31) & " SCAN LOG AND SUGGESTIONS FOR REMOVAL " & _StringRepeat("*", 31) )
	FileWrite($han, $smark & @CRLF & @CRLF & @CRLF )

	_FileReadToArray($subdir & "\parsed_props.log", $buffer)
	Local $p = 0, $m1, $m2, $lbuf, $sections = 0
	Local $camstart
	Do
		$p += 1
		$lbuf = $buffer[$p]
	Until StringRight($lbuf, $l_c_h) = $c_h
	$m2 = $p

	While 1
		$m1 = $m2
		Do
			$p += 1
			If $p > $buffer[0] Then ExitLoop 2
			$lbuf = $buffer[$p]
		Until StringRight($lbuf, $l_c_h) = $c_h
		$m2 = $p
		If $m1 < 10 Then $camstart = $m2
		$sections += 1
		$message = "Recursive defines " & $sections & "/" & $sup_cams & " ..."
		AutoSplash($message)
		$StatusMsg = $message
		UpdateStatus()
		; check for props defined as another prop ...
		For $i = $m2 To $m1 Step -1
			$lbuf = StringSplit($buffer[$i], " ")
			If @error = 1 Or StringLeft($lbuf[1], 1) <> "@" Or $lbuf[0] < 5 Then ContinueLoop
			For $v = $i - 1 To $m1 Step -1
				$line = StringSplit($buffer[$v], " ")
				If @error = 1 Or $line[0] < 5 Then ContinueLoop
				If $lbuf[5] = $line[2] Then
					$buffer[$i] = "~" & StringReplace($buffer[$i], $lbuf[5], $line[5] & "  <--- was: " & $lbuf[5])
					For $w = 1 To $camstart
						$lbuf = StringSplit($buffer[$w], " ")
						If @error = 1 Or StringLeft($lbuf[1], 1) <> "@" Or $lbuf[0] < 5 Then ContinueLoop
						If $lbuf[2] = $line[2] Then
							If $lbuf[5] = $line[5] Or $lbuf[5] = "(" & $line[5] & ")" Or "(" & $lbuf[5] & ")" = $line[5] Then $buffer[$i] = "*" & $buffer[$i] & $remove_marker
							ExitLoop
						EndIf
					Next
					ExitLoop
				EndIf
			Next
		Next
	WEnd
	$p = 0
	$sections = 0
	Do
		$p += 1
		$lbuf = $buffer[$p]
	Until StringRight($lbuf, $l_c_h) = $c_h
	$m2 = $p

	While 1
		$m1 = $m2
		Do
			$p += 1
			If $p > $buffer[0] Then ExitLoop 2
			$lbuf = $buffer[$p]
		Until StringRight($lbuf, $l_c_h) = $c_h
		$m2 = $p
		$sections += 1
		$message = "Post Recursion check " & $sections & "/" & $sup_cams & " ..."
		AutoSplash($message)
		$StatusMsg = $message
		UpdateStatus()
		; mark superfluous defs & undefs ...
		For $i = $m2 To $m1 Step -1
			$lbuf = StringSplit($buffer[$i], " ")
			If @error = 1 Or StringLeft($lbuf[1], 1) <> "*" Or $lbuf[3] <> "defined" Then ContinueLoop
			For $v = $i - 1 To $m1 Step -1
				$line = StringSplit($buffer[$v], " ")
				If @error = 1 Or StringLeft($line[1], 1) <> "@" Then ContinueLoop
				If $lbuf[2] = $line[2] Or $lbuf[2] = $line[2] & "(x)" Or $lbuf[2] = $line[2] & "(y)" Then
					$buffer[$v] = "*" & $buffer[$v] & $remove_marker
				EndIf
			Next
		Next
	WEnd

	Local $han2 = FileOpen($subdir & "\reparsed_props.log", 2)
	Local $non_overridden = 0
	For $i = 1 To $buffer[0]
		If StringLeft($buffer[$i], 1) = "*" Then $fixed_lines[1] += 1
		If StringLeft($buffer[$i], 1) = "!" Then $non_overridden += 1
		FileWriteLine( $han, $buffer[$i])
		FileWriteLine($han2, $buffer[$i])
	Next
	FileClose($han2)

	FileWriteLine($han, @CRLF & @CRLF & $mark)
	FileWriteLine($han, "Found " & $fixed_lines[0] & " lines to add to " & $cam_h_main )
	FileWriteLine($han, "Found " & $fixed_lines[1] & " lines to uncomment or remove" )
	FileWriteLine($han, "Found " & $non_overridden & " camera's with missing platform_camera.h " )
	FileWriteLine($han, $mark)

	FileClose($han)
	$StatusMsg = $ready
	DisableMainControls(0)
	UpdateStatus()
	AutoSplash("")
_ap_ProfileStop(59)
	If $show Then _ArrayDisplay($all_cam_props, $description, -1, 0, "", "|", $head)	; kept outside of profiling because it is blocking
EndFunc   ;==>XRefCamProps
; --------------------------------------------
Func PreCompile()
_ap_ProfileStart(60)
	Local $ret, $comp_warn, $logdir = $sourcedir & "\bin\logs"

	If $GCCpath = $GCC4path And $AutoGCC = 0 Then
		$comp_warn = "This trunk version does NOT adapt its' CFLAGS" & @CR & "to the compiler version automatically." & @CR & "You have GCC4 selected, so you should probably" & @CR
		If $NoGCC4Flags <> "" Then
			$comp_warn &= "uncomment the following in 'makefile.inc':" & @CR & @CR & $NoGCC4Flags
			If $InstallFlag = 7 Then $comp_warn &= @CR & @CR & " - or "
		EndIf
		If $InstallFlag = 7 Then $comp_warn &= "switch to GCC3."
		$comp_warn &= @CR & @CR & "Continue compilation anyway ?"
		$ret = MsgBox($topmost + 4, "Warning", $comp_warn)
		If $ret = 7 Then
_ap_ProfileStop(60)
			Return False ; return if 'No' selected
		EndIf
	EndIf
	Set_CompileType()
	;MsgBox($topmost, "Debug", "MakStyle=" & $MakStyle & @CR & "MakCmd=" & $MakCmd)
	MakeBatch($sourcedir)
	$ret = StringReplace(FileRead($sourcedir & "\localbuildconf.inc"), @LF, @CRLF)
	FileWrite($sourcedir & "\buildconf.txt", $ret)
	Reset_Colors()
	DirCreate($logdir)
	$errlog = $logdir & "\errors.txt"
	FileDelete($errlog)
	FileDelete($sourcedir & "\bin\caminfo.txt")
	GUICtrlSetState($but_err_show, 32) ; $GUI_HIDE = 32
	DisableMainControls(1)
_ap_ProfileStop(60)
	Return True
EndFunc   ;==>PreCompile
; --------------------------------------------
Func Compile($all)
_ap_ProfileStart(61)
	Local $q, $s_hnd, $fn, $realfirm, $count = 0, $total = $all * $sup_firms
	Local $dummy, $copyflag, $copylist = ""

	If Not IsChecked($chk_comp_all) And $all = 1 Then
		GUISetState($State_Disable, $main)
		$q = MsgBox($topmost + 4, "Compile All", "With recent builds this wil take several HOURS ..." & @CR & "Are you sure you want to continue ?" & @CR & @CR & "[ disable this warning with checkbox next to button ]")
		GUISetState($State_Enable, $main)
		WinActivate($main)
		If $q = 7 Then
_ap_ProfileStop(61)
			Return
		EndIf
	EndIf
	If Not PreCompile() Then
_ap_ProfileStop(61)
		Return
	EndIf

	If $all = 1 Then
		For $c = 0 To $sup_cams - 1
			For $f = 1 To $maxfirm
				GUICtrlSetState($chk_cams[$c][$f - 1], 128)	; $GUI_DISABLE = 128
			Next
		Next
	EndIf

	For $c = 0 To $sup_cams - 1
		$copylist = ""
		For $f = 1 To $maxfirm
			If IsChecked($chk_comp_abort) Then ExitLoop 2
			If $cams[$c][$f] == "" Then ExitLoop
			If $all = 0 Then
				GUICtrlSetState($chk_cams[$c][$f - 1], 128)	; $GUI_DISABLE = 128
				; this assures that $total gets updated before every compilation,
				; in case user makes changes during the process ...
				$total = 0
				For $e = 0 To $sup_cams - 1
					For $g = 1 To $maxfirm
						If IsChecked($chk_cams[$e][$g - 1]) Then $total += 1
					Next ; $g
				Next ; $e
			EndIf
			If IsChecked($chk_cams[$c][$f - 1]) Or $all = 1 Then
				$count += 1
				If $count = $total Then
					GUICtrlSetState($chk_comp_abort, 36) ; $GUI_HIDE = 32, $GUI_UNCHECKED = 4
				Else
					GUICtrlSetState($chk_comp_abort, 20) ; $GUI_SHOW = 16, $GUI_UNCHECKED = 4
				EndIf
				; check if the the selected cam/firm is a dup
				$IsDuplicate = -1
				$realfirm = $cams[$c][$f]
				$copyflag = 0
				For $q = 0 To $sup_cams - 1
					If $firmdup[$q][0] = "" Then ExitLoop
					If $cams[$c][0] = $firmdup[$q][0] And $cams[$c][$f] = $firmdup[$q][1] Then
						FileWriteLine($sourcedir & "\bin\caminfo.txt", " ==== Please note that for " & $firmdup[$q][0] & " firmware " & $firmdup[$q][1] & " is identical to " & $firmdup[$q][2] & " ====")
						For $z = 1 To $maxfirm
							If $cams[$c][$z] = $firmdup[$q][2] And IsChecked($chk_cams[$c][$z - 1]) Then
								; original firm also selected, mark for copying later
								$copylist &= $firmdup[$q][0] & "-" & $firmdup[$q][2] & " " & $firmdup[$q][0] & "-" & $firmdup[$q][1] & " "
								$copyflag = 1
								ExitLoop 2
							EndIf
						Next
						$realfirm = $firmdup[$q][2]
						$IsDuplicate = $q
						ExitLoop
					EndIf
				Next
				; remove zips left over from previous compilation for this cam /firm ...
				FileChangeDir($sourcedir & "\bin")
				$s_hnd = FileFindFirstFile("*.zip")
				While 1
					$dummy = FileFindNextFile($s_hnd)
					If @error = 1 Then ExitLoop
					If StringInStr($dummy, $cams[$c][0] & "-" & $cams[$c][$f]) Then
						FileDelete($sourcedir & "\bin\" & $dummy)
					EndIf
				WEnd
				FileClose($s_hnd)
				FileChangeDir($here)
				; if marked for later copying, skip compilation ...
				If $copyflag = 1 Then
					GUICtrlSetBkColor($chk_cams[$c][$f - 1], $seagreen)
					ContinueLoop
				EndIf
				GUICtrlSetBkColor($chk_cams[$c][$f - 1], $red)
				$StatusMsg = "[" & $count & " of " & $total & "] Compiling for: " & StringUpper($cams[$c][0] & "-" & $cams[$c][$f])
				UpdateStatus()
				If $Introspection Then FileWriteLine($tracelog, $Pad & $StatusMsg)
				$dummy = "docam " & $cams[$c][0] & " " & $realfirm
				Local $ts = TimerInit()
				DosExec($dummy) ; run the compile batch
				$dummy = StringFormat("'" & $dummy & "': run took %.2f seconds", TimerDiff($ts) / 1000 )
				If $Introspection Then FileWriteLine($tracelog, $Pad & $dummy)
				If IsChecked($chk_debug2) Then MsgBox($topmost, "Info", $dummy, 10, $main)
				Local $camlog = $sourcedir & "\bin\logs\log-" & $cams[$c][0] & "-" & $realfirm & ".txt"
				FileWriteLine($camlog, $dummy)
				$dummy = StringReplace($camlog, "log-", "err-")
				If FileGetSize($dummy) = 0 Then
					GUICtrlSetBkColor($chk_cams[$c][$f - 1], $green)
				Else
					GUICtrlSetBkColor($chk_cams[$c][$f - 1], $orange)
					; if this compilation caused errors/warnings, then append to main error log
					FileWriteLine($errlog, "========== " & StringUpper($dummy) & " ==========" & @CRLF & @CRLF)
					SilentDosExec("copy " & $errlog & "+" & $dummy & " " & $errlog)
					FileWriteLine($errlog, @CRLF)
				EndIf
				FileDelete($dummy)
				FileChangeDir($sourcedir & "\bin")
				$s_hnd = FileFindFirstFile("*.zip")
				While 1
					$dummy = FileFindNextFile($s_hnd)
					If @error = 1 Then ExitLoop
					If Not StringInStr($dummy, $cams[$c][0] & "-" & $realfirm) Then ContinueLoop
					SilentDosExec($GCCpath & '\zip -9j ' & $sourcedir & '\bin\' & $dummy & ' ' & $sourcedir & '\buildconf.txt')
					$fn = $dummy
					If StringInStr($dummy, "-r" & $LongBuildName) = 0 Then
						If StringInStr($dummy, "-" & $CurrentBuild) = 0 Then
							$q = ".zip"
							If StringInStr($dummy, "-full") Then $q = "-full" & $q
							$fn = StringReplace($dummy, $q, "-r" & $LongBuildName & $q)
						Else
							$fn = StringReplace($dummy, $CurrentBuild, "r" & $LongBuildName)
						EndIf
					EndIf
					If $IsDuplicate > -1 Then
						If StringInStr($fn, $firmdup[$IsDuplicate][0]) > 0 Then
							If StringInStr($fn, $firmdup[$IsDuplicate][2]) Then
								$fn = StringReplace($fn, $firmdup[$IsDuplicate][2], $firmdup[$IsDuplicate][1])
							EndIf
						EndIf
					EndIf
					If StringLeft($fn, 8) == "CHDK-DE-" Then $fn = StringTrimLeft($fn, 8)
					If StringLeft($fn, 5) == "CHDK-" Then $fn = StringTrimLeft($fn, 5)
					If $fn <> $dummy Then FileMove(@WorkingDir & "\" & $dummy, @WorkingDir & "\" & $fn)
				WEnd
				FileClose($s_hnd)
				FileChangeDir($here)

				DiskSpace()
			EndIf
		Next ; $f
		; done for this cam, before switching to next, check if duplicate copying is needed ...
		Local $cline
		If $copylist <> "" Then
			$copylist = StringTrimRight($copylist, 1)	; remove trailing space
			$cline = StringSplit($copylist, " ")
			FileChangeDir($sourcedir & "\bin")
			For $z = 1 To $cline[0] - 1 Step 2
				$s_hnd = FileFindFirstFile("*.zip")
				While 1
					$dummy = FileFindNextFile($s_hnd)
					If @error = 1 Then ExitLoop
					If StringInStr($dummy, $cline[$z]) Then
						FileCopy(@WorkingDir & "\" & $dummy, @WorkingDir & "\" & StringReplace($dummy, $cline[$z], $cline[$z+1]), 1)
					EndIf
				WEnd
				FileClose($s_hnd)
			Next
			FileChangeDir($here)
		EndIf
	Next ; $c
	PostCompile()
_ap_ProfileStop(61)
	If Not IsChecked($chk_comp_abort) And $count = 0 And $all = 0 Then Dlg_MyMsgBox(0, "Compilation Failed", "No target cams selected ...")
EndFunc   ;==>Compile
; --------------------------------------------
Func PostCompile()
_ap_ProfileStart(62)

	$StatusMsg = $ready
	UpdateStatus()
	GUICtrlSetState($chk_comp_abort, 36) ; $GUI_HIDE = 32, $GUI_UNCHECKED = 4
	SetIncrementalLockControls()
	If FileExists($errlog) Then
		GUICtrlSetState($but_err_show, 16) ; $GUI_SHOW = 16
		If IsChecked($chk_autoerr) Then
			ShellExecute($errlog, "", $sourcedir, "open")
		EndIf
	EndIf
	FileDelete($sourcedir & "\buildconf.txt")
	FileDelete($sourcedir & "\docam.cmd")
	FileChangeDir($here)
_ap_ProfileStop(62)
EndFunc   ;==>PostCompile
; --------------------------------------------
Func AutoCompile()
_ap_ProfileStart(63)
	Local $all, $savstate, $auto = IniRead($inifile, $sections[1], "autocompile_option", 0)

	If $auto = 0 Then
_ap_ProfileStop(63)
		Return
	EndIf
	$all = 2 - $auto
	If $all = 0 Then
		GUICtrlSetState($chk_autocams, 1) ; $GUI_CHECKED = 1
		$savstate = IsChecked($chk_comp_all)
		If $savstate Then GUICtrlSetState($chk_comp_all, 4)
	EndIf
	If $miniGUI = 1 Then AutoSplash("AutoCompiling ...")
	Compile($all)
	If $savstate Then GUICtrlSetState($chk_comp_all, 1) ; $GUI_CHECKED = 1
	$checkcompile = 0
_ap_ProfileStop(63)
EndFunc   ;==>AutoCompile
; --------------------------------------------
Func Set_CompileType()
_ap_ProfileStart(64)
	Local $opt = IsChecked($chk_comp_full)

	If $MakOptions[1][0] = "" Then $opt = 0
	$MakStyle = $MakOptions[$opt][0]
	$MakCmd = $MakOptions[$opt][1]
	SaveSett($chk_comp_full, $sections[0], "chk_compilecomplete")
_ap_ProfileStop(64)
EndFunc   ;==>Set_CompileType
; --------------------------------------------
Func DiskSpace()
_ap_ProfileStart(65)
	Local $dfs = Round(DriveSpaceFree($here) / 1024, 2)
	Local $disp = FormatFreeSpace($dfs)

	If $disp = FormatFreeSpace($diskfreespace) Then
_ap_ProfileStop(65)
		Return
	EndIf
	$diskfreespace = $dfs
	GUICtrlSetData($lab_space, $disp)
	If $miniGUI Then GUICtrlSetData($lab_minispace, " Free: " & $disp)
	If $diskfreespace < 0.25 Then
		GUICtrlSetBkColor($lab_space, $red)
		If $miniGUI Then GUICtrlSetBkColor($lab_minispace, $red)
	Else
		GUICtrlSetBkColor($lab_space, -1)
		If $miniGUI Then GUICtrlSetBkColor($lab_minispace, -1)
	EndIf
_ap_ProfileStop(65)
EndFunc   ;==>DiskSpace
; --------------------------------------------
Func Reset_Colors()
_ap_ProfileStart(67)
	For $c = 0 To $sup_cams - 1
		For $f = 1 To $maxfirm
			If $cams[$c][$f] == "" Then ExitLoop
			GUICtrlSetBkColor($chk_cams[$c][$f - 1], -1)
		Next ; $f
	Next ; $c
_ap_ProfileStop(67)
EndFunc   ;==>Reset_Colors
; --------------------------------------------
Func ToggleTrunkBranch()
_ap_ProfileStart(68)
	Local $tr = "trunk" & $site, $z = $trunk[$site]

	$LastUsed[1 - $z][$site] = $sourcedir
	If IsChecked($rad_build[1]) And $z = 0 Then
		$trunk[$site] = 1
	ElseIf IsChecked($rad_build[2]) And $z = 1 Then
		$trunk[$site] = 0
	EndIf
	IniWrite($inifile, $sections[1], $tr, $trunk[$site])
	UpdateCurrentBuild(0)
_ap_ProfileStop(68)
EndFunc   ;==>ToggleTrunkBranch
; --------------------------------------------
Func UpdateCurrentBuild($force, $preset = "")
_ap_ProfileStart(69)
	Local $build, $retflag = 0

	SaveWinState()
	WriteIni()
	If $force = -1 Then
		SelectLocalBuild(-1)	; -1 -> just refresh UI
		Build_GUI()
	Else
		GetWPos()
		$build = SelectLocalBuild($force, $preset)
		If $build <> "" And $build <> $sourcedir Then
			$retflag = 1		;  0 -> no fileselect, select latest if IsChecked($chk_nosel), else keep current
			$sourcedir = $build	;  1 -> force fileselect, no checking needed
			Build_GUI()
		EndIf
	EndIf
	If Not WinActive($ActWin) Then WinActivate($ActWin)
_ap_ProfileStop(69)
	Return $retflag
EndFunc   ;==>UpdateCurrentBuild
; --------------------------------------------
Func SelectLocalBuild($flag = 0, $preset = "")
_ap_ProfileStart(70)
	Local $i, $k, $p, $q, $cc, $fc, $thiscam, $prevcam, $thisfirm, $builddir, $root, $dummy
	Local $cp, $fp, $highbuild, $temp, $buf, $cln, $selbuild, $camindex, $tr = "trunk"
	Local $camlistfile

	$dummy = $here & $VerPrefix[$site]
	$tpath = $dummy & "\trunk"
	$bpath = $dummy & "\branches"
	$apath = $dummy & "\archives"

	If $trunk[$site] = 1 Then
		$root = $tpath
		$BuildName = $root & "\" & $tr
		$selbuild = $tr
	Else
		$root = $bpath
		$BuildName = $root & "\" & $branches[1][0]
		$selbuild = $branches[1][0]
	EndIf

	$NewestBuild = ""

	For $i = $MaxSearch[$site] To 1 Step -1
		$temp = StringFormat("%d", $i) ; "%03d"
		$highbuild = $BuildName & $temp
		If FileExists($highbuild) Then
			$NewestBuild = $temp
			If $i > $MaxBuild[$site] Then $MaxBuild[$site] = $i
			If $MaxBuild[$site] > $MinBuild[$site] Then UpdateMaxSearch()
			ExitLoop
		EndIf
	Next

	$BuildName = StringTrimLeft($BuildName, StringLen($here) + 1)
	If $trunk[$site] = 1 And $i = $MinBuild[$site] Then $InstallFlag += 10 ; probably a new install, set flag for message

	Switch $flag
		Case -1
			$builddir = $sourcedir
		Case 0
			$temp = $LastUsed[1 - $trunk[$site]][$site]
			If $LastBuildName = $Buildname And $InstallFlag < 10 And $sourcedir <> "" Then
				$builddir = $sourcedir
			ElseIf $temp = "" Or $sourcedir = "" Then
				$builddir = $highbuild
			Else
				$builddir = $temp
			EndIf
		Case 1
			If $preset = "" Then
				Do
					$builddir = FileSelectFolder("Local " & $BuildName & "xxx directory to work with" & @CRLF & "Newest is preselected; you may rename, but keep" & @CRLF & "format as '" & $BuildName & "xxx<modname>'", $root, 6, $highbuild	)
					; the 'dummy' stuff enforces that only folders whose name starts with selected build are accepted
					$dummy = StringSplit($builddir, "\")
				Until $builddir = "" Or StringLeft($dummy[$dummy[0]], StringLen($selbuild)) = $selbuild
				FileChangeDir($here)
				$dummy = 0
				If $builddir = "" Then
_ap_ProfileStop(70)
					Return "" ; nothing selected
				EndIf
			Else
				$builddir = $preset
			EndIf
	EndSwitch
	; ---------------------------------------------------------------------------------------
	If IsBuildValid($builddir) = "" Then
_ap_ProfileStop(70)
		Return $sourcedir ; invalid, so keep current
	EndIf
	; ---------------------------------------------------------------------------------------
	If $builddir <> $sourcedir Then
		$LastUsed[1 - $trunk[$site]][$site] = $builddir
		$LastBuildName = $Buildname
		$LongBuildName = StringTrimLeft($builddir, StringLen($here & "\" & $BuildName))
		$CBFN = "Current build: " & $selbuild & $LongBuildName & " [svn = " & GetSVN_Name($site) & "]"
		$CurrentBuild = ""
		For $i = 1 To StringLen($LongBuildName)
			$k = StringMid($LongBuildName, $i, 1)
			If StringIsDigit($k) Then
				$CurrentBuild &= $k
			Else
				ExitLoop
			EndIf
		Next
		; make sure revision number is inserted at the proper place (different for CHDK and CHDK-DE)
		$buf = $builddir & "\version.inc"
		$cc = 0
		If $site = 1 Then
			$dummy = FileRead($builddir & "\buildconf.inc")
			$dummy = StringReplace($dummy, "DEF_SVN_REF=0", "DEF_SVN_REF=" & $LongBuildName)
			If StringInStr($dummy, "DEF_SVN_REF=") Then
				If FileExists($buf & ".org") Then FileMove($buf & ".org", $buf, 1)
				$cc = 1
				FileDelete($builddir & "\buildconf.inc")
				FileWrite($builddir & "\buildconf.inc", $dummy)
			EndIf
		EndIf
		If $site = 0 Or $cc = 0 Then	; note: if $cc = 0, then it's an old CHDK-DE build, treat like CHDK ...
			$dummy = FileReadLine($buf)
			If StringLen($dummy) = 21 Then
				If Not FileExists($buf & ".org") Then FileCopy($buf, $buf & ".org")
				$dummy &= "-" & $LongBuildName & @LF
				FileDelete($builddir & "\version.inc")
				FileWrite($builddir & "\version.inc", $dummy)
			EndIf
		EndIf
		; safety cleaning of $cam_props & $firmdup - necessary if going from very old to new build ...
		Global $cam_props[100][2]
		Global $firmdup[100][3]

		$i = 0
		$q = 0
		$cc = -1
		$prevcam = ""
		$MakCmd = ""
		$sup_cams = 0
		$maxfirm = 0
		Local $dup_status, $status_tail
		Local $status_strings[250][3]	; [ cam, firm, status ] ONLY for alpha/beta status cam/firms
		; note: Globals $mak (array !), $MakStyle and $makstart, and $NewStyle_Makefile were initialised by call to IsBuildValid ( ~ 32 lines up )
		;
		; ============================================================================
		; 13-09-11 support for philmoz' new Makefile system added, 12-10 modded for v2
		; ============================================================================
		Local $first_entry = 2, $dups
		If $NewStyle_Makefile Then
			$camlistfile = $builddir & '\camera_list.csv'
			If Not FileExists($camlistfile) Then
				$camlistfile = $builddir & '\camindex.csv'
				$first_entry = 1

				If Not FileExists($camlistfile) Then
					$dummy = $ShowSplash
					$ShowSplash = 1
					AutoSplash("Creating camindex for " & $LongBuildName & " ...")
					$ShowSplash = $dummy
					$dummy = ""
				EndIf
				$dummy = FileOpen($builddir & '\ci.cmd', 2)
				FileWrite($dummy, "set PATH=" & $GCCpath & ";%PATH%" & @CRLF & "gmake camindex.csv" & @CRLF)
				FileClose($dummy)
;~ 				DosExec($builddir & "\ci.cmd", $builddir)
				SilentDosExec($builddir & "\ci.cmd", $builddir)
				FileDelete($builddir & "\ci.cmd")
				AutoSplash("")

			EndIf
			_FileReadToArray($camlistfile, $camindex)
			For $k = $first_entry To $camindex[0]
				If $camindex[$k] = "" Then ContinueLoop
				$temp = StringSplit($camindex[$k], ",", 1)
				; $temp should be [5, cam, firm, beta_status, dup_firm, skip_autobuild ] ....
				If $temp[0] <> 5 Then ContinueLoop	; ... else skip, entry illegal
				$thiscam = $temp[1]
				If $thiscam <> $prevcam Then
					$sup_cams += 1
					$fc = 1
				Else
					$fc += 1
				EndIf
				If $temp[4] <> "" Then
					$dups = StringSplit($temp[4], ":")
					If IsArray($dups) Then $fc += $dups[0]
				EndIf
				If $fc > $maxfirm Then $maxfirm = $fc
				$prevcam = $thiscam
			Next
			; now that we have the number of cams and firmwares, config global arrays ...
			ResetDynamicArrays($sup_cams, $maxfirm)
			; ... and fill $cams and $firmdup
;~ 			=====================================================
			For $k = $first_entry To $camindex[0]
				If $camindex[$k] = "" Then ContinueLoop
				$temp = StringSplit($camindex[$k], ",", 1)
				; temp = [ 5, cam, firm, beta_status, dup_firm, skip_autobuild ]
				If $temp[0] <> 5 Then ContinueLoop	; ... else skip, entry illegal
				$temp[5] = StringStripWS($temp[5], 3)
				If $first_entry = 2 And $temp[5] <> "SKIP_AUTOBUILD" Then $temp[5] = ""
				$dup_status = "DUP of " & StringLeft($temp[2], 3) & " " & StringUpper(StringRight($temp[2], 1)) & ", "
				$thiscam = $temp[1]
				If $thiscam <> $prevcam Then
					$cc += 1
					$fc = 1
					$cams[$cc][0] = $thiscam
				Else
					$fc += 1
				EndIf
				$cams[$cc][$fc] = $temp[2]

				$status_tail = ""
				If $temp[3] <> "" Then $status_tail &= $temp[3] & " + "
				If $first_entry = 2 And $temp[5] <> "" Then $status_tail &= $temp[5] & " + "
				If $status_tail <> "" Then
					$status_tail = StringTrimRight($status_tail, 3) & " status !)"
					$status_strings[$q][0] = $temp[1] ; cam name
					$status_strings[$q][1] = $temp[2] ; firmware
					$status_strings[$q][2] = $status_tail
					$q += 1
				EndIf
				If $temp[4] <> "" Then		; there's firm DUPs
					; ====================================================
					; added support for CHDKLover's 'multi-DUP' syntax
					; ====================================================
					$dups = StringSplit($temp[4], ":")
					If IsArray($dups) Then
						For $cnt = 1 To $dups[0]
							$firmdup[$i][0] = $temp[1] ; cam name
							$firmdup[$i][1] = $dups[$cnt] ; dup firm
							$firmdup[$i][2] = $temp[2] ; existing firm
							$i += 1
							$status_strings[$q][0] = $temp[1] ; cam name
							$status_strings[$q][1] = $dups[$cnt] ; dup firmware
							$status_strings[$q][2] = $dup_status & $status_tail

							$q += 1
						Next
					Else
						MsgBox(0, $camlistfile, "Parsing Error in line " & $k & @CRLF & @CRLF & $camindex[$k])
						ContinueLoop
					EndIf
				EndIf
				$prevcam = $thiscam
			Next
			; release memory for $camindex ....
			$camindex = 0
		; =======================================================
		Else
			; this is for 'classic' Makefile, i.e. before philmoz mod

			Local $status

			For $k = $makstart To $mak[0]
				$cln = StringStripWS($mak[$k], 3)
				If $cln = "batch-clean:" Then ExitLoop
				$dummy = StringLeft($cln, 2)
				$status = ""
				If StringLeft($cln, 7) = "$(MAKE)" Then
					$cp = StringInStr($cln, "PLATFORM=", 1)
					If $cp = 0 Then
						MsgBox($topmost, "Fatal Error", "Error in Makefile '$(MAKE)' params at line " & $k & ":" & @CR & $cln)
						Exit(1)
					EndIf
					$thiscam = CopyStringWord($cln, $cp + 9, " ")
					If $thiscam <> $prevcam Then
						$cc += 1
						$fc = 1
						$cam_props[$cc][0] = $thiscam
					Else
						$fc += 1
					EndIf
					$cam_props[$cc][1] = $fc
					$prevcam = $thiscam
				ElseIf StringInStr($cln, "-full") Then
					ContinueLoop
				ElseIf $dummy = "cp" Then ; if not duplicate firmware copy line
					$temp = StringSplit(StringTrimLeft($cln, 3), " ")
					If $temp[0] < 2 Then
						MsgBox($topmost, "Fatal Error", "Error in Makefile 'cp' params at line " & $k & ":" & @LF & $cln)
						Exit(1)
					EndIf
					$buf = StringSplit(StringTrimLeft($temp[1], 13), "-")
					If @error Then
						MsgBox($topmost, "Fatal Error", "Error in Makefile 'cp' params at line " & $k & ":" & @LF & $cln)
						Exit(1)
					EndIf
					$firmdup[$i][0] = $buf[1] ; cam name
					$firmdup[$i][2] = $buf[2] ; existing firm
					$status = "DUP of " & StringUpper($buf[2]) & ", "
					$buf = StringSplit(StringTrimLeft($temp[2], 13), "-")
					$firmdup[$i][1] = $buf[2] ; dup firm
					; ------------------------------------
					; make a status entry for dups as well - we'll use this for tooltipping
					$status_strings[$q][0] = $buf[1] ; cam name
					$status_strings[$q][1] = $buf[2] ; firmware
					$status_strings[$q][2] = $status
					$q += 1
					; ------------------------------------
					If $i > 0 And ($buf[1] <> $firmdup[$i - 1][0] Or $buf[2] <> $firmdup[$i - 1][1]) Then
						For $p = 0 To $cc
							If $cam_props[$p][0] = $buf[1] Then
								$cam_props[$p][1] += 1
								ExitLoop
							EndIf
						Next
					EndIf
					$i += 1
				ElseIf $dummy = "mv" Then ; if not duplicate firmware copy line
					$temp = StringSplit(StringTrimLeft($cln, 3), " ")
					If $temp[0] <> 2 Then
						MsgBox($topmost, "Fatal Error", "Error in Makefile 'mv' params at line " & $k & ":" & @LF & $cln)
						Exit(1)
					EndIf
					$buf = StringSplit(StringTrimLeft($temp[1], 13), "-")
					If @error Then
						MsgBox($topmost, "Fatal Error", "Error in Makefile 'mv' params at line " & $k & ":" & @LF & $cln)
						Exit(1)
					EndIf
					If StringInStr($temp[2], "_ALPHA") Then $status = "ALPHA"
					If StringInStr($temp[2], "_BETA") Then $status = "BETA"
					If $status <> "" Then
						$status_strings[$q][0] = $buf[1] ; cam name
						$status_strings[$q][1] = $buf[2] ; firmware
						$status_strings[$q][2] = $status & " status !)"
						$q += 1
					EndIf
				EndIf
			Next
			$sup_cams = $cc + 1
			$maxfirm = 0
			For $i = 0 To $cc
				If $cam_props[$i][0] = "" Then ExitLoop
				If $maxfirm < $cam_props[$i][1] Then $maxfirm = $cam_props[$i][1]
			Next
			$firmdup = 0
			$cam_props = 0
			; now that we have the number of cams and firmwares, config global arrays ...
			ResetDynamicArrays($sup_cams, $maxfirm)
			; ... and fill $cams and $firmdup arrays ...
			$cc = -1
			$prevcam = ""
			$i = 0
			For $k = $makstart To $mak[0]
				$cln = StringStripWS($mak[$k], 3)
				If $cln = "batch-clean:" Then ExitLoop
				If StringLeft($cln, 7) = "$(MAKE)" Then
					$cp = StringInStr($mak[$k], "PLATFORM=", 1)
					$fp = StringInStr($mak[$k], "PLATFORMSUB=", 1)
					$thiscam = CopyStringWord($mak[$k], $cp + 9, " ")
					$thisfirm = CopyStringWord($mak[$k], $fp + 12, " ")
					If $thiscam <> $prevcam Then
						$fc = 1
						$cc += 1
						$cams[$cc][0] = $thiscam
					Else
						$fc += 1
					EndIf
					$cams[$cc][$fc] = $thisfirm
					$prevcam = $thiscam
				ElseIf StringLeft($cln, 2) = "cp" Then
					; get firmware dups into array
					$temp = StringSplit(StringTrimLeft($cln, 3), " ")
					$buf = StringSplit(StringTrimLeft($temp[1], 13), "-")
					$firmdup[$i][0] = $buf[1] ; cam name
					$firmdup[$i][2] = $buf[2] ; existing firm
					$buf = StringSplit(StringTrimLeft($temp[2], 13), "-")
					$firmdup[$i][1] = $buf[2] ; dup firm
					If $i > 0 And $firmdup[$i][0] = $firmdup[$i - 1][0] And $firmdup[$i][1] = $firmdup[$i - 1][1] Then
						; no increase of $i, and clean double entries ..
						For $p = 0 To 2
							$firmdup[$i][$p] = ""
						Next
					Else
						$i += 1
					EndIf
				EndIf
			Next
		EndIf
;~ 		=====================================================================
		; we don't need $mak anymore, so clear the memory ...
		$mak = 0
		If IsChecked($chk_debug2) Then _ArrayDisplay($firmdup, "$firmdup", 0)
;~ 		_ArrayDisplay($status_strings)
		; merge $firmdup into $cams ...
		$i = 0
		While $firmdup[$i][0] <> ""
			For $cc = 0 To $sup_cams - 1
				If $cams[$cc][0] = $firmdup[$i][0] Then
					For $fc = 1 To $maxfirm
						If $cams[$cc][$fc] = "" Then
							$cams[$cc][$fc] = $firmdup[$i][1]
							ExitLoop
						EndIf
					Next
					For $p = $fc To 2 Step -1 ; 'bubble sort' the firmwares ...
						If $cams[$cc][$p] < $cams[$cc][$p - 1] Then
							$temp = $cams[$cc][$p - 1]
							$cams[$cc][$p - 1] = $cams[$cc][$p]
							$cams[$cc][$p] = $temp
						EndIf
					Next
					ExitLoop
				EndIf
			Next ; $c
			$i += 1
		WEnd
		If IsChecked($chk_debug2) Then _ArrayDisplay($cams, "$cams", 0)
		; ... and finish off by sorting entire array alphabetically on cam name
		_ArraySort($cams, 0, 0, $sup_cams - 1, 0)
		;_ArrayDisplay($cams, "$cams", 0)
		For $q = 0 To 249
			If $status_strings[$q][0] = "" Then ExitLoop
			For $r = 0 To $sup_cams - 1
				If $status_strings[$q][0] = $cams[$r][0] Then
					For $s = 1 To $maxfirm
						If $status_strings[$q][1] = $cams[$r][$s] Then
							$cam_status[$r][$s - 1] &= $status_strings[$q][2]
							ExitLoop 2
						EndIf
					Next
				EndIf
			Next
		Next
		;_ArrayDisplay($cam_status)
		; assure any new cam/firm combo's are stored in the inifile
		For $cc = 0 To $sup_cams - 1
			$cam_props[$cc][0] = $cams[$cc][0]
			If $cams[$cc][0] <> "" Then
				For $fc = 1 To $maxfirm
					If $cams[$cc][$fc] = "" Then ExitLoop
					$dummy = $cams[$cc][0] & "-" & $cams[$cc][$fc]
					; state 3 is impossible, so this only happens if cam/firm is not yet in inifile ...
					If IniRead($inifile, $sections[4], $dummy, 3) = 3 Then
						IniWrite($inifile, $sections[4], $dummy, 0)
					EndIf
				Next
			EndIf
		Next ;
		If IsChecked($chk_debug2) Then _ArrayDisplay($cams, "$cams (sorted)", 0)
	EndIf

	Local $ws_0 = $w_scaler
	$w_cw0 = $w_cw

	Local $fake, $dpos, $shift
	$fake = GUICreate("", 100, 100, -1, -1, $WS_CAPTION + $WS_SYSMENU + $WS_MINIMIZEBOX)
	$dpos = WinGetPos($fake)
	$ovh_h = $dpos[3] - 100
	$ovh_w = $dpos[2] - 100
	GUIDelete($fake)
	While 1
		$shift = R($w_cw)
		While @DesktopHeight < R($w_ch) + $ovh_h
			$w_scaler = Round(0.99 * $w_scaler, 2)
			$f_scaler = Round(1.1 * $w_scaler, 2)
		WEnd
		; cam select boxes, first calc optimal spacing ...
		For $cc = 1 To 4
			$max_entry = $sup_cams / $cc
			If $max_entry <> Int($max_entry) Then $max_entry = Int($max_entry) + 1
			For $fc = 100 To $min_line_height Step -1
				If R($w_ch - 3) > R(12) + Round($fc / 2) + $max_entry * $fc Then ExitLoop 2
			Next
		Next
		$cam_row_spacing = $fc
		$cam_columns = $cc
		$ccs = $cb_slot * $maxfirm + $cambutton_size + 15
		$w_cw = 300 + $cam_columns * $ccs
		While @DesktopWidth < R($w_cw) + $ovh_w
			$w_scaler = Round(0.99 * $w_scaler, 2)
			$f_scaler = Round(1.1 * $w_scaler, 2)
		WEnd
		$shift -= R($w_cw)
		If $shift <> 0 Then
			IniWrite($inifile, $sections[0], "scale_w", $w_scaler)
			IniWrite($inifile, $sections[0], "scale_f", $f_scaler)
		Else
			ExitLoop
		EndIf
	WEnd
	If $w_cw0 = 0 Then $w_cw0 = $w_cw
	If $w_scaler <> $ws_0 Then
		If $PivIndex = 1 Or $PivIndex = 3 Then
			; adapt $wpos[0] to size change
			$wpos[0] += Round($w_cw0 * $ws_0) - R($w_cw)
		EndIf
		If $PivIndex = 2 Or $PivIndex = 3 Then
			; adapt $wpos[1] to size change
			$wpos[1] += Round($w_ch * $ws_0) - R($w_ch)
		EndIf
	EndIf

_ap_ProfileStop(70)
	Return $builddir
EndFunc   ;==>SelectLocalBuild
; --------------------------------------------
Func IsBuildValid($path)
_ap_ProfileStart(71)
	Local $s, $makinc, $h_in, $h_out, $dummy, $optfile = "\buildconf.inc", $loc_optfile = "\localbuildconf.inc", $patch = 0
	Local $flag = 0, $_str = "SORT := $(dir $(shell which uniq.exe | sed s"
	Local $bz = "batch-zip:", $bzc = "batch-zip-complete:"
	Local $fzs = "firzipsub:", $fzsc = "firzipsubcomplete:"	;, $def_opts
	Local $OPT_DEFAULT_LANG = "OPT_DEFAULT_LANG"
	Local $group_opt = "--start-group $^  $(LDLIBS) --end-group"

	If Not FileExists($path & "\Makefile") Then
_ap_ProfileStop(71)
		Return "" ; no makefile: new is illegal, keep current
	EndIf

	If Not FileExists($path & "\makinc.unp") Then
		$h_in = FileOpen($path & "\makefile.inc", 0) ; read mode
		$h_out = FileOpen($path & "\makinc.pat", 2) ; overwrite mode
		While 1
			$dummy = FileReadLine($h_in)
			If @error = -1 Then ExitLoop ; EOF reached
			If StringLeft(StringStripWS($dummy, 3), StringLen($_str)) == $_str Then
				$patch = 1
				FileWrite($h_out, Chr(9) & "OLDSEPARATOR = \\\\" & @LF)
				FileWrite($h_out, Chr(9) & "NEWSEPARATOR = /" & @LF)
				FileWrite($h_out, Chr(9) & "SORT := $(dir $(shell which uniq.exe | sed 's_$(OLDSEPARATOR)_$(NEWSEPARATOR)_g'))/sort.exe" & @LF)
			Else
				FileWrite($h_out, $dummy & @LF)
			EndIf
		WEnd
		FileClose($h_in)
		FileClose($h_out)
		If $patch = 1 Then ; if patched make sure to keep a backup of original & patched version ...
			FileMove($path & "\makefile.inc", $path & "\makinc.unp", 1)
			FileMove($path & "\makinc.pat", $path & "\makefile.inc", 1)
		EndIf
	EndIf
	FileDelete($path & "\makinc.pat")
	If _FileReadToArray($path & "\Makefile", $mak) = 0 Then
		Dlg_MyMsgBox(0, "Debugging", "IsBuildValid: FileReadToArray error: " & @error)
_ap_ProfileStop(71)
		Return ""
	EndIf
	If IsChecked($chk_debug2) Then _ArrayDisplay($mak, "Makefile", 0)
	For $i = 0 To 1
		$MakOptions[$i][0] = ""
		$MakOptions[$i][1] = ""
	Next
	$NewStyle_Makefile = False
	$DefLang_Configurable = False
	For $i = 1 To $mak[0]
		; ========================================================================
		; 13-09-11 added for new Makefile style (philmoz)
		; ========================================================================
		If $mak[$i] = ".PHONY: fir" Then
			$NewStyle_Makefile = True
			; note we're assuming here that both firzipsub and firzipsubcomplete
			; options are available for new style Makrfile !
			$MakOptions[0][0] = $bz
			$MakOptions[0][1] = StringTrimRight($fzs, 1)
			$MakOptions[1][0] = $bzc
			$MakOptions[1][1] = StringTrimRight($fzsc, 1)
			$MakStyle = $bzc
			; ====================================================================
			; 08-11-11 added
			; ====================================================================
			If StringInStr(FileRead($path & $optfile), $OPT_DEFAULT_LANG) Then $DefLang_Configurable = True
			ExitLoop
		ElseIf StringLeft($mak[$i], 9) = "firzipsub" Then
			$dummy = StringSplit($mak[$i], " " & Chr(9))
			If $dummy[1] = $fzs Then
					$MakOptions[0][0] = $bz
					$MakOptions[0][1] = StringTrimRight($fzs, 1)
					$MakStyle = $bz
			ElseIf $dummy[1] = $fzsc Then
					$MakOptions[1][0] = $bzc
					$MakOptions[1][1] = StringTrimRight($fzsc, 1)
					$MakStyle = $bzc
			EndIf
		Else
			If StringLeft($mak[$i], 10) = $bz Or StringLeft($mak[$i], 19) = $bzc Then $makstart = $i + 1
		EndIf
	Next
	If $MakOptions[0][0] = "" And $MakOptions[1][0] = "" Then
_ap_ProfileStop(71)
		Return "" ; makefile invalid
	EndIf
	; prepare file with isolated conditional compile - first handle existing .org method situation ...
	$dummy = 0
	If FileExists($path & $optfile & ".org") Then FileMove($path & $optfile & ".org", $path & $optfile, 1)
	If FileExists($path & "\conditional.txt") Then
		; convert existing custom opts
		_FileReadToArray($path & "\conditional.txt", $dummy)
		FileDelete($path & "\conditional.txt")
	ElseIf FileExists($path & $optfile) Then
		If FileExists($path & $loc_optfile) Then
			_FileReadToArray($path & $loc_optfile, $dummy)
		Else
		; convert standard opts if no local opts available
		_FileReadToArray($path & $optfile, $dummy)
		EndIf
	EndIf

	$CustomPrimary = False ; reset test flags
	$SupportsPrimary = False
	$AutoGCC = 0
	$NoGCC4Flags = 0
	If IsArray($dummy) Then
		$h_out = FileOpen($path & $loc_optfile, 2)
		Local $DefLangFlag = False
		For $i = 1 To $dummy[0]
			$dummy[$i] = StringStripWS($dummy[$i], 8)
			If StringLeft($dummy[$i], 4) == "#OPT" Then $dummy[$i] = CopyStringWord($dummy[$i], 2, "1")
			If StringInStr($dummy[$i], $OPT_DEFAULT_LANG) Then
				If Not $DefLang_Configurable Then ContinueLoop
				If StringInStr($dummy[$i], $OPT_DEFAULT_LANG)>2 Then ContinueLoop
				$DefLangFlag = True
				If $DefLang[$site] <> "" And FileExists($path & "\CHDK\LANG\" & $DefLang[$site] & ".lng") Then
					$dummy[$i] = $OPT_DEFAULT_LANG & "=" & $DefLang[$site]
				Else
					$dummy[$i] = $OPT_DEFAULT_LANG & "=" & "english"
				EndIf
			EndIf
			If StringLeft($dummy[$i], 4) == "OPT_" Then FileWrite($h_out, $dummy[$i] & @LF)
			If StringLeft($dummy[$i], 12) == "PRIMARY_ROOT" Then $CustomPrimary = True
		Next
		If $DefLang_Configurable And Not $DefLangFlag Then FileWrite($h_out, $OPT_DEFAULT_LANG & "=" & $DefLang[$site] & @LF)
		FileClose($h_out)
	EndIf

	; we haven't checked for extra support stuff yet, do it now
	$dummy = _FileReadToArray($path & "\makefile.inc", $makinc)
	If $dummy = 0 Then	; Or $makinc[0] > 500
		MsgBox($topmost, "Fatal Error !", "Please check your 'makefile.inc' -" & @CR & "something is BADLY wrong with it !" & @CR & @CR & "[ program will now exit ]")
		MyExit(1)
	EndIf
	For $i = 1 To $makinc[0]
		$s = StringStripWS($makinc[$i], 3)
		If $s = "include $(topdir)buildconf.inc" Then $flag = $i
		If $flag > 0 And $s = "-include $(topdir)localbuildconf.inc" Then $flag = - $i
		$dummy = StringLeft($s, 4)
		If $dummy = "PRIM" And StringLeft($s, 12) = "PRIMARY_ROOT" Then $SupportsPrimary = True
		If $dummy = "GCC_" And StringLeft($s, 11) = "GCC_VERSION" Then $AutoGCC = 1
		If $dummy = "# CF" Then
			If $s = "# CFLAGS+=-mcpu=arm946e-s" Or $s = "# CFLAGS+=-mtune=arm946e-s" Then
				$NoGCC4Flags = "line " & $i & ": " & $s
			EndIf
		EndIf
	Next
	; if a conditional include for 'localbuildconf.inc' is not present, add it ...
	If $flag > 0 Then
		$makinc[$flag] &= @LF & "-include $(topdir)localbuildconf.inc"
		$h_out = FileOpen($path & "\makefile.inc", 2)
		For $i = 1 To $makinc[0]
			FileWrite($h_out, $makinc[$i] & @LF)
		Next
		FileClose($h_out)
	EndIf
	; added 7-12-11: patch core/Makefile for GCC 4.6.x and up
	$dummy = FileRead($path & "\core\Makefile")
	If StringInStr($dummy, $group_opt) Then
		FileDelete($path & "\core\Makefile")
		FileWrite($path & "\core\Makefile", StringReplace($dummy, $group_opt, StringReplace($group_opt, "--", "Wl,--") ) )
	EndIf
_ap_ProfileStop(71)
	Return $MakStyle
EndFunc   ;==>IsBuildValid
; --------------------------------------------
Func GetLocalHighBuild($name, $which_site)
_ap_ProfileStart(72)
	Local $i, $temp, $ret = "000", $zipname = $name, $br = "branches\", $brlen = StringLen($br)
	Local $tr = "trunk\", $trlen = 6, $purgename, $path

	;AutoSplash("GetLocalHighBuild")
	If StringLeft($name, $brlen) == $br Then
		$zipname = StringTrimLeft($name, $brlen)	; 1-12-10
		$purgename = $br
	ElseIf StringLeft($name, $trlen) == $tr Then
		$zipname = StringTrimLeft($name, $trlen)	; 1-12-10
		$purgename = $tr
	EndIf
	$purgename &= "~!~" & $zipname
	Local $locbuild = $here & $VerPrefix[$which_site] & "\"
	Local $archive = $here & $VerPrefix[$which_site] & "\archives\"
	For $i = $MaxSearch[$which_site] To 0 Step -1
		$temp = StringFormat("%d", $i)	; "%03d"
		If FileExists($locbuild & $name & $temp) Or FileExists($archive & $zipname & $temp & ".zip") Then
			$ret = $temp
			ExitLoop
		EndIf
	Next
	If $i > $MaxBuild[$which_site] Then $MaxBuild[$which_site] = $i
	If $MaxBuild[$which_site] > $MinBuild[$which_site] Then UpdateMaxSearch()

	If $LimitBuilds = 1 Then
		Local $skip = $BuildsToKeep
		For $k = $i To $MinBuild[$site] + 1 Step -1
			$temp = StringFormat("%d", $k)
			$path = $locbuild & $name & $temp
			If $path = $sourcedir Then ContinueLoop
			If Not FileExists($path) Then
				If FileExists($locbuild & $purgename & $temp) Then $PurgeFlag = True
				ContinueLoop
			ElseIf StringInStr(FileGetAttrib($path), "D") Then
				If $skip = 0 Then
					DirMove($path, $locbuild & $purgename & $temp, 1)
					$PurgeFlag = True
				Else
					$skip -= 1
				EndIf
			EndIf
		Next
	EndIf
_ap_ProfileStop(72)
	Return $ret
EndFunc   ;==>GetLocalHighBuild
; --------------------------------------------
Func UpdateStatus($_suffix = "")
_ap_ProfileStart(73)
	Local $m = $StatusMsg, $nv = ""

	If $ulink <> "" Then $nv = " (New version: " & $uver & " )"
	If $m = $ready Then
		$m &= $nv
		If $miniGUI = 1 Then GUICtrlSetBkColor($lab_minigreen, $dgrey)
	Else
		If $_suffix <> "" Then $m &= " " & $_suffix
		If $miniGUI = 1 Then GUICtrlSetBkColor($lab_minigreen, $green)
	EndIf
	GUICtrlSetData($status, $m)
	If $miniGUI = 1 Then
		GUICtrlSetData($ministatus, $m)
	EndIf
_ap_ProfileStop(73)
EndFunc   ;==>UpdateStatus
; --------------------------------------------
Func Do_Search()
_ap_ProfileStart(74)
	If WinExists("dsFSR") Then
		WinActivate("dsFSR")
	Else
		ShellExecute('dsfsr.exe ', $sourcedir, $subdir)
	EndIf
_ap_ProfileStop(74)
EndFunc   ;==>Do_Search
; --------------------------------------------
Func GetVersionInfo()
_ap_ProfileStart(75)
	Local $prefix = $web_prefix & $SrcSites[$site] & $VerPaths[$site] & "log/?action=follow_copy&rev="
	Local $postfix = "&stop_rev=&mode=follow_copy&verbose=on"

	If $NetConnected[$site] = 1 Then Browse($prefix & $CurrentBuild & $postfix)

;~ 	If $NetConnected[$site] = 1 Then Browse($web_prefix & $SrcSites[$site] & $VerPaths[$site] & "timeline")
_ap_ProfileStop(75)
EndFunc   ;==>GetVersionInfo
; --------------------------------------------
Func Calc_CP_colors()
_ap_ProfileStart(76)
	For $t = 0 To 1
		For $z = 0 To 1
			$CP_color[$t][$z] = RGBColor( $CP_current[7 * $t + 3 * $z + 1], $CP_current[7 * $t + 3 * $z + 2], $CP_current[7 * $t + 3 * $z + 3] )
		Next
		$CP_bold[$t] = $CP_current[7 * $t]
	Next
	$CP_bold[2] = $CP_current[14]
	$CP_bold[3] = $CP_current[15]
_ap_ProfileStop(76)
EndFunc   ;==>Calc_CP_colors
; --------------------------------------------
Func UnzipArchives()
_ap_ProfileStart(77)
	Local $ret, $cl, $k, $name, $bname, $ver, $path, $upath

	$ret = FileOpenDialog("Select downloaded CHDK archive to unzip", $apath & "\", "ZIP files (*.zip)", 1, "", $main)
	FileChangeDir($here) ; dialog sets @WorkingDir to dir of file selected, set it back ...
	If $ret = "" Then
_ap_ProfileStop(77)
		Return
	EndIf

	$name = StringTrimRight(StringTrimLeft($ret, StringInStr($ret, "\", 2, -1)), 4)	; get archive name (strip path & extension)
	$bname = $name	; get build name by stripping version
	While StringIsDigit(StringRight($bname, 1))
		$bname = StringTrimRight($bname, 1)
	Wend
	$ver = StringTrimLeft($name, StringLen($bname))
	If $bname <> "trunk" Then
		$upath = $here ; unpack to base dir, branch zips already contain branch subdir !
		$path = $bpath & "\"
	Else
		$upath = $tpath
		$path = $tpath & "\"
	EndIf
	If FileExists($path & $name) Then
		$k = Dlg_MyMsgBox(4, "Path already exists !", "OVERWRITE '" & $path & $name & "' ?")
		If $k <> 6 Then
_ap_ProfileStop(77)
			Return
		EndIf
		$StatusMsg = "Removing dir " & $name & " ..."
		UpdateStatus()
;~ 		DosExec("attrib -R -H -S " & $path & $name & "\*.* /S /D", $here)
		SilentDosExec("attrib -R -H -S " & $path & $name & "\*.* /S /D", $here)
		DirRemove($path & $name, 1) ; wipe target dir ...
	EndIf
	DirRemove($path & $bname, 1) ; wipe temp unpack dir ...
	$StatusMsg = "Unzipping " & $name & ".zip ..."
	UpdateStatus()
	$cl = $GCCpath & '\unzip.exe -o ' & $ret & ' -d ' & $upath
	DosExec($cl, $here) ; unzip from gcc
	DirMove($path & $bname, $path & $name, 1)
	$StatusMsg = $ready
	UpdateStatus()
	If $ver = $LongBuildName Then
		$sourcedir0 = ""	; force a CamProperties update
		UpdateCurrentBuild(-1)
	EndIf
_ap_ProfileStop(77)
EndFunc   ;==>UnzipArchives
; --------------------------------------------
Func MakeBatch($path)
_ap_ProfileStart(78)
	Local $hh, $option = "", $version = StringSplit(FileReadLine($sourcedir & "\version.inc"), " ")
	Local $thisbuild = $version[$version[0]]
	Local $MAKE = 'gmake ', $ARM_PREFIX = 'arm-elf'
	Local $sepa = _StringRepeat("=", 80)

	If $make_uses_options Then
		Local $gmopts = StringSplit($make_options, "|")
		$option = $gmopts[$make_uses_options] & " "
	EndIf
	If $Incremental_Lock = 1 Then
		$MakCmd = "fir"
		DirCreate($sourcedir & "\bin\logs")
	EndIf
	; write a small cmd batch that will do the actual work (processes a single cam/firm	combination)
	$hh = FileOpen($path & "\docam.cmd", 2) ; open for overwrite
	FileWriteLine($hh, '@echo off')
	FileWriteLine($hh, 'setlocal')
	FileWriteLine($hh, 'title Compiling CHDK for %1-%2')
	FileWriteLine($hh, 'set PATH=' & $GCCpath & ';%PATH%')
	FileWriteLine($hh, 'set LF=bin\logs\log-%1-%2.txt')
	FileWriteLine($hh, 'set EF=bin\logs\err-%1-%2.txt')
	FileWriteLine($hh, 'set DF=bin\logs\dump-%1-%2.txt')
	FileWriteLine($hh, 'echo ========== Specs for ' & $MAKE & '==========> %LF%')
	FileWriteLine($hh, $MAKE & ' --version >> %LF%')
	FileWriteLine($hh, 'echo ========== Specs for sh ==========>> %LF%')
	FileWriteLine($hh, 'sh --version >> %LF%')
	FileWriteLine($hh, 'echo.>> %LF%')
	FileWriteLine($hh, 'echo ========== Specs for gcc ==========>> %LF%')
	FileWriteLine($hh, 'gcc -v 2>> %LF%')
	FileWriteLine($hh, 'echo.>> %LF%')
	FileWriteLine($hh, 'echo ========== Specs for ' & $ARM_PREFIX & '-gcc ==========>> %LF%')
	FileWriteLine($hh, $ARM_PREFIX & '-gcc -v 2>> %LF%')
	FileWriteLine($hh, 'echo.>> %LF%')
	FileWriteLine($hh, 'echo [%DATE%][%TIME%]>> %LF%')
	FileWriteLine($hh, 'echo.>> %LF%')
	FileWriteLine($hh, 'copy %LF% %DF% >NUL')
	FileWriteLine($hh, $MAKE & $option & 'PLATFORM=%1 PLATFORMSUB=%2 ' & $MakCmd & ' 2>>%EF% | tee -a %LF%')
	FileWriteLine($hh, 'echo. >> %LF%')
	FileWriteLine($hh, 'echo [%DATE%][%TIME%] compilation : Done.>> %LF%')
	FileWriteLine($hh, 'echo.| tee -a %LF%')
	If IsChecked($chk_keep_dumps) Then
		FileWriteLine($hh, 'echo ' & $sepa & ' >>%DF%')
		FileWriteLine($hh, 'echo ========== core\main.dump: >>%DF%')
		FileWriteLine($hh, 'type core\main.dump >>%DF%')
		FileWriteLine($hh, 'echo. >> %DF%')
		FileWriteLine($hh, 'echo ' & $sepa & ' >>%DF%')
		FileWriteLine($hh, 'echo ========== loader\%1\resetcode\main.dump: >>%DF%')
		FileWriteLine($hh, 'type loader\%1\resetcode\main.dump >>%DF%')
		FileWriteLine($hh, 'echo. >> %DF%')
		FileWriteLine($hh, 'echo ' & $sepa & ' >>%DF%')
		FileWriteLine($hh, 'echo ========== loader\%1\main.dump: >>%DF%')
		FileWriteLine($hh, 'type loader\%1\main.dump >>%DF%')
		FileWriteLine($hh, 'echo [%DATE%][%TIME%] save dumps : Done.>> %LF%')
	Else
		FileWriteLine($hh, 'del /F /Q %DF% 2>NUL >NUL')
	EndIf
	FileWriteLine($hh, 'echo.| tee -a %LF%')
	; perform 'safety' make clean unless actively disabled
	If $SkipPostClean = 0 Then
		FileWriteLine($hh, $MAKE & 'PLATFORM=%1 PLATFORMSUB=%2 clean 2>>%EF% | tee -a %LF%')
		FileWriteLine($hh, 'echo.>> %LF%')
		FileWriteLine($hh, 'echo [%DATE%][%TIME%] clean after : Done.>> %LF%')
		FileWriteLine($hh, 'echo.| tee -a %LF%')
	EndIf
	FileWriteLine($hh, 'unix2dos -k -o %LF% %EF% bin\caminfo.txt')
	FileWriteLine($hh, 'echo [%DATE%][%TIME%] unix2dos log files : Done.>> %LF%')
	FileWriteLine($hh, 'echo.>> %LF%')
	If $Incremental_Lock = 1 Then
		FileWriteLine($hh, 'zip -9j bin\CHDK-%1-%2-' & $thisbuild & '-inc.zip bin\*.fi? bin\*.bin')
		FileWriteLine($hh, 'echo [%DATE%][%TIME%] zip *.bin *.fi? : Done.>> %LF%')
		FileWriteLine($hh, 'del /F /Q bin\*.fi? bin\*.bin 2>NUL >NUL')
		FileWriteLine($hh, 'echo [%DATE%][%TIME%] wipe *.bin *.fi? : Done.>> %LF%')
		FileWriteLine($hh, 'echo.| tee -a %LF%')
	EndIf
	FileClose($hh)
	; for checking
;~ 	FileCopy($path & "\docam.cmd", $path & "\docam.txt", 1)
_ap_ProfileStop(78)
EndFunc   ;==>MakeBatch
; --------------------------------------------
Func Show_InteractiveCmd()
_ap_ProfileStart(79)
	Local $hh, $cver = $gccver[1]

	; make sure /bin folder exists
	DirCreate($sourcedir & "\bin")
	If $GCCpath = $GCC3path Then $cver = $gccver[0]
	$hh = FileOpen($subdir & "\interact.cmd", 2) ; open for overwrite
	FileWrite($hh, '@echo off' & @CRLF & 'title Cmd line compilation with GCC ' & $cver & @CRLF & 'set PATH=' & $GCCpath & ';%PATH%' & @CRLF & "echo Note: - The following has been prepended to path: '" & $GCCpath & "'" & @CRLF & "echo.        (that's the path to your CURRENTLY SELECTED compiler)" & @CRLF & "echo.      - Main GUI is disabled to prevent side effects" & @CRLF & "echo.      - Both will be restored on closing this Cmd Window" & @CRLF & "echo." & @CRLF & "echo Hint: To manually compile a full zip for A620 firmware 100F :" & @CRLF & "echo.      'gmake PLATFORM=a620 PLATFORMSUB=100f firzipsubcomplete'" & @CRLF & "echo.       (use 'firzipsub' if you only want the CHDK boot files)" & @CRLF & "echo." & @CRLF & "echo on >nul" & @CRLF	)
	FileClose($hh)
	GUISetState($State_Disable, $main)
	RunWait($SysComSpec & " /k " & $subdir & "\interact.cmd", $sourcedir)
	GUISetState($State_Enable, $main)
	WinActivate($main)
	FileDelete($subdir & "\interact.cmd")
_ap_ProfileStop(79)
EndFunc   ;==>Show_InteractiveCmd
; --------------------------------------------
Func CmdLog($text)
_ap_ProfileStart(80)
	If $Introspection Then
		TimeStamp()
		FileWriteLine($tracelog, $Pad & $text)
	EndIf
_ap_ProfileStop(80)
EndFunc   ;==>CmdLog
; --------------------------------------------
Func DosExec($cmdline, $wd = $sourcedir, $waitflag = 1)
_ap_ProfileStart(81)
	Local $ret, $mode = $cmd_mode

	If IsChecked($chk_debug2) Then $mode = "/k"		; debug mode also keeps visible Cmd windows open
	CmdLog("{wd=" & $wd & "} " & $cmdline)
	If BitAND(GUICtrlRead($chk_debug), 1) = 1 Then ; $GUI_CHECKED = 1
		$ret = ConditionalRunWait($waitflag, $SysComSpec & " " & $mode & " " & $cmdline, $wd, $State_Show)
	ElseIf BitAND(GUICtrlRead($chk_debug), 2) = 2 Then ; $GUI_INDETERMINATE = 2
		$ret = ConditionalRunWait($waitflag, $SysComSpec & " /c " & $cmdline, $wd, $State_Minimize)
	Else
		$ret = ConditionalRunWait($waitflag, $SysComSpec & " /c " & $cmdline, $wd, $State_Hide)
	EndIf
_ap_ProfileStop(81)
	Return $ret
EndFunc   ;==>DosExec
; --------------------------------------------
Func SelectCams_All_None($choice, $sel = "")
_ap_ProfileStart(82)
	For $c = 0 To $sup_cams - 1
		If ($sel = "vx" And $dry_cams[$c] = 1) Or ($sel = "dry" And $dry_cams[$c] = 0) Then ContinueLoop
		For $f = 1 To $maxfirm
			If $cams[$c][$f] == "" Then ExitLoop
			GUICtrlSetState($chk_cams[$c][$f - 1], $choice)
		Next
	Next
_ap_ProfileStop(82)
EndFunc   ;==>SelectCams_All_None
; --------------------------------------------
Func WriteLog($idx)
_ap_ProfileStart(83)
	Local $line, $changes, $logfile = $subdir & "\upd-log.txt", $log

	$log = FileOpen($logfile, 1)
	FileWrite($log, "[" & @MON & "-" & @MDAY & "-" & @YEAR & " @ " & @HOUR & ":" & @MIN & ":" & @SEC & "] " & @CRLF & "Action: [" & GetSVN_Name($site) & "]" & $txt_process[$w_upd] & @CRLF & "Branch: " & $branches[$idx][0] & "-r" & $branches[$idx][2] & ". Released on " & $branches[$idx][3] & @CRLF )
	$changes = $branches[$idx][5]
	If StringRight($changes, 9) = " &hellip;" Then $changes = StringTrimRight($changes, 9) & " ..."
	$line = "Author: " & $branches[$idx][4] & ", changes: " & $changes
	FileWriteLine($log, $line & @CRLF & _StringRepeat("-", StringLen($line)) )
	FileClose($log)
_ap_ProfileStop(83)
EndFunc   ;==>WriteLog
; --------------------------------------------
Func SaveWinState()
_ap_ProfileStart(84)
	$ActWin = WinGetHandle("[ACTIVE]")	; another couple of lines saved, thanks to Melba23
_ap_ProfileStop(84)
EndFunc   ;==>SaveWinState
; --------------------------------------------
Func SatIcon($_state)
_ap_ProfileStart(85)
	GUICtrlSetState($pic_sat, 32 - $_state * 16) ; $GUI_SHOW = 16, $GUI_HIDE = 32
	If $miniGUI = 1 Then	; added check for miniGUI !!! -> 16-12-10 Cures graphical bugs
		If $_state = 1 Then
			GUICtrlSetImage($ico_sat, $icons & "\sat.ico")
		Else
			GUICtrlSetImage($ico_sat, $arr_icon[3 - $PivIndex])
		EndIf
	EndIf
	$OnLine = $_state
_ap_ProfileStop(85)
EndFunc   ;==>SatIcon
; --------------------------------------------
Func UpdateLastCheck()
_ap_ProfileStart(86)

	GUICtrlSetData($lab_time, $t_last)
	GUICtrlSetData($lab_runtime, $d_last)
	If $miniGUI = 1 Then
		GUICtrlSetData($lab_minitime, $t_last)
		GUICtrlSetData($lab_miniruntime, $d_last)
	EndIf
_ap_ProfileStop(86)
EndFunc   ;==>UpdateLastCheck
; --------------------------------------------
Func Browse($url)
_ap_ProfileStart(87)
	Static $mbox_timeout58 = 30

	If IsChecked($chk_inet) Then
		ShellExecute($url)
	Else
		Dlg_MyMsgBox(0, "Oops !", $url & @CR & @CR & "Can't go there - you disallowed Internet", $mbox_timeout58, $main)
		If @error <> 0 Then
			$mbox_timeout58 = @error
		Else
			$mbox_timeout58 = @extended
		EndIf
	EndIf
_ap_ProfileStop(87)
EndFunc   ;==>Browse
; --------------------------------------------
Func CheckHelperFiles($where)
_ap_ProfileStart(88)
	Local $uts, $tmp, $file, $missing = "", $ret = 0

	If StringInStr($semi_allowed, $CurrOSVersion) Then
		SilentDosExec('sh --version exit > _sh_ver.txt', $where)
		$tmp = FileRead($where & "\_sh_ver.txt")
		FileDelete($where & "\_sh_ver.txt")
		$GCC3_Lock = False
		If Not StringInStr($tmp, "GNU bash, version 3") Then
;~ 			MsgBox($topmost + 4096, "Error", "sh.exe found in " & $where & @LF & "is not compatible with " & $CurrOSVersion)
			Dlg_MyMsgBox(0, "Error", "sh.exe found in " & $where & @LF & "is not compatible with " & $CurrOSVersion)
			$GCC3_Lock = True
			$ret += 10
		EndIf
	EndIf
	_FileReadToArray($subdir & "\helperfiles.txt", $uts)
	For $c = 1 To $uts[0]
		$tmp = StringStripWS($uts[$c], 3)
		If $tmp = "" Or StringLeft($tmp, 1) = "#" Then ContinueLoop
		$file = $where & '\' & $uts[$c]
		If (Not FileExists($file)) And (Not FileExists($file & ".exe")) Then $missing &= ($tmp & "(.exe) ")
	Next
	If $missing <> "" Then
;~ 		MsgBox($topmost + 4096, "Error", "Helper file(s) not found in " & $where & @CR & @CR & "Missing file(s): " & $missing)
		Dlg_MyMsgBox(0, "Error", "Helper file(s) not found in " & $where & @CR & @CR & "Missing file(s): " & $missing)
		$ret += 1
	EndIf

_ap_ProfileStop(88)
	Return $ret
EndFunc   ;==>CheckHelperFiles
; --------------------------------------------
Func AutoPos()
_ap_ProfileStart(89)
	If $w_screensnap = 0 Then
_ap_ProfileStop(89)
		Return
	EndIf
	Local $win, $p[4], $xoff = 0, $yoff = 0
	GetWPos()
	If $miniGUI = 1 Then
		$mpos = WinGetPos($minimain)
		$win = $minimain
		$p = $mpos
		$p[2] = 215				; mystery, solves Win 7 problem
		$p[3] = $mini_height	; mystery, solves Win 7 problem
		$xoff = 15
		$yoff = 10
	ElseIf WinExists($cardmenu) Then
		$mpos = WinGetPos($cardmenu)
		$win = $cardmenu
		$p = $mpos
	Else
		$win = $main
		$p = $wpos
	EndIf
	If Not WinActive($win) Then
_ap_ProfileStop(89)
		Return
	EndIf
	; AERO graphics layer is not 'counted' for size returned by WinGetPos, Thanks M$ !
	If $w_aero = 1 Then
		$xoff += $AP_xoff
		$yoff += $AP_yoff
	EndIf
	If $p[0] > @DesktopWidth - $p[2] - $xoff Then $p[0] = @DesktopWidth - $p[2] - $xoff
	If $p[1] > @DesktopHeight - $p[3] - $yoff Then $p[1] = @DesktopHeight - $p[3] - $yoff
	If $p[0] < - 1 Then
		$p[0] = $xoff
		If $xoff > 14 Then $p[0] -= 10
	EndIf
	If $p[1] - $yoff < - 1 Then $p[1] = $yoff
	WinMove($win, "", $p[0], $p[1], $p[2], $p[3])
_ap_ProfileStop(89)
EndFunc   ;==>AutoPos
; --------------------------------------------
Func WrongGCCVersion($ver)
_ap_ProfileStart(90)
	MsgBox($topmost + 4096, "Error", "Can't plug a GCC " & $ver & " version in the GCC " & 7 - $ver & " slot !" & @CR & @CR & "[ that would prevent the program from auto-" & @CR & "   adapting CFLAGS to the selected compiler ]")
_ap_ProfileStop(90)
EndFunc   ;==>WrongGCCVersion
; --------------------------------------------
Func UnpackReplaceRestart()
_ap_ProfileStart(91)

	If _FileInUse($UTarget) Then
_ap_ProfileStop(91)
		Return	; inaccessible, maybe still DL'ing ?
	EndIf
	DisableMainControls(1)
	Local $dummy = StringSplit($UTarget, "\")
	Local $updater = $dummy[$dummy[0]]
	Local $au3 = $subdir & "\SRC\CHDK-Shell-v"
	Local $newexe = StringTrimRight(@ScriptFullPath, 7) & $uver & ".exe"
	; OK, let's do it ... first, disable internet access ...
	Local $userpref = IsChecked($chk_inet)
	If $userpref = 1 Then
		GUICtrlSetState($chk_inet, 4)	; $GUI_UNCHECKED = 4
		Check_istate()
	EndIf
	AdlibUnRegister("DoGC")	; disable 'original' GC interrupt ...
	; check if we have access for at least ~5 seconds ...

	Local $iLoops = 50
	Do
		If _FileInUse($UTarget) Then ExitLoop
		Sleep(100)
		$iLoops -= 1
	Until $iLoops = 0
	If $iLoops <> 0 Then	; file was used during last 5 sec
		AdlibRegister("DoGC", 10 * 1000)	; Reset GC interrupt to assure it's > 5 sec
		AutoSplash("Waiting for " & $updater & " ...")
_ap_ProfileStop(91)
		Return	; wait till next interrupt
	EndIf
	; check for old version EXE and INI to remove
	If @Compiled And $Cleanup[0] <> 0 Then
		Local $skip = $Cleanup[3] - 1 ; get versions to keep ( sub 1 because we check from 1 before latest ! )
		Local $namestub = StringTrimRight(@ScriptFullPath, 4)
		Local $pversion = Number(StringRight($namestub, 3))
		$namestub = StringTrimRight($namestub, 3)
		For $c = $pversion - 1 To $pversion - 100 Step -1
			If FileExists($namestub & $c & ".exe") Then
				If $skip > 0 Then
					$skip -= 1
					ContinueLoop
				EndIf
				FileDelete($namestub & $c & ".exe")
				If $Cleanup[1] = 1 Then FileDelete($namestub & $c & ".ini")
				If $Cleanup[2] = 1 Then FileDelete($au3 & $c & ".au3")
			EndIf
		Next
	EndIf
	AutoSplash("Unpacking " & $updater & " ...")
	DosExec($subdir & '\7za.exe x "' & $UTarget & '" -o' & $here & ' * -r -aoa')
	Do
		Sleep(500)
	Until FileExists($newexe) And FileExists($au3 & $uver & ".au3") And FileExists($here & "\readme.txt")
	FileMove($UTarget, StringReplace($UTarget, ".7z", $uver & ".7z") )
	AutoSplash("Saving Settings ...")
	GetWPos()
	WriteXY()
	If $userpref = 1 Then GUICtrlSetState($chk_inet, 1)	; $GUI_CHECKED = 1
	WriteIni()
	SortIni($inifile)
	SplashOff()
	$dummy = StringSplit($newexe, "\")
	Implode("Restarting as " & $dummy[$dummy[0]] & " ...")
	GUIDelete($pic)
	If $GDI_plus Then _GDIPlus_Shutdown()
	ShellExecute($newexe, " -multiple", $here, "open")
_ap_ProfileStop(91)
_ap_ProfileStop(0)
	Exit
EndFunc   ;==>UnpackReplaceRestart
; --------------------------------------------
Func CheckShortcut()
_ap_ProfileStart(92)
	If @Compiled And $ShortcutDir <> "" Then
		Local $ver = Number(StringRight(StringTrimRight(@ScriptFullPath, 4), 3))
		Local $basename = StringTrimRight(@ScriptFullPath, 7)
		Local $latest = True
		For $c = $ver + 1 To $ver + 100		; check if current is the latest version
			If FileExists($basename & $c & ".exe") Then
				$latest = False
				ExitLoop
			EndIf
		Next
		If $latest Then FileCreateShortcut(@ScriptFullPath, $ShortcutDir & "\CHDK-Shell.lnk" , $here , "" , $Title)
	EndIf
_ap_ProfileStop(92)
EndFunc   ;==>CheckShortcut

#EndRegion
#
#Region ---------------------------- Dialogs -----------------------------------------------------

Func Dlg_SetSize()
_ap_ProfileStart(93)
	Local $sizer, $inp_ws, $inp_fs, $inp_countdown, $edit_greetz, $but_apply, $but_cancel, $but_campanel
	Local $chk_minitimer, $inp_minitimer, $chk_3D_countdown	;, $maxsize, $maxfont
	Local $chk_sticky, $chk_reduce, $chk_outtro, $chk_classic, $chk_showsplash, $rad_10, $rad_25
	Local $rad_slide, $rad_fade
	Local $button_label, $but_q[2][5] = [ 	[ 0, 0, 0, 0, 0 ], [ 77, 100, 125, 133, 150 ]  ]	; 82, 100, 135, 145, 165
	Local $chk_zoom, $chk_snap, $chk_boldpopups, $chk_showcountdown, $rad_pivot[4], $s_msg, $delta_w = 0, $delta_h = 0
	; current settings
	Local $ws_0 = $w_scaler, $fs_0 = $f_scaler, $reduce_logo_0 = $reduce_logo, $w_scdwn = $w_showcountdown, $w_3d = $3D_CountDown
	Local $w_classic0 = $w_classic, $nochange = 0, $restart = 0	;, $wforce0 = $w_force
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	GetWPos()
	Local $sizer_ypos = $wpos[1] + Round( (R($w_ch) - X(425)) / 2 )	; $wpos[3]
	; note 0x80C00000 = $WS_POPUP + $WS_CAPTION
	$sizer = GUICreate("Adapt Font and Window", X(270), X(425), $wpos[0] + $wpos[2] - X(300), $sizer_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, 400, 1, "Tahoma")
	GUICtrlCreateLabel("Scale Window size to ", X(15), X(10), X(120), X(20) )
	Set_BGColor()
	$inp_ws = GUICtrlCreateInput(String($w_scaler * 100), X(140), X(7), X(50), X(20), 0x2001)
	GUICtrlCreateUpdown($inp_ws, 0x20)
	GUICtrlSetLimit(-1, 150, 60) ; range = 60...maxsize
	GUICtrlCreateLabel("% of original", X(195), X(10), X(70), X(20) )
	Set_BGColor()
	GUICtrlCreateLabel("Scale Font size to ", X(15), X(40), X(120), X(20) )
	Set_BGColor()
	$inp_fs = GUICtrlCreateInput(String($f_scaler * 100), X(140), X(37), X(50), X(20), 0x2001)
	GUICtrlCreateUpdown($inp_fs, 0x20)
	GUICtrlSetLimit(-1, 165, 66)
	GUICtrlCreateLabel("% of original", X(195), X(40), X(70), X(20) )
	Set_BGColor()
	GUICtrlCreateLabel("Quick:", X(15), X(72), X(35), X(20) )
	Set_BGColor()
	For $i = 0 To 4
		If @DesktopHeight - $ovh_h < $w_ch * $but_q[1][$i] / 100 Then
			$button_label = Int(100 * (@DesktopHeight - $ovh_h) / $w_ch)
			If $button_label <> $but_q[1][$i - 1] Then
				$but_q[1][$i] = $button_label
				$but_q[0][$i] = GUICtrlCreateButton($but_q[1][$i] & "%", X(225 - $i * 40), X(70), X(37), X(18) )
			EndIf
			;GUICtrlSetFont(-1, $fontsize * 0.9, 400)
			ExitLoop
		EndIf
		$but_q[0][$i] = GUICtrlCreateButton($but_q[1][$i] & "%", X(225 - $i * 40), X(70), X(37), X(18) )
	Next
	$chk_sticky = GUICtrlCreateCheckbox(" Sticky Window (remember position)", X(15), X(100) )
	Set_BGColor()
	If $w_sticky = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_snap = GUICtrlCreateCheckbox(" Screen Snap (keep window on desktop)", X(15), X(125) )
	Set_BGColor()
	If $w_screensnap = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_zoom = GUICtrlCreateCheckbox(" Animate windows", X(15), X(150), X(120) )
	Set_BGColor()
	If $w_animate = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUIStartGroup()
	$rad_slide = GUICtrlCreateRadio(" slide", X(140), X(150), X(60), X(20) )
	Set_BGColor()
	GUICtrlSetState(-1, 128 - 64 * $w_animate)
	If $w_slide = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$rad_fade = GUICtrlCreateRadio(" fade", X(205), X(150), X(60), X(20) )
	Set_BGColor()
	GUICtrlSetState(-1, 128 - 64 * $w_animate)
	If $w_slide = 0 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUIStartGroup()
	$chk_classic = GUICtrlCreateCheckbox(" Force classic style for program", X(15), X(175) )
	Set_BGColor()
	If $w_classic = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_showsplash = GUICtrlCreateCheckbox(" Splash messages", X(15), X(200), X(120) )
	Set_BGColor()
	If $ShowSplash = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_boldpopups = GUICtrlCreateCheckbox(" with bold font", X(140), X(200) )
	Set_BGColor()
	If $w_boldpopups = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_reduce = GUICtrlCreateCheckbox(" Reduce main logo", X(15), X(225), X(120) )
	Set_BGColor()
	If $reduce_logo > 0 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUIStartGroup()
	$rad_10 = GUICtrlCreateRadio("by 10%", X(140), X(225), X(60), X(20) )
	Set_BGColor()
	GUICtrlSetState(-1, 128 - 64 * IsChecked($chk_reduce))
	If $reduce_logo = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$rad_25 = GUICtrlCreateRadio("by 25%", X(205), X(225), X(60), X(20) )
	Set_BGColor()
	GUICtrlSetState(-1, 128 - 64 * IsChecked($chk_reduce))
	If $reduce_logo = 2 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_showcountdown = GUICtrlCreateCheckbox(" Show Timer bars", X(15), X(250), X(120) )
	Set_BGColor()
	If $w_showcountdown = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_3D_countdown = GUICtrlCreateCheckbox(" in 3D for miniGUI", X(140), X(250) )
	Set_BGColor()
	If $3D_CountDown = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_minitimer = GUICtrlCreateCheckbox(" Switch to miniGUI if idle for >", X(15), X(275), X(180) )
	Set_BGColor()
	If $w_minitimer = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$inp_minitimer = GUICtrlCreateInput(String(IniRead($inifile, $sections[0], "mini_timer_min", 3)), X(203), X(275), X(40), X(20), 0x2001)
	GUICtrlCreateUpdown($inp_minitimer, 0x20)
	GUICtrlSetLimit(-1, 99, 1)
	GUICtrlCreateLabel("min", X(247), X(277), X(20), X(20) )
	Set_BGColor()
	$chk_outtro = GUICtrlCreateCheckbox(" Show shutdown message:", X(15), X(300) )
	Set_BGColor()
	If $w_outtro = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$edit_greetz = GUICtrlCreateInput(IniRead($inifile, $sections[0], "mess_text", "[ your message here ]"), X(15), X(325), X(160), X(20) )
	GUICtrlCreateLabel("for", X(205), X(303), X(14), X(20) )	; 158
	Set_BGColor()
	$inp_countdown = GUICtrlCreateInput(String($ctim * 4), X(190), X(325), X(55), X(20), 0x2001)
	GUICtrlCreateUpdown($inp_countdown, 0xA0)	; $UDS_ARROWKEYS + $UDS_NOTHOUSANDS = 0x20 + 0x80
	GUICtrlSetLimit(-1, 5000, 100)
	GUICtrlCreateLabel("ms", X(250), X(327), X(15), X(20) )
	Set_BGColor()
	GUIStartGroup()
	$rad_pivot[0] = GUICtrlCreateRadio("Top Left",   X(85), X(350), X(85), X(18) )
	Set_BGColor()
	$rad_pivot[1] = GUICtrlCreateRadio("Top Right", X(175), X(350), X(90), X(18) )
	Set_BGColor()
	GUICtrlCreateLabel("Pivot point", X(18), X(362), X(62), X(16) )
	Set_BGColor()
	$rad_pivot[2] = GUICtrlCreateRadio("Bottom Left",   X(85), X(370), X(85), X(18) )
	Set_BGColor()
	$rad_pivot[3] = GUICtrlCreateRadio("Bottom Right", X(175), X(370), X(90), X(18) )
	Set_BGColor()
	GUICtrlSetState($rad_pivot[$PivIndex], 1) ; $GUI_CHECKED = 1
	GUIStartGroup()
	$but_apply =	GUICtrlCreateButton("OK", 				X(15), X(395), X(75), X(20) )
	$but_cancel =	GUICtrlCreateButton("Cancel", 			X(95), X(395), X(75), X(20) )
	$but_campanel = GUICtrlCreateButton("Cam Panel ..",    X(175), X(395), X(90), X(20) )
	DisableMainControls(1)
	GUISetState($State_Show, $sizer)
	ControlFocus($sizer, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $sizer
	$CurrentGUI[1] = "GUI_Dlg"
	While 1
		$s_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($s_msg)
		If $Introspection Then Trace_Msg($s_msg)
		If WinActive($main) Then WinActivate($sizer)
		If $s_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($sizer)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $s_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		For $c = 0 To 4
			If $but_q[0][$c] = 0 Then ExitLoop
			If $s_msg = $but_q[0][$c] Then
				GUICtrlSetData($inp_ws, $but_q[1][$c])
				GUICtrlSetData($inp_fs, Int(1.1 * $but_q[1][$c]))
				ContinueLoop
			EndIf
		Next
		Switch $s_msg
			Case $chk_classic
				$w_classic = IsChecked($chk_classic)
				If $w_classic <> $w_classic0 Then
					GUICtrlSetData($but_apply, "Restart")
				Else
					GUICtrlSetData($but_apply, "OK")
				EndIf
			Case $chk_reduce
				GUICtrlSetState($rad_10, 128 - 64 * IsChecked($chk_reduce))
				GUICtrlSetState($rad_25, 128 - 64 * IsChecked($chk_reduce))
				If IsChecked($chk_reduce) Then GUICtrlSetState($rad_10, 1) ; $GUI_CHECKED = 1
			Case $chk_zoom
				$w_animate = IsChecked($chk_zoom)
				GUICtrlSetState($rad_fade, 128 - 64 * $w_animate)
				GUICtrlSetState($rad_slide, 128 - 64 * $w_animate)
			Case $but_apply
				For $c = 0 To 3
					If IsChecked($rad_pivot[$c]) Then
						$PivIndex = $c
						IniWrite($inifile, $sections[0], "pivot", $c)
						GUICtrlSetImage($but_mini, $arr_icon[$c])
					EndIf
				Next
				$w_scaler = Number(GUICtrlRead($inp_ws)) / 100.0
				If $w_scaler <> $ws_0 Then
					IniWrite($inifile, $sections[0], "scale_w", $w_scaler)
					GetWPos()
					$delta_w = Round( ($ws_0 - $w_scaler) * $w_cw )
					$delta_h = Round( ($ws_0 - $w_scaler) * $w_ch )
					$w_cw0 = $w_cw	; necessary to prevent 'double correction'
					If $PivIndex = 1 Or $PivIndex = 3 Then
						; adapt $wpos[0] to size change
						$wpos[0] += $delta_w
					EndIf
					If $PivIndex = 2 Or $PivIndex = 3 Then
						; adapt $wpos[1] to size change
						$wpos[1] += $delta_h
					EndIf
				EndIf
				$f_scaler = GUICtrlRead($inp_fs) / 100.0
				IniWrite($inifile, $sections[0], "scale_f", $f_scaler)
				$w_screensnap = IsChecked($chk_snap)
				IniWrite($inifile, $sections[0], "chk_snap", $w_screensnap)
				$w_sticky = IsChecked($chk_sticky)
				IniWrite($inifile, $sections[0], "chk_sticky", $w_sticky)
				If IsChecked($chk_reduce) Then
					If IsChecked($rad_10) Then
						$reduce_logo = 1
					Else
						$reduce_logo = 2
					EndIf
				Else
					$reduce_logo = 0
				EndIf
				IniWrite($inifile, $sections[0], "reduce_logo", $reduce_logo)
				$w_classic = IsChecked($chk_classic)
				If $w_classic <> $w_classic0 Then
					$restart = 1
					IniWrite($inifile, $sections[0], "force_classic", $w_classic)
				EndIf
				$ShowSplash = IsChecked($chk_showsplash)
				$w_boldpopups = IsChecked($chk_boldpopups)
				IniWrite($inifile, $sections[0], "show_splash", $ShowSplash)
				IniWrite($inifile, $sections[0], "bold_popups", $w_boldpopups)
				$w_animate = IsChecked($chk_zoom)
				IniWrite($inifile, $sections[0], "animate_use", $w_animate)
				$w_slide = IsChecked($rad_slide)
				IniWrite($inifile, $sections[0], "animate_slide", $w_slide)
				$w_showcountdown = IsChecked($chk_showcountdown)
				$3D_CountDown = IsChecked($chk_3D_countdown)
				IniWrite($inifile, $sections[0], "showcountdown", $w_showcountdown)
				IniWrite($inifile, $sections[0], "showcountdown3D", $3D_CountDown)
				$w_outtro = IsChecked($chk_outtro)
				IniWrite($inifile, $sections[0], "outtro", $w_outtro)
				IniWrite($inifile, $sections[0], "mess_text", GUICtrlRead($edit_greetz))
				Local $dummy = String(GUICtrlRead($inp_countdown))
				IniWrite($inifile, $sections[0], "mess_timer", $dummy)
				$ctim = Round($dummy / 4)
				$w_minitimer = IsChecked($chk_minitimer)
				IniWrite($inifile, $sections[0], "mini_timer", $w_minitimer)
				$dummy = String(GUICtrlRead($inp_minitimer))
				IniWrite($inifile, $sections[0], "mini_timer_min", $dummy)
				If $w_minitimer = 1 Then
					GUICtrlSetData($lab_minitimer, $dummy & " m")
				Else
					GUICtrlSetData($lab_minitimer, "")
				EndIf
				$mtim = $dummy * 60 / $Timer_Interval
				ExitLoop
			Case $but_campanel
				GUISetState($State_Hide, $sizer)	; $State_Hide +
				Dlg_SetCamPanel()
				ContinueCase
			Case $but_cancel
				$nochange = 1
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($s_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($sizer)
	$CurrentGUI = $CallingGUI
	$activity = $mtim
	If $nochange = 1 Then
_ap_ProfileStop(93)
		Return
	EndIf
	If $restart = 1 Then
_ap_ProfileStop(93)
		RestartProgram()	; no GUI refresh necessary ...
	EndIf
	If $w_scaler <> $ws_0 Or $f_scaler <> $fs_0 Or $reduce_logo <> $reduce_logo_0 Then
		AutoSplash("Refresh GUI ...")	; refresh GUI if change has to be direct
		UpdateCurrentBuild(-1)
	EndIf
	If $w_scdwn <> $w_showcountdown Or $w_3d <> $3D_CountDown Then Init_TimerBar()
_ap_ProfileStop(93)
EndFunc   ;==>Dlg_SetSize
; --------------------------------------------
Func Dlg_SetCamPanel()
_ap_ProfileStart(94)
	Local $but_ok, $but_cancel, $but_def, $but_cam[2], $chk_firm, $chk_cam[2], $fweight[2]
	Local $i, $cp_gui, $cp_msg, $ycoord, $inp_font, $upd_font, $inp_line_h, $upd_line_h, $changed = 1, $temp
	Local $updowns[2][2][3], $inputs[2][2][3], $local_colors[2][2]
	Local $strings[2][2] = [["Button style BEFORE getting cam props","CAM_NAME_INIT"],["Button style AFTER getting cam props","CAM_NAME_FINAL"]]
	Local $z, $fgbg, $color, $inp_cb_perc, $upd_cb_perc
	Local $cp_gui_ypos = $wpos[1] + Round( (R($w_ch) - X(425)) / 2 )	;$wpos[3]
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	$cp_gui = GUICreate("Set Camera Panel Style", X(270), X(425), $wpos[0] + R(140), $cp_gui_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, 400, 1, "Tahoma")
	For $z = 0 To 1
		$ycoord = X(55) + $z * X(110)
		GUICtrlCreateGroup($strings[$z][0], X(10), $ycoord - X(45), X(250), X(100) )
		GUICtrlSetFont(-1, $fontsize, Default, 0, $gr_font)
		GUICtrlSetColor(-1, $blue)
		$but_cam[$z] = GUICtrlCreateButton($strings[$z][1], X(20), $ycoord - X(25), X(120), X(19), 0x8F00)
		$chk_cam[$z] = GUICtrlCreateCheckbox("set bold font", X(170), $ycoord - X(25), X(80), X(19) )
		Set_BGColor()
		GUICtrlSetState(-1, 4 - 3 * $CP_current[7 * $z]) ; $GUI_CHECKED = 1, $GUI_UNCHECKED = 4
		GUICtrlCreateLabel("color:   text", X(25), $ycoord + X(3), X(65), X(20) )
		Set_BGColor()
		GUICtrlCreateLabel("background", X(25), $ycoord + X(28), X(65), X(20) )
		Set_BGColor()
		For $fgbg = 0 To 1
			For $color = 0 To 2
				$inputs[$z][$fgbg][$color] = GUICtrlCreateInput($CP_current[7 * $z + 3 * $fgbg + $color + 1], X(105) + $color * X(50), $ycoord + $fgbg * X(25), X(48), X(20), 0x2001)
				$i = ($color = 0) * 0xFF0000 + ($color = 1) * 0x00FF00 + ($color = 2) * 0x0000FF
				GUICtrlSetColor(-1, $i)
				GUICtrlSetBkColor(-1, $white)
				$updowns[$z][$fgbg][$color] = GUICtrlCreateUpdown($inputs[$z][$fgbg][$color], 0x20)
				GUICtrlSetLimit($updowns[$z][$fgbg][$color], 0xFF, 0x00)
			Next
		Next
	Next
	GUICtrlCreateGroup("Button Camera Names", X(10), X(230), X(250), X(35) )
	GUICtrlSetFont(-1, $fontsize, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$chk_firm = GUICtrlCreateCheckbox("in CAPITALS", X(170), X(242), X(80), X(19) )	; "set bold font"
	Set_BGColor()
	If $CP_current[14] = 0 Then GUICtrlSetState(-1, 4)
	If $CP_current[14] = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUICtrlCreateLabel("Apply font bolding ONLY if window is scaled to less than", X(20), X(275), X(170), X(35) )
	Set_BGColor()
	$inp_font = GUICtrlCreateInput($CP_current[15], X(195), X(280), X(48), X(20), 0x2001)
	GUICtrlCreateLabel("%", X(245), X(282), X(14), X(20) )
	Set_BGColor()
	$upd_font = GUICtrlCreateUpdown($inp_font, 0x20)
	GUICtrlSetLimit($upd_font, 201, 60)

	GUICtrlCreateLabel("Checkbox font size as % of button font size", X(20), X(315), X(170), X(35) )
	Set_BGColor()
	$inp_cb_perc = GUICtrlCreateInput($firm_font_perc, X(195), X(320), X(48), X(20), 0x2001)
	GUICtrlCreateLabel("%", X(245), X(322), X(14), X(20) )
	Set_BGColor()
	$upd_cb_perc = GUICtrlCreateUpdown($inp_cb_perc, 0x20)
	GUICtrlSetLimit($upd_cb_perc, 120, 50)

	GUICtrlCreateLabel("Add extra column if cam row spacing would be less than", X(20), X(355), X(170), X(35) )
	Set_BGColor()
	$inp_line_h = GUICtrlCreateInput($min_line_height, X(195), X(360), X(48), X(20), 0x2001)
	GUICtrlCreateLabel("pix", X(245), X(362), X(20), X(20) )
	Set_BGColor()
	$upd_line_h = GUICtrlCreateUpdown($inp_line_h, 0x20)
	GUICtrlSetLimit($upd_line_h, 18, 6)

	$but_ok = GUICtrlCreateButton("OK", X(10), X(395), X(70), X(20) )
	$but_cancel = GUICtrlCreateButton("Cancel", X(85), X(395), X(70), X(20) )
	$but_def = GUICtrlCreateButton("Default Colours", X(160), X(395), X(100), X(20) )
	For $z = 0 To 1
		For $fgbg = 0 To 1
			$local_colors[$z][$fgbg] =	GUICtrlRead($inputs[$z][$fgbg][2]) + GUICtrlRead($inputs[$z][$fgbg][1]) * 0x100 + GUICtrlRead($inputs[$z][$fgbg][0]) * 0x10000
		Next
		$fweight[$z] = 400 + 300 * IsChecked($chk_cam[$z])
		GUICtrlSetColor($but_cam[$z], $local_colors[$z][0])
		GUICtrlSetBkColor($but_cam[$z], $local_colors[$z][1])
		GUICtrlSetFont($but_cam[$z], -1, $fweight[$z])
	Next
	GUISetState($State_Show, $cp_gui)
	ControlFocus($cp_gui, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $cp_gui
	$CurrentGUI[1] = "CamPanel_Dlg"
	While 1
		$cp_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($cp_msg)
		If $Introspection Then Trace_Msg($cp_msg)
		If WinActive($main) Then WinActivate($cp_gui)
		If $cp_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($cp_gui)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $cp_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		For $z = 0 To 1
			For $fgbg = 0 To 1
				For $color = 0 To 2
					If $cp_msg = $updowns[$z][$fgbg][$color] Or $cp_msg = $inputs[$z][$fgbg][$color] Then
						$local_colors[$z][$fgbg] =	GUICtrlRead($inputs[$z][$fgbg][2]) + GUICtrlRead($inputs[$z][$fgbg][1]) * 0x100 + GUICtrlRead($inputs[$z][$fgbg][0]) * 0x10000
						GUICtrlSetColor($but_cam[$z], $local_colors[$z][0])
						GUICtrlSetBkColor($but_cam[$z], $local_colors[$z][1])
						ExitLoop 3
					EndIf
				Next
			Next
			If $cp_msg = $chk_cam[$z] Then
				$fweight[$z] = 400 + 300 * IsChecked($chk_cam[$z])
				GUICtrlSetFont($but_cam[$z], -1, $fweight[$z])
				ExitLoop
			EndIf
		Next
		Switch $cp_msg
			Case $but_cancel
				$changed = 0
				ExitLoop
			Case $but_def
				$CP_current = $CP_default
				Calc_CP_colors()
				Write_CP_ini_colors()
				ExitLoop
			Case $but_ok
				$changed = 0
				For $z = 0 To 1
					For $fgbg = 0 To 1
						For $color = 0 To 2
							; write panel values back into global flat array for inifile
							$temp = GUICtrlRead($inputs[$z][$fgbg][$color])
							If $temp <> $CP_current[7 * $z + 3 * $fgbg + $color + 1] Then
								$CP_current[7 * $z + 3 * $fgbg + $color + 1] = $temp
								$changed = 1
							EndIf
						Next
						; update global display array
						$temp = $CP_current[7 * $z + 3 * $fgbg + 3] + $CP_current[7 * $z + 3 * $fgbg + 2] * 0x100 + $CP_current[7 * $z + 3 * $fgbg + 1] * 0x10000
						If $temp <> $CP_color[$z][$fgbg] Then
							$CP_color[$z][$fgbg] = $temp
							$changed = 1
						EndIf
					Next
					; update font bolding settings for cam buttons ...
					$temp = IsChecked($chk_cam[$z])
					If $temp <> $CP_current[7 * $z] Then
						$CP_current[7 * $z] = $temp
						$CP_bold[$z] = $temp
						$changed = 1
					EndIf
				Next
				; ... for checkboxes
				$temp = IsChecked($chk_firm)
				If $temp <> $CP_current[14] Then
					$CP_current[14] = $temp
					$CP_bold[2] = $temp
					$changed = 1
				EndIf
				; ... for autobold settings
				$temp = Number(GUICtrlRead($inp_font))
				If $temp <> $CP_current[15] Then
					$CP_current[15] = $temp
					$CP_bold[3] = $temp
					$changed = 1
				EndIf
				; ... for relative size of checkbox fonts
				$temp = Number(GUICtrlRead($inp_cb_perc))
				If $temp <> $firm_font_perc Then
					$firm_font_perc = $temp
					IniWrite($inifile, $sections[0], "firm_font_perc", $firm_font_perc)
					$changed = 1
				EndIf
				; ... for min. line height settings
				$temp = Number(GUICtrlRead($inp_line_h))
				If $temp <> $min_line_height Then
					$min_line_height = $temp
					IniWrite($inifile, $sections[3], "CP_min_line_height", $min_line_height)
					WinActivate($main)
					GUISetState($State_Hide, $cp_gui)
					$w_propsortalpha0 = 1 - $w_propsortalpha	; make sure cam props are refreshed
					UpdateCurrentBuild(-1)
				EndIf
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($cp_msg)
	WEnd
	GUIDelete($cp_gui)
	$CurrentGUI = $CallingGUI
	If $changed <> 0 Then
		AutoSplash("Refresh CamPanel ...")
		Write_CP_ini_colors()
		UpdateCamPanel_Tip()
		If IsChecked($chk_tooltips) Then GUICtrlSetTip($but_sizer, "[ Keyboard shortcut <Alt> + G ]" & @CRLF & @CRLF & "Lets you adjust window and font size" & @CRLF & @CRLF & "[X,Y] WxH: [" & $wpos[0] & "," & $wpos[1] & "] " & $wpos[2] & "x" & (R($w_ch) + $titlebar_size) & " pixels," & @CRLF & "(client size: " & R($w_cw) & "x" & R($w_ch) & " pixels)" & @CRLF & "window: " & $w_scaler * 100 & "% ; font: " & $f_scaler * 100 & "%" & @CRLF & @CRLF & $tip)
		UpdateCamPanel()
	EndIf
_ap_ProfileStop(94)
EndFunc   ;==>Dlg_SetCamPanel
; --------------------------------------------
Func Dlg_SetBranch()
_ap_ProfileStart(95)
	Local $dlg_branch, $b_msg, $but_apply, $but_cancel, $cbo_branch, $rad_branches[3]	; , $but_sdm_dl = "X"
	Local $i, $j, $k, $firstbranch, $branch_list, $skipped, $but_reset_blacklist = "X"
	Local $i_br = "check_branches" & $site, $inp_local, $cflag = 0, $uflag = 1
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	GetWPos()
	$dlg_branch = GUICreate("Branch Checking Options", X(250), X(160), $wpos[0] + $wpos[2] - X(280), $wpos[1] + R(80), $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, 400, 1, "Tahoma")
	GUICtrlCreateLabel("Check:", X(25), X(11), X(40), X(20), 0x01 )
	Set_BGColor()
	$rad_branches[0] = GUICtrlCreateRadio($txt_branch[0],  X(70), X(10), X(48), X(20) )
	Set_BGColor()
	$rad_branches[1] = GUICtrlCreateRadio($txt_branch[1], X(120), X(10), X(83), X(20) )
	Set_BGColor()
	$rad_branches[2] = GUICtrlCreateRadio($txt_branch[2], X(205), X(10), X(35), X(20) )
	Set_BGColor()
	$k = $do_branches[$site]
	If $k = -1 Then $k = 0
	GUICtrlSetState($rad_branches[$k], 1) ; $GUI_CHECKED = 1
	If $k = 0 Then
		GUICtrlCreateLabel("Set Local branch", X(25), X(52), X(103), X(20) )
		Set_BGColor()
		$inp_local = GUICtrlCreateInput("", X(130), X(50), X(110), X(20) )
		If $do_branches[$site] = -1 Then GUICtrlSetData(-1, $DefBranch[$site])
	Else
		GUICtrlCreateLabel("Default:", X(25), X(38), X(45), X(20) )
		Set_BGColor()
		; get first non-blacklisted branch & create combobox
		For $i = 2 To 24
			If $branches[$i][6] = "000" Then Add2Blacklist($branches[$i][0])
			If Not StringInStr($BlackList[$site], $branches[$i][0]) Then
				$cbo_branch = GUICtrlCreateCombo($branches[$i][0], X(75), X(35), X(160) )
				$firstbranch = $i
				ExitLoop
			EndIf
		Next
		; collect other non-blacklisted branches in branchlist ...
		For $i = $firstbranch + 1 To 24
			If Not StringInStr($BlackList[$site], $branches[$i][0]) Then
				$branch_list &= ($branches[$i][0] & "|")
			EndIf
		Next
		$branch_list = StringTrimRight($branch_list, 1)
		; ... and update the combobox with it (after making sure that the default exists)
		If $branches[1][0] = "" Then
			If StringInStr($branch_list, $DefBranch[$site]) Then
				$branches[1][0] = $DefBranch[$site]
			Else
				$branches[1][0] = $VerDefBr[$site]
			EndIf
		EndIf
		For $i = 2 To 24
			If $branches[$i][0] = $branches[1][0] Then
				For $j = 1 To 6
					$branches[1][$j] = $branches[$i][$j]
				Next
				ExitLoop
			EndIf
		Next
		; keep current default branch setting ...
		$DefBranch[$site] = $branches[1][0]
		GUICtrlSetData(-1, $branch_list, $branches[1][0])
		; make string of blacklisted branches ...
		For $i = 2 To 24
;~ 			If $skip_branch[$i][0] <> "" And $skip_branch[$i][1] <> "0" Then
			If StringInStr($BlackList[$site], $branches[$i][0]) Then
				$skipped &= ("'" & $skip_branch[$i][0] & "' - ")
			EndIf
		Next
		$skipped = StringTrimRight($skipped, 3)
		; ... and, if any present create labels to tell the user about it
		If $skipped <> "" And $trunk[$site] = 0 Then
			GUICtrlCreateLabel("Blacklisted (empty/invalid Makefile)", X(25), X(60), X(220), X(20) )
			Set_BGColor()
			GUICtrlCreateLabel($skipped, X(25), X(75), X(200), X(50) )
			Set_BGColor()
			GUICtrlSetColor(-1, $red)
			GUICtrlSetFont(-1, -1, 700)
		Else
			$but_reset_blacklist = GUICtrlCreateButton("Reset Blacklist", X(140), X(70), X(90), X(16) )
		EndIf
		If $trunk[$site] = 1 Then
			GUICtrlSetState($cbo_branch, 128)
			GUICtrlCreateLabel("Switch to branch mode to change default", X(25), X(65), X(220), X(20) )
			Set_BGColor()
			GUICtrlSetColor(-1, $blue)
		EndIf
	EndIf
	$but_apply = GUICtrlCreateButton("OK", X(10), X(130), X(110), X(20) )
	$but_cancel = GUICtrlCreateButton("Cancel", X(130), X(130), X(110), X(20) )
	SplashOff()
	DisableMainControls(1)
	GUISetState($State_Show, $dlg_branch)
	ControlFocus($dlg_branch, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $dlg_branch
	$CurrentGUI[1] = "Branches_Dlg"
	While 1
		$b_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($b_msg)
		If $Introspection Then Trace_Msg($b_msg)
		If WinActive($main) Then WinActivate($dlg_branch)
		If $b_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($dlg_branch)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $b_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $b_msg
			Case $but_reset_blacklist
				For $i = 0 To 1
					$BlackList[$i] = ""
				Next
				ContinueLoop
			Case $but_cancel
				$uflag = 0
				ExitLoop
			Case $but_apply
				; Cams2Ini()
				For $i = 0 To 2
					If IsChecked($rad_branches[$i]) Then
						$do_branches[$site] = $i
						IniWrite($inifile, $sections[1], $i_br, $do_branches[$site])
					EndIf
				Next
				If $do_branches[$site] > 0 Then
					If $k = 0 Then
						; branch checking is on AND was off, flag netcheck
						;IniWrite($inifile, $sections[1], $i_br, $do_branches[$site])
						GUICtrlSetState($rad_build[2], 64)
						$cflag = 1
					Else
						; branch checking is on AND was on, check if default was changed
						$branches[1][0] = GUICtrlRead($cbo_branch)
						If $branches[1][0] <> $DefBranch[$site] Then
							; default branch changed, update branches array
							For $i = 2 To 24
								If $branches[$i][0] = $branches[1][0] Then
									For $j = 1 To 6
										$branches[1][$j] = $branches[$i][$j]
									Next
									ExitLoop
								EndIf
							Next
							$DefBranch[$site] = $branches[1][0]
							$LastUsed[1][$site] = ""	; invalidate last used branch version
							IniWrite($inifile, $sections[1], "branch" & $site, $DefBranch[$site])
							;IniWrite($inifile, $sections[1], $i_br, $do_branches[$site])
							$sourcedir = ""
						Else
							; branch not changed
							$uflag = 0
						EndIf
						; redo dialog to show blacklisted ...
						If $k = 1 And $do_branches[$site] = 2 Then $cflag = 1
					EndIf
					GUICtrlSetData($rad_build[2], $DefBranch[$site])
				Else
					; branch checking is off - "trunk" must be selected
					If $k = 0 Then
						; branch checking was off already
						Local $dummy = GUICtrlRead($inp_local)
						If $dummy = "" Then
							; branch checking = off, no local branch defined
							$trunk[$site] = 1
							IniWrite($inifile, $sections[1], "trunk" & $site, 1)
							IniWrite($inifile, $sections[1], $i_br, 0)
							IniWrite($inifile, $sections[1], "branch" & $site, $DefBranch[$site])
							$uflag = 0
						ElseIf $dummy <> $DefBranch[$site] Then
							; local branch found, is it valid ?
							If GetLocalHighBuild("branches\" & $dummy, $site) <> "000" Then
								$branches[1][0] = $dummy
								$DefBranch[$site] = $dummy
								$do_branches[$site] = -1
								IniWrite($inifile, $sections[1], $i_br, -1)
								IniWrite($inifile, $sections[1], "branch" & $site, $dummy)
								$LastUsed[1][$site] = ""
								$sourcedir = ""
							Else
								Dlg_MyMsgBox(0, $dummy, "No branch builds with this name found" & @CR & "Field must have valid name or be empty" )
								ContinueLoop
							EndIf
						EndIf
					Else
						; branch check was on, but is now off
						$trunk[$site] = 1
						IniWrite($inifile, $sections[1], "branch" & $site, $VerDefBr[$site])
						IniWrite($inifile, $sections[1], "trunk" & $site, 1)
						IniWrite($inifile, $sections[1], $i_br, 0)
					EndIf
				EndIf
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($b_msg)
	WEnd
	DisableMainControls(0)
	If $cflag And $snooped < $do_branches[$site] Then
		AutoSplash("SVN ReCheck ....")
		TracChecker()
		Check_istate()
		SplashOff()
	EndIf
	GUIDelete($dlg_branch)
	$CurrentGUI = $CallingGUI
	If $cflag Then
_ap_ProfileStop(95)
		Return False
	EndIf
	If $uflag Then
		AutoSplash("Refresh GUI ...")
		If UpdateCurrentBuild(0) = 0 Then UpdateCurrentBuild(-1)
	EndIf
_ap_ProfileStop(95)
	Return True
EndFunc   ;==>Dlg_SetBranch
; --------------------------------------------
Func Dlg_SelectSite()
_ap_ProfileStart(96)
	Local $dlg_sel_site, $rad_site[2], $but_site[2], $c_msg, $but_cancel, $but_apply, $site0 = $site
	Local $i, $chk_sync_checks, $chk_silent_mode, $dummy
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	; Cams2Ini()
	GetWPos()
	Local $gui_ypos = $wpos[1] + Round( (R($w_ch) - X(215)) / 2 )
	$dlg_sel_site = GUICreate("Select SVN Source Site", X(270), X(215), $wpos[0] + $wpos[2] - X(300), $gui_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, 400, 1, "Tahoma")
	GUICtrlCreateGroup(" Foreground SVN Site ", X(10), X(10), X(250), X(170) )
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel(	"Use radio buttons to select SVN site," & @CRLF & "push buttons to browse source pages.", X(30), X(30), X(220), X(30) )
	Set_BGColor()
	For $i = 0 To 1
		$dummy = GetSVN_Name($i)
		$rad_site[$i] = GUICtrlCreateRadio($dummy, X(30), X(71 + ($i * 30)), X(75), X(18) )
		Set_BGColor()
		$but_site[$i] = GUICtrlCreateButton("Browse " & $dummy & " ..", X(120), X(70 + ($i * 30)), X(120), X(18) )
		GUICtrlSetTip(-1, $web_prefix & $SrcSites[$i] & $VerPaths[$i])
	Next
	GUICtrlSetState($rad_site[$site], 1) ; $GUI_CHECKED = 1
	$chk_sync_checks = GUICtrlCreateCheckbox("Include BOTH sites in TIMED checks", X(30), X(131), X(225), X(18) )
	Set_BGColor()
	If $Sync_Checks Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_silent_mode = GUICtrlCreateCheckbox("Silent checks on background site", X(50), X(151), X(205), X(18) )
	Set_BGColor()
	If $Sync_Checks_BG Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUICtrlSetState(-1, 128 - 64 * $Sync_Checks )	; $GUI_ENABLE = 64, $GUI_DISABLE = 128
	$but_apply = GUICtrlCreateButton("OK", X(10), X(190), X(120), X(20) )
	$but_cancel = GUICtrlCreateButton("Cancel", X(140), X(190), X(120), X(20) )
	DisableMainControls(1)
	GUISetState($State_Show, $dlg_sel_site)
	ControlFocus($dlg_sel_site, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $dlg_sel_site
	$CurrentGUI[1] = "SVN_SetSite_Dlg"
	While 1
		$c_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($c_msg)
		If $Introspection Then Trace_Msg($c_msg)
		If WinActive($main) Then WinActivate($dlg_sel_site)
		If $c_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($dlg_sel_site)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $c_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $c_msg
			Case $but_cancel
				$site = $site0
				ExitLoop
			Case $but_site[0]
				Browse($web_prefix & $SrcSites[0] & $VerPaths[0] & "browser/")
			Case $but_site[1]
				Browse($web_prefix & $SrcSites[1] & $VerPaths[1])
			Case $chk_sync_checks
				$Sync_Checks = IsChecked($chk_sync_checks)
				GUICtrlSetState($chk_silent_mode, 128 - 64 * $Sync_Checks )
			Case $but_apply
				;$Sync_Checks = IsChecked($chk_sync_checks)
				$Sync_Checks_BG = IsChecked($chk_silent_mode)
				IniWrite($inifile, $sections[1], "sync_checks", $Sync_Checks)
				IniWrite($inifile, $sections[1], "sync_checks_bg", $Sync_Checks_BG)
				UpdateDoubleCheckLabels()
				For $i = 0 To 1
					If IsChecked($rad_site[$i]) Then
						$site = $i
						IniWrite($inifile, $sections[1], "site", $i)
					EndIf
				Next
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($c_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($dlg_sel_site)
	$CurrentGUI = $CallingGUI
	If $site <> $site0 Then SwitchSites(0, True)
	$activity = $mtim
_ap_ProfileStop(96)
EndFunc   ;==>Dlg_SelectSite
; --------------------------------------------
Func Dlg_SetPostCheck()
_ap_ProfileStart(97)
	Local $dlg_postcheck, $rad_process[3], $c_msg, $but_cancel, $but_apply, $inp_timeout, $chk_noptpCamGui	;, $chk_dont_force, $chk_inet_debug, $chk_inet_progress
	Local $chk_remove_old, $inp_leave_alone, $i, $rad_autcomp[3], $state, $nosel	;, $changed = 0, $w_inet_debug0 = $w_inet_debug
	Local $chk_new_ptpcam, $chk_use_https, $chk_use_trash
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	$nosel = IsChecked($chk_nosel)
	GetWPos()
	Local $gui_ypos = $wpos[1] + Round( (R($w_ch) - X(425+25)) / 2 )
	$dlg_postcheck = GUICreate("SVN Processing Options", X(270), X(425+25), $wpos[0] + $wpos[2] - X(300), $gui_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, 400, 1, "Tahoma")

	GUICtrlCreateGroup(" Page Recovery Timeout ", X(10), X(10), X(250), X(125) )
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)	; $f_normal
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel( "HTML page loading will time out after", X(25), X(30), X(120), X(35) )
	Set_BGColor()
	$inp_timeout = GUICtrlCreateInput(String($InetTimeOut), X(150), X(35), X(50), X(18), 0x2001)	; 90
	GUICtrlCreateUpdown($inp_timeout, 0x20)
	GUICtrlSetLimit(-1, 999, 5)
	GUICtrlCreateLabel("seconds", X(205), X(36), X(50), X(20) )	; 145
	Set_BGColor()
	$chk_use_https = GUICtrlCreateCheckbox(" Use HTTPS where possible", X(25), X(67), X(230), X(18) )
	Set_BGColor()
	If $web_prefix = $sweb Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$chk_noptpCamGui = GUICtrlCreateCheckbox(" Disable ptpCamGui download", X(25), X(92), X(230), X(18) )
	GUICtrlSetFont(-1, $fontsize, 700)
	Set_BGColor()
	If $no_ptpcamgui_dl = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1

	$chk_new_ptpcam = GUICtrlCreateCheckbox(" Use latest ptpcam.exe", X(48), X(113), X(190), X(18) )
	Set_BGColor()
	If $update_ptpcam = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	If $no_ptpcamgui_dl = 1 Then GUICtrlSetState(-1, 128)	; $GUI_DISABLE = 128

	GUICtrlCreateGroup(" Archive Processing Mode ", X(10), X(145), X(250), X(90) )
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel("Download and ...", X(25), X(188), X(105), X(18) )
	Set_BGColor()

	For $i = 0 To 2
		$rad_process[$i] = GUICtrlCreateRadio($txt_process[$i], X(135), X(165 + ($i * 20)), X(120), X(18) )	; 60
		Set_BGColor()
	Next
	GUICtrlSetState($rad_process[$w_upd], 1) ; $GUI_CHECKED = 1

	GUICtrlCreateGroup(" AutoCompile new downloads ", X(10), X(245), X(250), X(105) )
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel("Only available if you have enabled: 'Make new downloaded builds current' and Unzip (1 of the lower 2 options above)", X(25), X(265), X(230), X(50) )
	Set_BGColor()
	For $i = 0 To 2
		$rad_autcomp[$i] = GUICtrlCreateRadio($txt_autcomp[$i], X(30 + ($i * 75)), X(318), X(70), X(20) )
		Set_BGColor()
	Next
	GUICtrlSetState($rad_autcomp[$w_auto], 1) ; $GUI_CHECKED = 1
	If $w_upd <> 0 And $nosel Then
		$state = 64 ; $GUI_ENABLE = 64
	Else
		$state = 128 ; $GUI_DISABLE = 128
	EndIf
	For $i = 0 To 2
		GUICtrlSetState($rad_autcomp[$i], $state)
	Next

	$chk_remove_old = GUICtrlCreateCheckbox(" Remove old builds except last", X(20), X(365), X(193), X(20) )
	Set_BGColor()
	If $LimitBuilds = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$inp_leave_alone = GUICtrlCreateInput(String($BuildsToKeep), X(215), X(365), X(45), X(18), 0x2001)	; 90
	GUICtrlCreateUpdown($inp_leave_alone, 0x20)
	GUICtrlSetLimit(-1, 999, 1)
	$chk_use_trash = GUICtrlCreateCheckbox(" Recycle instead of Delete", X(40), X(365+25), X(220), X(20) )
	Set_BGColor()
	If $PurgeToTrash = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1

	$but_apply = GUICtrlCreateButton("OK", 		 X(10), X(395+25), X(120), X(20) )
	$but_cancel = GUICtrlCreateButton("Cancel", X(140), X(395+25), X(120), X(20) )
	DisableMainControls(1)
	GUISetState($State_Show, $dlg_postcheck)
	ControlFocus($dlg_postcheck, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $dlg_postcheck
	$CurrentGUI[1] = "SVN_Options_Dlg"
	While 1
		$c_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($c_msg)
		If $Introspection Then Trace_Msg($c_msg)
		If WinActive($main) Then WinActivate($dlg_postcheck)
		If $c_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($dlg_postcheck)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $c_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $c_msg
			Case $rad_process[0], $rad_process[1], $rad_process[2]
				If ( IsChecked($rad_process[1]) Or IsChecked($rad_process[2]) ) And $nosel Then
					$state = 64 ; $GUI_ENABLE = 64
				Else
					$state = 128 ; $GUI_DISABLE = 128
				EndIf
				For $i = 0 To 2
					GUICtrlSetState($rad_autcomp[$i], $state)
				Next
				ContinueLoop
			Case $but_cancel
				ExitLoop
			Case $chk_noptpCamGui
				If IsChecked($chk_noptpCamGui) Then
					GUICtrlSetState($chk_new_ptpcam, 128)	; $GUI_DISABLE = 128
				Else
					GUICtrlSetState($chk_new_ptpcam, 64)	; $GUI_ENABLE = 64
				EndIf
			Case $but_apply
				For $i = 0 To 2
					If IsChecked($rad_process[$i]) Then
						$w_upd = $i
						IniWrite($inifile, $sections[1], "update_option", $i)
					EndIf
					If IsChecked($rad_autcomp[$i]) Then
						$w_auto = $i
						IniWrite($inifile, $sections[1], "autocompile_option", $i)
					EndIf
				Next
				$InetTimeOut = Number(GUICtrlRead($inp_timeout))
				IniWrite($inifile, $sections[0], "inet_timeout", $InetTimeOut)
				$i = IsChecked($chk_use_https)
				IniWrite($inifile, $sections[0], "inet_use_https", $i)
				$web_prefix = $web
				If $i Then $web_prefix = $sweb
				$no_ptpcamgui_dl = IsChecked($chk_noptpCamGui)
				IniWrite($inifile, $sections[0], "no_ptpcamgui_dl", $no_ptpcamgui_dl)
				$update_ptpcam = IsChecked($chk_new_ptpcam)
				IniWrite($inifile, $sections[0], "update_ptpcam", $update_ptpcam)
				$LimitBuilds = IsChecked($chk_remove_old)
				IniWrite($inifile, $sections[1], "limit_builds", $LimitBuilds)
				$BuildsToKeep = Number(GUICtrlRead($inp_leave_alone))
				IniWrite($inifile, $sections[1], "limit_builds_to", $BuildsToKeep)
				$PurgeToTrash = IsChecked($chk_use_trash)
				IniWrite($inifile, $sections[1], "purge_to_trash", $PurgeToTrash)
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($c_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($dlg_postcheck)
	$CurrentGUI = $CallingGUI
	$activity = $mtim
	UpdateAutoUpdateControls()
_ap_ProfileStop(97)
;~ 	If $changed = 1 Then RestartProgram()
EndFunc   ;==>Dlg_SetPostCheck
; --------------------------------------------
Func Dlg_CompileOptions()
_ap_ProfileStart(98)

	Local $cc_gui, $cc_msg, $but_apply, $but_cancel, $chk_comp_option, $chk_postclean, $chk_incremental
	Local $but_primary, $but_gmhelp, $but_compilers, $string, $ic, $cc_flag, $cc_name, $h_in, $h_out
	Local $ln, $max_option, $cbo_option, $gmopt, $cbo_lang = "X", $dummy
	Local $rad_gcc[2], $primary_path, $chk_primary, $lab_primary, $wp_path, $dummy_path = "Internal (path not set)"
	Local $optfile = "\buildconf.inc", $loc_optfile = "\localbuildconf.inc", $oldbuild = 0
	Local $ccy = 275 + 60, $gwidth = 420, $vsiz = R($ccy + 50)	;
	Local $inc_lock_state = $Incremental_Lock	; $cc_array, $h_out2
	Local $weight = 400
	Local $OPT_DEFAULT_LANG = "OPT_DEFAULT_LANG"
	Local Const $NA = "Not available in this build"

	; note: this dialog SHOULD resize, and will be vertically centered relative to mainGUI
	GetWPos()
	$CustomPrimary = False
	If Not FileExists($sourcedir & $optfile) Then
		$optfile = "\makefile.inc"
		$oldbuild = 1
		$vsiz += R(25)
	Else
		$h_in = FileOpen($sourcedir & $loc_optfile, 0)
		$dummy = 0
		While 1
			$ln = FileReadLine($h_in)
			If @error = -1 Then ExitLoop
			If StringLeft($ln, 16) == $OPT_DEFAULT_LANG Then ContinueLoop
			If StringLeft($ln, 4) == "OPT_" Then $dummy += 1
			If StringLeft($ln, 12) == "PRIMARY_ROOT" Then $CustomPrimary = True
		Wend
		FileClose($h_in)
		Local $chk_comp_option[$dummy][2]
		If Not IsInt($dummy / 2) Then $dummy += 1
		$vsiz += R(25 * $dummy / 2)
		$h_in = FileOpen($sourcedir & $loc_optfile, 0)
		For $i = 0 To Ubound($chk_comp_option) - 1
			$ln = FileReadLine($h_in)
			; ====================================================================
			If StringLeft($ln, 16) == $OPT_DEFAULT_LANG Then ContinueLoop
			; ====================================================================
			If StringLeft($ln, 4) == "OPT_" Then $chk_comp_option[$i][1] = $ln
		Next
		FileClose($h_in)
		If $DefLang_Configurable Then
			FileChangeDir($sourcedir & "\CHDK\LANG")
			Local $langs = "", $s_hnd = FileFindFirstFile("*.lng")
			While 1
				$dummy = FileFindNextFile($s_hnd)
				If @error = 1 Then ExitLoop
				$langs &= StringTrimRight($dummy, 4) & "|"
			WEnd
			$langs = StringTrimRight($langs, 1)
			FileClose($s_hnd)
			FileChangeDir($here)
		EndIf
	EndIf

;~ 	Local $dlg_ypos = $wpos[1] - $vsiz + R($w_ch - 20)
	Local $dlg_ypos = $wpos[1] + Round( (R($w_ch) - $vsiz) / 2)
	If $dlg_ypos < 0 Then $dlg_ypos = 0

	; this dialog will be follow the font bolding settings
	; defined in Dlg_SetCamPanel()
	If $CP_bold[3] > 100 * $w_scaler Then ; is winsize < threshold ?
		If $CP_bold[1] = 1 Then $weight = 700
	EndIf

	$cc_gui = GUICreate("  Compile Options", R($gwidth + 40), $vsiz, $wpos[0] + $wpos[2] - R($gwidth + 70), $dlg_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW	)
	GUISetFont($f_normal, $weight)

	GUICtrlCreateGroup("GCC Compiler Version", R(20), R(10), R($gwidth), R(45))
	GUICtrlSetFont(-1, $f_normal, $weight, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	For $ic = 0 To 1
		$rad_gcc[$ic] = GUICtrlCreateRadio($gccver[$ic], R($gwidth - 290 + $ic * 100), R(27), R(80), R(20))	; 57
		Set_BGColor()
		GUICtrlSetFont(-1, $f_large, 700)
	Next
	If Not FileExists($GCC3path & "\arm-elf-gcc.exe") Or $GCC3_Lock = True Then GUICtrlSetState($rad_gcc[0], 128) ; $GUI_DISABLE = 128
	If Not FileExists($GCC4path & "\arm-elf-gcc.exe") Then GUICtrlSetState($rad_gcc[1], 128) ; $GUI_DISABLE = 128
	If $GCCpath = $GCC3path Then
		GUICtrlSetState($rad_gcc[0], 1) ; $GUI_CHECKED = 1
		GUICtrlSetState($rad_gcc[1], 4) ; $GUI_UNCHECKED = 4
		If $InstallFlag = 3 Then GUICtrlSetState($rad_gcc[1], 128) ; $GUI_DISABLE = 128
	Else
		GUICtrlSetState($rad_gcc[0], 4) ; $GUI_UNCHECKED = 4
		If $InstallFlag = 4 Then GUICtrlSetState($rad_gcc[0], 128) ; $GUI_DISABLE = 128
		GUICtrlSetState($rad_gcc[1], 1) ; $GUI_CHECKED = 1
	EndIf
	$but_compilers = GUICtrlCreateButton("Set Paths ...", R($gwidth - 75), R(27), R(85), R(20))

	GUICtrlCreateGroup("PRIMARY_ROOT", R(20), R(60), R($gwidth), R(95))
	GUICtrlSetFont(-1, $f_normal, $weight, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	If $SupportsPrimary Then ; if not in makefile.inc then PRIMARY is not supported in this build
		$wp_path = IniRead($inifile, $sections[0], "ext_primary", "")
		If $wp_path <> "" Then
			$primary_path = StringReplace($wp_path, "\", "/")
			$string = $wp_path
			$dummy = StringSplit($wp_path, "\")
			If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0]-1] & " \" & $dummy[$dummy[0]]
		Else
			$primary_path = ""
			$string = $dummy_path
		EndIf
		$but_primary = GUICtrlCreateButton("Set Path ...", R($gwidth - 75), R(80), R(85), R(20))
		$chk_primary = GUICtrlCreateCheckbox("  Use (can't uncheck until path is set)", R(35), R(80), R($gwidth - 145), R(20))
		Set_BGColor()

		If $wp_path = "" Or $CustomPrimary Then GUICtrlSetState(-1, 1)	; $GUI_CHECKED
		$lab_primary = GUICtrlCreateLabel($string, R(35), R(110), R($gwidth - 25), R(30), $SS_SUNKEN)
		If $wp_path <> "" Then GUICtrlSetTip(-1, $wp_path)
		GUICtrlSetColor(-1, $seagreen)
	Else
		GUICtrlCreateLabel($NA, R(35), R(90), R($gwidth - 25), R(20))
		Set_BGColor()
		GUICtrlSetFont(-1, $f_normal, 700)
	EndIf

	GUICtrlCreateGroup("GMAKE Options", R(20), R(160), R($gwidth), R(90))
	GUICtrlSetFont(-1, $f_normal, $weight, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$chk_postclean = GUICtrlCreateCheckbox("  Skip GMAKE clean AFTER", R(35), R(185), R(190), R(16) )
	Set_BGColor()
	If $SkipPostClean = 1 Then GUICtrlSetState(-1, 1)	; $GUI_CHECKED
	$chk_incremental = GUICtrlCreateCheckbox("  Incremental ('gmake fir')", R(25 + $gwidth / 2), R(185), R(190), R(16) )
	Set_BGColor()
	If $inc_lock_state Then GUICtrlSetState(-1, 1)	; $GUI_CHECKED
	$make_uses_options = 1 * IniRead($inifile, $sections[0], "make_uses_options", 0)
	$but_gmhelp = GUICtrlCreateButton("?", R(35), R(212), R(20), R(20) )
	GUICtrlCreateLabel(" GMAKE option(s)  select", R(60), R(215), R(165), R(14) )
	Set_BGColor()
	$gmopt = StringSplit($make_options, "|")
	$max_option = $gmopt[0]
	$gmopt[0] = "default (none)"
	$cbo_option = GUICtrlCreateCombo($gmopt[0], R(25 + $gwidth / 2), R(212), R(190), R(20) )
	GUICtrlSetData(-1, $make_options, $gmopt[$make_uses_options])
	If $oldbuild = 1 Then
		$dummy = R(50)
	Else
		$dummy = Ubound($chk_comp_option)	;$cc_array[0]
		If Not IsInt($dummy / 2) Then $dummy += 1
		$dummy = R(25 + 25 * $dummy / 2)
	EndIf
	; ===================================================================================================
	; insert control for default language selection here
	GUICtrlCreateGroup(GetSVN_Name($site) & " Internal Default Language", R(20), R(260), R($gwidth), R(50))
	GUICtrlSetFont(-1, $f_normal, $weight, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel($NA, R(35), R(281), R(190), R(14) )
	Set_BGColor()
	If $oldbuild = 0 And $DefLang_Configurable Then
		GUICtrlSetData(-1, GetSVN_Name($site) & " user interface in")
		$cbo_lang = GUICtrlCreateCombo("", R(25 + $gwidth / 2), R(278), R(190), R(20) )
		GUICtrlSetData(-1, $langs, $DefLang[$site])
	EndIf
	; ===================================================================================================
	GUICtrlCreateGroup("Optional Components for " & CopyStringWord($CBFN, 16, " "), R(20), R($ccy - 20), R($gwidth), $dummy)
	GUICtrlSetFont(-1, $f_normal, $weight, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	If $oldbuild = 0 Then
		Local $col_off = 0
		For $ic = 0 To Ubound($chk_comp_option) - 1
			Switch StringRight($chk_comp_option[$ic][1], 1)
				Case "="
					$cc_flag = 4 ; $GUI_UNCHECKED = 4
					$chk_comp_option[$ic][1] = StringTrimRight($chk_comp_option[$ic][1], 1)
				Case "1"
					$cc_flag = 1 ; $GUI_CHECKED = 1
					$chk_comp_option[$ic][1] = StringTrimRight($chk_comp_option[$ic][1], 2)
			EndSwitch
			$cc_name = "  " & $chk_comp_option[$ic][1]
			$chk_comp_option[$ic][0] = GUICtrlCreateCheckbox($cc_name, R(35 + $col_off), R($ccy), R(190), R(20))
			Set_BGColor()
			GUICtrlSetState(-1, $cc_flag)
			If IsInt($ic / 2) Then
				$col_off = $gwidth / 2 - 10
			Else
				$col_off = 0
				$ccy += 25
			EndIf
		Next
	Else
		GUICtrlCreateLabel($NA, R(35), R($ccy + 5), R(175), R(20))
		Set_BGColor()
	EndIf
	$but_apply = GUICtrlCreateButton("OK", R(20), $vsiz - R(32), R(203), R(22))
	$but_cancel = GUICtrlCreateButton("Cancel", R(25 + $gwidth / 2), $vsiz - R(32), R(203), R(22))
	DisableMainControls(1)
	GUISetState($State_Show, $cc_gui)
	ControlFocus($cc_gui, "", $but_cancel)

	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $cc_gui
	$CurrentGUI[1] = "Comp_Options_Dlg"
	While 1
		$cc_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($cc_msg)
		If $Introspection Then Trace_Msg($cc_msg)
		If WinActive($main) Then WinActivate($cc_gui)
		If $cc_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($cc_gui)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $cc_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $cc_msg
			Case $but_cancel
				ExitLoop
			Case $but_compilers
				GUISetState($State_Disable, $cc_gui)
				$dummy = Dlg_CompilerPaths(IsChecked($rad_gcc[0]))
				GUISetState($State_Enable, $cc_gui)
				WinActivate($cc_gui)
				;$CurrentGUI = $cc_gui
				ControlFocus($cc_gui, "", $but_cancel)
				GUICtrlSetData($rad_gcc[0], $gccver[0])
				GUICtrlSetData($rad_gcc[1], $gccver[1])
				Switch $dummy
					Case 3
						GUICtrlSetState($rad_gcc[0], 64) ; $GUI_ENABLE = 64
					Case 4
						GUICtrlSetState($rad_gcc[1], 64)
					Case 7
						GUICtrlSetState($rad_gcc[0], 64)
						GUICtrlSetState($rad_gcc[1], 64)
				EndSwitch
			Case $but_primary
				If $SupportsPrimary Then
					$wp_path = Dlg_PrimaryPath($cc_gui)
					FileChangeDir($here)
					WinActivate($cc_gui)
					If $wp_path = "" Then
						$primary_path = ""
						GUICtrlSetData($lab_primary, $dummy_path)
						GUICtrlSetTip($lab_primary, "")
						GUICtrlSetState($chk_primary, 1)
					Else
						$string = $wp_path
						$dummy = StringSplit($wp_path, "\")
						If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0]-1] & " \" & $dummy[$dummy[0]]
						GUICtrlSetData($lab_primary, $string)
						GUICtrlSetTip($lab_primary, $wp_path)
						$primary_path = StringReplace($wp_path, "\", "/")
						GUICtrlSetState($chk_primary, 4) ; $GUI_UNCHECKED = 4
					EndIf
				EndIf
			Case $chk_primary
				If $primary_path = "" Then GUICtrlSetState($chk_primary, 1)
			Case $chk_incremental, $chk_postclean
				If IsChecked($chk_incremental) Then
					If SelectedFirms() <> 1 Or IsChecked($chk_inet) = 1 Then
						GUICtrlSetState($chk_incremental, 4) ; $GUI_UNCHECKED = 4
						Dlg_MyMsgBox(0, "Can not activate option", "The following conditions must be met first:" & @CR & @CR & "-->  Only 1 firmware is selected" & @CR & "-->  Internet is disabled ('Allow Internet' unchecked)"& @CR & @CR & "Note: You will be 'locked' into your current build while" & @CR & "this option is active, only options directly related to" & @CR & "compilation will be available." & @CR & "It will also enforce 'Skip GMAKE clean AFTER'", 0, $cc_gui)
					Else
						GUICtrlSetState($chk_postclean, 1) ; $GUI_CHECKED = 1
						$inc_lock_state = 1
					EndIf
				Else
					$inc_lock_state = 0
				EndIf
			Case $but_gmhelp
				RunWait($SysComSpec & " /c gmake.exe --help > gmake.txt", $GCCpath, $State_Hide)
				ShellExecute($GCCpath & "\gmake.txt", "", "", "open")
			Case $but_apply
				If $oldbuild = 0 Then
					$h_out = FileOpen($sourcedir & $loc_optfile, 2)
					For $i = 0 To Ubound($chk_comp_option) - 1
						$dummy = $chk_comp_option[$i][1] & "="	; option name=
						If IsChecked($chk_comp_option[$i][0]) Then $dummy &= "1"
						FileWrite($h_out, $dummy & @LF)
					Next
					If $primary_path <> "" And IsChecked($chk_primary) Then
						FileWrite($h_out, "PRIMARY_ROOT=" & $primary_path & @LF)
					EndIf
					$dummy = GUICtrlRead($cbo_lang)
					If $DefLang_Configurable Then
						FileWrite($h_out, $OPT_DEFAULT_LANG & "=" & $dummy & @LF)
						$DefLang[$site] = $dummy
						IniWrite($inifile, $sections[1], "def_lang" & $site, $DefLang[$site])
					EndIf
					FileClose($h_out)
				EndIf
				If $primary_path <> "" Then
					IniWrite($inifile, $sections[0], "ext_primary", $wp_path)
				Else
					IniDelete($inifile, $sections[0], "ext_primary")
				EndIf
				$make_uses_options = -1
				Local $selopt = GUICtrlRead($cbo_option)
 				For $i = 0 To $max_option
					If $selopt = $gmopt[$i] Then
						$make_uses_options = $i
						ExitLoop
					EndIf
				Next
				If $make_uses_options = -1 Then
					; user edited, add as new option ...
					$make_options &= "|" & $selopt
					IniWrite($inifile, $sections[0], "make_options", $make_options)
					; ... and select it
					$make_uses_options = $max_option + 1
				EndIf
				IniWrite($inifile, $sections[0], "make_uses_options", $make_uses_options)
				$GCCpath = $GCC4path
				If IsChecked($rad_gcc[0]) Then $GCCpath = $GCC3path
				IniWrite($inifile, $sections[0], "GCCpath", $GCCpath)
				IniWrite($inifile, $sections[0], "GCC3path", $GCC3path)
				IniWrite($inifile, $sections[0], "GCC4path", $GCC4path)
				$SkipPostClean = IsChecked($chk_postclean)
				$Incremental_Lock = $inc_lock_state
				IniWrite($inifile, $sections[0], "skip_postclean", $SkipPostClean)
				If IsChecked($chk_tooltips) Then Set_Dyn_Tooltips()
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($cc_msg)
	WEnd
	FileDelete($GCCpath & "\gmake.txt")
	GUIDelete($cc_gui)
	$CurrentGUI = $CallingGUI
	$activity = $mtim
	SetIncrementalLockControls()
_ap_ProfileStop(98)
EndFunc   ;==>Dlg_CompileOptions
; --------------------------------------------
Func Dlg_PrimaryPath($parent)
_ap_ProfileStart(99)
	DisableMainControls(1)
	Local $ret = FileSelectFolder(	"External PRIMARY_ROOT (NO error checking !!)" & @CRLF & "Click 'Cancel' to reset to Internal Default", $mycomp, 6, "", $parent)
	FileChangeDir($here)
	DisableMainControls(0)
_ap_ProfileStop(99)
	Return $ret
EndFunc   ;==>Dlg_PrimaryPath
; --------------------------------------------
Func Dlg_CompilerPaths($gcc3_selected)
_ap_ProfileStart(100)
	Local $_lab3 = "GCC 3", $_lab4 = "GCC 4", $browse = " << click to browse"
	Local $ill = "[Not supported in " & $CurrOSVersion & "]"
	Local $c_msg, $dlg_comp_path, $but_g3, $but_g4, $but_apply, $but_cancel, $but_help
	Local $lab_newg3, $lab_newg4, $lab_g3_p, $lab_g4_p, $lab_newg3_p, $lab_newg4_p
	Local $_path3[2], $_path4[2], $_pnewg3[2], $_pnewg4[2], $ret, $state = 0
	Local $vers = "[W32ver][ARMver] && path"
	Local $OSflag = $GCC3_Lock	; StringInStr($semi_allowed, $CurrOSVersion)
	Local $gccver_org = $gccver

	; note: this dialog SHOULD resize

	$_path3 = StringSplit(ValidateDevKit($GCC3path), " = ", 3)
	If $OSflag Then $_path3[0] = $ill
	$_path4 = StringSplit(ValidateDevKit($GCC4path), " = ", 3)
	$_pnewg3[0] = $browse
	$_pnewg4[0] = $browse
	$dlg_comp_path = GUICreate("Set Path to DevKits", R(250), R(350), $wpos[0] + $wpos[2] - R(280), $wpos[1] + R(210), $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont(8.5 * $f_scaler) ; to allow for running from SanityCheck, before main GUI
	GUICtrlCreateGroup("Current  " & $vers, R(10), R(10), R(230), R(145))
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel($_lab3 & " :", R(20), R(35), R(45), R(20))
	Set_BGColor()
	GUICtrlCreateLabel($_path3[0], R(75), R(35), R(160), R(20))
	Set_BGColor()
	$lab_g3_p = GUICtrlCreateLabel($_path3[1], R(20), R(55), R(210), R(30), $SS_SUNKEN)
	GUICtrlSetColor($lab_g3_p, $seagreen)
	If StringInStr($_path3[0], "[N") Then GUICtrlSetColor($lab_g3_p, $red)
	GUICtrlCreateLabel($_lab4 & " :", R(20), R(95), R(45), R(20))
	Set_BGColor()
	GUICtrlCreateLabel($_path4[0], R(75), R(95), R(160), R(20))
	Set_BGColor()
	$lab_g4_p = GUICtrlCreateLabel($_path4[1], R(20), R(115), R(210), R(30), $SS_SUNKEN)
	GUICtrlSetColor($lab_g4_p, $seagreen)
	If StringInStr($_path4[0], "[N") Then GUICtrlSetColor($lab_g4_p, $red)
	GUICtrlCreateGroup("New      " & $vers, R(10), R(165), R(230), R(145))
	GUICtrlSetFont(-1, Default, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$but_g3 = GUICtrlCreateButton($_lab3, R(20), R(188), R(50), R(20))	; 18
;~ 	If $OSflag Then GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$lab_newg3 = GUICtrlCreateLabel($_pnewg3[0], R(75), R(190), R(160), R(20))
	Set_BGColor()
	$lab_newg3_p = GUICtrlCreateLabel($_pnewg3[1], R(20), R(210), R(210), R(30), $SS_SUNKEN)
	GUICtrlSetColor($lab_newg3_p, $seagreen)
	If StringInStr($_pnewg3[0], "[N") Then GUICtrlSetColor($lab_newg3_p, $red)
	$but_g4 = GUICtrlCreateButton($_lab4, R(20), R(248), R(50), R(20))	; 18
	$lab_newg4 = GUICtrlCreateLabel($_pnewg4[0], R(75), R(250), R(160), R(20))
	Set_BGColor()
	$lab_newg4_p = GUICtrlCreateLabel($_pnewg4[1], R(20), R(270), R(210), R(30), $SS_SUNKEN)
	GUICtrlSetColor($lab_newg4_p, $seagreen)
	$but_apply = GUICtrlCreateButton("Accept New", R(10), R(320), R(85), R(20))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$but_cancel = GUICtrlCreateButton("Keep Current", R(100), R(320), R(85), R(20))
	$but_help = GUICtrlCreateButton("Help ...", R(190), R(320), R(50), R(20))
	DisableMainControls(1)
	GUISetState($State_Show, $dlg_comp_path)
	ControlFocus($dlg_comp_path, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $dlg_comp_path
	$CurrentGUI[1] = "Comp_Paths_Dlg"
	While 1
		$c_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($c_msg)
		If $Introspection Then Trace_Msg($c_msg)
		If Not WinActive($dlg_comp_path) Then WinActivate($dlg_comp_path)
		If $c_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($dlg_comp_path)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $c_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $c_msg
			Case $but_g3, $but_g4
				$ret = FileSelectFolder("Select path to DevKit with " & GUICtrlRead($c_msg), $mycomp, 6, $mycomp, $dlg_comp_path)
				FileChangeDir($here)
				If $ret = "" Then ContinueLoop ; Cancel selected
				If StringInStr($ret, "=") <> 0 Then
					Dlg_MyMsgBox(0, "Path: " & $ret, "DevKit utilities will NOT work with '=' in the path !" & @CR & "Please correct this to use the DevKit !")
					ContinueLoop
				Else
					$ret &= "\bin"
					If CheckHelperFiles($ret) <> 0 Then ContinueLoop
					Switch $c_msg
						Case $but_g3
							$_pnewg3 = StringSplit(ValidateDevKit($ret), " = ", 3)
							If @error Then ContinueLoop
							GUICtrlSetData($lab_newg3, $_pnewg3[0])
							GUICtrlSetData($lab_newg3_p, $_pnewg3[1])
							GUICtrlSetColor($lab_newg3_p, $red)
							If StringInStr($_pnewg3[0], "][4") Then
								WrongGCCVersion(4)
								WinActivate($dlg_comp_path)
								GUICtrlSetData($lab_newg3, $browse)
								GUICtrlSetData($lab_newg3_p, "")
								ContinueLoop
							EndIf
							If Not StringInStr($_pnewg3[0], "[N") Then GUICtrlSetColor($lab_newg3_p, $seagreen)
						Case $but_g4
							$_pnewg4 = StringSplit(ValidateDevKit($ret), " = ", 3)
							If @error Then ContinueLoop
							GUICtrlSetData($lab_newg4, $_pnewg4[0])
							GUICtrlSetData($lab_newg4_p, $_pnewg4[1])
							GUICtrlSetColor($lab_newg4_p, $red)
							If StringInStr($_pnewg4[0], "][3") Then
								WrongGCCVersion(3)
								WinActivate($dlg_comp_path)
								GUICtrlSetData($lab_newg4, $browse)
								GUICtrlSetData($lab_newg4_p, "")
								ContinueLoop
							EndIf
							If Not StringInStr($_pnewg4[0], "[N") Then GUICtrlSetColor($lab_newg4_p, $seagreen)
					EndSwitch
				EndIf
				If ((Not StringInStr($_pnewg3[0], "[N")) And $_pnewg3[0] <> $browse) Or ((Not StringInStr($_pnewg4[0], "[N")) And $_pnewg4[0] <> $browse) Then
					GUICtrlSetState($but_apply, 64) ; $GUI_ENABLE = 64
					ControlFocus($dlg_comp_path, "", $but_apply)
				Else
					GUICtrlSetState($but_apply, 128) ; $GUI_DISABLE = 128
					ControlFocus($dlg_comp_path, "", $but_cancel)
				EndIf
				WinActivate($dlg_comp_path)
			Case $but_cancel
				$gccver = $gccver_org
				ExitLoop
			Case $but_help
				ShellExecute($subdir & "\devkits.txt", "", "", "open")
			Case $but_apply
				If ((Not StringInStr($_pnewg3[0], "[N")) And $_pnewg3[0] <> $browse) Then
					If ($_pnewg3[1] & "\bin") <> $GCC3path Then
						$state += 3
						$GCC3path = $_pnewg3[1] & "\bin"
						If $gcc3_selected = 1 Then $GCCpath = $GCC3path
					EndIf
				EndIf
				If ((Not StringInStr($_pnewg4[0], "[N")) And $_pnewg4[0] <> $browse) Then
					If ($_pnewg4[1] & "\bin") <> $GCC4path Then
						$state += 4
						$GCC4path = $_pnewg4[1] & "\bin"
						If $gcc3_selected = 0 Then $GCCpath = $GCC4path
					EndIf
				EndIf
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($c_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($dlg_comp_path)
	$CurrentGUI = $CallingGUI
	If $state <> 0 And IsChecked($chk_tooltips) Then Set_Dyn_Tooltips()
	$activity = $mtim
_ap_ProfileStop(100)
	Return $state
EndFunc   ;==>Dlg_CompilerPaths
; --------------------------------------------
Func Dlg_VersionStats()
_ap_ProfileStart(101)
	Local $_datref, $_datcur, $_tmp, $_stats, $_cur = Number(GUICtrlRead($cur_t))
	Local $_ddif, $_flag = 0, $_buf
	;                                                                            cams firms supported @ ref version
	Local $refvalues[2][6] = [ 	[ "212 (released 24-10-2007)", "2007", "10", "24",  7, 10 ], [ "193 (released 16-12-2009)", "2009", "12", "16", 48, 98 ]	]
	Local $refver = Number(StringLeft($refvalues[$site][0], 4))

	If $branches[1 - $trunk[$site]][3] = "" Then
		$_stats = "No SVN data (a quick Internet on/off might help)"
	ElseIf $_cur < $refver + 1 Then
		$_stats = "Problems calculating, try a newer build !"
	Else
		$_stats = "Averages derived from build " & $refvalues[$site][0] & " and" & @CRLF
		$_stats &= "your current build " & $_cur & " (released* "
		$_datref = _DateToDayValue($refvalues[$site][1], $refvalues[$site][2], $refvalues[$site][3])
		If Not FileExists($sourcedir & "\released@.txt") Then
			If Not $_cur = Number($branches[1 - $trunk[$site]][2]) Then
				$_stats &= "around "
				$_tmp = FileGetTime($sourcedir & "\core", 1, 1)
			Else
				FileWriteLine($sourcedir & "\released@.txt", $branches[1 - $trunk[$site]][3])
			EndIf
		EndIf
		If Not StringInStr($_stats, "around") Then
			$_flag = 1 ; has already been tagged by program
			$_stats &= "on "
			$_buf = StringLeft(FileReadLine($sourcedir & "\released@.txt"), 10)
			If StringMid($_buf, 5, 1) = "/" Or StringMid($_buf, 5, 1) = "-" Then	; YYYY/MM/DD notation
				$_tmp = StringReplace($_buf, "/", "")
				$_tmp = StringReplace($_tmp, "-", "")
			ElseIf StringInStr($_buf, " ") Then		; MM/DD/YY notation
				$_buf = StringTrimRight($_buf, 2)
				$_tmp = "20" & StringRight($_buf, 2)
			Else								; MM/DD/YYYY notation
				$_tmp = StringRight($_buf, 4)
			EndIf
			$_tmp &= StringLeft($_buf, 2) & StringMid($_buf, 4, 2)
		EndIf
		$_datcur = _DateToDayValue(StringLeft($_tmp, 4), StringMid($_tmp, 5, 2), StringMid($_tmp, 7, 2))
		$_ddif = Round($_datcur - $_datref)
		$_stats &= StringMid($_tmp, 7, 2) & "-" & StringMid($_tmp, 5, 2) & "-" & StringLeft($_tmp, 4) & ")" & @CRLF & @CRLF
		$_stats &= "Period (elapsed time between releases):      " & $_ddif & " days" & @CRLF
		$_stats &= "Cameras / firmwares added in this period:     " & $sup_cams - $refvalues[$site][4]
		$_stats	&= " / " & $sup_firms - $refvalues[$site][5] & @CRLF & @CRLF
		$_stats &= "Support for a  camera  was added every:" & StringFormat("    % .2f days", $_ddif / ($sup_cams - $refvalues[$site][4])) & @CRLF
		$_stats &= "Support for a firmware was added every:" & StringFormat("    % .2f days", $_ddif / ($sup_firms - $refvalues[$site][5])) & @CRLF & @CRLF
		$_stats &= "        Number of committed builds per day:       " & Round(($_cur - $refver) / $_ddif, 2) & @CRLF & @CRLF
		If $_flag = 0 Then
			$_stats &= "* Note: based on /core creation day for build " & $_cur & ", so YMMV" & @CRLF & "             unless you run this program regularly with" & @CRLF & "             Recheck activated ... ;)"
		Else
			$_stats &= "* Note: based on true release date from svn"
		EndIf
	EndIf
	DisableMainControls(1)
	Dlg_MyMsgBox(0, "Development Stats for: " &  $branches[1 - $trunk[$site]][0] & " [" & GetSVN_Name($site) & "]", $_stats)
	ClearQ($msg) ; assure msg buffer clear
	DisableMainControls(0)
	WinActivate($main)
_ap_ProfileStop(101)
EndFunc   ;==>Dlg_VersionStats
; --------------------------------------------
Func Dlg_ProgUpdates()
_ap_ProfileStart(102)
	Local $dlg_updates, $rad_options[3], $c_msg, $but_cancel, $but_apply, $but_manual, $but_dl_dir
	Local $but_clear, $but_clear2, $but_shortcut_dir, $lab_shortcut_dir, $chk_kill_exe, $chk_kill_ini
	Local $chk_kill_au3, $chk_noreadme, $inp_keep_versions, $ud, $zapstate, $dummy
	Local $txt_options[3] = [" No (Manual)", " Yes, color Button if found", " Yes, open DL page if found"]
	Local $lab_dl_dir, $string, $vsiz = 440, $DLDir = $BrowserDLDir, $SCDir = $ShortcutDir
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	If $ulink <> "" Then
		GetNewVersion()
_ap_ProfileStop(102)
		Return
	EndIf
	GetWPos()
	Local $gui_ypos = $wpos[1] + Round( (R($w_ch) - X($vsiz)) / 2 )

	$dlg_updates = GUICreate("Program Updates", X(270), X($vsiz), $wpos[0] + $wpos[2] - X(300), $gui_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($fontsize, Default, 1, "Tahoma")

	GUICtrlCreateGroup("AutoChecking / Applying Updates", X(20), X(5), X(230), X(185) )
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
;~ 	$but_manual = GUICtrlCreateButton("Check Now", X(150), X(25), X(80), X(18) )
	$but_manual = GUICtrlCreateButton("Check Now", X(140), X(25), X(90), X(18) )
	$rad_options[0] = GUICtrlCreateRadio($txt_options[0], X(40), X(25), X(98), X(18) )
	Set_BGColor()
	For $i = 1 To 2
		$rad_options[$i] = GUICtrlCreateRadio($txt_options[$i], X(40), X(25) + $i * X(20), X(200), X(18) )
		Set_BGColor()
	Next
	GUICtrlSetState($rad_options[$w_chkver], 1) ; $GUI_CHECKED = 1
	GUICtrlCreateLabel("AutoApply: Browse to download dir to enable, clear to disable", X(40), X(92), X(200), X(30) )
	Set_BGColor()
	$but_dl_dir = GUICtrlCreateButton("Browse ...", X(40), X(125), X(90), X(18) )
	$but_clear  = GUICtrlCreateButton("Clear", X(140), X(125), X(90), X(18) )
	$lab_dl_dir = GUICtrlCreateLabel("", X(40), X(150), X(190), X(30), $SS_SUNKEN)
	GUICtrlSetColor(-1, $seagreen)
	If $BrowserDLDir <> "" Then
		$string = $BrowserDLDir
		$dummy = StringSplit($BrowserDLDir, "\")
		If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0] - 1] & " \" & $dummy[$dummy[0]]
		GUICtrlSetData(-1, $string)
		GUICtrlSetTip(-1, $BrowserDLDir)
	EndIf
	GUICtrlCreateGroup("Post Update Options", X(20), X(195), X(230), X(215))
	GUICtrlSetFont(-1, $fontsize, 400, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel("AutoShortcut: Browse to shortcut dir to enable, clear to disable", X(40), X(215), X(200), X(30) )
	Set_BGColor()
	$but_shortcut_dir = GUICtrlCreateButton("Browse ...", X(40), X(250), X(90), X(18) )
	$but_clear2  = GUICtrlCreateButton("Clear", X(140), X(250), X(90), X(18) )
	$lab_shortcut_dir = GUICtrlCreateLabel("", X(40), X(275), X(190), X(30), $SS_SUNKEN)
	GUICtrlSetColor(-1, $seagreen)
	If $ShortcutDir <> "" Then
		$string = $ShortcutDir
		$dummy = StringSplit($ShortcutDir, "\")
		If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0] - 1] & " \" & $dummy[$dummy[0]]
		GUICtrlSetData(-1, $string)
		GUICtrlSetTip(-1, $ShortcutDir)
	EndIf
	$chk_noreadme = GUICtrlCreateCheckbox(" Do NOT show 'readme.txt'", X(40), X(315), X(200), X(16) )
	Set_BGColor()
	If $no_readme_popup = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	GUICtrlCreateLabel("Remove old program versions", X(40), X(335), X(200), X(20) )
	Set_BGColor()
	GUICtrlSetFont(-1, $fontsize, 700)
	$chk_kill_exe = GUICtrlCreateCheckbox(".EXE", X(40), X(358), X(55), X(16) )
	Set_BGColor()
	If $Cleanup[0] = 1 Then
		GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
		$zapstate = 64	; $GUI_ENABLE
	Else
		GUICtrlSetState(-1, 4) ; $GUI_UNCHECKED = 4
		$zapstate = 128	; $GUI_DISABLE
	EndIf
	$chk_kill_ini = GUICtrlCreateCheckbox(".INI", X(103), X(358), X(55), X(16) )
	Set_BGColor()
	If $Cleanup[1] = 1 Then
		GUICtrlSetState(-1, 1 + $zapstate) ; $GUI_CHECKED = 1
	Else
		GUICtrlSetState(-1, 4 + $zapstate) ; $GUI_UNCHECKED = 4
	EndIf
	$chk_kill_au3 = GUICtrlCreateCheckbox(".AU3(src)", X(165), X(358), X(75), X(16) )
	Set_BGColor()
	If $Cleanup[2] = 1 Then
		GUICtrlSetState(-1, 1 + $zapstate) ; $GUI_CHECKED = 1
	Else
		GUICtrlSetState(-1, 4 + $zapstate) ; $GUI_UNCHECKED = 4
	EndIf
	GUICtrlCreateLabel("... but keep last", X(40), X(383), X(95), X(14) )
	Set_BGColor()
	$inp_keep_versions = GUICtrlCreateInput(String($Cleanup[3]), X(140), X(380), X(45), X(20), 0x2001)
	GUICtrlSetState(-1, $zapstate)
	$ud = GUICtrlCreateUpdown($inp_keep_versions, 0x20 )
	GUICtrlSetState(-1, $zapstate)
	GUICtrlSetLimit(-1, 99, 1)
	GUICtrlCreateLabel("versions", X(190), X(383), X(50), X(14), 0x01 )
	Set_BGColor()
	$but_apply = GUICtrlCreateButton("OK", X(20), X($vsiz - 22), X(110), X(18) )
	$but_cancel = GUICtrlCreateButton("Cancel", X(140), X($vsiz - 22), X(110), X(18) )
	DisableMainControls(1)
	GUISetState($State_Show, $dlg_updates)
	ControlFocus($dlg_updates, "", $but_cancel)

	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $dlg_updates
	$CurrentGUI[1] = "ProgUpdates_Dlg"
	While 1
		$c_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($c_msg)
		If $Introspection Then Trace_Msg($c_msg)
		If WinActive($main) Then WinActivate($dlg_updates)
		If $c_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($dlg_updates)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $c_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $c_msg
			Case $but_manual
				VersionSnoop(True)
				ContinueLoop
			Case $but_cancel
				ExitLoop
			Case $but_dl_dir
				$dummy = FileSelectFolder( "Select browser download directory", $mycomp, 6, "", $dlg_updates)
				FileChangeDir($here)
				If $dummy = "" Then ContinueLoop
				$DLDir = $dummy
				$string = $dummy
				$dummy = StringSplit($DLDir, "\")
				If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0]-1] & " \" & $dummy[$dummy[0]]
				GUICtrlSetData($lab_dl_dir, $string)
				GUICtrlSetTip($lab_dl_dir, $DLDir)
			Case $but_shortcut_dir
				$dummy = FileSelectFolder( "Select directory for program shortcut", "", 6, @DesktopDir, $dlg_updates)
				FileChangeDir($here)
				If $dummy = "" Then ContinueLoop
				$SCDir = $dummy
				$string = $dummy
				$dummy = StringSplit($SCDir, "\")
				If $dummy[0] > 4 Then $string = $dummy[1] & "\... \" & $dummy[$dummy[0]-1] & " \" & $dummy[$dummy[0]]
				GUICtrlSetData($lab_shortcut_dir, $string)
				GUICtrlSetTip($lab_shortcut_dir, $SCDir)
			Case $but_clear
				$DLDir = ""
				GUICtrlSetData($lab_dl_dir, "")
				GUICtrlSetTip($lab_dl_dir, "")
			Case $but_clear2
				$SCDir = ""
				GUICtrlSetData($lab_shortcut_dir, "")
				GUICtrlSetTip($lab_shortcut_dir, "")
			Case $chk_kill_exe
				$zapstate = 128 - 64 * IsChecked($chk_kill_exe)
				GUICtrlSetState($inp_keep_versions, $zapstate)
				GUICtrlSetState($ud, $zapstate)
				GUICtrlSetState($chk_kill_ini, $zapstate)
				GUICtrlSetState($chk_kill_au3, $zapstate)
			Case $but_apply
				For $i = 0 To 2
					If IsChecked($rad_options[$i]) Then
						IniWrite($inifile, $sections[0], "check_progver", $i)
						$w_chkver = $i
					EndIf
				Next
				If $DLDir <> $BrowserDLDir Then
					$BrowserDLDir = $DLDir
					If $DLDir = "" Then
						IniDelete($inifile, $sections[0], "download")
					Else
						IniWrite($inifile, $sections[0], "download", $BrowserDLDir)
					EndIf
				EndIf
				If $SCDir <> $ShortcutDir Then
					$ShortcutDir = $SCDir
					If $SCDir = "" Then
						IniDelete($inifile, $sections[0], "shortcut")
					Else
						IniWrite($inifile, $sections[0], "shortcut", $ShortcutDir)
					EndIf
				EndIf
				$no_readme_popup = IsChecked($chk_noreadme)
				IniWrite($inifile, $sections[0], "no_readme_popup", $no_readme_popup)
				$Cleanup[0] = IsChecked($chk_kill_exe)
				$Cleanup[1] = IsChecked($chk_kill_ini)
				$Cleanup[2] = IsChecked($chk_kill_au3)
				$Cleanup[3] = Number(GUICtrlRead($inp_keep_versions))
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($c_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($dlg_updates)
	$CurrentGUI = $CallingGUI
	$activity = $mtim
_ap_ProfileStop(102)
EndFunc   ;==>Dlg_ProgUpdates
; --------------------------------------------
Func Dlg_SourceTools()
_ap_ProfileStart(103)
	Local $vsiz = X(355), $src_gui, $src_msg, $but_done, $but_diff, $but_patch	;, $but_clone_and_fix	;, $but_run_ext		;vsize = + 30
	Local $rad_patch[2], $chk_patch, $chk_propsort, $but_xref, $patched = 0, $xref = 0
	GetWPos()
	Local $dlg_ypos = $wpos[1] + Round( (R($w_ch) - $vsiz) / 2 )
	Local $fontsize = $f_scaler * 8.5

	If $fontsize < 8.5 Then $fontsize = 8.5

	If $dlg_ypos < 0 Then $dlg_ypos = 0
	$src_gui = GUICreate("  Source Code Tools", X(280), $vsiz, $wpos[0] + $wpos[2] - X(310), $dlg_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW )
	GUISetFont($fontsize)

	GUICtrlCreateGroup("Diffing and Patching", X(20), X(10), X(240), X(135) )
	GUICtrlSetFont(-1, $fontsize, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel("Note: both work on the current build", X(30), X(35), X(220), X(20) )
	Set_BGColor()
	$but_diff = GUICtrlCreateButton("Diff ...", 	  X(30),  X(60), X(60), X(20) )
	$but_patch = GUICtrlCreateButton("Patch ...", 	  X(30),  X(90), X(60), X(20) )
	$rad_patch[0] = GUICtrlCreateRadio(" Apply", 	 X(115),  X(90), X(70), X(20) )
	Set_BGColor()
	GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$rad_patch[1] = GUICtrlCreateRadio(" Undo", 	 X(190),  X(90), X(60), X(20) )
	Set_BGColor()
	$chk_patch = GUICtrlCreateCheckbox(" Test only", X(115), X(115), X(80), X(20) )
	Set_BGColor()

	GUICtrlCreateGroup("Cam Properties Cross-reference", X(20), X(160), X(240), X(150) )
	GUICtrlSetFont(-1, $fontsize, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel(	"Shows && saves as flat text in your source folder as 'camprops_xref.log' - Please open with a REAL editor, Notepad won't do, lines are over 1600 chars wide ;)", X(30), X(180), X(220), X(65))
	Set_BGColor()
	$chk_propsort = GUICtrlCreateCheckbox(" Alphabetical sorting", X(115), X(250), X(135), X(20) )
	Set_BGColor()
	If $w_propsortalpha = 1 Then GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	$but_xref = GUICtrlCreateButton("Show", X(30), X(250), X(70), X(20) )
;~ 	$but_run_ext = GUICtrlCreateButton("Run CHDK-XREF", X(30), X(465 - 165 + 30), X(220), X(20) )
	$but_done = GUICtrlCreateButton("Return",  X(20), $vsiz - X(30), X(240), X(20) )
	DisableMainControls(1)
	GUISetState($State_Show, $src_gui)
	ControlFocus($src_gui, "", $but_done)

	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $src_gui
	$CurrentGUI[1] = "SrcTools_Dlg"
	While 1
		$src_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($src_msg)
		If $Introspection Then Trace_Msg($src_msg)
		If WinActive($main) Then WinActivate($src_gui)
		If $src_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($src_gui)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $src_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $src_msg
			Case $but_done
				ExitLoop
			Case $but_diff
				Dlg_MakeDiff($src_gui)
			Case $but_patch
				Dlg_Patch($src_gui, IsChecked($rad_patch[0]), IsChecked($chk_patch))
				$patched = 1
			Case $chk_propsort
				$w_propsortalpha = IsChecked($chk_propsort)
				IniWrite($inifile, $sections[0], "prop_sort_alpha", $w_propsortalpha)
			Case $but_xref
				$xref = 1
				ExitLoop
;~ 			Case $but_run_ext
;~ 				Run(@AutoItExe & " /AutoIt3ExecuteScript " & $subdir & "\CHDKXREF-v102.au3 /path=" & $sourcedir & _
;~ 					" /output=" & $sourcedir & "\CHDKXREF-v102.log /gui=1", $subdir)
;~ 				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($src_msg)
	WEnd
	DisableMainControls(0)
	GUIDelete($src_gui)
	$CurrentGUI = $CallingGUI
	If $w_propsortalpha <> $w_propsortalpha0 Then UpdateCurrentBuild(-1)
	If $xref = 1 Then XRefCamProps()
	$activity = $mtim
_ap_ProfileStop(103)
	Return $patched
EndFunc   ;==>Dlg_SourceTools
; --------------------------------------------
Func Dlg_Debug()
_ap_ProfileStart(104)
	Local $vsiz = X(345), $src_gui, $src_msg, $but_apply, $but_cancel, $but_default
	Local $but_report, $inp_granularity
	Local $inp_gc_ratio, $ProcMem[2], $interval = $Timer_Interval, $state = $Introspection
	Local $id = @AutoItExe, $pid = @AutoItPID, $aiver = @AutoItVersion
	Local $wtitle = "  " & @UserName & " @ " & @ComputerName & "   Prog uptime: "
	Local $fontsize = $f_scaler * 8.5, $apply = 0
	Local $MyHandles[24]
	Local $elapsed = _WinAPI_GetProcessTimes($pid)	; $ThisProcess
	If Not @error Then
		$elapsed[0] = TimerDiff($ProgStarted)
		$elapsed[1] = Round($elapsed[1] / (100 * $elapsed[0]), 2)
		$elapsed[2] = Round($elapsed[2] / (100 * $elapsed[0]), 2)
	EndIf

	$MyHandles[0] = UBound($MyHandles) - 1
	If $fontsize < 8.5 Then $fontsize = 8.5

	GetWPos()
	Local $src_gui_ypos = $wpos[1] + Round( (R($w_ch) - $vsiz) / 2 )

	If StringInStr(@ScriptName, ".a") Then $id &= ' "' & @ScriptFullPath & '"'
	If @AutoItX64 Then
		$aiver &= " (x64)"
	Else
		$aiver &= " (x86)"
	EndIf

	$src_gui = 	GUICreate($wtitle & Round(TimerDiff($ProgStarted)/ 1000) & " s" , X(270), $vsiz, $wpos[0] + $wpos[2] - X(300), $src_gui_ypos, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW	)
	GUISetFont($fontsize)
	$MyHandles[1] = GUICtrlCreateLabel("System:  " & $CurrOSVersion, X(10), X(8), X(125), X(16) )
	$MyHandles[2] = GUICtrlCreateLabel(@OSServicePack & "   (" & StringLower(@OSArch) & ")", X(142), X(8), X(118), X(16) )
	$MyHandles[3] = GUICtrlCreateLabel("Running (PID: " & $pid & ")", X(10), X(28), X(125), X(16) )
	$MyHandles[4] = GUICtrlCreateLabel("AutoIt v " & $aiver, X(142), X(28), X(118), X(16) )
	GUICtrlCreateLabel($id, X(10), X(48), X(250), X(30), $SS_SUNKEN)
	GUICtrlSetColor(-1, $seagreen)
	GUICtrlSetFont(-1, $fontsize * 0.9)

	$MyHandles[5] = GUICtrlCreateLabel("Mem Usage:", X(10), X(85), X(75), X(16) )
	$ProcMem = ProcessGetStats($pid)
	; StringFormat("%5u", Round($ProcMem[0] / 1024))
	$MyHandles[6] = GUICtrlCreateLabel(Round($ProcMem[0] / 1024), X(90), X(85), X(35), X(16), 0x0002 )
	$MyHandles[7] = GUICtrlCreateLabel("kB    Peak:", X(130), X(85), X(60), X(16) )
	$MyHandles[8] = GUICtrlCreateLabel(Round($ProcMem[1] / 1024), X(195), X(85), X(35), X(16), 0x0002 )
	$MyHandles[9] = GUICtrlCreateLabel("kB", X(235), X(85), X(25), X(16) )

	$MyHandles[10] = GUICtrlCreateLabel("CPU kernel:", X(10), X(105), X(75), X(16) )
	$ProcMem = ProcessGetStats($pid)
	$MyHandles[11] = GUICtrlCreateLabel(StringFormat("%#2.2f", $elapsed[1]), X(90), X(105), X(35), X(16), 0x0002 )
	$MyHandles[12] = GUICtrlCreateLabel("%     user:", X(130), X(105), X(60), X(16) )
	$MyHandles[13] = GUICtrlCreateLabel(StringFormat("%#2.2f", $elapsed[2]), X(195), X(105), X(35), X(16), 0x0002 )
	$MyHandles[14] = GUICtrlCreateLabel("%", X(235), X(105), X(25), X(16) )
	$MyHandles[15] = GUICtrlCreateLabel("Timer Tick Length", X(10), X(130), X(110), X(18) )

	$inp_granularity = GUICtrlCreateInput(String($Timer_Interval), X(131), X(127), X(50), X(20), 0x2001)	; $ES_CENTER = 0x0001
	GUICtrlSetFont(-1, $fontsize + 0.5, 700)
	GUICtrlCreateUpdown($inp_granularity, 0x20)
	GUICtrlSetLimit(-1, 30, 1)

	$MyHandles[16] = GUICtrlCreateLabel("seconds", X(190), X(130), X(70), X(18) )
	$MyHandles[17] = GUICtrlCreateLabel("Rounds up, legal = 1...6, 10, 12, 15, 20, 30", X(30), X(153), X(230), X(14) )
	GUICtrlSetFont(-1, $fontsize * ($f_small/$f_normal), 700)
	$MyHandles[18] = GUICtrlCreateCheckbox(" Run Memory Garbage Collection", X(10), X(175), X(250), X(18) )
	If $GC_Flag = 1 Then GUICtrlSetState(-1, 1)
	$MyHandles[19] = GUICtrlCreateLabel("after every", X(62), X(198), X(65), X(18) )

	$inp_gc_ratio = GUICtrlCreateInput(String($GC_ratio), X(131), X(195), X(50), X(20), 0x2001)	; $ES_CENTER = 0x0001
	GUICtrlSetFont(-1, $fontsize + 0.5, 700)
	GUICtrlCreateUpdown($inp_gc_ratio, 0x20)
	GUICtrlSetLimit(-1, 100, 1)

	$MyHandles[20] = GUICtrlCreateLabel("timer tick(s)", X(190), X(198), X(70), X(18) )
	$MyHandles[21] = GUICtrlCreateCheckbox(" Show Control Sizes (colour background)", X(10), X(223), X(250), X(18) )
	$MyHandles[22] = GUICtrlCreateCheckbox(" Function Profile/Trace", X(10), X(248), X(134), X(18) )
	If Not FileExists($subdir & "\SRC\" & StringTrimRight(@ScriptName, 3) & "au3") Then
		GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	ElseIf $Introspection Then
		GUICtrlSetState(-1, 1) ; $GUI_CHECKED = 1
	EndIf
	$but_report = GUICtrlCreateButton("View Last Logs",  X(175), X(250), X(85), X(14) )
	GUICtrlSetFont(-1, $fontsize * ($f_small/$f_normal) )
	If $Introspection Then GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$MyHandles[23] = GUICtrlCreateLabel("Change triggers a restart ! If enabled, logs are " & "shown at program shutdown; else use 'View Last Logs'", X(30), X(250+20), X(230), X(40) )
	GUICtrlSetFont(-1, $fontsize * ($f_small/$f_normal), 700)
	$but_apply = GUICtrlCreateButton("Apply",  X(10), $vsiz - X(25), X(70), X(18) )
	$but_cancel = GUICtrlCreateButton("Cancel",  X(85), $vsiz - X(25), X(70), X(18) )
	$but_default = GUICtrlCreateButton("Reset Default",  X(160), $vsiz - X(25), X(100), X(18) )
	DisableMainControls(1)
	If $Controls_ShowBG = 1 Then
		Debug_Controls($MyHandles, 1)
		GUICtrlSetState($MyHandles[21], 1) ; $GUI_CHECKED = 1
	EndIf
	GUISetState($State_Show, $src_gui)
	ControlFocus($src_gui, "", $but_cancel)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $src_gui
	$CurrentGUI[1] = "Debug_Dlg"
	While 1
		$src_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($src_msg)
		If $Introspection Then Trace_Msg($src_msg)
		If WinActive($main) Then WinActivate($src_gui)
		If $src_msg = 0 Then
			$activity = $mtim
			If $gc = True Then
				Clean($src_gui)
				$ProcMem = ProcessGetStats($pid)
				GUICtrlSetData($MyHandles[6], StringFormat("%5u", Round($ProcMem[0] / 1024) ) )
				GUICtrlSetData($MyHandles[8], StringFormat("%5u", Round($ProcMem[1] / 1024) ) )
				$elapsed = _WinAPI_GetProcessTimes($pid)	; $ThisProcess
				If Not @error Then
					$elapsed[0] = TimerDiff($ProgStarted)
					$elapsed[1] = Round($elapsed[1] / (100 * $elapsed[0]), 2)
					$elapsed[2] = Round($elapsed[2] / (100 * $elapsed[0]), 2)
					WinSetTitle($src_gui, "", $wtitle & Round($elapsed[0] / 1000) & " s")
					GUICtrlSetData($MyHandles[11], StringFormat("%#2.2f", $elapsed[1]) )
					GUICtrlSetData($MyHandles[13], StringFormat("%#2.2f", $elapsed[2]) )
				EndIf
			EndIf
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			ContinueLoop
		EndIf
		If $src_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $src_msg
			Case $but_cancel
				ExitLoop
			Case $but_report
				ShowLastReports()
				ControlFocus($src_gui, "", $but_cancel)
			Case $MyHandles[18]
				$GC_Flag = IsChecked($MyHandles[18])
			Case $but_default
				GUICtrlSetData($inp_gc_ratio, "1")
				GUICtrlSetData($inp_granularity, "5")
				GUICtrlSetState($MyHandles[18], 1)	; $GUI_CHECKED = 1
				GUICtrlSetState($MyHandles[21], 4)	; $GUI_UNCHECKED = 4
				Debug_Controls($MyHandles, IsChecked($MyHandles[21]) )
				GUICtrlSetState($MyHandles[22], 4)	; $GUI_UNCHECKED = 4
				ContinueCase
			Case $MyHandles[22]
				$state = IsChecked($MyHandles[22])
				If $state <> $Introspection Then
					GUICtrlSetData($but_apply, "Restart")
				Else
					GUICtrlSetData($but_apply, "Apply")
				EndIf
			Case $MyHandles[21]
				Debug_Controls($MyHandles, IsChecked($MyHandles[21]) )
			Case $but_apply
				$apply = 1
				IniWrite($inifile, $sections[0], "gc_use", $GC_Flag)
				$state = IsChecked($MyHandles[22])
				$GC_Flag = IsChecked($MyHandles[18])
				$Timer_Interval = Number(GUICtrlRead($inp_granularity))
				While (60.0 / $Timer_Interval) <> Round(60.0 / $Timer_Interval)
					$Timer_Interval += 1
				Wend
				If $Timer_Interval <> $interval Then
					IniWrite($inifile, $sections[0], "timer_interval", $Timer_Interval)
					$mtim = IniRead($inifile, $sections[0], "mini_timer_min", 3) * 60 / $Timer_Interval
					If $w_minitimer = 1 Then GUICtrlSetData($lab_minitimer, ($mtim * $Timer_Interval / 60) & " m")
					TracChecker()
				EndIf
				$GC_ratio = Number(GUICtrlRead($inp_gc_ratio))
				IniWrite($inifile, $sections[0], "gc_ratio", $GC_ratio)
				ExitLoop
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($src_msg)
	WEnd
	DisableMainControls(0)
	If $apply = 1 And $Controls_ShowBG <> IsChecked($MyHandles[21]) Then
		$Controls_ShowBG = IsChecked($MyHandles[21])
		$apply = 2
	EndIf
	GUIDelete($src_gui)
	$CurrentGUI = $CallingGUI
	$activity = $mtim
	If $apply = 0 Then
_ap_ProfileStop(104)
		Return
	EndIf
	If $apply = 2 Then UpdateCurrentBuild(-1)
	Set_Dyn_Tooltips()
_ap_ProfileStop(104)
	If $state <> $Introspection Then ToggleProfiling($state)
EndFunc   ;==>Dlg_SourceTools
; --------------------------------------------
Func Dlg_Clone($preset = "")
_ap_ProfileStart(105)
	Local $ret, $ret2, $selpath, $basename = $here & "\" & $BuildName

	$ret = $preset

	Do
		If $preset = "" Then
			$ret = InputBox("Select Clone Name", "Name must begin as shown, whatever you add should" & @CRLF & "not start with a digit or contain spaces. Keep your" & @CRLF & "addition at ~10 chars max. to fit on screen", $LongBuildName, "", 300, 150)
		Else
			$ret = $LongBuildName & $preset
		EndIf
		$selpath = $basename & $ret
		If FileExists($selpath) Then
			$ret2 = Dlg_MyMsgBox(4, "Warning", $selpath & " already exists !" & @CR & "Overwrite ?", 0, $main)
			If $ret2 = 7 Then $ret = "X"
		EndIf
	Until $ret = "" Or StringLeft($ret, StringLen($LongBuildName)) = $LongBuildName
	If $ret = "" Then
_ap_ProfileStop(105)
		Return
	EndIf
	$StatusMsg = "Cloning " & $LongBuildName & " to " & $ret & " ..."
	DisableMainControls(1)
	UpdateStatus()
	AutoSplash($StatusMsg)
	If FileExists($selpath) Then SilentDosExec("rd /S /Q " & $selpath, $here)
	DosExec("xcopy " & $basename & $LongBuildName & " " & $selpath & " /E /I /Y", $here)
	DisableMainControls(0)
	SplashOff()
	$StatusMsg = $ready
	UpdateStatus()
_ap_ProfileStop(105)
EndFunc   ;==>Dlg_Clone
; --------------------------------------------
Func Dlg_MakeDiff($parent, $preset = "")
_ap_ProfileStart(106)
	Local $len, $ret, $root, $selbuild, $refdir = $preset, $srch_cmd, $fhnd, $line, $refb, $dummy
	Local $err, $errmsg
	Local $diffout = $subdir & "\diff.out"
	Local $patchtxt = $subdir & "\patch.txt"
	Local $patchfil = $subdir & "\patch.diff"
	Local $exc_file = $subdir & "\exc_diff.txt"
	Local $z = $trunk[$site]
	Static $mbox_timeout79 = 30

	If $z = 1 Then
		$root = $tpath
		$selbuild = $branches[0][0]
	Else
		$root = $bpath
		$selbuild = $branches[1][0]
	EndIf
	If $refdir = "" Then
		Do
			$refdir = FileSelectFolder("Select the reference build directory; a DIFF will be" & @CRLF & "created from current build and this reference build", $root, 6, $sourcedir, $parent)
			; the 'dummy' stuff enforces that only folders whose name starts with selected build are accepted
			$dummy = StringSplit($refdir, "\")
		Until $refdir = "" Or StringLeft($dummy[$dummy[0]], StringLen($selbuild)) = $selbuild
		$dummy = ""
		FileChangeDir($here)
	EndIf
	If $refdir = "" Or $refdir = $sourcedir Then
_ap_ProfileStop(106)
		Return
	EndIf
	$ret = StringSplit($refdir, "\")
	$StatusMsg = "Diff'ing current vs. " & $ret[$ret[0]]
	DisableMainControls(1)
	UpdateStatus()
	AutoSplash($StatusMsg)
	$refb = ""
	For $z = StringLen($refdir) To 1 Step -1
		If StringInStr("0123456789", StringMid($refdir, $z, 1)) = 0 Then ExitLoop
		$refb = StringMid($refdir, $z, 1) & $refb
	Next
	If Not FileExists($exc_file) Then
		FileWrite($exc_file, "stubs_auto.S" & @LF & "stubs_entry.S" & @LF & "*.o" & @LF & "*.a" & @LF & "*.bin" & @LF & "*.BIN" & @LF & "*.exe" & @LF & "*.log" & @LF & "*.org" & @LF & "*.txt" & @LF & "bin" & @LF & "bin/*.*" & @LF & "bin/logs/*.*" & @LF & @LF)
	EndIf
	$srch_cmd = "diff -U 3 -X " & StringReplace($exc_file, "\", "/") & " -r "
	$len = StringLen($srch_cmd)
	$dummy = $srch_cmd & StringReplace($refdir, "\", "/") & " " & StringReplace($sourcedir, "\", "/") & " > " & $diffout
	DosExec($dummy, $GCCpath)
	$dummy = 0
	$ret = _FileReadToArray($diffout, $dummy)
	$err = @error
	If $ret = 0 Then
		Switch $err
			Case 1
				$errmsg = "Unable to open file:"
			Case 2
				$errmsg = "Unable to split:"
			Case Else
				$errmsg = "Unknown error with"
		EndSwitch
		Dlg_MyMsgBox(0, "Diff error " & $err, $errmsg & @CR & $patchtxt)
		Return
	EndIf
	$fhnd = FileOpen($patchtxt, 2)
	For $z = 1 To $dummy[0]
		If StringLeft($dummy[$z], 3) = "---" Then
			$line = StringSplit($dummy[$z], " " & Chr(9), 0)
			If @error Or $line[0] < 2 Then
				FileWriteLine($fhnd, $dummy[$z])
				ContinueLoop
			EndIf
			$ret = StringTrimLeft($line[2], 1 + StringLen($refdir))
			FileWriteLine($fhnd, "Index: " & $ret & @CRLF & "=============================================================================")
			$dummy[$z] = $line[1] & " " & $ret & Chr(9) & "(revision " & $refb & ")"
			$dummy[$z + 1] = "+++ " & $ret & Chr(9) & "(working copy)"
			FileWriteLine($fhnd, $dummy[$z])
		ElseIf StringLeft($dummy[$z], $len) <> $srch_cmd Then
			FileWriteLine($fhnd, $dummy[$z])
		EndIf
	Next
	$dummy = 0
	FileClose($fhnd)
;~ 	DosExec("dos2unix -n " & $patchtxt & " " & $patchfil, $GCCpath)
	SilentDosExec("dos2unix -n " & $patchtxt & " " & $patchfil, $GCCpath)
	SplashOff()
	$StatusMsg = $ready
	UpdateStatus()
	If $preset = "" Then
		ShellExecute("notepad", $patchtxt)
		Dlg_MyMsgBox(0, "About " & $patchtxt & " ...", "This is the DOS(cr/lf) version of your diff file;" & @CR & "*nix(lf) version here: " & $patchfil & @CR & "They are OVERWRITTEN at each Diff operation, so" & @CR & "please rename them if necessary ..." & @CR & @CR & "Even if CHDK-Shell will happily use DOS-style Diffs" & @CR & "please use the Unix-style versions for distribution" & @CR & "to make sure all users can apply them.", $mbox_timeout79, $parent)
	EndIf
	If @error <> 0 Then
		$mbox_timeout79 = @error
	Else
		$mbox_timeout79 = @extended
	EndIf
	DisableMainControls(0)
	$activity = $mtim
_ap_ProfileStop(106)
EndFunc   ;==>Dlg_MakeDiff
; --------------------------------------------
Func Dlg_Patch($parent, $apply, $test)
_ap_ProfileStart(107)
	Local $c, $k, $fh, $ret, $patchfile, $patnam = "", $deffile = "", $defpath = $mycomp

	If $lastpatch <> "" Then
		$k = StringSplit($lastpatch, "\")
		$deffile = $k[$k[0]]
		$defpath = ""
		For $c = 1 To $k[0] - 1
			$defpath &= $k[$c] & "\"
		Next
		$defpath = StringTrimRight($defpath, 1)
	EndIf
	$patchfile = FileOpenDialog("Select patch file", $defpath, "All (*.*)", 1, $deffile, $parent)
	Local $errflag = @error
	FileChangeDir($here)
	If $errflag Or $patchfile = "" Then
_ap_ProfileStop(107)
		Return
	EndIf
	$fh = FileOpen($patchfile, 0)
	If $fh = -1 Then
		Dlg_MyMsgBox(0, "Error", "Unable to open " & $patchfile, 0, $parent)
_ap_ProfileStop(107)
		Return
	EndIf
	DisableMainControls(1)
	$ret = FileRead($fh)
	FileClose($fh)
	$lastpatch = $patchfile
	$k = StringSplit($patchfile, "\")
	$patnam = $k[$k[0]]
	If $patchfile <> $sourcedir & "\" & $patnam Then FileCopy($patchfile, $sourcedir & "\" & $patnam, 1)
	If StringInStr($ret, @CRLF) Then	; it's a DOS patchfile, convert
		; RunWait($SysComSpec & " /c dos2unix.exe -o " & $sourcedir & "\" & $patnam, $GCCpath, $State_Minimize)
;~ 		DosExec("dos2unix.exe -o " & $sourcedir & "\" & $patnam, $GCCpath)
		SilentDosExec("dos2unix.exe -o " & $sourcedir & "\" & $patnam, $GCCpath)
	EndIf
	Local $cl = $GCCpath & "\patch "
	If $test = 1 Then $cl &= "--dry-run "
	If $apply = 0 Then $cl &= "--reverse "
	$cl &= "--verbose -p0 <" & $patnam
	$ret = RunWait($SysComSpec & " /k " & $cl, $sourcedir)
	FileDelete($sourcedir & "\" & $patnam)
	DisableMainControls(0)
	$activity = $mtim
_ap_ProfileStop(107)
	Return $ret
EndFunc   ;==>Dlg_Patch
; --------------------------------------------
Func Dlg_MyMsgBox($butstyle, $title, $text, $timeout = 0, $parent = $main)
_ap_ProfileStart(108)
	; Sort of ugly, but non-blocking MsgBox, supports styles 0, 1 & 4 (OK, OK/Cancel and Yes/No)
	; return codes identical to buit-in MsgBox, supports timeout with in-dialog countdown
	Local $but_ok, $but_reset = "X", $but_canc = "X", $but_yes = "X", $but_no = "X"
	Local $par = $parent, $timer = 0, $lab, $ret, $msg_gui, $msg_msg
	Local $vsiz, $left, $left0, $temp = 0, $lines = 1, $reset = 0
;~ 	Local $Calling_GUI = $CurrentGUI

	For $i = 0 To StringLen($text) - 1
		If StringMid($text, $i, StringLen(@CR)) = @CR Then $lines += 1
	Next
	$vsiz = 110 + $lines * 14
	If $timeout = 0 Then
		$temp = 30
		$vsiz -= $temp
	EndIf
	Local $dx = -1, $dy = -1
	If $par <> -1 Then
		Local $ppos = WinGetPos($par)
		$dx = $ppos[0] + ($ppos[2] - 320) / 2
		$dy = $ppos[1] + ($ppos[3] - $vsiz) / 2
	Else
		$par = 0
	EndIf
	; modded to center on parent gui 1-12-10
	$msg_gui = GUICreate($title, 320, $vsiz, $dx, $dy, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW, $par)
	GUICtrlCreateLabel($text, 20, 20, 280, $vsiz + $temp - 70)
	Switch $butstyle
		Case 0
			$but_ok = GUICtrlCreateButton("OK", 120, $vsiz - 25, 80, 20)
		Case 1
			$but_ok = GUICtrlCreateButton("OK", 75, $vsiz - 25, 80, 20)
			$but_canc = GUICtrlCreateButton("Cancel", 165, $vsiz - 25, 80, 20)
		Case 4
			$but_yes = GUICtrlCreateButton("Yes", 75, $vsiz - 25, 80, 20)
			$but_no = GUICtrlCreateButton("No", 165, $vsiz - 25, 80, 20)
	EndSwitch
	If $timeout <> 0 Then
		$timer = $timeout * 1000
		GUICtrlCreateLabel("[ AutoClose in", 72, $vsiz - 55, 68, 15)
		$lab = GUICtrlCreateLabel($timeout, 142, $vsiz - 55, 14, 15, 0x0102 )	; $SS_RIGHT = 0x0002 right align style
		GUICtrlCreateLabel("seconds ]", 160, $vsiz - 55, 50, 15)
		$but_reset = GUICtrlCreateButton("Reset", 220, $vsiz - 55, 35, 14)
	EndIf
	$temp = 0
	Local $ticker0 = TimerInit()
	GUISetState()
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $msg_gui
	$CurrentGUI[1] = "MsgBox_Dlg"
	While 1
		$msg_msg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($msg_msg)
		If $Introspection Then Trace_Msg($msg_msg)
		If Not WinActive($msg_gui) Then WinActivate($msg_gui)	; assure it stays on top
		If $msg_msg = 0 Then
			$activity = $mtim
			If $gc = True Then Clean($msg_gui)
			; when idle, allow msg loop to slow down to ~ 3 per second; this works because
			; hovering the GUI will trigger a message -11, and fast response is restored
			Sleep(300)
			If $timeout <> 0 Then
				$timer = $timeout * 1000 - TimerDiff($ticker0)
				If $timer < 1 Then
					$ret = 1
					$temp = $timeout
					ExitLoop
				EndIf
 				$left = StringFormat("%2s", Round( ($timer / 1000.0) ) )
 				If $left <> $left0 Then GUICtrlSetData($lab, $left)
 				$left0 = $left
			EndIf
			ContinueLoop
		EndIf
		If $msg_msg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		Switch $msg_msg
			Case $but_reset
				$timeout = 30
				$timer = 30000
				$ticker0 = TimerInit()
				ContinueLoop
			Case $but_ok
				$temp = $timeout - Int($timer / 1000)
				If $temp < 3 Then $temp = 3
				$ret = 1
			Case $but_canc
				$ret = 2
			Case $but_yes
				$ret = 6
			Case $but_no
				$ret = 7
			Case Else
				ContinueLoop
		EndSwitch
		ExitLoop
	WEnd
	GUIDelete($msg_gui)
	$CurrentGUI = $CallingGUI
	If $parent = -1 Then WinActivate($par)
	$activity = $mtim
_ap_ProfileStop(108)
	Return SetError($reset, $temp, $ret)
EndFunc   ;==>Dlg_MyMsgBox
; --------------------------------------------
Func Dlg_Welcome()
_ap_ProfileStart(109)
	If $InstallFlag < 10 Or Number($NewestBuild) > $MinBuild[$site] Then
_ap_ProfileStop(109)
		Return
	EndIf
	$InstallFlag -= 10 ; restore flag to prevent multiple run
	DisableMainControls(1)
	If $site = 0 Then	; note these MsgBox's must be BLOCKING !!!
		MsgBox($topmost, "Welcome !", "This ancient version of CHDK trunk (300)" & @CR & "has been included because CHDK-Shell needs" & @CR & "at least one trunk version to function." & @CR & @CR & "Just activate 'Allow Internet' and the" & @CR & "latest version will be downloaded (only if" & @CR & "you have a connection of course) :)" & @CR & @CR & "Have fun," & @CR & @CR & "whim", 0, $main)
	Else
		MsgBox($topmost, "Willkommen !", "Diese alte Version des CHDK-Quelcodes (trunk 10," & @CR & "entspricht CHDK #300) ist fr die Funktion der" & @CR & "CHDK-Shell erforderlich." & @CR & @CR & "Deshalb nun den Punkt 'Allow Internet' aktivieren," & @CR & "dann wird automatisch die aktuelle CHDK-DE Version" & @CR & "vom SVN-Server heruntergeladen und entpackt." & @CR & @CR & "Have fun / Viel Spa," & @CR & @CR & "whim && fe50", 0, $main)
	EndIf
	DisableMainControls(0)
_ap_ProfileStop(109)
EndFunc   ;==>Dlg_Welcome

#EndRegion
#
#Region ---------------------------- INI Functions -----------------------------------------------

Func IniIni()
_ap_ProfileStart(110)
	If FileExists($inifile) Then
_ap_ProfileStop(110)
		Return 0
	EndIf
	Local $sver, $_tmp, $retcode = 2, $basename = StringTrimRight($inifile, 4)
	$sver = Number(StringRight($basename, 3)) - 1
	For $i = $sver To $sver - 10 Step -1	; try to recover settings from lets say previous 10 versions ...
		$_tmp = StringTrimRight($basename, 3) & StringFormat("%03d", $i) & ".ini"
		If FileExists($_tmp) Then
			SortIni($_tmp)
			$retcode = 1
			ExitLoop
		EndIf
	Next
	If $retcode = 2 Then FileCopy($subdir & "\inistub2", $inifile)
	; reset maxsearch for both sites to default 9999
	IniDelete($inifile, $sections[1], "maxsearch0")
	IniDelete($inifile, $sections[1], "maxsearch1")
_ap_ProfileStop(110)
	Return $retcode
EndFunc   ;==>IniIni
; --------------------------------------------
Func SortIni($from)
_ap_ProfileStart(111)
	Local $aSection, $tmpfile = $here & "\tmp.ini", $tmpini = $here & "\tmpini.ini"
	Local $obsolete = 	"trunk|branch|check_branches|maxbuild0|maxbuild1|fscale|wscale|profiling|gc_interval|"
	$obsolete &=		"inet_progress|inet_debug|_inet_dont_force|CPchkbold|$min_line_height|force_size|zoom"

	IniWriteSection($tmpini, "ID", IniReadSection($from, "ID") )
	FileDelete($tmpfile)	; just in case ...
	For $j = 0 To 4
		IniWriteSection($tmpfile, $sections[$j], IniReadSection($from, $sections[$j]) )
		_FileReadToArray($tmpfile, $aSection)
		_ArraySort($aSection, 0, 2)
		For $k = 1 To $aSection[0]
			Local $entry = StringSplit($aSection[$k], "=")
			If IsArray($entry) Then
				If $entry[$entry[0]] = "" Or StringInStr($obsolete, $entry[1]) Then ContinueLoop
			EndIf
			FileWriteLine($tmpini, $aSection[$k])
		Next
		FileDelete($tmpfile)
	Next
	FileMove($tmpini, $inifile, 1)
_ap_ProfileStop(111)
EndFunc   ;==>SortIni
; --------------------------------------------
Func ReadIni()
_ap_ProfileStart(112)
	; --- program group ---
	ReadSett($chk_autocams, $sections[0], "chk_autocams", 1)
	ReadSett($chk_autoerr, $sections[0], "chk_autoerr", 1)
	GUICtrlSetState($chk_debug, IniRead($inifile, $sections[0], "chk_debug", 0))
	ReadSett($chk_trayicon, $sections[0], "chk_trayicon")
	SetTrayIcon()
	ReadSett($chk_tooltips, $sections[0], "tooltips", 1)
	ReadSett($chk_comp_full, $sections[0], "chk_compilecomplete", 1)
	ReadSett($chk_keep_dumps, $sections[0], "chk_keep_dumps", 1)
	; --- trunk group ---
	ReadSett($chk_nosel, $sections[1], "chk_nosel", 1)
	ReadSett($chk_inet, $sections[1], "chk_inet")
	ReadSett($chk_upd, $sections[1], "chk_upd", 1)
	GUICtrlSetData($inp_upd, IniRead($inifile, $sections[1], "inp_upd", 30))
	; --- cams group: restore ONLY if required
	If IniRead($inifile, $sections[0], "chk_autocams", 0) = 0 Then
_ap_ProfileStop(112)
		Return
	EndIf
	For $c = 0 To $sup_cams - 1
		For $f = 1 To $maxfirm
			If $cams[$c][$f] == "" Then ExitLoop
			ReadSett($chk_cams[$c][$f - 1], $sections[4], $cams[$c][0] & "-" & $cams[$c][$f])
		Next ; $f
	Next ; $c
_ap_ProfileStop(112)
EndFunc   ;==>ReadIni
; --------------------------------------------
Func WriteIni()
_ap_ProfileStart(113)
	IniWrite($inifile, "ID", "ProgVer", $Title)
	IniWrite($inifile, "ID", "AutoItVer", @AutoItVersion)
	; --- program group ---
	If $GCCpath <> $GCC3path And $GCCpath <> $GCC4path Then $GCCpath = $GCC4path
	IniWrite($inifile, $sections[0], "GCCpath", $GCCpath)
	IniWrite($inifile, $sections[0], "GCC3path", $GCC3path)
	IniWrite($inifile, $sections[0], "GCC4path", $GCC4path)
	IniWrite($inifile, $sections[0], "miniGUI", $miniGUI)
	IniWrite($inifile, $sections[0], "remove_exe", $Cleanup[0])
	IniWrite($inifile, $sections[0], "remove_ini", $Cleanup[1])
	IniWrite($inifile, $sections[0], "remove_au3", $Cleanup[2])
	IniWrite($inifile, $sections[0], "keep_versions", $Cleanup[3])
	SaveSett($chk_autocams, $sections[0], "chk_autocams")
	SaveSett($chk_autoerr, $sections[0], "chk_autoerr")
	SaveSett($chk_trayicon, $sections[0], "chk_trayicon")
	SaveSett($chk_tooltips, $sections[0], "tooltips")
	SaveSett($chk_comp_full, $sections[0], "chk_compilecomplete")
	SaveSett($chk_keep_dumps, $sections[0], "chk_keep_dumps")
	; --- trunk group ---
	SaveSett($chk_nosel, $sections[1], "chk_nosel")
	SaveSett($chk_inet, $sections[1], "chk_inet")
	SaveSett($chk_upd, $sections[1], "chk_upd")
	IniWrite($inifile, $sections[1], "inp_upd", GUICtrlRead($inp_upd))
	IniWrite($inifile, $sections[1], "site", $site)
	For $i = 0 To 1
		IniWrite($inifile, $sections[1], "branch" & $i, $DefBranch[$i])
		IniWrite($inifile, $sections[1], "blacklist" & $i, $BlackList[$i])
	Next
	; --- cams group ---
	Cams2Ini()
	Write_CP_ini_colors()
_ap_ProfileStop(113)
EndFunc   ;==>WriteIni
; --------------------------------------------
Func Cams2Ini()
_ap_ProfileStart(114)
	For $c = 0 To $sup_cams - 1
		For $f = 1 To $maxfirm
			If $cams[$c][$f] == "" Then ExitLoop
			SaveSett($chk_cams[$c][$f - 1], $sections[4], $cams[$c][0] & "-" & $cams[$c][$f])
		Next
	Next
_ap_ProfileStop(114)
EndFunc   ;==>Cams2Ini
; --------------------------------------------
Func PreReadIni()
_ap_ProfileStart(115)
	Local $dummy, $germanic = 0

	For $i = 0 To 1
		DirCreate($here & $VerPrefix[$i] & "\archives")
		DirCreate($here & $VerPrefix[$i] & "\trunk")
		DirCreate($here & $VerPrefix[$i] & "\branches")
		$trunk[$i] = IniRead($inifile, $sections[1], "trunk" & $i, 1)
		$do_branches[$i] = IniRead($inifile, $sections[1], "check_branches" & $i, 0)
		$DefBranch[$i] = IniRead($inifile, $sections[1], "branch" & $i, $VerDefBr[$i])
		$MaxSearch[$i] = IniRead($inifile, $sections[1], "maxsearch" & $i, 9999)
		$DefLang[$i] = IniRead($inifile, $sections[1], "def_lang" & $i, $DefLang[$i])
		$BlackList[$i] = IniRead($inifile, $sections[1], "blacklist" & $i, "")
	Next
	If StringInStr($GermanOSLang, @OSLang) Then $germanic = 1
	$site = IniRead($inifile, $sections[1], "site", $germanic)
	$w_upd = IniRead($inifile, $sections[1], "update_option", 1)
	$w_auto = IniRead($inifile, $sections[1], "autocompile_option", 0)
	$Sync_Checks = 1 * IniRead($inifile, $sections[1], "sync_checks", 0)
	$Sync_Checks_BG = 1 * IniRead($inifile, $sections[1], "sync_checks_bg", 1)
	$LimitBuilds = 1 * IniRead($inifile, $sections[1], "limit_builds", 0)	; ===== added 29-3-11
	$BuildsToKeep = 1 * IniRead($inifile, $sections[1], "limit_builds_to", 20)	; ===== added 29-3-11
	$PurgeToTrash = 1 * IniRead($inifile, $sections[1], "purge_to_trash", 1)	; ===== added 31-7-11
	$ShowSplash = 1 * IniRead($inifile, $sections[0], "show_splash", 1)
	$f_scaler = IniRead($inifile, $sections[0], "scale_f", 1)
	$w_scaler = IniRead($inifile, $sections[0], "scale_w", 1)
	$w_boldpopups = IniRead($inifile, $sections[0], "bold_popups", 1)
	$w_sticky = IniRead($inifile, $sections[0], "chk_sticky", 1)
	$w_screensnap = IniRead($inifile, $sections[0], "chk_snap", 1)
	$w_classic = IniRead($inifile, $sections[0], "force_classic", 0)
	If $w_classic = 1 Then
		DllCall("uxtheme.dll", "none", "SetThemeAppProperties", "int", 0)	; forces classic mode
	ElseIf _Vista_ICE() <> 0 Then
		$AP_xoff = IniRead($inifile, $sections[0], "ap_xoff", 7)
		$AP_yoff = IniRead($inifile, $sections[0], "ap_yoff", 7)
	EndIf
	$w_outtro = IniRead($inifile, $sections[0], "outtro", 0)
	$w_animate = 1 * IniRead($inifile, $sections[0], "animate_use", 1)
	$w_slide = 1 * IniRead($inifile, $sections[0], "animate_slide", 1)
	$w_showcountdown = IniRead($inifile, $sections[0], "showcountdown", 1)
	$3D_CountDown = IniRead($inifile, $sections[0], "showcountdown3D", 0)
	$w_chkver = IniRead($inifile, $sections[0], "check_progver", 1)
	$w_minitimer = IniRead($inifile, $sections[0], "mini_timer", 0)
	$w_propsortalpha = IniRead($inifile, $sections[0], "prop_sort_alpha", 0)
	$w_propsortalpha0 = 1 - $w_propsortalpha
	$miniGUI = IniRead($inifile, $sections[0], "miniGUI", 0)
	$cmd_mode = IniRead($inifile, $sections[0], "cmd_mode", "/c")
	$GC_Flag = 1 * IniRead($inifile, $sections[0], "gc_use", 1)
	$Timer_Interval = IniRead($inifile, $sections[0], "timer_interval", 5)
	$GC_ratio = IniRead($inifile, $sections[0], "gc_ratio", 1)
	$ctim = Round(IniRead($inifile, $sections[0], "mess_timer", 1600) / 4)
	$mtim = IniRead($inifile, $sections[0], "mini_timer_min", 3) * 60 / $Timer_Interval
	$BrowserDLDir = IniRead($inifile, $sections[0], "download", "")
	$ShortcutDir = IniRead($inifile, $sections[0], "shortcut", "")
	$Cleanup[0] = IniRead($inifile, $sections[0], "remove_exe", 0)
	$Cleanup[1] = IniRead($inifile, $sections[0], "remove_ini", 0)
	$Cleanup[2] = IniRead($inifile, $sections[0], "remove_au3", 0)
	$Cleanup[3] = IniRead($inifile, $sections[0], "keep_versions", 3)
	$SkipPostClean = IniRead($inifile, $sections[0], "skip_postclean", 0)
	$PivIndex = IniRead($inifile, $sections[0], "pivot", 0)
	$GCC4path = IniRead($inifile, $sections[0], "GCC4path", $here & "\gcc4\bin")
	$InetTimeOut = IniRead($inifile, $sections[0], "inet_timeout", 10)
	If IniRead($inifile, $sections[0], "make_options", -1) = "-1" Then IniWrite($inifile, $sections[0], "make_options", "-d|-r|-j 2|-r -j 4|-j 8|-j 16")
	$make_options = IniRead($inifile, $sections[0], "make_options", "")
	$make_uses_options = 1 * IniRead($inifile, $sections[0], "make_uses_options", 0)
	$w_override_oscheck = 1 * IniRead($inifile, $sections[0], "override_oscheck", 0)
	$no_ptpcamgui_dl = 1 * IniRead($inifile, $sections[0], "no_ptpcamgui_dl", 0)
	$update_ptpcam = 1 * IniRead($inifile, $sections[0], "update_ptpcam", 0)
	If $update_ptpcam = 0 Then FileDelete($subdir & "\guest\ptpcamGUI\ptpcam.exe")
	$wget_options = IniRead($inifile, $sections[0], "wget_options", "--no-http-keep-alive")
	$min_line_height = 1 * IniRead($inifile, $sections[3], "CP_min_line_height", 8)
	$reduce_logo = 1 * IniRead($inifile, $sections[0], "reduce_logo", 0)
	$no_readme_popup = 1 * IniRead($inifile, $sections[0], "no_readme_popup", 0)
	$firm_font_perc = 1 * IniRead($inifile, $sections[0], "firm_font_perc", 90)
	$dummy = 1 * IniRead($inifile, $sections[0], "inet_use_https", 1)
	$web_prefix = $web
	If $dummy = 1 Then $web_prefix = $sweb

_ap_ProfileStop(115)
EndFunc   ;==>PreReadIni
; --------------------------------------------
Func ReadXY()
_ap_ProfileStart(116)
	$wpos[0] = IniRead($inifile, $sections[0], "w_x", -1)
	$wpos[1] = IniRead($inifile, $sections[0], "w_y", -1)
_ap_ProfileStop(116)
EndFunc   ;==>ReadXY
; --------------------------------------------
Func WriteXY()
_ap_ProfileStart(117)
	IniWrite($inifile, $sections[0], "w_x", $wpos[0])
	IniWrite($inifile, $sections[0], "w_y", $wpos[1])
_ap_ProfileStop(117)
EndFunc   ;==>WriteXY
; --------------------------------------------
Func Read_CP_ini_colors()
_ap_ProfileStart(118)
	Global $CP_current[16] = [IniRead($inifile, $sections[3], "CPinit_bold", $CP_default[0]), IniRead($inifile, $sections[3], "CPinit_f_R", $CP_default[1]), IniRead($inifile, $sections[3], "CPinit_f_G", $CP_default[2]), IniRead($inifile, $sections[3], "CPinit_f_B", $CP_default[3]), IniRead($inifile, $sections[3], "CPinit_b_R", $CP_default[4]), IniRead($inifile, $sections[3], "CPinit_b_G", $CP_default[5]), IniRead($inifile, $sections[3], "CPinit_b_B", $CP_default[6]), IniRead($inifile, $sections[3], "CPstat_bold", $CP_default[7]), IniRead($inifile, $sections[3], "CPstat_f_R", $CP_default[8]), IniRead($inifile, $sections[3], "CPstat_f_G", $CP_default[9]), IniRead($inifile, $sections[3], "CPstat_f_B", $CP_default[10]), IniRead($inifile, $sections[3], "CPstat_b_R", $CP_default[11]), IniRead($inifile, $sections[3], "CPstat_b_G", $CP_default[12]), IniRead($inifile, $sections[3], "CPstat_b_B", $CP_default[13]), IniRead($inifile, $sections[3], "CPcapitals", $CP_default[14]), IniRead($inifile, $sections[3], "CPautobold", $CP_default[15])]
	; replaced "CPchkbold" by "CPcapitals"
	Calc_CP_colors()
_ap_ProfileStop(118)
EndFunc   ;==>Read_CP_ini_colors
; --------------------------------------------
Func Write_CP_ini_colors()
_ap_ProfileStart(119)
	IniWrite($inifile, $sections[3], "CPinit_bold", $CP_current[0])
	IniWrite($inifile, $sections[3], "CPinit_f_R", $CP_current[1])
	IniWrite($inifile, $sections[3], "CPinit_f_G", $CP_current[2])
	IniWrite($inifile, $sections[3], "CPinit_f_B", $CP_current[3])
	IniWrite($inifile, $sections[3], "CPinit_b_R", $CP_current[4])
	IniWrite($inifile, $sections[3], "CPinit_b_G", $CP_current[5])
	IniWrite($inifile, $sections[3], "CPinit_b_B", $CP_current[6])
	IniWrite($inifile, $sections[3], "CPstat_bold", $CP_current[7])
	IniWrite($inifile, $sections[3], "CPstat_f_R", $CP_current[8])
	IniWrite($inifile, $sections[3], "CPstat_f_G", $CP_current[9])
	IniWrite($inifile, $sections[3], "CPstat_f_B", $CP_current[10])
	IniWrite($inifile, $sections[3], "CPstat_b_R", $CP_current[11])
	IniWrite($inifile, $sections[3], "CPstat_b_G", $CP_current[12])
	IniWrite($inifile, $sections[3], "CPstat_b_B", $CP_current[13])
	IniWrite($inifile, $sections[3], "CPcapitals", $CP_current[14])
	IniWrite($inifile, $sections[3], "CPautobold", $CP_current[15])
_ap_ProfileStop(119)
EndFunc   ;==>Write_CP_ini_colors

#EndRegion
#
#Region ---------------------------- Internet related functions ----------------------------------

Func WgetHTMLSource($url, ByRef $aPage)
_ap_ProfileStart(120)
	Local $ret, $tfile = $subdir & "\_tmp_.html"

	FileDelete($tfile)
	$ret = DosExec($GCCpath & '\wget.exe ' & $wget_options & ' -F -t 1 -T ' & $InetTimeOut & ' -O ' & $tfile & ' ' & $url, $here)
	If $ret <> 0 Then
_ap_ProfileStop(120)
		FileDelete($tfile)
		Return 1
	EndIf
	_FileReadToArray($tfile, $aPage)
	If @error Or Not IsArray($aPage) Then
		FileDelete($tfile)
_ap_ProfileStop(120)
		Return 2
	EndIf
	If IsChecked($chk_debug2) Then	_ArrayDisplay($aPage, $url, 0)
	FileDelete($tfile)
_ap_ProfileStop(120)
EndFunc   ;==>WgetHTMLSource
; --------------------------------------------
Func NetBuildSnoop()
_ap_ProfileStart(121)
	;TimeStamp()
	Local $i, $k, $z, $sbtmp, $aSource, $branch_no, $UpdatedBuild[2], $runtime = 0, $flag

	Local $page1 = $VerPaths[$site] & "browser", $page2 = $page1 & "/branches"
	Local $sname = GetSVN_Name($site)

	Local $search = '<a class="dir" title="View Directory" href="' & $page1
	Local $search2 = '<a title="View Revision Log" href="' & $VerPaths[$site] & 'log/'
	Local $search3 = '<a class="timeline" href="' & $VerPaths[$site] & 'timeline?from='
	Local $search4 = '<td class="author">'
	Local $search5 = '<td class="change">'
	Local $dummy

	$t_last = "@ " & @HOUR & ":" & @MIN
	$d_last = "FAILED    "
	SatIcon(1)
	$StatusMsg = "Reading " & $sname & " root page"
	UpdateStatus()
	$runtime = (@MSEC / 1000) + @SEC + 60 * @MIN + 3600 * @HOUR
	$flag = WgetHTMLSource($web_prefix & $SrcSites[$site] & $page1, $aSource)
	If $flag <> 0 Then
_ap_ProfileStop(121)
		Return ("unavailable")
	EndIf
	SatIcon(0)
	$StatusMsg = "Analysing " & $sname & " root page"
	UpdateStatus()
	$branches[0][0] = ""
	For $i = 1 To $aSource[0]
		If StringInStr($aSource[$i], $search & '/trunk') Then		; get trunk path & local highest build
			$branches[0][1] = $VerPaths[$site] & "browser/trunk"
			$branches[0][0] = "trunk"
			$branches[0][6] = GetLocalHighBuild("trunk\" & $branches[0][0], $site)
			ContinueLoop
		EndIf
		If $branches[0][0] = "" Then ContinueLoop

		If StringInStr($aSource[$i], $search2) Then					; get version
			$sbtmp = _StringBetween($aSource[$i], '">', '</a>')
			$branches[0][2] = $sbtmp[0]
			ContinueLoop
		EndIf

		If StringInStr($aSource[$i], $search3) Then					; get release date/time
			$sbtmp = _StringBetween($aSource[$i], 'title="', 'Z in Timeline')
			$branches[0][3] = StringReplace($sbtmp[0], 'T', ' @ ')
			ContinueLoop
		EndIf

		If StringInStr($aSource[$i], $search4) Then					; get Author
			$sbtmp = _StringBetween($aSource[$i], $search4, '</td>')
			$branches[0][4] = $sbtmp[0]
			ContinueLoop
		EndIf

		If StringInStr($aSource[$i], $search5) Then					; get change remarks
			$sbtmp = _StringBetween($aSource[$i], $search5, '</td>')
			If @error = 1 Then
				$z = $i + 1
				$branches[0][5] = ''
				While Not StringInStr($aSource[$z], '</td>')
					$branches[0][5] &= $aSource[$z]
					$z += 1
				WEnd
				$sbtmp = _StringBetween($aSource[$z], "", '</td>')
				$branches[0][5] &= $sbtmp[0]
			Else
				$branches[0][5] = $sbtmp[0]
			EndIf
			$branches[0][5] = StringStripWS($branches[0][5], 7)
			ExitLoop
		EndIf
	Next
	If $do_branches[$site] > 0 Then		; check branches
		SatIcon(1)
		$StatusMsg = "Reading " & $sname & " branch page"
		UpdateStatus()
		$flag = WgetHTMLSource($web_prefix & $SrcSites[$site] & $page2, $aSource)
		If $flag <> 0 Then
_ap_ProfileStop(121)
			Return ("unavailable")
		EndIf
		SatIcon(0)
		$StatusMsg = "Analysing " & $sname & " branch page"
		$search &= '/branches'
		UpdateStatus()
		$branch_no = 2
		For $i = 1 To $aSource[0]
			$k = StringInStr($aSource[$i], $search)
			If $k Then												; get branch name, path & local highest build
				$branches[$branch_no][1] = $VerPaths[$site] & "browser/branches" & CopyStringWord($aSource[$i], $k + StringLen($search), '"')
				$z = StringSplit($branches[$branch_no][1], "/")
				If Not StringInStr($BlackList[$site], $z[$z[0]]) Then
					$branches[$branch_no][0] = $z[$z[0]]
					$branches[$branch_no][6] = GetLocalHighBuild("branches\" & $branches[$branch_no][0], $site)
				Else
					$branches[$branch_no][0] = ""
					$branches[$branch_no][1] = ""
					$branches[$branch_no][6] = ""
				EndIf
				ContinueLoop
			EndIf

			If $branches[$branch_no][0] = "" Then ContinueLoop

			If StringInStr($aSource[$i], $search2) Then				; get version
				$sbtmp = _StringBetween($aSource[$i], '">', '</a>')
				$branches[$branch_no][2] = $sbtmp[0]
				ContinueLoop
			EndIf

			If StringInStr($aSource[$i], $search3) Then				; get release date/time
				$sbtmp = _StringBetween($aSource[$i], 'title="', 'Z in Timeline')
				$branches[$branch_no][3] = StringReplace($sbtmp[0], 'T', ' @ ')
				ContinueLoop
			EndIf

			If StringInStr($aSource[$i], $search4) Then				; get Author
				$sbtmp = _StringBetween($aSource[$i], $search4, '</td>')
				$branches[$branch_no][4] = $sbtmp[0]
				ContinueLoop
			EndIf

			If StringInStr($aSource[$i], $search5) Then				; get change remarks
				$sbtmp = _StringBetween($aSource[$i], $search5, '</td>')
				If @error = 1 Then
					$z = $i + 1
					$branches[$branch_no][5] = ''
					While Not StringInStr($aSource[$z], '</td>')
						$branches[$branch_no][5] &= $aSource[$z]
						$z += 1
					WEnd
					$sbtmp = _StringBetween($aSource[$z], "", '</td>')
					$branches[$branch_no][5] &= $sbtmp[0]
				Else
					$branches[$branch_no][5] = $sbtmp[0]
				EndIf
				$branches[$branch_no][5] = StringStripWS($branches[$branch_no][5], 7)
				$branch_no += 1
			EndIf
		Next
		$branches[1][0] = $DefBranch[$site]
		For $k = 2 To 24
			If $branches[$k][0] = $branches[1][0] Then
				For $i = 1 To 6
					$branches[1][$i] = $branches[$k][$i]
				Next
				ExitLoop
			EndIf
		Next
	EndIf	; end check branches
	If IsChecked($chk_debug2) Then _ArrayDisplay($branches, "$branches")
	$UpdatedBuild[0] = WgetBuildIfNewer(0) ; check trunk (always)
	If $do_branches[$site] > 0 Then $UpdatedBuild[1] = WgetBuildIfNewer(1) ; check default branch only
	If $do_branches[$site] > 1 Then ; check other branches as well
		For $k = 2 To 24
			If $branches[$k][0] = "" Then ExitLoop ; done, no more branches
			If $branches[$k][0] <> $branches[1][0] Then
				If Not StringInStr($BlackList[$site], $branches[$k][0]) Then WgetBuildIfNewer($k)
				ContinueLoop
			EndIf
		Next
	EndIf
	SatIcon(0)
	$runtime = ((@MSEC / 1000) + @SEC + 60 * @MIN + 3600 * @HOUR) - $runtime
	$StatusMsg = $ready
	UpdateStatus()
	$dummy = "took "
	If $runtime >= 60.0 Then
		$dummy &= Int($runtime / 60) & " m "
	EndIf
	$d_last = $dummy & StringFormat("%#2.1f", $runtime - 60 * Int($runtime / 60)) & " s"
	UpdateLastCheck()
	If IsChecked($chk_debug2) Then _ArrayDisplay($skip_branch, "$skip_branch")
	$NetBuild = $UpdatedBuild[1 - $trunk[$site]]		; IsChecked($rad_build[0])
	If Number($NetBuild) > Number($NewestBuild) And Not IsMainMinimised() And $cardlock = 0 And Not $Background Then RefreshGUI()
	If Not $snooped Then
		$snooped = $do_branches[$site]
		GUICtrlSetState($but_branch, 64) ; $GUI_ENABLE = 64
	EndIf
_ap_ProfileStop(121)
	Return $NetBuild
EndFunc   ;==>NetBuildSnoop
; --------------------------------------------
Func WgetBuildIfNewer($index)
_ap_ProfileStart(122)
	Local $i, $k, $link, $aSource, $path, $cl, $upath, $flag
	Local $sname = GetSVN_Name($site) & " " & $branches[$index][0] & " "

	If ($branches[$index][0] = $skip_branch[$index][0]) And ($skip_branch[$index][1] = 1) Or $branches[$index][6] = "XXX" Then ; it's on the blacklist
		Add2Blacklist($branches[$index][0])
_ap_ProfileStop(122)
		Return "000"
	EndIf
	$k = Number( StringStripWS($branches[$index][2], 3) ) - Number( StringStripWS($branches[$index][6], 3) )
	If Not $k > 0 Then
;~ 	If Not ( Number($branches[$index][2]) > Number($branches[$index][6]) ) Then
_ap_ProfileStop(122)
		Return $branches[$index][6] ; local version is same or newer
	EndIf
	; ============ check if we need to postpone the pending update(s) ===================
	If IsMainMinimised() Or $cardlock = 1 Or $Background Then
		$Rflag = 1	; we need to postpone, set a flag ...
_ap_ProfileStop(122)
		Return $branches[$index][6] ; ... and pretend there's no update
	EndIf
	; ============ download required, find download link ================================
	SatIcon(1)
	$StatusMsg = "Checking " & $sname
	UpdateStatus()
	$flag = WgetHTMLSource($web_prefix & $SrcSites[$site] & $branches[$index][1], $aSource)
	If $flag Then
_ap_ProfileStop(122)
		Return ("unavailable")
	EndIf
	SatIcon(0)
	For $i = $aSource[0] To 1 Step -1 ; backward search is faster, it's near the end ...
		If StringInStr($aSource[$i], ">Zip Archive</a>") Then
			$k = StringInStr($aSource[$i], $VerPaths[$site] & "changeset/")
			$link = CopyStringWord($aSource[$i], $k, '"')
			$cl = $GCCpath & '\wget.exe ' & $wget_options & ' -O ' & $apath & '\' & $branches[$index][0] & $branches[$index][2] & '.zip "' & $web_prefix & $SrcSites[$site] & StringReplace($link, "%2F&amp;", "/&", 1, 1) & '"'
			;MsgBox($topmost, "Download CmdLine", $cl)	; uncomment to see link
			ExitLoop
		EndIf
	Next
	; ============ we got the link, now download =======================================
	ShowNetBuild($branches[$index][2])
	If $miniGUI Then AutoSplash("new " & $sname & $branches[$index][2] & "     ")
	$StatusMsg = "Downloading: " & $sname & $branches[$index][2]
	UpdateStatus()
	SatIcon(1)
	$i = DosExec($cl, $here)
	SatIcon(0)
	If $w_upd > 0 Then ; user selection requires unzipping ...
		$StatusMsg = "Unzipping: " & $sname & $branches[$index][2]
		UpdateStatus()
		If $index > 0 Then
			$upath = $here & $VerPrefix[$site] ; unpack to base dir, branch zips already contain branch subdir !
			$path = $bpath & "\" & $branches[$index][0]
		Else
			$upath = $tpath
			$path = $tpath & "\" & $branches[$index][0]
		EndIf
		$cl = $GCCpath & '\unzip.exe -o ' & $apath & '\' & $branches[$index][0] & $branches[$index][2] & ' -d ' & $upath & '\'
		$k = DosExec($cl, $here)
		;----------------------------------------------------------------------------
		; 2012/07/06
		; allowed also exitcode=2 as valid
		; unzip.exe exitcode=2
		;	a generic error in the zipfile format was detected.
		;	Processing may have completed successfully anyway
		; 	some broken zipfiles created by other archivers have simple work-arounds.
		;----------------------------------------------------------------------------
		If $k = 2 Then $k = 0

		$skip_branch[$index][0] = $branches[$index][0]
		If ($i + $k) > 0 Or IsBuildValid($path) = "" Then	; download or unzip failed ...
			$StatusMsg &= " ... Error!"
			UpdateStatus()
			FileDelete($apath & "\" & $branches[$index][0] & $branches[$index][2] & ".zip")
			DirRemove($path, 1)
			; don't blacklist trunk or default branch ...
			If $index > 2 Then
				$skip_branch[$index][1] = "1"
				$branches[$index][6] = "XXX"
				Add2Blacklist($branches[$index][0])
			EndIf
		Else
			$skip_branch[$index][1] = "0"
			; make sure we have full access to source (just in case SVN pulls any funny stuff)
;~ 			DosExec("attrib -R -A -S -H " & $path & "\*.* /S /D", $here)
			SilentDosExec("attrib -R -A -S -H " & $path & "\*.* /S /D", $here)
			DirRemove($path & $branches[$index][2], 1)
			DirMove($path, $path & $branches[$index][2]) ; 'cuz there's no Rename
			; copy the true release date/time in a file in builds' root dir
			If Not FileExists($path & $branches[$index][2] & "\released@.txt") Then
				FileWriteLine($path & $branches[$index][2] & "\released@.txt", $branches[$index][3])
			EndIf
			If $w_upd = 2 Then
				FileDelete($apath & "\" & $branches[$index][0] & $branches[$index][2] & ".zip")
			EndIf
			; if this is the current build, and it was updated, a compile might be necessary; '$index<2' is just for speedup ....
			If $index < 2 And $w_auto > 0 And IsChecked($chk_nosel) And ($index + $trunk[$site] = 1) Then $checkcompile = 1
			WriteLog($index)
			$branches[$index][6] = $branches[$index][2]
		EndIf
	Else
		WriteLog($index)	; download only still requires writing to log ...
	EndIf
	ShowNetBuild("")
_ap_ProfileStop(122)
	Return ($branches[$index][6])
EndFunc   ;==>WgetBuildIfNewer
; --------------------------------------------
Func ShowNetBuild($tv)
_ap_ProfileStart(123)
	Local $tag = ""
	If $tv = "" Then
		If IsChecked($chk_debug2) Then $tag = "d"
		If $Introspection Then $tag = "P"
		;If $Rflag = 1 Then $tag &= " *"
		$StatusMsg = $ready
		UpdateStatus()
		SplashOff()
	EndIf
	GUICtrlSetData($new_t, $tv & $tag)
	GUICtrlSetData($lab_mininew, $tv & $tag)
_ap_ProfileStop(123)
EndFunc   ;==>ShowNetBuild
; --------------------------------------------
Func Check_istate()
_ap_ProfileStart(124)
	$istate = IsChecked($chk_inet)
	If $istate = $last_istate Then	; must short-circuit ASAP, we don't want GUI flicker ...
_ap_ProfileStop(124)
		Return
	EndIf
	AdlibUnRegister("DoGC")
	GUICtrlSetState($lab_timerbar, 32) ; $GUI_HIDE = 32
	GUICtrlSetState($lab_dock, 32) ; $GUI_HIDE = 32
	If $miniGUI = 1 Then
		GUICtrlSetState($mini_countdown, 32) ; $GUI_HIDE = 32
		If $3D_CountDown Then
			GUICtrlSetState($mini_countdown2, 32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_countdown3, 32) ; $GUI_HIDE = 32
			GUICtrlSetState($mini_countdown4, 32) ; $GUI_HIDE = 32
		EndIf
		GUICtrlSetState($mini_dock, 32) ; $GUI_HIDE = 32
	EndIf
	If $istate = 1 Then
		; --- internet has just been checked ON by user, OR it was already on and TracChecker() has triggered
		SetAutoUpdateControls(64)
		Check_auto()
		AdlibUnRegister("TracChecker")
		TimeStamp()
		$NetBuild = NetBuildSnoop()
		TimeStamp()
		If IsChecked($chk_upd) Then
			AdlibRegister("TracChecker", GUICtrlRead($inp_upd) * 60 * 1000)
			$ticks_max = GUICtrlRead($inp_upd) * 60 / $Timer_Interval	; 1 +
			$ticks_left = $ticks_max
			Init_TimerBar()
		EndIf
		If StringLeft($NetBuild, StringLen("unavailable")) = "unavailable" Then
			SatIcon(0)
			If $warnflag[$site] Then
				; note this should be a BLOCKING MsgBox, since Check_istate() is (indirectly) called from Clean() !!!
				MsgBox($topmost, "Connection Error", "Connection with '" & $web_prefix & $SrcSites[$site] & "'" & @CR & "appears to be (temporarily?) unavailable." & @CR & "The 'Allow internet ...' option is painted" & @CR & "orange to remind you of this." & @CR & "Autochecking (if selected) will keep trying," & @CR & "and will resume as soon as net and site are" & @CR & "available again." & @CR & @CR & "[ AutoClose in 10 seconds ]", 10)
				$warnflag[$site] = 0 ; warn only once after net dropout
			EndIf
			GUICtrlSetBkColor($chk_inet, $orange)
			GUICtrlSetBkColor($lab_miniupd, $orange)
			$NetConnected[$site] = 0
		Else
			If $Controls_ShowBG = 1 Then
				GUICtrlSetBkColor($chk_inet, $CP_color[0][1])
				GUICtrlSetBkColor($lab_miniupd, $CP_color[0][1])
			Else
				GUICtrlSetBkColor($chk_inet, -1)
				GUICtrlSetBkColor($lab_miniupd, -1)
			EndIf
			$NetConnected[$site] = 1
			$warnflag[$site] = 1 ; re-arm net dropout warn flag
		EndIf
	Else
		; --- internet has just been checked OFF by user - disable AutoCheck controls ...
		SetAutoUpdateControls(128) ; $GUI_DISABLE = 128
		GUICtrlSetBkColor($chk_inet, -1)
	EndIf
	UpdateLastCheck()
	$StatusMsg = $ready
	UpdateStatus()
	$last_istate = $istate
	AdlibRegister("DoGC", $Timer_Interval * 1000)
_ap_ProfileStop(124)
EndFunc   ;==>Check_istate
; --------------------------------------------
Func Check_auto()
_ap_ProfileStart(125)
	If IsChecked($chk_upd) Then
		SetAutoCheckControls(64)	; $GUI_ENABLE = 64
	Else
		SetAutoCheckControls(128)	; $GUI_DISABLE = 128
	EndIf
_ap_ProfileStop(125)
EndFunc   ;==>Check_auto
; --------------------------------------------
Func ForceForegroundCheck()
_ap_ProfileStart(126)
	Local $bgstate = $Sync_Checks_BG

	$Sync_Checks_BG = 0			; temporarily set to foreground ...
	TracChecker()
	Wrapped_Check_istate()
	$Sync_Checks_BG = $bgstate	; ... and back to original setting
	UpdateDoubleCheckLabels()
_ap_ProfileStop(126)
EndFunc
; --------------------------------------------
Func Init_TimerBar()
_ap_ProfileStart(127)
	Local $mini_controls[4] = [ $mini_countdown4, $mini_countdown3, $mini_countdown2, $mini_countdown ]

	If IsChecked($chk_inet) And IsChecked($chk_upd) And $w_showcountdown = 1  And $ticks_left > 2 Then
		GUICtrlSetState($lab_timerbar, 16) ; $GUI_SHOW = 16
		If $miniGUI = 1 Then
			For $i = 0 To 2
				GUICtrlSetState($mini_controls[$i], 32 - 16 * $3D_CountDown) ; $GUI_SHOW = 16, $GUI_HIDE = 32
			Next
			GUICtrlSetState($mini_countdown, 16) ; $GUI_SHOW = 16
		EndIf
	Else
		GUICtrlSetState($lab_timerbar, 32) ; $GUI_HIDE = 32
		GUICtrlSetState($lab_dock, 32) ; $GUI_HIDE = 32
		If $miniGUI = 1 Then
			For $i = 0 To 3
				GUICtrlSetState($mini_controls[$i], 32) ; $GUI_HIDE = 32
			Next
			GUICtrlSetState($mini_dock, 32) ; $GUI_HIDE = 32
		EndIf
	EndIf
	Update_TimerBar()
_ap_ProfileStop(127)
EndFunc   ;==>Init_TimerBar
; --------------------------------------------
Func SetAutoUpdateControls($state)
_ap_ProfileStart(128)
	GUICtrlSetState($but_branch, $state)
	GUICtrlSetState($chk_upd, $state)
	GUICtrlSetState($lab_upd, $state)
	GUICtrlSetState($lab_upd2, $state)
	SetAutoCheckControls($state)
_ap_ProfileStop(128)
EndFunc   ;==>SetAutoUpdateControls
; --------------------------------------------
Func UpdateAutoUpdateControls()
_ap_ProfileStart(129)
	GUICtrlSetData($lab_upd, $txt_process[$w_upd])
	GUICtrlSetData($lab_upd2, "AutoCompile: " & $txt_autcomp[$w_auto])
_ap_ProfileStop(129)
EndFunc   ;==>UpdateAutoUpdateControls
; --------------------------------------------
Func SetAutoCheckControls($state)
_ap_ProfileStart(130)
	GUICtrlSetState($lab_interval, $state)
	GUICtrlSetState($inp_upd, $state)
	GUICtrlSetState($upd_upd, $state)
_ap_ProfileStop(130)
EndFunc   ;==>SetAutoCheckControls
; --------------------------------------------
Func VersionSnoop($always = False)
_ap_ProfileStart(131)
	Local $i, $str, $flag, $aSource, $temp, $search = "CHDK-Shell-v"
	Local $curver = StringLeft($Version, 1) & StringRight($Version, 2)
	Static $mbox_timeout105 = 30

	If (Not IsChecked($chk_inet)) Or ($w_chkver = 0 And (Not $always)) Then
_ap_ProfileStop(131)
		Return
	EndIf
	; prevent update triggering if we run an older version on purpose
	$temp = Number($curver)
	For $i =  $temp + 500 To $temp + 1 Step -1
		If FileExists($here & "\" & $search & String($i) & ".exe") Then
			$curver = String($i)
			ExitLoop
		EndIf
	Next
	SatIcon(1)
	$StatusMsg = "Checking program page ..."
	UpdateStatus()
	$flag = WgetHTMLSource($Get_gcc, $aSource)
	SatIcon(0)	; _ArrayDisplay($aSource, "Program Page", 0)
	If $flag <> 0 Then
		GUICtrlSetColor($but_go_progver, $red)
		GUICtrlSetData($but_go_progver, "Failed Err = " & $flag)
		Sleep(3000)
		GUICtrlSetData($but_go_progver, $UpdateButtonText)
		GUICtrlSetColor($but_go_progver, -1 )
		$StatusMsg = $ready
		UpdateStatus()
_ap_ProfileStop(131)
		Return
	EndIf
	$UpdateButtonText = "Updates OK"
	$uver = $curver
	For $i = 1 To $aSource[0]
		$str = $aSource[$i]
		If StringInStr($str, $search) Then
			For $k = Number($curver) + 100 To Number($curver) + 1 Step -1
				$temp = $search & String($k) & "-sfx.exe"
				If StringInStr($str, $temp, 1, -1) Then
					$uver = String($k)
					$ulink = $Get_CHDK_Shell_updater	; $Get_gcc
					ExitLoop 2
				EndIf
			Next
		EndIf
	Next
	If Number($uver) > Number($curver) Then
		$StatusMsg = $ready
		UpdateStatus()
		If $w_chkver = 2 Or $always Then
			GetNewVersion()
		ElseIf $w_chkver = 1 Then
			GUICtrlSetColor($but_go_progver, $red)
			GUICtrlSetData($but_go_progver, "Get v" & StringLeft($uver, 1) & "." & StringRight($uver, 2))
		EndIf
	Else
		GUICtrlSetData($but_go_progver, $UpdateButtonText)
		If $always Then
			$ulink = ""
			$uver = ""
			Dlg_MyMsgBox(0, "No New Version", "You're running " & $Title & " ," & @CR & @CR & "which is the latest version", $mbox_timeout105)
			If @error <> 0 Then
				$mbox_timeout105 = @error
			Else
				$mbox_timeout105 = @extended
			EndIf
		EndIf
	EndIf
	$StatusMsg = $ready
	UpdateStatus()
_ap_ProfileStop(131)
EndFunc   ;==>VersionSnoop
; --------------------------------------------
Func GetNewVersion()
_ap_ProfileStart(132)
	If $BrowserDLDir <> "" Then
		$UTarget = $BrowserDLDir & "\CHDK-Shell-updater.7z"
		If FileExists($UTarget) Then FileDelete($UTarget)	; avoid auto renaming by browser ...
	EndIf
	Browse($ulink)
	$ulink = ""
	GUICtrlSetColor($but_go_progver, -1)
	GUICtrlSetData($but_go_progver, $UpdateButtonText)
	$StatusMsg = $ready
	UpdateStatus()
_ap_ProfileStop(132)
EndFunc   ;==>GetNewVersion
; --------------------------------------------
Func Get_ptpCamGui()
_ap_ProfileStart(133)
	Local $dummy, $files, $icons, $_tmp = "", $exerev = "", $message = ""
	Local $gpath = $subdir & "\guest\ptpCamGui", $fresh_CHDKDE = GetLocalHighBuild("trunk\trunk", 1)

	If $update_ptpcam = 1 Then
		For $i = Number($fresh_CHDKDE) To 560 Step -1
			$_tmp = $here & "\DE\trunk\trunk" & $i
			If FileExists($_tmp & "\tools\ptpcam\ptpcam.c") Then
				$exerev = $i
				ExitLoop
			EndIf
		Next
	EndIf

	If $exerev <> "" And IsChecked($chk_inet) And $update_ptpcam = 1 Then
		FileDelete($gpath & "\exerevision.txt")
		FileWriteLine($gpath & "\exerevision.txt", $exerev)
	ElseIf Not FileExists($gpath & "\ptpcam.exe") Then
		FileDelete($gpath & "\exerevision.txt")
		FileWriteLine($gpath & "\exerevision.txt", "internal")
	EndIf
	If FileExists($gpath & "\ptpCamGui_Obfuscated.au3") Then $message = '  (gui=r' & FileReadLine($gpath & "\guirevision.txt")
	If FileExists($gpath & "\ptpcam.dll") Then $message &= ' , dll=r' & FileReadLine($gpath & "\dllrevision.txt")

	If StringInStr($message, "gui=") And StringInStr($message, "dll=") Then
		$message &= ' , exe=' & FileReadLine($gpath & "\exerevision.txt")
		; update context menu; works via the global $ptp_ctx_entry to make it survive a GUI rebuild
		$ptp_ctx_entry = "ptpCamGui" & $message
		GUICtrlSetData($ctx_ptpcam, $ptp_ctx_entry)
		If $miniGUI = 1 Then GUICtrlSetState($ico_canon, 64) ; $GUI_ENABLE = 64
	EndIf
	; if Internet not allowed, or user selects not to update ptpCamGui ...
	If Not IsChecked($chk_inet) Or $no_ptpcamgui_dl = 1 Then
_ap_ProfileStop(133)
		Return $_tmp
	EndIf

	Local $wgetcmdline = $SysComSpec & " /c " & $GCCpath & "\wget.exe "
	Local $params =  $wget_options & ' -N -T 5 -t 1 -O '
	Local $wpath = $gpath & "\work"

	Local $cpath = $_tmp & "\tools\ptpcam"
	Local $ipath = $gpath & "\icons"
	Local $pid, $aPage, $rev = "", $currev = ""
	Local $rudi_space = $web_prefix & "subversion.assembla.com/svn/rudi_space"
	Local $gui_trunk_url = $rudi_space & "/ptpCamGUI/trunk"
	Local $dll_trunk_url = $rudi_space & "/ptpcam_dll/build"
	Local $dll_url = $dll_trunk_url & "/ptpcam.dll"

	Local $dll_dest = $gpath & "\ptpcam.dll"

	$StatusMsg = "Checking ptpcam ..."
	UpdateStatus()

	; add check for 'work' subdir, clean up if existing ...
	If FileExists($wpath) Then
		DirRemove($wpath, 1)
		FileDelete($gpath & "\*.*")
	EndIf
	; OK, now _tmp points to the newest CHDK-DE dir containing a valid ptpcam source ...
	; If source is newer than existing exe, compile; use Run() to do it in the background
	If $update_ptpcam = 1 And $_tmp <> "" And ( Number(FileGetTime($cpath & "\ptpcam.c", 0, 1)) > Number(FileGetTime($gpath & "\ptpcam.exe", 0, 1)) ) Then
		; write a small cmd batch that will do the actual work
		FileWriteLine($_tmp & "\doptp.cmd", "setlocal" & @CRLF & 'set PATH=' & $GCCpath & ';%PATH%' & @CRLF & 'gmake -C tools/ptpcam -f makefile.chdkshell'	)
		; run the batch; new 'DosExec' 3rd param '0' makes it use Run() i.o. RunWait() ..
		$pid = DosExec("doptp", $_tmp, 0)	; keep PID to monitor the process
	EndIf
	; assure icons subdirs exist ...
	DirCreate($ipath)
	$StatusMsg = "Checking ptpcam.dll ..."
	UpdateStatus()
	SatIcon(1)
	; check/download if newer: ptpcam.dll
	$currev = FileReadLine($gpath & "\dllrevision.txt")
	WgetHTMLSource($dll_trunk_url, $aPage)	; download page
	If IsArray($aPage) Then
        ; CopyStringWord copies from {position in string} to {separator character}
		$rev = CopyStringWord($aPage[1], 9 + StringInStr($aPage[1], "Revision"), ":")
	EndIf
	If $currev = "" Or $rev <> $currev Then
		$StatusMsg = "Updating ptpcam.dll (r" & $rev & ") ..."
		UpdateStatus()
		DosExec($wgetcmdline & $params  & $dll_dest & ' ' & $dll_url, $here)
		FileDelete($gpath & "\dllrevision.txt")
		FileWriteLine($gpath & "\dllrevision.txt", $rev)
		$currev = $rev
	EndIf
	$message = ' , dll=r' & $currev & ' , exe='
	If $_tmp <> "" Then
		$message &= 'r' & $exerev & ')'
	Else
		$message &= 'internal)'
	EndIf
	; ... and check/download if newer ptpCamGui + icons
	$StatusMsg = "Checking ptpCamGui ..."
	UpdateStatus()
	$aPage = 0
	$rev = ""
	$currev = FileReadLine($gpath & "\guirevision.txt")
	WgetHTMLSource($gui_trunk_url, $aPage)
	If IsArray($aPage) Then
		Local $candidate
        ; CopyStringWord copies from {position in string} to {separator character}
		$rev = CopyStringWord($aPage[1], 9 + StringInStr($aPage[1], "Revision"), ":")
		For $i = 2 To $aPage[0]
			$dummy = StringInStr($aPage[$i], "href=")
			If $dummy <> 0 Then
				$candidate = CopyStringWord($aPage[$i], 6 + $dummy, '"')
				If StringInStr(".exe.au3", StringRight($candidate, 4)) Then $files &= "|" & $candidate
			EndIf
		Next
		$files = StringTrimLeft($files, 1)	; remove leading '|'
		$aPage = 0
		WgetHTMLSource($gui_trunk_url & "/icons", $aPage)
		If IsArray($aPage) Then
			For $i = 2 To $aPage[0]
				$dummy = StringInStr($aPage[$i], "href=")
				If $dummy <> 0 Then
					$candidate = CopyStringWord($aPage[$i], 6 + $dummy, '"')
					If StringRight($candidate, 4) = ".ico" Then $icons &= "|" & $candidate
				EndIf
			Next
			$icons = StringTrimLeft($icons, 1)	; remove leading '|'
		EndIf
	EndIf
;~ 	MsgBox($topmost, "testing", "files=" & $files & @CR & "icons=" & $icons)
	If $currev = "" Or $rev <> $currev Then
		$StatusMsg = "Updating ptpCamGui (r" & $rev & ") ..."
		UpdateStatus()
		$dummy = StringSplit($files, "|")
		For $i = 1 To $dummy[0]
			DosExec($wgetcmdline & $params  & $gpath & "\" & $dummy[$i] & ' ' & $gui_trunk_url & "/" & $dummy[$i], $here)
		Next
		$dummy = StringSplit($icons, "|")
		For $i = 1 To $dummy[0]
			DosExec($wgetcmdline & $params & $ipath & "\" & $dummy[$i] & ' ' & $gui_trunk_url & "/icons/" & $dummy[$i], $here)
		Next
		FileDelete($gpath & "\guirevision.txt")
		FileWriteLine($gpath & "\guirevision.txt", $rev)
	EndIf
	SatIcon(0)

	If $rev <> "" Then $currev = $rev
	$message = '  (gui=r' & $currev & $message
	; update context menu; works via the global $ptp_ctx_entry to make it survive a GUI rebuild
	$ptp_ctx_entry = "ptpCamGui" & $message
	GUICtrlSetData($ctx_ptpcam, $ptp_ctx_entry)
	If $update_ptpcam = 1 Then
		; if compilation of ptpcam.exe not yet finished, wait for it ...
		$StatusMsg = "Waiting for ptpcam.exe ..."
		UpdateStatus()
		While ProcessExists($pid)
			Sleep(100)
		WEnd
		FileDelete($_tmp & "\doptp.cmd")	; clean up
		If FileExists($cpath & "\ptpcam.exe") Then FileMove($cpath & "\ptpcam.exe", $gpath & "\ptpcam.exe", 1)
	EndIf
	$StatusMsg = $ready
	UpdateStatus()
	; once we're here we can allow the program to be started
	If $miniGUI = 1 Then GUICtrlSetState($ico_canon, 64) ; $GUI_ENABLE = 64
_ap_ProfileStop(133)
	Return $_tmp
EndFunc   ;==>Get_ptpCamGui

#EndRegion
#
#Region ----(no Profile/Trace)------ Profiler routines -------------------------------------------

Func RestartProgram()
_ap_ProfileStop(0)
	GetWPos()
	WriteIni()
	WriteXY()
	SortIni($inifile)
	SplashOff()
	Implode("Restarting ...")
	If $miniGUI = 1 Then GUIDelete($minimain)
	GUIDelete($pic)
	If $GDI_plus Then _GDIPlus_Shutdown()
	GUIDelete($main)
	Local $param = ' -multiple'
	; creature comfort: assure we can restart even if running as au3 or a3x ...
	Local $ext = StringRight(@ScriptName, 3)
	If $ext = "au3" Or $ext = "a3x" Then $param = ' "' & @ScriptFullPath & '"' & $param
	ShellExecute(@AutoItExe, $param, $here, "open")
	Exit 0
EndFunc

Func ToggleProfiling($onoff, $running = 1)
	Local $thesource = $subdir & "\SRC\" & StringTrimRight(@ScriptName, 3) & "au3"

	If Not @Compiled Then FileCopy(@ScriptFullPath, $thesource, 1)	; assure latest version ...
	If $running = 1 Then	; if called from Dlg_Debug(), a restart is required
		IniWrite($inifile, $sections[0], "introspection", $onoff)
		RestartProgram()
	EndIf
	If $onoff = 1 And FileExists($thesource) Then
		; ================ start init profiling arrays ==========================
		Global $_ap_g_aProfileStore[$maxfuncs][5]	; entertime, hitcount, ExitCount, totaltime, ChildTime
		Global $FuncStore[$maxfuncs][2] ; funcline#, funcname
		$_ap_g_iStackSize = 25
		$_ap_g_iStackIndex = 0
		Global $_ap_g_aFuncStack[$_ap_g_iStackSize]
		; ================= end init profiling arrays ===========================
		Local $time, $aSource, $fname, $fnum, $fline
		Local $mainstart = "If $cmdline[0] = 0", $token = "_ap_ProfileStart("
		; calc profiling overhead
		$OVH = 0.0
		OpenTraceLog()
		$time = TimerInit()
		For $i = 1 To 1000
			ProfilerCycle()
		Next
		$OVH = TimerDiff($time)
		CloseTraceLog()
		; calc looping overhead and subtract ...
		$time = TimerInit()
		For $i = 1 To 1000
		Next
		$OVH -= TimerDiff($time)
		; normalise to 1 profiler cycle (in milliseconds)
		; note there's 2 profiling start-stop's in a cycle !
		$OVH = $OVH / 2000

		_FileReadToArray($thesource, $aSource)
		For $i = 1 To $aSource[0]
			$aSource[$i] = StringStripWS($aSource[$i], 1)
			If $aSource[$i] = "" Or StringLeft($aSource[$i], 1) = ";" Then ContinueLoop	; skip empty & comment lines
			; we need to climb some fences here, _ap_ProfileStart(0) is offset,
			; so we will specifically search for the first statement
			If StringLeft($aSource[$i], 18) = $mainstart Then
				$FuncStore[0][0] = $i
				$FuncStore[0][1] = StringTrimRight(@ScriptName, 4) & " (main)"
			ElseIf StringLeft($aSource[$i], 17) = $token Then
				$fnum = Number(StringTrimRight(StringTrimLeft($aSource[$i], 17), 1))
				If $fnum = 0 Then
					ContinueLoop
				Else
					$fname = ""
					; for 'normal' funcs _ap_ProfileStart(...) is the first line in the Func
					$fline = $i - 1
					If StringLeft($aSource[$fline], 4) = "Func" Then
						$fname = CopyStringWord($aSource[$fline], 6, "(")
					EndIf
				EndIf
				If $fname <> "" Then
					$FuncStore[$fnum][1] = $fname
					$FuncStore[$fnum][0] = $fline
				EndIf
			EndIf
		Next
		$Introspection = 1
		OpenTraceLog()
		FileWrite($tracelog, "# this log is: " & $subdir & "\trace.log" & @CRLF & "# source code: " & $thesource & " ( " & FileGetSize($thesource) / 1000 & " kB, " & $aSource[0] & " lines )"  & @CRLF & @CRLF	)
	Else
		CloseTraceLog()
		If Not FileExists($thesource) Then
			If $onoff = 1 Then MsgBox($topmost, "Profiling Problem",	"Tracing/profiling disabled, source code not" & @CR & "found at " & $thesource )
			IniWrite($inifile, $sections[0], "introspection", 0)
		EndIf
		$Introspection = 0
	EndIf
EndFunc   ;==>ToggleProfiling
; --------------------------------------------
Func _ap_ProfileStackAdd($FuncId)
	If Not IsArray($_ap_g_aFuncStack) Then Return
	$_ap_g_iStackIndex += 1
	If $_ap_g_iStackIndex < $_ap_g_iStackSize Then
		$_ap_g_aFuncStack[$_ap_g_iStackIndex] = $FuncId
	Else
		$_ap_g_iStackSize += 25
		ReDim $_ap_g_aFuncStack[$_ap_g_iStackSize]
		$_ap_g_aFuncStack[$_ap_g_iStackIndex] = $FuncId
	EndIf
	If $_ap_g_iStackIndex > $StackUsed Then $StackUsed = $_ap_g_iStackIndex
EndFunc   ;==>_ap_ProfileStackAdd
; --------------------------------------------
Func _ap_ProfileStackPop()
	Local $iIndex = ""
	If IsArray($_ap_g_aFuncStack) And $_ap_g_iStackIndex > 0 Then
		$_ap_g_aFuncStack[$_ap_g_iStackIndex] = ""
		$_ap_g_iStackIndex -= 1
		$iIndex = $_ap_g_aFuncStack[$_ap_g_iStackIndex]
	EndIf
	Return $iIndex
EndFunc   ;==>_ap_ProfileStackPop
; --------------------------------------------
Func _ap_ProfileReport()
	If Not $Introspection Then Return
	Local $aReport[$maxfuncs][8]

	; determine profiler overhead
	Local $total_elapsed = $_ap_g_aProfileStore[0][3]
	Local $profcalls = 0
	For $i = 0 To $maxfuncs - 2
		$aReport[$i][0] = $FuncStore[$i][1] ; func name
		$aReport[$i][1] = $FuncStore[$i][0] ; line no
		$aReport[$i][2] = $_ap_g_aProfileStore[$i][1] ; hits
		$aReport[$i][3] = $_ap_g_aProfileStore[$i][2] - $_ap_g_aProfileStore[$i][1] ; bad exits
		$aReport[$i][4] = $_ap_g_aProfileStore[$i][3] ; Func + child
		$aReport[$i][5] = $aReport[$i][4] - $_ap_g_aProfileStore[$i][4] ; Func Only
		$profcalls += $aReport[$i][2]
		If $aReport[$i][2] Then
			$aReport[$i][6] = $aReport[$i][5] / $aReport[$i][2]	;Average time func only
		EndIf
		$aReport[$i][7] = Round($aReport[$i][5] / $total_elapsed * 100, 3)	; Percentage
		For $j = 4 To 6
			$aReport[$i][$j] = TimeFormat($aReport[$i][$j])
		Next
		If $aReport[$i][2] = 0 Then
			$aReport[$i][3] = ""
			$aReport[$i][7] = ""
		ElseIf $aReport[$i][7] = 0 Then
			$aReport[$i][7] = "< 0.001"
		EndIf
	Next
	$aReport[$maxfuncs - 1][0] = "~~~~~~~~~~~~~~~~~"
	$aReport[$maxfuncs - 1][1] = "calls ->"
	$aReport[$maxfuncs - 1][2] = $profcalls
	$aReport[$maxfuncs - 1][3] = "overhead ->"
	$aReport[$maxfuncs - 1][4] = TimeFormat($profcalls * $OVH)
	$aReport[$maxfuncs - 1][5] = "correction (applied) ->"
	$aReport[$maxfuncs - 1][6] = TimeFormat($OVH)
	$aReport[$maxfuncs - 1][7] = Round($profcalls * $OVH * 100 / $total_elapsed, 3)
	If $aReport[$maxfuncs - 1][7] = 0 Then $aReport[$maxfuncs - 1][7] = "< 0.001"
	CloseTraceLog()
	Local $header = "Func#|Func Name|Line#|Hits|Errors|FuncTot(+ SubFunc)|FuncTot(- SubFunc)|FuncAvg(- SubFunc)|% FuncTot(- SubFunc)"
				;             0       1     2     3           4                  5                  6                    7
	Local $plog = FileOpen($subdir & "\prof.log", 2)
	FileWriteLine($plog, $maxfuncs & @CRLF & $header)
	For $i = 0 To $maxfuncs - 1
		Local $t = ""
		For $k = 0 To 7
			$t &= $aReport[$i][$k] & "|"
		Next
		$t = StringTrimRight($t, 1)
		FileWriteLine($plog, $t)
	Next
	FileClose($plog)
	SplashOff()
	ShowLastReports()
EndFunc   ;==>_ap_ProfileReport
; --------------------------------------------
Func ShowLastReports()
	Local $tlog = $subdir & "\trace.log"
	Local $hPlog = FileOpen($subdir & "\prof.log", 0)
	Local $ret, $msg = ""
	Local $title = "Profiler Report (log at " & $subdir & "\prof.log) - see trace log for creation data"

	If FileExists($tlog) Then
		ShellExecute($tlog, "", $subdir, "open")
		$ret = TimerInit()
		Do
			Sleep(100)
		Until StringInStr(WinGetTitle("[active]"), "trace.log") Or TimerDiff($ret) > 5000
	Else
		$msg = $tlog & " not found" & @CRLF
	EndIf
	If $hPlog <> -1 Then
		Local $maxf = Number(FileReadLine($hPlog))
		Local $head = FileReadLine($hPlog)
		Local $aReport[$maxf][8], $line
		For $i = 0 To $maxf - 1
			$line = StringSplit(FileReadLine($hPlog), "|")
			For $k = 1 To $line[0]
				$aReport[$i][$k - 1] = $line[$k]
			Next
		Next
		FileClose($hPlog)
		_ArrayDisplay($aReport, $title, -1, 0, "", "|", $head)
	Else
		$msg &= $subdir & "\prof.log not found"
	EndIf
	FileClose($hPlog)
	If $msg <> "" Then
		Dlg_MyMsgBox(0, "Log(s) missing", $msg)
	ElseIf $Introspection = 1 Then
		$ret = Dlg_MyMsgBox(4, 	"Keep Log files ?", "Because Profiling is ON, these logs will be overwritten" & @CR & "at the next program start. This can be avoided by turning" & @CR & "Profiling OFF (use 'View Last Logs' to inspect them)" & @CR & @CR & "Keep logs and turn OFF Profiling ?", 0, -1)
		If $ret = 6 Then IniWrite($inifile, $sections[0], "introspection", 0)
	EndIf
EndFunc
; --------------------------------------------
Func _ap_ProfileStart($iProfId)
	If Not $Introspection Then Return
	FileWriteLine($tracelog, $Pad & "==> " & $FuncStore[$iProfId][1] & " @ " & $FuncStore[$iProfId][0])
	$Pad &= "    "
	$_ap_g_aProfileStore[$iProfId][1] += 1
	_ap_ProfileStackAdd($iProfId)
	$_ap_g_aProfileStore[$iProfId][0] = TimerInit()
EndFunc   ;==>_ap_ProfileStart
; --------------------------------------------
Func _ap_ProfileStop($iProfId)
	If Not $Introspection Then Return
	$Pad = StringTrimLeft($Pad, 4)
	FileWriteLine($tracelog, $Pad & "<-- " & $FuncStore[$iProfId][1])
	Local $iDiff = TimerDiff($_ap_g_aProfileStore[$iProfId][0]) - $OVH
	Local $iParent = ""
	$_ap_g_aProfileStore[$iProfId][2] += 1
	$_ap_g_aProfileStore[$iProfId][3] += $iDiff
	$iParent = _ap_ProfileStackPop()
	If Not ($iParent == "") Then $_ap_g_aProfileStore[$iParent][4] += $iDiff
	If $iProfId = 0 Then CloseTraceLog()
EndFunc   ;==>_ap_ProfileStop
; --------------------------------------------
Func TimeStamp()
	If Not $Introspection Then Return
	FileWrite($tracelog, $Pad & "=======================" & @CRLF & $Pad & "[" & @MON & "-" & @MDAY & "-" & @YEAR & " @ " & @HOUR & ":" & @MIN & ":" & @SEC & "] " & @CRLF & $Pad & "=======================" & @CRLF )
EndFunc   ;==>TimeStamp
; --------------------------------------------
Func OpenTraceLog()
	$StackUsed = 0
	$tracelog = FileOpen($subdir & "\trace.log", 2)
	$Pad = ""
	TimeStamp()
EndFunc   ;==>OpenTraceLog
; --------------------------------------------
Func CloseTraceLog()
	TimeStamp()
	FileWriteLine($tracelog, @CRLF & "[ Profiler call stack used: " & $StackUsed & " of " & $_ap_g_iStackSize & " ]")
	FileClose($tracelog)
EndFunc   ;==>CloseTraceLog
; --------------------------------------------
Func ProfilerCycle()
_ap_ProfileStart($maxfuncs - 1)
_ap_ProfileStart($maxfuncs - 1)
_ap_ProfileStop($maxfuncs - 1)
_ap_ProfileStop($maxfuncs - 1)
EndFunc   ;==>ProfilerCycle
; --------------------------------------------
Func TimeFormat($ms)
	Local $ret = StringFormat(" %.6f s", $ms / 1000.0)
 	If $ms = 0.0 Then $ret = ""
	Return $ret
EndFunc   ;==>TimeFormat

#EndRegion
#
#Region ---------------------------- Card related functions --------------------------------------

Func CardMainMenu()
_ap_ProfileStart(134)
	Local $Title = " CardTricks Menu -- " & $CBFN
	Local $mbut_mkboot, $mbut_form_fat, $mbut_copy_bin, $mbut_copy_2cust, $mbut_copy_2card, $mbut_sel_cust
	Local $mbut_chdk_cfg, $mbut_chdk_show, $mbut_udump_analyse
	Local $chk_bin_over, $chk_fix_disk, $chk_stop_info, $chk_auto_sel, $chk_CF
	Local $mbut_udump_newdry, $mbut_udump_dry, $mbut_udump_vxw, $mbut_udump_show, $mbut_show, $mbut_go_back, $mbut_credits, $mbut_analyse
	Local $lab_card_drv, $lab_card_typ, $lab_card_fs, $lab_card_lab, $lab_card_siz, $lab_card_boot, $lab_cust_path, $card_pic, $ico_arr
	Local $cmsg, $ret, $dummy, $flag, $bootstate, $redraw
	Local $card_fs = "", $card_sz, $custom_path
	Local $illegal = StringLeft(@HomeDrive, 1) & StringLeft(@SystemDir, 1) & StringLeft($here, 1)
	Local $acceptable, $delta_x = 0, $delta_y = 0
	Static $mbox_timeout107 = 30

	If $PivIndex = 1 Or $PivIndex = 3 Then $delta_x = $wpos[2] - R(558)
	If $PivIndex = 2 Or $PivIndex = 3 Then $delta_y = $wpos[3] - R(348)
	$cardmenu = GUICreate($Title, R(550), R(320), $wpos[0] + $delta_x, $wpos[1] + $delta_y, $WS_POPUP + $WS_CAPTION, $WS_EX_TOOLWINDOW)
	GUISetFont($f_normal, 400, 1, "Tahoma")
	; -------------------------------------------------------------------------------
	GUICtrlCreateGroup(" Card Info && Selection", R(20), R(20), R(250), R(180))
	GUICtrlSetFont(-1, $f_normal, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$chk_auto_sel = GUICtrlCreateCheckbox("Auto", R(225), R(20), R(40), R(18))
	GUICtrlSetFont(-1, $f_small)
	Set_BGColor()
	$mbut_analyse = GUICtrlCreateButton("Analyse", R(160), R(20), R(50), R(16))
	GUICtrlCreateLabel("Selected Drive: ", R(30), R(50))
	Set_BGColor()
	$lab_card_drv = GUICtrlCreateLabel("", R(110), R(50), R(30), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("Drive Type:", R(30), R(70))
	Set_BGColor()
	$lab_card_typ = GUICtrlCreateLabel("", R(110), R(70), R(60), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("File System:", R(30), R(90))
	Set_BGColor()
	$lab_card_fs = GUICtrlCreateLabel("", R(110), R(90), R(40), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("Drive Label:", R(30), R(110))
	Set_BGColor()
	$lab_card_lab = GUICtrlCreateLabel("", R(110), R(110), R(120), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("Card Size: ", R(30), R(130))
	Set_BGColor()
	$lab_card_siz = GUICtrlCreateLabel("", R(110), R(130), R(155), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("CHDK Boot: ", R(30), R(150))
	Set_BGColor()
	$lab_card_boot = GUICtrlCreateLabel("", R(110), R(150), R(155), R(20))
	Set_BGColor()
	GUICtrlCreateLabel("Select >>", R(180), R(52), R(55), R(14))
	Set_BGColor()
	GUICtrlSetFont(-1, $f_small)
	$card_pic = GUICtrlCreateIcon($icons & "\card2.ico", -1, R(225), R(43), R(33), R(43), -1)
	$mbut_show = GUICtrlCreateButton("Show", R(225), R(91), R(35), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	GUICtrlSetFont(-1, $f_small)
	$mbut_form_fat = GUICtrlCreateButton("Format as FAT", R(30), R(170), R(115), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_mkboot = GUICtrlCreateButton("Make Bootable", R(150), R(170), R(110), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	; -------------------------------------------------------------------------------
	GUICtrlCreateGroup(" Create/Inspect Universal Dumper Card", R(20), R(210), R(250), R(95))
	GUICtrlSetFont(-1, $f_normal, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	GUICtrlCreateLabel("This will DELETE ALL DATA on the card !", R(30), R(230), -1, R(14))
	Set_BGColor()
	GUICtrlSetColor(-1, 0xFF0000)
	$mbut_udump_newdry = GUICtrlCreateButton("NewDryOS", R(30), R(245), R(70), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_udump_dry = GUICtrlCreateButton("DryOS", R(105), R(245), R(75), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_udump_vxw = GUICtrlCreateButton("VxWorks", R(185), R(245), R(75), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	GUICtrlCreateLabel("AFTER dumping -->", R(33), R(280), R(105), R(20))
	Set_BGColor()
	$mbut_udump_show = GUICtrlCreateButton("Strings", R(140), R(275), R(60), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_udump_analyse = GUICtrlCreateButton("Clean", R(205), R(275), R(55), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	; -------------------------------------------------------------------------------
	GUICtrlCreateGroup("Binaries @ " & $BuildName & $LongBuildName & "", R(280), R(20), R(250), R(50))
	GUICtrlSetFont(-1, $f_normal, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$mbut_copy_bin = GUICtrlCreateButton("Unzip to Card ...", R(290), R(40), R(150), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$chk_bin_over = GUICtrlCreateCheckbox("Overwrite", R(445), R(43), R(78), R(18))
	Set_BGColor()
	; -------------------------------------------------------------------------------
	GUICtrlCreateGroup("CHDK Folder Operations", R(280), R(80), R(250), R(120))
	GUICtrlSetFont(-1, $f_normal, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)
	$mbut_copy_2cust = GUICtrlCreateButton("CHDK -> Custom", R(290), R(100), R(110), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_copy_2card = GUICtrlCreateButton("Custom -> CHDK", R(405), R(100), R(115), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_sel_cust = GUICtrlCreateButton("Select", R(290), R(128), R(40), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$custom_path = IniRead($inifile, $sections[2], "custom_path", $subdir & "\Custom")
	$lab_cust_path = GUICtrlCreateLabel($custom_path, R(335), R(132), R(190), R(37))
	Set_BGColor()
	$mbut_chdk_cfg = GUICtrlCreateButton("Save Config ...", R(290), R(170), R(110), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128
	$mbut_chdk_show = GUICtrlCreateButton("Load Config ...", R(405), R(170), R(115), R(22))
	GUICtrlSetState(-1, 128) ; $GUI_DISABLE = 128

	GUICtrlCreateGroup("Note: Settings are saved to ini file", R(280), R(210), R(250), R(95))
	GUICtrlSetFont(-1, $f_normal, Default, 0, $gr_font)
	GUICtrlSetColor(-1, $blue)

	$chk_stop_info = GUICtrlCreateCheckbox("Stop info messages", R(300), R(230), R(150), R(18))
	Set_BGColor()
	$chk_fix_disk = GUICtrlCreateCheckbox("Allow fixed disks", R(300), R(252), R(117), R(18))
	Set_BGColor()
	$ico_arr = GUICtrlCreateIcon($arr_icon[3 - $PivIndex], -1, R(495), R(220), R(32), R(32))
	$chk_CF = GUICtrlCreateCheckbox("CF boot sector", R(420), R(252), R(105), R(18))
	Set_BGColor()
	$mbut_credits = GUICtrlCreateButton("About / Credits", R(290), R(275), R(90), R(22))
	$mbut_go_back = GUICtrlCreateButton("Return (=Esc/<Alt>+C)", R(385), R(275), R(135), R(22))

	ReadSett($chk_bin_over, $sections[2], "chk_bin_over")
	ReadSett($chk_fix_disk, $sections[2], "chk_fix_disk")
	ReadSett($chk_stop_info, $sections[2], "chk_stop_info")
	ReadSett($chk_auto_sel, $sections[2], "chk_auto_sel")
	ReadSett($chk_auto_sel, $sections[2], "chk_CF")

	If $w_animate = 1 Then AnimateWin($cardmenu, $PivotPrms[$PivIndex][0], $ctim)
	GUISetState($State_Show, $cardmenu)
	Local $CallingGUI = $CurrentGUI
	$CurrentGUI[0] = $cardmenu
	$CurrentGUI[1] = "CardTricks_Dlg"

	$mpos0 = WinGetPos($cardmenu)

	If IniRead($inifile, $sections[0], "tooltips", 1) = 1 Then	; set tooltips state according to checkbox in main GUI
		GUICtrlSetTip($mbut_analyse, "Shows key data for DISKBOOT.BIN," & @CRLF & "like cam/firm, build date, etc.")
		GUICtrlSetTip($card_pic, "[ Keyboard shortcut <Alt> + S ]" & @CRLF & "Select card to work with")
		GUICtrlSetTip($mbut_show, "Show card contents")
		GUICtrlSetTip($mbut_form_fat, "Formats your card and writes 'ver.req' to it, so that" & @CRLF & "it is able show your cam's firmware version." & @CRLF & "(Button shows 'Format as FAT32' for cards > 4 GB !)")
		GUICtrlSetTip($mbut_mkboot, "Writes 'BOOTDISK' to the cards' bootsector" & @CRLF & "to allow Canon cams to boot from it. Note:" & @CRLF & "this works on FAT only (NOT FAT32) !")
		GUICtrlSetTip($mbut_udump_newdry, "Allows up to 4 GB, but warns > 2 GB")
		GUICtrlSetTip($mbut_udump_dry, "Allows up to 4 GB, but warns > 2 GB")
		GUICtrlSetTip($mbut_udump_vxw, "Allows up to 4 GB, but warns > 2 GB")
		GUICtrlSetTip($mbut_udump_show, "Shows you all strings found in" & @CRLF & "'empty.dum' on the current card")
		GUICtrlSetTip($mbut_udump_analyse, "Analyses your dump. If it is OK, a clean copy" & @CRLF & "(leading/trailing zeros stripped) will be made:" & @CRLF & $subdir & "\stripped.bin")
		GUICtrlSetTip($mbut_copy_bin, "Select a ZIP archive with binaries for" & @CRLF & "your camera/firmware and unpack to card" & @CRLF & "Note: Fresh builds do NOT contain CCHDK.CFG," & @CRLF & "so your existing configuration is safe.")
		GUICtrlSetTip($mbut_copy_2cust, "Copy entire contents of CHDK folder on" & @CRLF & "card to a user-defined folder.")
		GUICtrlSetTip($mbut_copy_2card, "Copy entire contents of a user-defined" & @CRLF & "folder to CHDK folder on card. CCHDK.CFG" & @CRLF & "on card will be renamed to CCHDK.BAK")
		GUICtrlSetTip($mbut_chdk_cfg, "Make time/date stamped backup and store" & @CRLF & "in dedicated folder; allows adding tags" & @CRLF & "of up to 250 chars, no linefeeds though")
		GUICtrlSetTip($mbut_chdk_show, "Shows CCHDK.CFG backup collection in" & @CRLF & "Notepad and lets you select one. CCHDK.CFG" & @CRLF & "on card will be backed up as CCHDK.BAK")
		GUICtrlSetTip($chk_stop_info, "Will stop Info message boxes that might" & @CRLF & "start to irritate you after a while ;)")
		GUICtrlSetTip($chk_fix_disk, "The following fixed drives will never be accepted:" & @CRLF & "SystemDrive, HomeDrive, and the drive containing" & @CRLF & "this program (if a fixed drive !)")
		GUICtrlSetTip($chk_CF, "When making the drive bootable, this will additionally" & @CRLF & "write 'EOS_DEVELOP' to offset 0x24 in the boot sector" & @CRLF & "(should work with P&S, but only useful for DSLR cams)")
	EndIf

	CardBootSector($chk_CF)

	If IsChecked($chk_auto_sel) Then $redraw = 1

	$AccelCard[0][0] = "!c"
	$AccelCard[0][1] = $mbut_go_back
	$AccelCard[1][0] = "!s"
	$AccelCard[1][1] = $card_pic

	GUISetAccelerators($AccelCard, $cardmenu)

	While 1
		$cmsg = GUIGetMsg()
		If IsChecked($chk_debug2) Then Debug_LoopTimer($cmsg)
		If $cmsg = 0 Then
			; $activity = $mtim
			If $gc = True Then Clean()
			Sleep(300)
			ContinueLoop
		EndIf
		If $cmsg = -8 Then AutoPos() ; -8 = left mouse button released
		If $cmsg = -3 Then ExitLoop ; $GUI_EVENT_CLOSE = -3
		If $cmsg < 0 Then ContinueLoop
		If IsChecked($chk_debug2) Then ToolTip("")
		If $redraw > 0 Then $cmsg = $card_pic
		Switch $cmsg
			Case $mbut_go_back, $ico_arr
				ExitLoop
			Case $chk_CF
				CardBootSector($chk_CF)
			Case $mbut_credits
				Dlg_MyMsgBox(0, "CardTricks Menu ...", "This adapted version of CardTricks v1.44 (info here:" & @CR & $web & "chdk.setepontos.com/index.php/topic,964.0.html)" & @CR & "uses the incredible Universal Dumper developed at the" & @CR & "CHDK forum (Forum link button in main CHDK-Shell GUI)" & @CR & "thanks to ewavr, Jeff666, mx3, chr, RyeBrye, brake and" & @CR & "ma_jk." & @CRLF & @CRLF & "Source code in " & $subdir & "\SRC", $mbox_timeout107, $cardmenu)
				If @error <> 0 Then
					$mbox_timeout107 = @error
				Else
					$mbox_timeout107 = @extended
				EndIf
			Case $mbut_form_fat
				$redraw = CardFormat($card_drive, "CANON_DC", $chk_stop_info)
			Case $mbut_mkboot
				$redraw = CardMakeBoot($card_drive, $chk_stop_info)
			Case $mbut_analyse
				GUISetState($State_Disable, $cardmenu)
				AnalyseCHDKBin($card_drive)
				GUISetState($State_Enable, $cardmenu)
				WinActivate($cardmenu)
			Case $mbut_udump_newdry
				$redraw = CardMakeUdumper("newdryos.bin", $card_drive, $chk_stop_info)
			Case $mbut_udump_dry
				$redraw = CardMakeUdumper("dryos.bin", $card_drive, $chk_stop_info)
			Case $mbut_udump_vxw
				$redraw = CardMakeUdumper("vxworks.bin", $card_drive, $chk_stop_info)
			Case $mbut_udump_analyse
				CardCleanDump($cardmenu)
			Case $mbut_udump_show
				AutoSplash("Scanning for strings ...")
;~ 				DosExec('arm-elf-strings -a --radix=x -T binary ' & $card_drive & 'empty.dum > ' & $subdir & '\strings.txt', $GCCpath)
				SilentDosExec('arm-elf-strings -a --radix=x -T binary ' & $card_drive & 'empty.dum > ' & $subdir & '\strings.txt', $GCCpath)
				SplashOff()
				ShellExecute("notepad.exe", $subdir & '\strings.txt', $here)
			Case $mbut_copy_bin
				GUICtrlSetState($mbut_copy_bin, 128) ; $GUI_DISABLE = 128

				If FileExists($sourcedir & "\bin") Then
					$ret = FileOpenDialog("Choose the proper ZIP file for your camera/firmware", $sourcedir & "\bin", "Zip files (*.zip)", 3, "", $cardmenu)
				Else
					Dlg_MyMsgBox(0, "No binaries found", "Looks like you have not compiled any binaries for" & @CR & $sourcedir & " yet." & @CR & "Please close the card menu and compile, or choose" & @CR & "another build version" & @CR, $mbox_timeout107, $cardmenu)
					If @error <> 0 Then
						$mbox_timeout107 = @error
					Else
						$mbox_timeout107 = @extended
					EndIf
					$ret = ""
				EndIf
				FileChangeDir($here)
				If $ret <> "" Then
					AutoSplash("Unpacking " & $ret & " to " & $card_drive & " ...")
					SaveSett($chk_bin_over, $sections[2], "chk_bin_over")
					If IsChecked($chk_bin_over) Then
						$flag = '-o '
					Else
						$flag = '-n '
					EndIf
					DosExec($GCCpath & '\unzip.exe ' & $flag & $ret & ' -d ' & $card_drive, $subdir)
					SplashOff()
					DriveSetLabel($card_drive, "CANON_DC")
					$redraw = 2
				EndIf
				GUICtrlSetState($mbut_copy_bin, 64) ; $GUI_ENABLE = 64
				WinActivate($cardmenu)
			Case $mbut_copy_2card
				AutoSplash("Copying " & $custom_path & " to " & $card_drive & "CHDK ...")
				DirCopy($custom_path, $card_drive & "CHDK", 1)
				SplashOff()
				$redraw = 2
			Case $mbut_copy_2cust
				AutoSplash("Copying " & $card_drive & "CHDK to " & $custom_path & " ...")
				DirCopy($card_drive & "CHDK", $custom_path, 1)
				SplashOff()
				$redraw = 2
			Case $mbut_sel_cust
				If $custom_path = $subdir & "\Custom" And Not FileExists($custom_path) Then
					DirCreate($custom_path)
					Dlg_MyMsgBox(0, "Custom Folder", "This appears to be the first time that you use this" & @CR & "option. For your convenience, the folder:" & @CR & $custom_path & @CR & "has been created and is preselected. You can" & @CR & "of course change this", $mbox_timeout107, $cardmenu)
					If @error <> 0 Then
						$mbox_timeout107 = @error
					Else
						$mbox_timeout107 = @extended
					EndIf
				EndIf
				$ret = FileSelectFolder("Select CHDK Custom folder. ALL CONTENT" & @CRLF & "here will be copied to <card>\CHDK" & @CRLF & "and vice versa when pressing the buttons" & @CRLF & "'CHDK->Card' && 'Card->CHDK', respectively", StringLeft($here, 3), 7, $custom_path, $cardmenu)
				FileChangeDir($here)
				If $ret <> "" Then
					$custom_path = $ret
					IniWrite($inifile, $sections[2], "custom_path", $custom_path)
					$redraw = 2
				EndIf
			Case $mbut_chdk_cfg
				$dummy = $subdir & "\CFGS\" & @YEAR & @MON & @MDAY & "@" & @HOUR & @MIN & ".CFG"
				$ret = InputBox("Save CCHDK.CFG from Card", "The file will be saved as " & $dummy & "; type a tag below, if you want one. Name and tag will be kept " & "in " & $subdir & "\CFGS\CCHDK_CFG.INI", "", "", R(400), R(150), Default, Default, 0, $cardmenu)
				If @error <> 1 Then
					AutoSplash("Copying " & $card_drive & "CHDK\CCHDK.CFG" & " ...")
					FileCopy($card_drive & "CHDK\CCHDK.CFG", $dummy, 8) ; 8 creates path if needed
					AutoSplash("Adding tag to " & $subdir & "\CFGS\CCHDK_CFG.INI" & " ...")
					IniWrite($subdir & "\CFGS\CCHDK_CFG.INI", "CCHDK_CFG", @YEAR & @MON & @MDAY & "@" & @HOUR & @MIN & ".CFG", $ret)
					GUICtrlSetState($mbut_chdk_show, 64) ; $GUI_ENABLE = 64
					SplashOff()
				EndIf
			Case $mbut_chdk_show
				ShellExecute("notepad.exe", $subdir & "\CFGS\CCHDK_CFG.INI", $here)
				WinActivate($cardmenu)
				$ret = FileOpenDialog("Select CFG to restore to Card", $subdir & "\CFGS", "Config (*.CFG)", 1, "", $cardmenu)
				If Not @error = 1 And $ret <> "" Then
					If FileExists($card_drive & "CHDK\CCHDK.CFG") Then
						FileMove($card_drive & "CHDK\CCHDK.CFG", $card_drive & "CHDK\CCHDK.BAK", 1)
					EndIf
					FileCopy($ret, $card_drive & "CCHDK\CCHDK.CFG", 9) ; overwrite + creates path if not present
				EndIf
				WinClose("CCHDK_CFG.INI", "")
			Case $card_pic
				If $redraw < 2 Then
					GUICtrlSetState($mbut_form_fat, 128) ; $GUI_DISABLE = 128
					;WinSetOnTop($cardmenu, "", 1)
					Do
						$card_drive = FileSelectFolder("Select SD Card drive - Please note that only 'Removable' or" & @CRLF & "'Unknown' (and 'Fixed' if selected) drive types will be" & @CRLF & "accepted; select Cancel if no drive selectable.", $mycomp, 2, "", $cardmenu)
						If $card_drive = "" Then ExitLoop
						$card_drive = StringLeft($card_drive, 3) ; ignore selected subdir
						$acceptable = False
						Switch DriveGetType($card_drive)
							Case "Removable", "Unknown"
								$acceptable = True
							Case "Fixed"
								If IsChecked($chk_fix_disk) Then $acceptable = True
						EndSwitch
					Until (StringInStr($illegal, StringLeft($card_drive, 1)) = 0) And $acceptable
					FileChangeDir($here)
				EndIf
				SaveSett($chk_fix_disk, $sections[2], "chk_fix_disk")
				If $card_drive <> "" Then
					GUICtrlSetState($mbut_show, 64) ; $GUI_ENABLE = 64
					GUICtrlSetState($mbut_form_fat, 64) ; $GUI_ENABLE = 64
					GUICtrlSetData($lab_card_drv, $card_drive)
					GUICtrlSetData($lab_card_typ, DriveGetType($card_drive))
					If DriveGetType($card_drive) = "Fixed" Then GUICtrlSetColor($lab_card_typ, 0xFF0000)
					$card_fs = DriveGetFileSystem($card_drive)
					GUICtrlSetData($lab_card_fs, $card_fs)
					GUICtrlSetData($lab_card_lab, DriveGetLabel($card_drive))
					$card_sz = DriveSpaceTotal($card_drive)
					GUICtrlSetData($lab_card_siz, Round($card_sz, 1) & " MB  (" & Round(DriveSpaceFree($card_drive), 1) & " MB free)")
					GUICtrlSetData($lab_cust_path, $custom_path)
					GUICtrlSetState($mbut_sel_cust, 64) ; $GUI_ENABLE = 64
					If $card_sz <= 4096 Then
						GUICtrlSetState($mbut_udump_newdry, 64) ; $GUI_ENABLE = 64
						GUICtrlSetState($mbut_udump_dry, 64) ; $GUI_ENABLE = 64
						GUICtrlSetState($mbut_udump_vxw, 64) ; $GUI_ENABLE = 64
						GUICtrlSetData($mbut_form_fat, "Format as FAT")
						If $card_fs = "FAT" Then
							GUICtrlSetState($mbut_copy_bin, 64) ; $GUI_ENABLE = 64
							$bootstate = SilentDosExec("echo r | bootable.exe " & StringLeft($card_drive, 2), $subdir)
							Switch $bootstate
								Case 4
									GUICtrlSetData($lab_card_boot, "ON ('BOOTDISK' at 0x40)")
									GUICtrlSetState($mbut_mkboot, 128) ; $GUI_DISABLE = 128
								Case 5
									GUICtrlSetData($lab_card_boot, "OFF (NO 'BOOTDISK' at 0x40)")
									GUICtrlSetState($mbut_mkboot, 64) ; $GUI_ENABLE = 64
								Case 3
									CardReadError()
							EndSwitch
						Else
							GUICtrlSetState($mbut_copy_bin, 128) ; $GUI_DISABLE = 128
							GUICtrlSetState($mbut_mkboot, 128) ; $GUI_DISABLE = 128
							GUICtrlSetData($lab_card_boot, "not tested, FAT32 can't boot")
						EndIf
					Else
						GUICtrlSetState($mbut_copy_bin, 128) ; $GUI_DISABLE = 128
						GUICtrlSetData($lab_card_boot, "Cards > 4GB can't boot !")
						GUICtrlSetState($mbut_udump_newdry, 128) ; $GUI_DISABLE = 128
						GUICtrlSetState($mbut_udump_dry, 128) ; $GUI_DISABLE = 128
						GUICtrlSetState($mbut_udump_vxw, 128) ; $GUI_DISABLE = 128
						GUICtrlSetData($mbut_form_fat, "Format as FAT32")
					EndIf
					If $card_fs = "FAT" Or $card_fs = "FAT32" Then
						GUICtrlSetState($mbut_copy_2cust, 64) ; $GUI_ENABLE = 64
						GUICtrlSetState($mbut_copy_2card, 64) ; $GUI_ENABLE = 64
					Else
						GUICtrlSetState($mbut_copy_2cust, 128) ; $GUI_DISABLE = 128
						GUICtrlSetState($mbut_copy_2card, 128) ; $GUI_DISABLE = 128
					EndIf
					If FileExists($card_drive & "empty.dum") Then
						GUICtrlSetState($mbut_udump_show, 64) ; $GUI_ENABLE = 64
						GUICtrlSetState($mbut_udump_analyse, 64) ; $GUI_ENABLE = 64
					Else
						GUICtrlSetState($mbut_udump_show, 128) ; $GUI_DISABLE = 128
						GUICtrlSetState($mbut_udump_analyse, 128) ; $GUI_DISABLE = 128
					EndIf
					If FileExists($card_drive & "CHDK\CCHDK.CFG") Then
						GUICtrlSetState($mbut_chdk_cfg, 64) ; $GUI_ENABLE = 64
					Else
						GUICtrlSetState($mbut_chdk_cfg, 128) ; $GUI_DISABLE = 128
					EndIf
					If FileExists($subdir & "\CFGS\CCHDK_CFG.INI") Then
						GUICtrlSetState($mbut_chdk_show, 64) ; $GUI_ENABLE = 64
					Else
						GUICtrlSetState($mbut_chdk_show, 128) ; $GUI_DISABLE = 128
					EndIf
				Else
					GUICtrlSetState($mbut_show, 128) ; $GUI_DISABLE = 128
				EndIf
				WinActivate($cardmenu)
				$redraw = 0
			Case $mbut_show
				ShellExecute("explorer.exe", $card_drive, $card_drive)
			Case Else
				ContinueLoop
		EndSwitch
		ClearQ($cmsg)
	WEnd
	IniWrite($inifile, $sections[2], "custom_path", $custom_path)
	SaveSett($chk_bin_over, $sections[2], "chk_bin_over")
	SaveSett($chk_fix_disk, $sections[2], "chk_fix_disk")
	SaveSett($chk_stop_info, $sections[2], "chk_stop_info")
	SaveSett($chk_auto_sel, $sections[2], "chk_auto_sel")
	SaveSett($chk_auto_sel, $sections[2], "chk_CF")

	GUISetAccelerators("", $cardmenu)
	$mpos = WinGetPos($cardmenu)
	If $w_animate = 1 Then AnimateWin($cardmenu, $PivotPrms[$PivIndex][1], $ctim)
	GUIDelete($cardmenu)
	$CurrentGUI = $CallingGUI
_ap_ProfileStop(134)
EndFunc   ;==>CardMainMenu
; --------------------------------------------
Func CardMakeUdumper($bin, $drive, $stop_info)
_ap_ProfileStart(135)
	Local $ret
	Static $mbox_timeout108 = 30

	If DriveSpaceTotal($drive) < 11 Then
		Dlg_MyMsgBox(0, "Card too small !", 	"Please use a card with 16 Mb or more ...", $mbox_timeout108, $cardmenu)
		If @error <> 0 Then
			$mbox_timeout108 = @error
		Else
			$mbox_timeout108 = @extended
		EndIf
		WinActivate($cardmenu)
_ap_ProfileStop(135)
		Return 0
	EndIf
	SaveSett($stop_info, $sections[2], "chk_stop_info")
	If Not IsChecked($stop_info) Then
		$ret = Dlg_MyMsgBox(4, "Important !", "Important info about Universal Dumper:" & @CR & "You CAN NOT SEE IF IT WORKS, it gives" & @CR & "NO VISUAL OR SOUND FEEDBACK WHILE RUNNING !" & @CR & "If the NewDryOS version just says 'Card Locked'" & @CR & "please retry SEVERAL times before giving up." & @CR & "Use as follows to make a dump:" & @CR & @CR & "1) assure card is write protected, insert in cam" & @CR & "2) assure cam is in play (not shoot) mode" & @CR & "3) start cam and wait at least 30 seconds" & @CR & "4) remove first battery/ies then card" & @CR & "5) re-insert battery/ies" & @CR & "6) reopen this program, select your card " & @CR & "7) press 'View strings in dump', that should" & @CR & "   show you if your dump succeeded. If it didn't" & @CR & "   try the other versions" & @CR & @CR & "Create Universal Dumper card now ?" & @CR, 0, $cardmenu)
		WinActivate($cardmenu)
		If $ret = 2 Then
_ap_ProfileStop(135)
			Return 0
		EndIf
	EndIf
	$ret = CardFormat($drive, "UD_" & StringUpper(StringTrimRight($bin, 4)), $stop_info)
	If $ret = 0 Then
_ap_ProfileStop(135)
		Return 0
	EndIf
	AutoSplash("Copying UDUMPER to " & $drive & " ...")
	; assure 'empty.bin' gets written first ...
	DosExec($GCCpath & '\unzip.exe -o empty2.zip -d ' & $drive, $subdir)
	; ... then write all udumper binaries to card ...
	DosExec($GCCpath & '\unzip.exe -o udumpfull2.zip -d ' & $drive, $subdir)
	; ... and copy the appropiate 1 to 'DISKBOOT.BIN'
	FileCopy($drive & $bin, $drive & "DISKBOOT.BIN")
	FileWrite($drive & "ver.req", "")
	FileWrite($drive & "vers.req", "")
	SplashOff()
_ap_ProfileStop(135)
	Return CardMakeBoot($drive, $stop_info)
EndFunc   ;==>CardMakeUdumper
; --------------------------------------------
Func CardFormat($drive, $label, $stop_info)
_ap_ProfileStart(136)
	Local $ret, $type, $cmd, $warn = ""
	Static $mbox_timeout109 = 30

	SaveSett($stop_info, $sections[2], "chk_stop_info")
	; check for photo/video on card
	If SilentDosExec("dir " & $drive & "*.JPG /S") = 0 Then $warn &= " JPG"
	If SilentDosExec("dir " & $drive & "*.CRW /S") = 0 Then $warn &= " CRW"
	If SilentDosExec("dir " & $drive & "*.CR2 /S") = 0 Then $warn &= " CR2"
	If SilentDosExec("dir " & $drive & "*.DNG /S") = 0 Then $warn &= " DNG"
	If SilentDosExec("dir " & $drive & "*.WAV /S") = 0 Then $warn &= " WAV"
	If SilentDosExec("dir " & $drive & "*.AVI /S") = 0 Then $warn &= " AVI"
	If $warn <> "" Then $warn = "Attention! Card " & $drive & " contains:" & $warn & " files" & @CRLF & @CRLF

	If ($warn <> "") Or (Not IsChecked($stop_info)) Then
		$ret = Dlg_MyMsgBox(1, "Warning", $warn & "Formatting will DESTROY ALL DATA on card " & $drive & @CR & @CR & "Are you sure you want to continue ?", $mbox_timeout109, $cardmenu)
		If @error <> 0 Then
			$mbox_timeout109 = @error
		Else
			$mbox_timeout109 = @extended
		EndIf
		If $ret = 2 Then
_ap_ProfileStop(136)
			Return 0
		EndIf
	EndIf
	If DriveSpaceTotal($drive) > 4096 Then
		$type = " as FAT32"
		$cmd = ""
	Else
		If DriveSpaceTotal($drive) > 2048 Then
			If IsChecked($stop_info) Then
				Dlg_MyMsgBox(0, "Warning", "4 GB Cards will be FAT16 formatted with 64 KB clusters" & @CR & "Although non-standard, all CHDK able cams support this", 0, $cardmenu)
			EndIf
		EndIf
		$type = " as FAT16"
		$cmd = " /FS:FAT"
	EndIf
	AutoSplash("Formatting Card " & $drive & $type & " ...")
	$ret = DosExec("echo | format " & StringLeft($drive, 2) & " /X" & $cmd & " /V:" & $label)
	SplashOff()
	WinActivate($cardmenu)
	If $ret <> 0 Then
		CardWriteError()
_ap_ProfileStop(136)
		Return 0
	Else
		If StringLeft($label, 2) <> "UD" Then
			FileWrite($drive & "ver.req", "")
			FileWrite($drive & "vers.req", "")
		EndIf
_ap_ProfileStop(136)
		Return 2
	EndIf
EndFunc   ;==>CardFormat
; --------------------------------------------
Func CardMakeBoot($drive, $stop_info)
_ap_ProfileStart(137)
	Local $ret

	SaveSett($stop_info, $sections[2], "chk_stop_info")
	AutoSplash("Making Card " & $drive & " bootable ...")
	$ret = SilentDosExec("echo w | bootable.exe " & StringLeft($drive, 2), $subdir)
	If $ret = 3 Then
		CardWriteError()
		SplashOff()
_ap_ProfileStop(137)
		Return 0
	Else
		SplashOff()
		If Not IsChecked($stop_info) Then
			Dlg_MyMsgBox(0, "Note", "Card is now bootable in Canon cams." & @CR & "Do not forget to set Write Protect on the card" & @CR & "- slide tab up, away from the electric connectors -" & @CR & "to take advantage of this feature.", 0, $cardmenu)
			WinActivate($cardmenu)
		EndIf
_ap_ProfileStop(137)
		Return 2
	EndIf
EndFunc   ;==>CardMakeBoot
; --------------------------------------------
Func CardWriteError()
_ap_ProfileStart(138)
	Dlg_MyMsgBox(0, "Error", "Check Write Protect, could not write to Card !", 0, $cardmenu)
	WinActivate($cardmenu)
_ap_ProfileStop(138)
EndFunc   ;==>CardWriteError
; --------------------------------------------
Func CardReadError()
_ap_ProfileStart(139)
	Dlg_MyMsgBox(0, "Error", "Could not read from the Card !" & @CR & "Please check if card was removed from reader." & @CR & "If not, check if Windows recognizes it.", 0, $cardmenu)
	WinActivate($cardmenu)
_ap_ProfileStop(139)
EndFunc   ;==>CardReadError
; --------------------------------------------
Func CardCleanDump($parent)
_ap_ProfileStart(140)
	Local $infile, $outfile, $tempfile, $hnd_in, $hnd_out, $long, $trailing_zeros = -1, $pos, $blob
	Local $i, $orgsize, $newname

	$infile = $card_drive & "empty.dum"
	$orgsize = FileGetSize($infile)
	$tempfile = $subdir & "\stripped.tmp"
	$outfile = $subdir & "\stripped.bin"
	$hnd_in = FileOpen($infile, 16) ; open for binary read
	If $hnd_in = -1 Then
		CardReadError()
_ap_ProfileStop(140)
		Return
	EndIf
	AutoSplash("Scanning your dump ...")
	$pos = 0
	Do
		$long = FileRead($hnd_in, 4)
		$i = @error
		$pos += 4
	Until $long <> 0x00000000 Or $i = -1
	SplashOff()
	If $i = -1 Then
		FileClose($hnd_in)
		Dlg_MyMsgBox(0, "No Data", "This dump contains no valid data !", 0, $parent)
_ap_ProfileStop(140)
		Return
	EndIf
	$hnd_out = FileOpen($tempfile, 18) ; open for binary write
	FileWrite($hnd_out, $long)
	AutoSplash("Trimming " & $pos - 4 & " Leading 00's ...")
	While 1
		$long = FileRead($hnd_in, 4)
		If @error = -1 Then ExitLoop
		If $long = 0x00000000 Then
			If $trailing_zeros = -1 Then
				$trailing_zeros = $pos
			EndIf
		Else
			$trailing_zeros = -1
		EndIf
		$pos += 4
		FileWrite($hnd_out, $long)
	WEnd
	SplashOff()
	FileClose($hnd_in)
	FileClose($hnd_out)
	; now recalculate the $trailing_zeros offset for the temp file (because it had its' leading 0's trimmed)
	$trailing_zeros -= ($orgsize - FileGetSize($tempfile))

	$hnd_in = FileOpen($tempfile, 16) ; for bin. read
	$hnd_out = FileOpen($outfile, 18) ; for bin. write

	AutoSplash("Trimming " & ($orgsize - $trailing_zeros) & " Trailing 00's ...")
	$pos = 0
	Do
		$long = FileRead($hnd_in, 4)
		If @error = -1 Then ExitLoop ; should never be reached
		$pos += 4
		FileWrite($hnd_out, $long)
	Until $pos = $trailing_zeros
	SplashOff()
	FileClose($hnd_in)
	FileClose($hnd_out)
	FileDelete($tempfile)
	$orgsize = FileGetSize($outfile) ; get outfile's size
	FileMove($outfile, $outfile & ".org")
	$hnd_in = FileOpen($outfile & ".org", 16) ; open for binary read
	$hnd_out = FileOpen($outfile, 18) ; for bin. write
	$blob = FileRead($hnd_in, $orgsize - 2) ; read all but the last 2 bytes ...
	FileWrite($hnd_out, $blob) ; ... and write them back
	FileClose($hnd_in)
	FileClose($hnd_out)
	FileDelete($outfile & ".org")
	$newname = FileSaveDialog("Done, please rename stripped.bin (ex. PRIMARY_A620-100f.bin)", $subdir, "Binary Files (*.bin)", 16, "PRIMARY_cam-firm.bin", $parent)
	If $newname <> "" Then
		If FileExists($newname) Then FileDelete($newname)
		FileMove($outfile, $newname)
	EndIf
	FileChangeDir($here)
	WinActivate($cardmenu)
_ap_ProfileStop(140)
EndFunc   ;==>CardCleanDump
; --------------------------------------------
Func CardBootSector($cb)
_ap_ProfileStart(141)
	SaveSett($cb, $sections[2], "chk_CF")
	If IsChecked($cb) Then
		FileCopy($subdir & "\bootable.exe.cf", $subdir & "\bootable.exe", 1)
	Else
		FileCopy($subdir & "\bootable.exe.org", $subdir & "\bootable.exe", 1)
	EndIf
_ap_ProfileStop(141)
EndFunc   ;==>CardBootSector
; --------------------------------------------
Func AnalyseCHDKBin($drive)
_ap_ProfileStart(142)
	Local $h_str, $trim, $ret, $curline, $info[4]
	Local Const $bin = "DISKBOOT.BIN"
	; if a card is selected, see if diskboot.bin is there ...
	If $drive <> "" Then
		If FileExists($drive & $bin) Then
			$ret = $drive & $bin
		Else
			; ... if not offer to browse to it
			$ret = Dlg_MyMsgBox(1, "No " & $bin & " on card " & $drive, "Browse computer to find one ?", 0, $cardmenu)
			If $ret = 2 Then
_ap_ProfileStop(142)
				Return ; 'cancel' pressed
			EndIf
		EndIf
	EndIf
	If $ret = 1 Or $drive = "" Then
		; no card, or card without diskboot.bin found - browse for one
		Do
			$ret = FileOpenDialog("Select 'DISKBOOT.BIN' to analyse ...", $mycomp, "BIN files (*.BIN)", 1, "", $cardmenu)
		Until StringRight($ret, 12) = "DISKBOOT.BIN" Or $ret = ""
		FileChangeDir($here)
		If $ret = "" Then
_ap_ProfileStop(142)
			Return ; 'cancel' pressed
		EndIf
	EndIf
	SilentDosExec('arm-elf-strings -a --radix=x -T binary ' & $ret & ' > ' & $subdir & '\db.txt', $GCCpath)
	$h_str = FileOpen($subdir & '\db.txt', 0)
	While 1
		$curline = FileReadLine($h_str)
		If @error = -1 Then ExitLoop ; EOF reached
		If StringInStr($curline, "CHDK Firmware") > 0 Then
			$trim = StringInStr($curline, "CHDK Firmware") - 1
			$info[0] = " (VxWorks)"
			$info[1] = StringTrimLeft($curline, $trim)
			$info[2] = StringTrimLeft(FileReadLine($h_str), $trim)
			$info[3] = StringTrimLeft(FileReadLine($h_str), $trim)
			ExitLoop
		EndIf
	WEnd
	FileDelete($subdir & '\db.txt')
	FileClose($h_str)
	If $info[0] = "" Then ; no 'CHDK Firmware' string there, it must have been encoded
		SilentDosExec('decode ' & $ret & ' ' & $subdir & '\dbdec.bin', $subdir)
		SilentDosExec('arm-elf-strings -a --radix=x -T binary ' & $subdir & '\dbdec.bin' & ' > ' & $subdir & '\dbdec.txt', $GCCpath)
		$h_str = FileOpen($subdir & '\dbdec.txt', 0)
		While 1
			$curline = FileReadLine($h_str)
			If @error = -1 Then ExitLoop ; EOF reached
			If StringInStr($curline, "CHDK Firmware") > 0 Then
				$trim = StringInStr($curline, "CHDK Firmware") - 1
				$info[0] = " (DryOS)"
				$info[1] = StringTrimLeft($curline, $trim)
				$info[2] = StringTrimLeft(FileReadLine($h_str), $trim)
				$info[3] = StringTrimLeft(FileReadLine($h_str), $trim)
				ExitLoop
			EndIf
		WEnd
		FileClose($h_str)
		FileDelete($subdir & '\dbdec.bin')
		FileDelete($subdir & '\dbdec.txt')
	EndIf
	; present results ...
	If $info[0] = "" Then
		Dlg_MyMsgBox(0, "Not a valid CHDK " & $bin, "Maybe you accidentally selected" & @CR & "a LEDdumper or udumper binary ?", 0, $cardmenu)
	Else
		Dlg_MyMsgBox(0, "Info for " & $ret, $info[3] & $info[0] & @CR & @CR & $info[1] & @CR & @CR & $info[2], 0, $cardmenu)
	EndIf
_ap_ProfileStop(142)
EndFunc   ;==>AnalyseCHDKBin

#EndRegion
#
#Region ============================ Main Program ================================================

$ProgStarted = TimerInit()
$WinVer = __Ver()	; see includes: recovers Win version in format needed by _WinAPI_GetProcessTimes

If $cmdline[0] = 0 Or $cmdline[1] <> "-multiple" Then
	; unless overridden, we don't want more than 1 version of the program (any version) running ...
	If WinExists($CShell) Then
		WinActivate($CShell)
		Exit
	EndIf
ElseIf $cmdline[1] = "-multiple" Then
	Sleep(500)	; allow previous instance time to die in peace ...
EndIf
; assure we get the PID ptr
Do
	$ThisProcess = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
Until @error = 0

; set base paths & make sure they exist ...
$here = @ScriptDir ; If, and only if, ScriptDir is root it has a trailing '\' ...
If StringRight($here, 1) = "\" Then $here = StringTrimRight($here, 1) ; ... so  remove in that case

$inifile = StringTrimRight(@ScriptFullPath, 4) & ".ini"
$subdir = $here & "\CHDK-Shell"
$icons = $subdir & "\icons"

DirCreate($subdir & "\SRC") ; will also create $subdir if it doesn't exist

$arr_icon[0] = $icons & "\arrowl.ico"
$arr_icon[1] = $icons & "\arrow.ico"
$arr_icon[2] = $icons & "\arrowdl.ico"
$arr_icon[3] = $icons & "\arrowdr.ico"

If IniIni() Then
	$no_readme_popup = 1 * IniRead($inifile, $sections[0], "no_readme_popup", 0)
	If @Compiled And $no_readme_popup = 0 Then $NewVersion = True
EndIf

; note we need to pass 0 as 2nd parameter to prevent restart ...
ToggleProfiling( Number(IniRead($inifile, $sections[0], "introspection", 0)), 0 )

; now that profiling is set up, we can start monitoring, if selected
_ap_ProfileStart(0)

PreReadIni()

$activity = $mtim + 1
$branches[0][0] = "trunk"
$branches[1][0] = $DefBranch[$site]

CheckShortcut()

$GCC4path = IniRead($inifile, $sections[0], "GCC4path", $here & "\gcc4\bin")
If StringInStr($semi_allowed, $CurrOSVersion) Then $w_aero = 1 - $w_classic
$GCC3path = IniRead($inifile, $sections[0], "GCC3path", $here & "\gcc\bin")
$GCCpath = IniRead($inifile, $sections[0], "GCCpath", "")

ReadXY()

$InstallFlag = Sanity_Check() ; check if environment properly set up

$sourcedir = SelectLocalBuild(0)

If $sourcedir = "" Then Exit

Read_CP_ini_colors()

Build_GUI()

If $miniGUI = 1 Then GUICtrlSetState($ico_canon, 128) ; $GUI_DISABLE = 128

VersionSnoop()

$PTP_base = Get_ptpCamGui()

Check_istate()	; Wrapped_Check_istate()

$startup = False

DisableMainControls(0)

Check_ptpCamGui()

If $NewVersion Then
	ShellExecute($here & "\readme.txt")
	$NewVersion = False
EndIf

While 1
	; Run the GUI until the dialog is closed
	$msg = GUIGetMsg()
	If IsChecked($chk_debug2) Then Debug_LoopTimer($msg)
	If $Introspection Then Trace_Msg($msg)
	If $msg = 0 Then
		If $gc = True Then Clean()
		; when idle, allow msg loop to slow down to ~ 3 per second; this works because
		; hovering an ACTIVE GUI will trigger a message -11, and fast response is restored
		Sleep(300)
		; hide stop button for 'Thanks' if process no longer exists
		If $PID_Thanks And Not ProcessExists($PID_Thanks) Then
			GUICtrlSetState($ico_stop, 32) ; $GUI_HIDE = 32
			$PID_Thanks = 0
		EndIf
		ContinueLoop
	EndIf
	If $msg = -8 Then AutoPos()	; mouse up event, for 'screen snap' if selected
	If $msg = -5 Then			; -5 = restore event
		GUISetState($State_Restore, $main)
		GetWPos()
		If $Rflag = 1 Then ForceForegroundCheck()
	EndIf
	If $msg = -3 Then ExitLoop ; $GUI_EVENT_CLOSE = -3
	If WinActive($minigraph) Then WinActivate($minimain)
	If $msg < 0 Then ContinueLoop
	If IsChecked($chk_debug2) Then ToolTip("")
	If $miniGUI = 0 Then
		; normal full GUI received a message
		WinActivate($main)
		WinWaitActive($main)
		For $c = 0 To $sup_cams - 1
			If $msg = $but_cams[$c] Then ShowCamProps($c)
		Next
		Switch $msg
			Case $but_branch
				Do
				Until Dlg_SetBranch()
			Case $but_sizer
				Dlg_SetSize()
			Case $but_mini, $ctx_mini
				SwitchGUI(1)
				WinActivate($minimain)
			Case $but_go_forum
				Browse($Forum[$site])
			Case $ctx_forum[0]
				Browse($Forum[0])
			Case $ctx_forum[1]
				Browse($Forum[1])
			Case $ctx_home[0]
				Browse($Home[0])
			Case $ctx_home[1]
				Browse($Home[1])
			Case $but_go_wikia
				Browse($Wikia)
			Case $ctx_wikia
				Browse($Wikia & "-Shell")
			Case $but_go_mantis
				Browse($Mantis)
			Case $rad_build[1], $rad_build[2]
				ToggleTrunkBranch()
			Case $but_sel_ver
				UpdateCurrentBuild(1)
			Case $ico_clone
				Dlg_Clone()
			Case $cur_t
				GetVersionInfo()
			Case $but_sel_site
				Dlg_SelectSite()
			Case $chk_nosel
				IniWrite($inifile, $sections[1], "chk_nosel", IsChecked($chk_nosel))
			Case $chk_inet
				Check_istate()
			Case $chk_upd
				Check_auto()
				Init_TimerBar()
				If IsChecked($chk_upd) Then TracChecker()
			Case $but_upd_opt
				Dlg_SetPostCheck()
			Case $but_log_show
				ShellExecute($subdir & "\upd-log.txt", "", $subdir)
			Case $but_unzip
				UnzipArchives()
			Case $but_go_progver
				Dlg_ProgUpdates()
			Case $ico_stop
				ProcessClose($PID_Thanks)
			Case $chk_trayicon
				SetTrayIcon()
			Case $chk_tooltips
				Set_Tooltips()
			Case $chk_debug
				IniWrite($inifile, $sections[0], "chk_debug", GUICtrlRead($chk_debug))
			Case $chk_debug2
				ShowNetBuild("")
				Set_Dyn_Tooltips()
				If IsChecked($chk_debug2) = 0 Then ToolTip("")
			Case $but_debug
				Dlg_Debug()
			Case $pic_card, $ctx_card
				Switch2CardMenu()
			Case $but_err_show
				ShellExecute($errlog, "", $sourcedir, "open")
			Case $but_cond_comp
				Dlg_CompileOptions()
			Case $pic_search
				Do_Search()
			Case $but_open_src
				ShellExecute("explorer.exe", $sourcedir, $sourcedir)
			Case $chk_comp_full
				Set_CompileType()
			Case $chk_keep_dumps
				Do_Dumps()
			Case $but_src_tools
				Switch Dlg_SourceTools()
					Case 1
						$sourcedir0 = ""	; a patch was applied, force CamProperties refresh ...
						UpdateCurrentBuild(-1)
;~ 					Case -1
;~ 						FixCamProps()
				EndSwitch
			Case $but_comp_sel
				Compile(0)
			Case $pic_cmd
				Show_InteractiveCmd()
			Case $but_comp_all
				Compile(1)
			Case $but_exit
				ExitLoop
			Case $ctx_verstats
				Dlg_VersionStats()
			Case $ctx_ptpcam
				Run_ptpCamGui()
			Case $ctx_thanks
				Run_Thanks()
			Case $ctx_reset_opts
				ResetIncState($sourcedir)
			Case $ctx_cam_dry
				SelectCams_All_None(1, "dry") ; $GUI_CHECKED = 1
			Case $ctx_cam_vx
				SelectCams_All_None(1, "vx") ; $GUI_CHECKED = 1
			Case $ctx_cam_all
				SelectCams_All_None(1) ; $GUI_CHECKED = 1
			Case $ctx_cam_none
				SelectCams_All_None(4) ; $GUI_UNCHECKED = 4
			Case $ctx_switch
				$site = 1 - $site
				IniWrite($inifile, $sections[1], "site", $site)
				SwitchSites(0, True)
		EndSwitch
		ControlFocus($main, "", $but_def_focus)
	Else
		; miniGUI active
		WinActivate($minimain)
		WinWaitActive($minimain)
		Switch $msg
			Case $but_miniswitch
				$site = 1 - $site
				IniWrite($inifile, $sections[1], "site", $site)
				SwitchSites(0, True)
			Case $but_minigui, $ico_sat
				SwitchGUI(0)
				WinActivate($main)
				ContinueLoop
			Case $lab_minicur
				GetVersionInfo()
			Case $ico_canon
				Run_ptpCamGui()
;~ 			Case $but_minimenu
;~ 				MsgBox($topmost, "MiniGUI", "You hit the Menu button", 10)
;~ 			Case $ico_func
;~ 				MsgBox($topmost, "MiniGUI", "You hit the Func/Set button", 10)
;~ 			Case $ico_play
;~ 				MsgBox($topmost, "MiniGUI", "You hit the Play button", 10)
		EndSwitch
		ControlFocus($minimain, "", $ico_sat)
	EndIf
	ClearQ($msg)
	$activity = $mtim + 1
WEnd

MyExit(0)

#EndRegion
